Welcome

Welcome

Welcome to the Administrator's Guide for Windows SharePoint Services. Use the following topics to learn more about installing and managing Windows SharePoint Services.

Introduction

  • Welcome
  • Introducing Windows SharePoint Services
  • Introducing the Administration Tools for Windows SharePoint Services
  • Administrator's Guide for Microsoft Windows SharePoint Services Copyright Information

Planning

  • Hardware and Software Requirements
  • Microsoft Windows SharePoint Services 2.0 Architecture
  • Upgrade Considerations
  • Performance Implications of Windows SharePoint Services Features
  • Capacity Planning for Windows SharePoint Services
  • Language Considerations

Deployment Scenarios

  • Single Server Deployment
  • Remote SQL Server Deployment
  • Server Farm with Multiple Host Names Deployment
  • Configuring Two Virtual Servers to Host the Same Content
  • Separate Active Directory Directory Service Organization Unit Deployment

Installation

  • Installation Considerations for Windows SharePoint Services
  • Installation Points for Windows SharePoint Services
  • Performing a Quiet Installation
  • Extending Virtual Servers
  • Installing and Using Service Packs for Windows SharePoint Services
  • Uninstalling Windows SharePoint Services

Security

  • Windows SharePoint Services Security Model
  • Security Considerations for Server and Site Configurations
  • Internet Explorer Enhanced Security and Windows SharePoint Services
  • Configuring Authentication
  • Managing the SharePoint Administrators Group
  • Managing Users and Cross-Site Groups
  • Managing Site Groups and Permissions
  • Controlling User Rights and Assigning Tasks

Configuration

  • Specifying Central Administration Settings
  • Configuring Virtual Servers
  • Creating Sites and Subsites
  • Configuring E-Mail Settings
  • Configuring E-Mail-Enabled Document Libraries
  • Configuring Online Presence Settings
  • Configuring Site Quotas and Locks
  • Configuring Self-Service Site Creation
  • Managing and Customizing Search
  • Configuring Regional Settings
  • Configuring Usage Analysis
  • Configuring Antivirus Protection
  • Configuring Blocked File Extensions
  • Configuring Data Retrieval Services

Administration

  • Scheduling Timed Jobs
  • Managing Sites and Subsites
  • Managing Paths
  • Managing the Configuration Database
  • Managing Content Databases
  • Managing Web Discussions
  • Managing Alerts
  • Managing Versions and Checking Documents In and Out
  • Managing HTML Viewers
  • Managing a Server Farm Running Windows SharePoint Services
  • Managing Meeting Workspace Sites
  • About Web Parts
  • Managing a Site Collection Web Part Gallery
  • Managing Web Parts on Virtual Servers
  • Using SharePoint Configuration Analyzer

Backup and Migration

  • Backup and Restore Options for Windows SharePoint Services
  • Backing Up and Restoring Databases by Using the SQL Server 2000 Tools
  • Backing Up and Restoring Web Sites
  • Migrating and Upgrading Web Sites
  • Migrating from WMSDE to SQL Server

Maintenance

  • Analyzing Web Site Usage
  • Managing Unused Web Sites
  • Changing the Application Pool Identity for a Virtual Server
  • Monitoring Events for Windows SharePoint Services

Customization

  • Customizing a Web Site Based on Windows SharePoint Services
  • Customizing Help
  • Binding to a Document Library Event Handler
  • Configuring Discussion Boards
  • Extending Windows SharePoint Services
  • Working with Templates
  • Using the SDK to Perform Advanced Customization
  • Using the Object Model to Manage Windows SharePoint Services

Troubleshooting

  • Troubleshooting Installation Issues
  • Troubleshooting Other Issues

Reference

  • Command-Line Operations
  • Command-Line Parameters
  • Command-Line Properties
  • Command-Line Options for Setupsts.exe
  • User Rights and Site Groups
  • Files and Permissions
  • Special Directories and Storage Locations
  • Regional and Language Settings
  • Glossary
  • Index
©2003 Microsoft Corporation. All rights reserved.


Introducing Windows SharePoint Services

Introducing Windows SharePoint Services

Microsoft Windows SharePoint Services helps users work together. SharePoint sites provide a central repository for documents, information, and ideas, and allow users to work interactively.

Windows SharePoint Services is an update and revision to SharePoint Team Services v1.0 from Microsoft, and offers many improvements over SharePoint Team Services v1.0, several of which are detailed in the following sections.

What's New for Site Users

The following are a just few of the new features for users of Windows SharePoint Services.

  • Document versioning and document check-in and check-out

    Use document versioning to automatically create a backup copy of a file whenever it is saved to a document or picture library. Users can also check out a file to lock it while editing, preventing other users from overwriting or editing it inadvertently.

  • New lists and views

    Create a picture library to share a collection of digital pictures or graphics. Create an Issue tracking list to maintain a history on a specific issue. Use the calendar Monthly, Weekly, and Daily views to view information in any SharePoint list that has a date and time column.

  • Other improvements to lists

    Users can add attachments to list items, including HTML pages, documents, and images. List owners can approve or reject items that are submitted to the list and add comments. List owners can also apply permissions to a list, allowing only specific users to make changes to the list.

  • Support for list and site templates

    Users can save SharePoint lists as templates, and reuse them or distribute them to other sites. Administrators and Web Designers can save sites as templates to capture best practices or to define a consistent look and feel.

  • Support for Web Parts and Web Part Pages

    Each list in a site is a Web Part that allows easy customization and personalization using the browser. Users can customize Web Parts or add new Web Parts to a page.

  • Quicker page and site creation

    Users can go to one page to create any SharePoint list, such as discussion lists, document libraries, and other lists. Users can also create sites on demand without involving the IT department by using Self-Service Site Creation.

For a complete list of new features and information about using these features, see the Help system for Windows SharePoint Services.

What's New for Developers

The following are a few of the new features for developers working with or adding on to Windows SharePoint Services.

  • Built on the .NET framework

    SharePoint sites are built on ASP.NET and are extensible by using the .NET framework.

  • Support for solutions

    Use the object model to create custom solutions on the Windows SharePoint Services platform.

  • Remote programmability with SOAP

    Access the object model from a remote location by using the SOAP protocol.

For a complete list of new developer features and more information about using these features, see the Windows SharePoint Services Software Development Kit.

What's New for Server Administrators

The following new features have been included to help administrators of Windows SharePoint Services:

Architecture

  • Scalable architecture

    Windows SharePoint Services scales from a single server to a server farm with multiple front-end Web servers and back-end database servers. Front-end Web servers are stateless, so the load can be balanced across them.

  • Support for running multiple applications on a virtual server

    You can exclude part of the URL namespace on a virtual server so that Windows SharePoint Services does not overwrite data for a Web application. Windows SharePoint Services can co-exist with other applications on a single virtual server.

  • Store all documents, metadata, and site data in a database

    Microsoft SQL Server or Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) is used to store all site data, including documents. This improves reliability by ensuring complete transactional integrity of the data, and enables the scale-out architecture. Using the database also allows for both full-text searching and backing up sites by backing up the database.

  • Per-site full-text searching

    Use SQL Server full-text indexing to provide site-wide searching of sites on your server.

  • Comprehensive administrative object model

    Enables rich scenarios for writing custom management tools to manage sites.

International

  • Support for multiple language sites

    Multiple language sites can be hosted on a single server or server farm running Windows SharePoint Services. Note that site language is independent of server language.

  • Regional settings for each site

    Each site can have its own regional settings, such as time zone.

Management

  • Create sites from SharePoint Central Administration or by allowing Self-Service Site Creation

    Administrators can create sites for users or allow users to create their own sites automatically by using Self-Service Site Creation.

  • Site quotas and notifications

    Set quotas for site storage size and generate automatic notifications for the site owner when a site reaches its size limit. In Active Directory account creation mode, you can also set a quota to specify the maximum number of users that can be added to Microsoft Active Directory directory service from any single SharePoint site collection.

  • Inactive site management

    Site owners are notified on a periodic basis of all their sites, and asked to confirm that the sites are in use or delete them. If multiple notices are sent to the site owner without any response, the administrator can specify that the site be automatically deleted.

  • Site-level backup and restore

    Each site in a server farm can be individually backed up and restored. This feature can be used for archiving inactive sites prior to deleting them.

  • Blocked file extensions

    Server administrators can block the upload of specific file types (for example MP3 or .exe files).

  • Site migration

    Sites on one server can be moved to another by using the Microsoft SharePoint Migration Tool (Smigrate.exe).

Setup and Upgrade

  • Easy installation for small deployments

    If you want to set up Windows SharePoint Services on a single server with WMSDE, you can run Setup with the default settings and have a working site within minutes.

  • Support for server farm installations

    With Windows SharePoint Services, you can set up a server farm configuration, which includes multiple front-end Web servers and multiple back-end database.

  • Site migration

    SharePoint Team Services v1.0 sites can be migrated to Windows SharePoint Services by using the Microsoft SharePoint Migration Tool (Smigrate.exe).

Security

  • Works with standard Windows authentication and security methods

    Use Windows SharePoint Services with any IIS 6.0 authentication method, connect to the database by using Windows authentication or SQL Server authentication, and integrate Windows SharePoint Services with Microsoft Active Directory directory service.

  • SharePoint administrators group

    Allow members of a domain group to perform central administration tasks without granting them administrator rights to the local server computer.

  • Manage users from SharePoint Central Administration

    Use the SharePoint Central Administration pages to add or delete users on all sites and assign site owners.

  • Domain group support

    Use domain groups to control access to your site.

Scenarios

Microsoft Windows SharePoint Services can help people communicate within an organization, on the World Wide Web, and across these boundaries. The following scenarios illustrate how Windows SharePoint Services can be used in these situations.

Enhance Your Organization's Intranet

No matter how large or small your organization, the users inside your organization have data, documents, and thoughts to share with other users in the organization. You can install Windows SharePoint Services to a single server to support a small organization, or you can create a server farm environment to support a large, multinational organization.

Inside a Small Organization

In a smaller organization, you can install and run Windows SharePoint Services without a lot of overhead. For example, you can:

  • Use the single server installation to get a site up and running quickly.
  • Turn on Self-Service Site Creation to allow users to build sites as needed.
  • Enable full-text searching so your users can easily find the information and documents they need.

Inside a Large Organization

In a larger organization, you can take advantage of more sophisticated administration features. For example, you can:

  • Use a server farm configuration to support load balanced servers.
  • Increase efficiency by running both Windows SharePoint Services and other Web applications on the same servers.
  • Install language packs to allow for sites in different languages around the world.
  • Prompt for site use confirmation, and automatically delete unused Web sites.
  • Manage site users efficiently by using domain groups instead of individual users.

Host SharePoint Sites on the Internet

If you are an Internet Service Provider (ISP), you can appreciate the large-scale management features available with Windows SharePoint Services. And because Windows SharePoint Services includes a comprehensive administrative object model, you can build custom administration tools to manage your servers and SharePoint sites.

For example, you can:

  • Use a server farm configuration to allow load balancing for your servers.
  • Take advantage of the new site and server architecture to help isolate server processes from each other.
  • Set quotas for sites, so that you can predict how much space each site will take up on your servers, and set appropriate billing policies for larger sites.
  • Use Windows SharePoint Services in Active Directory account creation mode so that new user accounts are created automatically, up to a configurable limit, based on the e-mail addresses.
  • Provide automatic site backups for a monthly fee.

Communicate with External Partners by Using an Extranet

If you work with external partners, or if you have users who need to access data from outside of your organization's firewall, you can run Windows SharePoint Services in an intranet/extranet environment. In this configuration, you can:

  • Allow both internal and external users to view and interact with the same content and data.
  • Employ the antivirus protection and blocked file extension features to help protect your server integrity.

Using Windows SharePoint Services as a Platform

Windows SharePoint Services is a platform technology, and is designed to be extensible. Several products build on Windows SharePoint Services, and you can extend Windows SharePoint Services to work with your product. You can find information about ways to extend Windows SharePoint Services in the Windows SharePoint Services Software Development Kit.


Introducing the Administration Tools for Windows SharePoint Services

Introducing the Administration Tools for Windows SharePoint Services

Microsoft Windows SharePoint Services includes tools to help you manage the Web sites you create. You can manage Windows SharePoint Services locally by using HTML Administration pages or a command-line interface, or remotely by using HTML Administration pages. In addition, you can set properties — such as specifying whether alerts are enabled for a virtual server — by using the command-line interface or HTML Administration pages.

HTML Administration Pages

Windows SharePoint Services includes HTML Administration pages to help manage your Web sites and servers. You can use these forms on the local server computer or from a remote computer connected to the Internet. You must have the proper administrator rights to use HTML Administration pages.

For Windows SharePoint Services, there are two types of administration pages:

  • Central Administration pages
  • Site Administration and Site Settings pages

Central Administration Pages

The Central Administration pages allow you to manage settings for your server farm, Web server, and virtual servers. These pages are created during Windows SharePoint Services setup. By default, a newly created virtual server inherits settings from defaults set on the Central Administration pages. You can change these default settings and specify what settings to use for each extended virtual server. You must be either a member of the local Administrators group for the server computer or a member of the SharePoint administrators group to be able to use the Central Administration pages. For more information about the SharePoint administrators group, see Managing the SharePoint Administrators Group.

You gain access to the Central Administration pages from the administration port that Windows SharePoint Services created during setup. To view the pages, on the Start menu, point to All Programs, click Administrative Tools, and then click SharePoint Central Administration; or, from the browser on a remote computer, type the URL to the pages on the administration port. For example, http://server_name:port or http://localhost:port.

Site Administration and Site Settings Pages

In addition to the Central Administration pages, which control settings for each server and virtual server, there are administration pages that control settings for each Web site. You can perform some administrative actions from the Site Settings page, and you can link from there to the Site Administration page. You must have administrator rights to the Web site to perform administrative actions on the Site Settings and Site Administration pages.

From the Site Settings and Site Administration pages, you can perform tasks such as:

  • Manage users and site groups.

    You can add or remove users, edit site groups, and change a user's site group membership. For more information, see Managing Users and Cross-Site Groups and Managing Site Groups and Permissions.

  • Create or delete subsites.

    You can add a subsite or manage the existing subsites to your Web site. For more information, see Creating Sites and Subsites.

  • Change anonymous access.

    If anonymous access is available for the virtual server that contains your Web site, you can control whether or not it is enabled for your Web site. For more information, see Managing Site Groups and Permissions.

  • Change regional settings.

    You can change the locale, time zone, sort order, and time format to use for your Web site. For more information, see Language Considerations.

  • Manage Web discussions and alerts.

    You can view all Web discussions and user alerts for your Web site and delete any that are no longer needed. For more information, see Managing Web Discussions and Managing Alerts.

Note that if you are managing a subsite, the administration tasks available on the Site Administration page for the subsite are a subset of those available for top-level Web sites.

The Site Settings and Site Administration pages are stored in the _layouts directory of the Web site. You can navigate to the Site Settings pages by using any of the following methods:

  • In your Web site, to get to Site Settings, click Site Settings. To get to Site Administration, on the Site Settings page, click Go to Site Administration.
  • In Microsoft Office FrontPage 2003, on the Tools menu, click Server, and then click Administration Home to get to Site Settings.
  • In Microsoft Internet Explorer, type the URL to the pages.

    The path to the Site Settings page looks like this: http://websiteurl/_layouts/lcid/settings.aspx, where lcid refers to the locale ID. For example, for U.S. English, the lcid is 1033. The path to the Site Administration page in U.S. English looks like this: http://websiteurl/_layouts/1033/webadmin.aspx.

Command-Line Administration

Windows SharePoint Services includes Stsadm.exe for command-line administration of Windows SharePoint Services servers and sites. You must be an administrator of the server computer to be able to use the Stsadm.exe tool. (The remote command-line tool for SharePoint Team Services v1.0 from Microsoft, Owsrmadm.exe, is not available.) For remote administration, use HTML Administration pages.

The Stsadm.exe tool provides a method for performing the Windows SharePoint Services administration tasks to run once, to be used in batch files, or to be used within a script. The command-line tool has a more streamlined interface than HTML Administration pages, yet allows you to perform many of the same tasks. For example, you can use the command-line tool to:

  • Add or delete users.
  • Create or delete Web sites.
  • Extend a virtual server.
  • Set database connection properties.
  • Set configuration properties.

Note For a complete list of the operations you can perform by using the command-line tools, see Command-Line Operations.

The Command-Line Tool Is Not Interactive

Stsadm.exe is not an interactive tool. With Stsadm.exe, you type the operation and parameters all at once, and you cannot be prompted for and fill in missing parameters while the operation is running. If a required parameter is missing, the operation fails, and you must type the operation and parameters again.

This behavior allows better flexibility for batching commands, since the tools do not prompt you for information after you have submitted a command. If you want a more interactive tool, try using the administrative object model or HTML Administration pages.

Using the Command-Line Tool

The command-line tool is an application for the Microsoft Windows operating systems that offers a complete set of Windows SharePoint Services operations. You can use the command-line tool from the command line or from batch files. Stsadm.exe must be run on the server computer itself.

To use the Stsadm.exe tool, you must be a member of the local Administrators group on the server computer. When you invoke Stsadm.exe, you supply an operation and a set of command-line parameters in the form:

-operation OperationName -parameter value

Note If a value you need to use with the command line tool includes a space or a character that is treated as special by the command-line interface, such as an ampersand (&), you can enclose the string in quotation marks ("). For example, if the URL to a site is http://my site, you can enter the URL as "http://my site".

Most parameters for the command line also have a short form that you can use instead of the full parameter name. For example, the following command sets the configuration database to use Server1_collab on Server1 and specifies the database user name and password to connect with:

stsadm.exe –o setconfigdb –connect -ds Server1 -dn Server1_collab
-du User1 -dp password

The following table explains the command and parameters from this example. For detailed information about each command-line operation and related parameters, see Command-Line Operations and Command-Line Parameters.

Command or parameter | Definition
-o setconfigdb | Creates a connection between Windows SharePoint Services and a configuration database.
-connect | Specifies that there is an existing configuration database to use.
-ds Server1 | Specifies the server name that contains the database to use.
-dn Server1_collab | Specifies the database name to use on that server.
-du User1 | Specifies an administrator user name for the database.
-dp password | Specifies the password for the user.

Managing Windows SharePoint Services Remotely

When you install Windows SharePoint Services, the Central Administration pages are installed to an administration port. You use these pages on the administration port to manage your server remotely. You can open Central Administration pages from any client computer, provided you know the administration port number and log on by using an account that is a member of the Administrators group on the server. You can use the Site Administration pages by using an account that is a member of a site group with the Manage Web Site right for that site.

To help secure HTML Administration pages for Windows SharePoint Services, be sure to follow the security precautions discussed in this topic.

About Remote Administration and Security

When you manage a server remotely, a wider community of users is given greater access from the Internet to that Web server, which creates a security risk. In an unsecured server, an unauthorized person could gain access to Web sites based upon Windows SharePoint Services on your server and modify Web site settings — even delete Web sites. To help prevent such tampering during remote administration and authoring, the following precautions are recommended:

  • Require the use of a non-standard HTTP port for accessing the Central Administration pages.

    This precaution makes it much more difficult for malicious users to guess the URL of HTML Administration pages or the remote administration programs. When you install Windows SharePoint Services on the Microsoft Windows platform, a random non-standard administration port is automatically used for the Central Administration pages.

    Note You can use Stsadm.exe to change this administration port number. Do not use Internet Information Services to change the administration port, because that can break the shortcut to HTML Administration pages from the Start menu.

  • Use IP address mask restrictions to prevent unauthorized computers from gaining access to the administration port.

    If you are exposing the administration virtual server externally to allow remote administration, use secure connections, and require users to have strong passwords that are frequently updated. Typically, any IP addresses that are not part of the corporate or data center domain are denied access. For more information, see the Internet Information Services (IIS) 6.0 Help system.

  • Configure the administration virtual server to require secure connections

    In IIS, configure the administration virtual server to use a secure channel (SSL). For more information, see Configuring Authentication.

Using HTML Administration Pages Remotely

When you install Windows SharePoint Services, the Central Administration pages are installed to an administration port. You use these pages on the administration port to manage your server remotely. You can open Central Administration pages from any client computer, provided you log on by using an account that has administrator access rights to the server. You can open the Site Administration pages by using an account that has administrator rights to the Web site.

If you have chosen to use Secure Sockets Layer (SSL) on your administration port, you must use the HTTPS protocol to navigate to the pages. For more information about configuring SSL, see Configuring Authentication.

Connect to the administration port by using the HTTPS protocol
  • In the Address box of your browser, use the HTTPS protocol and type the Web address to your server's administration pages, including the server port number.

    For example, https://sample.microsoft.com:1439.

After you connect to the remote HTML Administration pages, you can perform any of the administration tasks as if you were connected locally.

Changing the Administration Port

You can change the administration port for your server to a port that is easy to remember or that is a standard installation port number for your organization. To change the administration port, use the setadminport operation. The setadminport operation takes the port parameter (specifying the new port number).

Changing the administration port can only be done from the command line. You must use the Stsadm.exe tool on the server computer itself to change the administration port. To change the administration port, use the following syntax:

Stsadm.exe –o –setadminport –port <port>

Note If you are using SSL for your administration port, be sure to use the -ssl parameter with the preceding command-line syntax to ensure that the links in HTML Administration work properly. For more information, see Configuring Authentication.

Setting Configuration Properties

You can configure several features of Windows SharePoint Services by setting the values of configuration properties. For example, you can set a property to:

  • Specify whether a secondary contact name is needed when creating sites with Self-Service Site Creation.
  • Specify SMTP server settings.
  • Specify whether alerts are enabled for a virtual server.

Many properties are included as options in HTML Administration pages for your server or virtual server. Properties can also be set from the command line or by using the object model. For a complete list of the properties you can set from the command line, see Command-Line Properties.

Most properties have a default value that is used at site creation time if no other value is specified. These default values are not enforced in any way, and can be overwritten by changing the value in the HTML Administration pages or on the command line. Default values are a starting point, they are not enforced or secured.

Using the Command Line to Set Properties

You can set configuration properties by using the command-line tool Stsadm.exe and the following operations: GetProperty and SetProperty. With these operations, you can query for or set property values directly from the command line. Because the properties are available through the command-line tools, you can set configuration properties and perform other operations by using a batch file.

When you get or set a property, you must specify the level of the Web server to which the property applies: server or virtual server. You specify the level you want for the property in the syntax of the command. The following table lists the parameters to use to specify the level of a property.

Parameter | Scope
<none> | Gets or sets the property per server. The property applies to all virtual servers, sites, and subsites on the server computer.
-url | Gets or sets the property by virtual server. The property applies to sites and subsites on a single virtual server.

Setting a Property

When you set a property, you must specify the property as a string, although some properties are interpreted numerically. You must also specify the propertyname (-pn) parameter and the propertyvalue (-pv) parameter when you set a property. In the following example, the alerts-enabled property is set for the virtual server at http://servername:

Stsadm.exe –o setproperty –pn alerts-enabled –pv true -url http://servername

The alerts-enabled property specifies whether alerts are turned on or off for a virtual server.

Querying for a Property

You can retrieve the current state of a property by using the GetProperty operation. You specify the propertyname, and the propertyvalue is returned. For example, to see what the alerts-enabled property is currently set to for the virtual server at http://servername, you type:

Stsadm.exe –o getproperty –pn alerts-enabled -url http://servername

Properties and HTML Administration

Most properties that can be set from the command line are also available as options in HTML Administration pages. For example, the alerts-enabled property can be set by turning alerts on or off on the Virtual Server General Settings page. If you are mainly using HTML Administration pages to perform your administration tasks, most properties are set for you when you select options on those pages.

Related Topics

For a complete list of the operations you can perform by using the command-line tools, see Command-Line Operations.

For a complete list of the properties that you can set, see Command-Line Properties.

For a complete list of the parameters you can use with operations and properties, see Command-Line Parameters.


Administrator's Guide for Microsoft Windows SharePoint Services Copyright Information

Administrator's Guide for Microsoft Windows SharePoint Services Copyright Information

Administrator's Guide for Microsoft® Windows® SharePoint™ Services Copyright Information

Information in this document, including URL and other Internet Web site references, is subject to change without notice. Unless otherwise noted, the example companies, organizations, products, domain names, e-mail addresses, logos, people, places and events depicted herein are fictitious, and no association with any real company, organization, product, domain name, e-mail address, logo, person, place or event is intended or should be inferred. Complying with all applicable copyright laws is the responsibility of the user. Without limiting the rights under copyright, no part of this document may be reproduced, stored in or introduced into a retrieval system, or transmitted in any form or by any means (electronic, mechanical, photocopying, recording, or otherwise), or for any purpose, without the express written permission of Microsoft Corporation.

Microsoft may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering subject matter in this document. Except as expressly provided in any written license agreement from Microsoft, the furnishing of this document does not give you any license to these patents, trademarks, copyrights, or other intellectual property.

© 2001-2003 Microsoft Corporation. All rights reserved.

Microsoft, MS-DOS, Windows, Windows NT, and SharePoint are either registered trademarks or trademarks of Microsoft Corporation in the United States and/or other countries.

The names of actual companies and products mentioned herein may be the trademarks of their respective owners.


Hardware and Software Requirements

Hardware and Software Requirements

Before you install Microsoft Windows SharePoint Services on your Web server, make sure that you have installed the required hardware and software.

Web Server Hardware Requirements

Hardware requirements for your Web server vary depending on the operating system you use. The following table describes the hardware requirements for the supported operating systems.

Operating system | Requirements for single server | Requirements for server farm installation
Microsoft Windows Server 2003, Standard Edition, Enterprise Edition, Datacenter Edition, or Web Edition | Same as requirements for Windows Server 2003 | Pentium CPU/550 MHZ 1 CPU (2 recommended) 512 MB RAM

Note Windows SharePoint Services requires the NTFS file system.

Software Requirements

To run Windows SharePoint Services, you must first install the following software on your server:

  • Microsoft Windows Server 2003, Standard Edition, Enterprise Edition, Datacenter Edition, or Web Edition, configured as a Web server (running Internet Information Services 6.0 in IIS 6.0 worker process isolation mode) and running ASP.NET. For more information about installing and configuring IIS and ASP.NET, see the Windows Server 2003 family documentation.
  • Microsoft Internet Explorer 5.01 or later (best results with Microsoft Internet Explorer 5.5 or later)

    – or –

    Netscape Navigator version 6.2 or later

Database Requirements

In addition to the operating system and Web server software, you must also have a database installed on your server (or on a separate server) to run Windows SharePoint Services. The following databases are supported:

  • Microsoft SQL Server 2000, Service Pack 3
  • Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE)

If you do not have SQL Server installed on your server, WMSDE is installed automatically when you install Windows SharePoint Services. If you are using the command-line interface to install Windows SharePoint Services, or are using a script to run the installation, you can specify a separate server to use for your database.

Note Windows Server 2003, Web Edition, requires the full version of Microsoft SQL Server rather than WMSDE.

Client Requirements

Any Windows, Macintosh, or UNIX client can use Windows SharePoint Services features, providing the client runs the following software:

  • Microsoft Internet Explorer 5.01 or later (best results with Microsoft Internet Explorer 5.5 or later), Microsoft Internet Explorer 5.2 or later for Macintosh, Netscape Navigator version 6.2 or later, or Mozilla 1.4 or later
  • A client program, such as Microsoft Office 2003 (required if the user contributes documents to a Web site, but not necessary for browsing)


Microsoft Windows SharePoint Services 2.0 Architecture

Microsoft Windows SharePoint Services 2.0 Architecture

The architecture for SharePoint Team Services v1.0 from Microsoft is improved and enhanced for Microsoft Windows SharePoint Services. In Windows SharePoint Services, site settings and information, along with all site content — such as all list data, all documents in document libraries, and other page content — is now stored in the Microsoft SQL Server or Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) database. It is no longer split between the file system and the database. This change was made primarily for the following reasons:

  • To enable Windows SharePoint Services to perform well in much larger installations. Data in the database can be managed transactionally, so that the Web site does not need to be locked whenever a file is saved.
  • To improve server availability. If you have multiple stateless Web servers in a server farm, when one fails, another can take over without losing access to any content.
  • To improve the integrity of the stored data. The possibility of conflicts between database and file system information is removed, and the database can be easily backed up.

Furthermore, because the new architecture greatly reduces the dependency on the Microsoft Windows registry and the Internet Information Services (IIS) metabase for each server that runs Windows SharePoint Services, you can now create a server farm system with multiple servers and host many more Web sites than you can with SharePoint Team Services v1.0.

Windows SharePoint Services Configurations

You can choose between two configurations for Windows SharePoint Services: stand-alone server or server farm. If you anticipate only light usage of your Web sites, you can use the stand-alone server configuration. If you are supporting Web sites in a large organization or as an Internet service provider (ISP), and anticipate heavy usage and a lot of data, you will most likely want to use the server farm configuration.

Stand-alone Server Configuration

A stand-alone server configuration has the following characteristics:

  • There is a single server running Windows SharePoint Services.
  • Multiple sites and subsites are grouped in site collections on each virtual server in IIS that is extended with Windows SharePoint Services. An Internet Server Applications Program Interface (ISAPI) filter maps incoming URLs to specific sites on that virtual server.
  • Scaling is achieved by adding site collections to an existing virtual server, or by adding subsites to an existing site collection.
  • Each virtual server has its own set of content databases in SQL Server or WMSDE. The configuration database directs each virtual server to the appropriate content database for a given Web site. The content for the top-level Web site and any subsites within a site collection is stored in the same content database.

The following diagram illustrates the architecture for the Windows SharePoint Services stand-alone server configuration.

Windows SharePoint Services Architecture diagram

This diagram shows a similar architecture to the one used for SharePoint Team Services v1.0, with the exception that all data is now in the SQL Server database rather than split between the database and the file system.

Server Farm Configuration

A server farm configuration has the following characteristics:

  • There are multiple separate servers running Windows SharePoint Services and SQL Server.
  • Multiple sites and subsites are grouped in site collections on each virtual server in IIS that is extended with Windows SharePoint Services. An ISAPI filter maps incoming URLs to specific sites on that virtual server.
  • Each virtual server has its own set of content databases in SQL Server. The configuration database for the server farm directs each server to the appropriate content database for a given Web site. The content for the top-level Web site and any subsites within a site collection is stored in the same content database.
  • Performance and capacity are increased by adding additional servers running Windows SharePoint Services and SQL Server.
  • Scaling is achieved by adding more front-end Web servers (to increase throughput for the existing content), and by adding top-level Web sites and subsites (to support more content).
  • Load balancing is achieved by using switching and routing hardware, or by using software such as Windows Network Load Balancing Service.

The following diagram illustrates the architecture for the Windows SharePoint Services in a server farm configuration.

Server Farm Environment for Windows SharePoint Services

In this diagram, you can see the larger effects of the architecture change. Because site information is stored in the content databases, you can distribute the load among several front-end Web servers running Windows SharePoint Services, and they can all communicate with the appropriate database. So, a request coming from the client can go to any of the front-end Web servers and still be able to connect to the correct Web site data.

In a server farm, each front-end Web server running Windows SharePoint Services can have multiple virtual servers. Each virtual server, in turn, can have multiple site collections, which can have one top-level Web site and multiple subsites. The following diagram illustrates this hierarchy.

Windows SharePoint Services Logical Architecture

About Virtual Servers

A virtual server is a way of breaking up the Web server structure, giving you finer control over settings for particular groups of Web sites. So, rather than configuring a setting for an entire server, you can configure it for just a virtual server. You can also configure authentication on a virtual server basis, so that different virtual servers can use different authentication methods. If you have some sites that are internal to an organization, and some that are accessible from the Internet, you can host them on separate virtual servers and use the appropriate authentication method for each environment.

Note Virtual servers are called Web sites in Internet Information Services (IIS).

Using virtual servers can also allow you to isolate Web sites from one another. You can specify different application pools for each virtual server, and be sure that changes made to a site on one virtual server will not accidentally be transferred to another site on a different virtual server. For more information about application pools and processes, see Windows SharePoint Services Security Model or IIS 6.0 Help.

SharePoint Team Services v1.0 supported approximately 1000 virtual servers per server. Windows SharePoint Services supports many fewer virtual servers per front-end Web server (approximately 10). This difference is a result of the use of ASP.NET, which creates a separate set of compiled DLLs for each virtual server. Because Windows SharePoint Services uses several large DLLs, it is not practical to have them all in memory at the same time. (When you extend a virtual server, approximately 50 MB of memory is taken up by the base working set of processes, including ASP.NET.) However, because you can host multiple site collections on each virtual server, you should not need to create as many separate virtual servers in Windows SharePoint Services as were needed in SharePoint Team Services v1.0.

Structuring the URL Namespace

Windows SharePoint Services can be used in a variety of environments, from the small, departmental server to a large server farm at an ISP. To suit these environments, Windows SharePoint Services running on an IIS 6.0 platform allows you to set up your URL namespace in several configurations, each of which is based on the type of site you want to create. Windows SharePoint Services supports the following types of sites:

  • Domain-named sites

    You can create multiple Windows SharePoint Services site collections with a network domain name as the URL, for example, http://mysite or http://mysite.mycorp.com. Use domain-named sites to allow users to create short, simple URLs.

  • Subfolder-named sites

    You can also create multiple site collections that are named as subfolders of a domain URL, for example, http://myserver/sites/mysite or http://www.mycorp.com/myOffice/MyGroup/mysite. Use subfolder-named sites to show the hierarchy of sites in your organization.

You can choose between these types of sites depending on your organization's needs. After you decide which basic site types you will support, you can choose from the following namespace configurations:

  • One domain-named site per virtual server

    For example, Server1 contains http://site1, http://site2, and so on. Each top-level Web site is a separate virtual server and has its own database. This scenario allows each site to be isolated for billing or security purposes.

  • Multiple subfolder-named sites per virtual server

    For example, Server1 contains the sites http://server1/portal1, http://server1/portal2, http://server1/webapp, and so on. Each virtual server can host multiple sites based on Windows SharePoint Services, and the same virtual server can also host Web applications. All of the sites for that virtual server can share the same content database. This allows team Web sites to coexist with portals and other Web applications.

  • One domain-named site and multiple subfolder-named sites per virtual server

    For example, Server1 contains the sites http://portal/teams/site1, http://portal/teams/site2, http://portal/webapp, and so on. The virtual server contains a top-level Web site based on Windows SharePoint Services. Subfolders of that site can be Web sites based on Windows SharePoint Services, or be used for Web applications. All of the sites based on Windows SharePoint Services for the virtual server share the same database.

  • Two virtual servers hosting the same content (extranet scenario)

    For example, Server1 hosts http://portal and Server2 hosts https://portal.company.com. Both of the virtual servers (and they can be on separate server computers) share the same content database, and provide the same site content to create an intranet and extranet. The two servers can have different security settings in IIS (for example, requiring SSL access on the external site, and anonymous access for internal), but share content. Note that the Office FrontPage 2003 Recalculate hyperlinks feature cannot work in this scenario, because fixing the links for one URL path would break the links for the other.

  • Multiple domain-named sites per virtual server (large-scale hosting scenario)

    For example, Server1 hosts http://user1.company.com, http://user2.company.com, http://user3.company.com, and so on. Each of these sites is a top-level Web site on the same virtual server, but they are mapped to different URLs. There can be one or many content databases, depending on the scale.

Communication Between the Client and Server

The Office FrontPage 2003 client communicates with Windows SharePoint Services using HTTP, the same protocol Web browsers and Web servers use to communicate. FrontPage implements a remote procedure call mechanism on top of the HTTP POST request, so that the FrontPage client can request documents, update the Tasks list, add new users, and so on.

The Web server sees POST requests addressed to the Internet Server Applications Program Interface (ISAPI) filter for Windows SharePoint Services and directs those requests accordingly. FrontPage correctly communicates between client and server through proxy servers (firewalls).

Note FrontPage does not use the HTTP PUT request. As described in the HTTP specification, PUT sends a document to a Web server; however, few Web servers implement PUT. Therefore, the FrontPage client uses the universally implemented HTTP POST request for all communication with Windows SharePoint Services.

Windows SharePoint Services does not follow the "create and then publish" model you may be accustomed to with other Web sites. The moment you create a Web site based on Windows SharePoint Services it is live on the server; you do not need to publish the Web site to another server. You can still edit the Web site in a compatible Web page editor, such as Office FrontPage 2003, or add pages and documents to the site, but you do not need to publish your changes — they take effect immediately when you save the files.

Mapping URLs to Physical Paths

Windows SharePoint Services handles the mapping of incoming URLs to the site content in the databases. When using the server farm configuration, multiple sites are stored in each content database. A configuration database keeps track of which sites are mapped to which content database. The content databases themselves store all site content and provide the appropriate content when the front-end Web servers request it. In SharePoint Team Services v1.0, because site content was stored both in the file system and in the IIS metabase, IIS was responsible for URL mapping.

Because the mapping between a site and the content database is based on the site's URL, two URLs cannot point to the same site. For example, you cannot use both http://www.server_name.com/site1 and http://www.server_name.com/site2 to point to the same content in the database. You can, however, achieve the same effect by setting up http://www.server_name1.com/site1 to redirect to http://www.server_name2.com/site1. The exception to this rule is an intranet/extranet scenario, where you can have two virtual servers map to the same site content with URLs such as http://server_name/sites/site_name and http://extranet.company_name.com/sites/site_name. For more information about setting up this type of scenario, see Configuring Two Virtual Servers to Host the Same Content.

Handling ASP.NET Pages (ASPX Pages)

Windows SharePoint Services uses ASP.NET pages (Active Server Pages or ASPX pages) for forms and lists. These pages can be customized, and you can add additional ASP.NET pages to run custom solutions on top of Windows SharePoint Services.

ASP.NET pages in the _layouts directory for a SharePoint site run in direct mode, which means they are allowed to run directly. The _layouts directory contains fixed application pages for Windows SharePoint Services, such as the Create List, Create Field, and Site Settings pages. This directory is considered outside of the Web site, and these pages are supplied directly by IIS as requested.

ASP.NET pages inside a Web site run in safe mode. In safe mode, the ASP.NET page does not get compiled into a DLL and only a specific set of controls (identified previously as "safe") are allowed to run. You can edit the list of "safe" controls allowed to run in Web sites on a specific virtual server by editing the web.config file for a virtual server. For more information about customizing or adding ASP.NET pages in Windows SharePoint Services, see the Windows SharePoint Services Software Development Kit.


Upgrade Considerations

Upgrade Considerations

There are two stages in upgrading from SharePoint Team Services v1.0 from Microsoft or FrontPage 2002 Server Extensions from Microsoft to Microsoft Windows SharePoint Services:

  • First, you back up your existing Web sites using the Microsoft SharePoint Migration Tool and remove SharePoint Team Services v1.0 or FrontPage 2002 Server Extensions from the virtual servers.
  • Second, you install Windows SharePoint Services on your server computer or to a new server, and restore your Web sites to new locations on the existing server, or to the same locations on a new server.

There is no "upgrade in place" method for upgrading your server or your sites. Because Windows SharePoint Services requires Internet Information Services (IIS) to be in IIS 6.0 worker process isolation mode and SharePoint Team Services v1.0 and FrontPage 2002 Server Extensions work in IIS 5.0 isolation mode, you cannot run both the old applications and Windows SharePoint Services at the same time. Your sites are likewise always upgraded by way of migration.

You can also choose to upgrade your database from Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) to Microsoft SQL Server, if you find you need more database features or more storage capacity than are provided with WMSDE.

Considerations for Upgrading a Server from SharePoint Team Services v1.0 to Windows SharePoint Services

If you want to upgrade a server from SharePoint Team Services v1.0 or FrontPage 2002 Server Extensions to Windows SharePoint Services, consider the following changes:

  • The architecture has changed considerably. For example, you can now use Windows SharePoint Services in a server farm configuration. Also, all site content is now stored in the content databases instead of on the file system, and configuration data for a server or server farm is stored in the configuration database. For more information about the new architecture, see Windows SharePoint Services Architecture.
  • The security model has changed. For example, you can now grant Windows SharePoint Services administration rights to a specific domain group, in addition to the server's local administrators group. For more information about the new security model, see Windows SharePoint Services Architecture.
  • There are many new features, some changed features, and some features that no longer exist in the new version. For more information about features included in Windows SharePoint Services, see Introducing Windows SharePoint Services.

In addition to these general changes, several specific issues should be considered when you upgrade your server to Windows SharePoint Services. The following sections describe these areas and help you manage the upgrade process.

Upgrading from SharePoint Team Services v1.0 on Windows 2000 Server to Windows SharePoint Services on Windows Server 2003

Windows SharePoint Services requires that you be running Microsoft Windows Server 2003. If you are running SharePoint Team Services v1.0 on Windows 2000 Server, you must upgrade your server to Windows Server 2003 and then upgrade to Windows SharePoint Services. To upgrade successfully, you must perform the following steps:

  1. Use the SharePoint Migration Tool (smigrate.exe) to back up the SharePoint Team Services v1.0 Web sites. For more information about backing up Web sites, see Migrating and Upgrading Web Sites.

    Note Before you can use the SharePoint Migration Tool to migrate sites from SharePoint Team Services v1.0 to Windows SharePoint Services, you must verify that you are running the update to SharePoint Team Services v1.0 that updates it to function better with the SharePoint Migration Tool. To download this update, go to Microsoft Office XP Web Services Update.

  2. Remove SharePoint Team Services v1.0. For more information about removing SharePoint Team Services v1.0, see the SharePoint Team Services Administrator's Guide on the Microsoft TechNet Web site.

    Note When you uninstall SharePoint Team Services v1.0, some content may be left on the file system in the virtual server directory. In Windows SharePoint Services, all content is stored in the content databases, rather than on the file system, and so you no longer need this content. Because you have already backed up the Web sites, you can delete this content from the file system after you uninstall SharePoint Team Services v1.0, and before you install Windows SharePoint Services. After you install Windows SharePoint Services you can restore the Web sites, and the content will be added to the content database.

  3. Upgrade your server computer to Windows Server 2003, Standard, Enterprise, Datacenter, or Web Edition. For more information about upgrading to Windows Server 2003, see the Windows Server 2003 documentation.

    Note When you upgrade from Windows 2000 Server to Windows Server 2003, the FrontPage 2002 Server Extensions are automatically installed. If you do not need FrontPage 2002 Server Extensions, it is recommended that you remove them (from the virtual server, and from your computer) before you install Windows SharePoint Services. If you want to run both FrontPage 2002 Server Extensions and Windows SharePoint Services, you must first remove in FrontPage 2002 Server Extensions from the default Web site before installing Windows SharePoint Services. If the default site contains information that you wish to preserve, use the SharePoint Migration Tool to back up the data before removing FrontPage 2002 Server Extensions. See Migrating and Upgrading Web Sites for more information.

  4. Install and enable ASP.NET. For more information about installing ASP.NET, see the Windows Server 2003 documentation.
  5. Enable IIS and set it to run in IIS 6.0 worker process isolation mode, and then install Windows SharePoint Services. For more information, see Installation Considerations for Windows SharePoint Services, or one of the following deployment scenarios:
    • Single Server Deployment
    • Remote SQL Server Deployment
    • Server Farm with Multiple Host Names Deployment
    • Configuring Two Virtual Servers to Host the Same Content
    • Separate Active Directory Organization Unit Deployment
    • Performing a Quiet Installation
  6. Use the SharePoint Migration Tool to restore the backed up Web sites.

FrontPage 2002 Server Extensions Considerations

You cannot upgrade in place from FrontPage 2002 Server Extensions to Windows SharePoint Services. To upgrade successfully, you must perform the following steps:

  1. Use the SharePoint Migration Tool to back up the Web sites based on FrontPage 2002 Server Extensions. For more information about backing up Web sites, see Migrating and Upgrading Web Sites.
  2. Remove FrontPage 2002 Server Extensions. For more information, see the SharePoint Team Services Administrator's Guide on the Microsoft TechNet Web site.
  3. Install and enable ASP.NET. For more information about installing ASP.NET, see the Windows Server 2003 documentation.
  4. Enable IIS and set it to run in IIS 6.0 worker process isolation mode, and then install Windows SharePoint Services. For more information, see Installation Considerations for Windows SharePoint Services, or one of the following deployment scenarios:
    • Single Server Deployment
    • Remote SQL Server Deployment
    • Server Farm with Multiple Host Names Deployment
    • Configuring Two Virtual Servers to Host the Same Content
    • Separate Active Directory Organization Unit Deployment
    • Performing a Quiet Installation
  5. Use the SharePoint Migration Tool to restore the backed up Web sites.

Note that certain features from FrontPage 2002 Server Extensions, such as using ASP pages in a Web site and linking to a database file (such as an .MDB file) to display dynamic database content on a Web page, are not supported in Windows SharePoint Services and do not work in any Web sites you migrate to the new technology.

Role and Right Considerations

Note Microsoft SharePoint Products and Technologies no longer rely on role-based security for assigning rights and permissions to users. Instead, SharePoint Products and Technologies use site groups and cross-site groups to assign rights and permissions to users. Site groups are custom security groups that apply to a specific Web site. Cross-site groups are custom security groups that apply to more than one Web site. For more information, see Microsoft Windows SharePoint Services Help.

Because the site group names and definitions changed between SharePoint Team Services v1.0 and Windows SharePoint Services, the default site groups for your user accounts change when you upgrade. The new site group assignments attempt to preserve the meaning of the previous roles. The following table lists the roles in SharePoint Team Services v1.0 and the new site group assignments that take effect when you upgrade to Windows SharePoint Services.

SharePoint Team Services v1.0 role name | Windows SharePoint Services site group membership after upgrade
Administrator | Administrator
Advanced Author | Web Designer
Author | Contributor
Contributor | Reader
Browser | Reader

If you have a custom role that you created in SharePoint Team Services v1.0, a site group with the same name is created, and the Windows SharePoint Services rights that correspond to the SharePoint Team Services v1.0 rights are assigned to the site group when you upgrade. In some cases, because of changes to how Windows SharePoint Services works, there is no corresponding right. The following table lists the rights mapping between SharePoint Team Services v1.0 and Windows SharePoint Services.

SharePoint Team Services v1.0 right name | Windows SharePoint Services right
Author Lists | Add Items, Edit Items, and Delete Items
Author Pages | View Items, Add Items
Author Web Document Discussions | View Pages
Border Web | Apply Themes and Borders
Browse | View Pages
Close Web Document Discussions | View Pages
Configure Access | Manage Site Groups
Create Accounts | N/A
Design Lists | Manage Lists
Link Style Sheets | Apply Style Sheets
Manage Lists | Manage Lists
Manage Server Health | N/A
Manage Subweb | Create Subsites
Manage Usage Analysis | View Usage Data
Manage Web Document Discussions | N/A
Manage Web Subscriptions | N/A
Recalc Web | N/A
Set Source Control | N/A
Subscribe To Document | View Items
Theme Web | Apply Themes and Borders
View Lists | View Items
View Web Document Discussions | View Pages

For a complete list of the rights and site groups available in Windows SharePoint Services, see User Rights and Site Groups.

Considerations for Migrating Sites from SharePoint Team Services v1.0 to Windows SharePoint Services

You use the SharePoint Migration Tool to migrate sites from SharePoint Team Services v1.0 to Windows SharePoint Services. The site migration process is optimized for use with standard team Web sites. This means that many types of customizations do not migrate properly or do not work in a migrated site. Also, because the feature set and architecture have changed significantly between SharePoint Team Services v1.0 or FrontPage 2002 Server Extensions and Windows SharePoint Services, several features that you could use in these environments do not work in Windows SharePoint Services.

Note Before you can use the SharePoint Migration Tool to migrate sites from SharePoint Team Services v1.0 to Windows SharePoint Services, you must verify that you are running the update to SharePoint Team Services v1.0 that updates SharePoint Team Services v1.0 to function better with the SharePoint Migration Tool. To download this update, go to Microsoft Office XP Web Services Update.

The customizations and features that do not migrate include, but are not limited to, the following items:

Type of customization or feature | Explanation of migration issues
Customized home pages Home pages customized by using a Windows SharePoint Services-compatible Web page editor such as Microsoft Office FrontPage 2003 revert to the standard team Web site home page. Home pages customized in the browser retain their customizations, including views that were added and changes that were made to the Quick Launch bar.

Note When you migrate a site, the default.htm home page is replaced with a new page. The original default.htm page is renamed as default_old.htm.

Customized view and form pages | Most view and form pages customized by using a Windows SharePoint Services-compatible Web page editor such as Microsoft Office FrontPage 2003 revert to standard view and form pages. However, views created with other applications or that include settings not available in the SharePoint Team Services v1.0 browser interface will not migrate.
Customized link bars | Link bars, such as the top link bar, that were customized using a Windows SharePoint Services-compatible Web page editor such as Office FrontPage 2003 revert to the standard link bars.
Custom script files executed on the server By default, the ISAPI filter for Windows SharePoint Services blocks the use of any script files (such as ASP pages) that are executed on the server and are not part of the Windows SharePoint Services installation. If you want to use custom script files with your SharePoint sites, you must put the script files in a separate virtual directory, and create an excluded path for the directory in Windows SharePoint Services. This allows IIS to control the directory, rather than Windows SharePoint Services, and allows the ASP pages to run. Note that script files running on the client are not blocked. For more information about creating an excluded path, see Managing Paths. For more information about ASP pages in Windows SharePoint Services, see Windows SharePoint Services Architecture. To prevent script files from being included during migration, either add those file extensions to the blocked files list in the destination Windows SharePoint Services site, or remove those files from your SharePoint Team Services site before migrating. See Migrating and Upgrading Web Sites.

Caution Custom script files that are not being executed on the server can be browsed by users with read access to the folder where they are stored on the server. Browsing the files can allow users to discover information such as user names and passwords contained in the script files, as well as network paths.

Custom pages that link to SharePoint lists The SharePoint Migration Tool does not include an automatic link fixup tool. After migration, any links that you have created to point to specific lists are broken. You can update the links to refer to the current list location after migration.

Note If you have a link to a subsite, that link remains, but any links to parent Web sites or other Web sites at the same level do not work.

Customizations based on CAML | Customizations made to your site by using the Collaborative Application Markup Language (CAML) are not migrated. You must re-create these customizations. For more information about customizing SharePoint sites programmatically, see the Windows SharePoint Services Software Development Kit.
Files or folders with trailing spaces | Trailing spaces at the very end of a filename ("filename.doc ") are not supported in Windows SharePoint Services. You must change the file name and then add the file manually to your site.
Unsupported characters The following characters are not supported in Windows SharePoint Services:

/\:*?"<>|#{}%&~ or tab characters and multiple periods.

If a file, folder, or URL name in your original site contains one of these characters, it is replaced with an underscore (_). Multiple periods are replaced with a single period. Additional digits may be appended to the file or folder name if there are conflicting renaming changes.
Files with file extensions that are blocked in Windows SharePoint Services | A new feature allows server administrators to control whether specific file types can be uploaded or downloaded to the server. If a file in your site uses one of these file extensions (for example, .exe), the file are not migrated to the new site. If you know that certain file extensions are in a site you want to migrate, you can temporarily remove those file extensions from the list of blocked file extensions while you migrate the site. For more information about blocked file extensions, see Configuring Blocked File Extensions.
Long file and folder names (more than 255 characters) | File and folder names longer than 255 characters are not supported in Windows SharePoint Services. You can rename files or folders that have long names before migrating a site, or rename them after migration and add them manually to the new site.
Lists with too many fields or columns Lists in Windows SharePoint Services can only contain a certain number of fields or columns. If a list in your site contains too many fields or columns, it are not migrated. You must manually re-create the list. Note that this includes surveys. The maximum numbers for fields and columns are:
  • 64 text fields, including the following field types: Single line of text, Choice, Hyperlink, or Picture.
  • 16 Lookup fields
  • 16 Date and Time fields
  • 16 Yes/No fields
  • 32 Number and Currency fields
  • 32 Multiple lines of text fields
Links with long URLs (more than 255 characters) | URLs longer than 255 characters are not supported in Windows SharePoint Services. Note that this character limit is for the URL and description.
User account limits | User account limits are not supported in Windows SharePoint Services. If you are using Active Directory account creation mode for user accounts, you can limit the number of users per site by using quotas. For more information, see Configuring Site Quotas and Locks.
Local user accounts | Local user accounts are only supported if you are using Active Directory account creation mode with Windows SharePoint Services, and local user accounts from your original site are not automatically created during migration. If you are using local accounts, first be sure that the server you are migrating to is using Active Directory account creation mode, and then add the users to the site manually after migration. For more information, see Installation Considerations for Windows SharePoint Services and Managing Users and Cross-Site Groups.
Subscriptions | The subscriptions feature in SharePoint Team Services v1.0 changed to the Alerts feature for Windows SharePoint Services. Users can create alerts in the new site to notify them about changes. To restore subscriptions as alerts, you must be sure that alerts are enabled for the virtual server you are restoring to. Set the number of alerts to unlimited so that the restore does not stop when it reaches a limit. Also note that if a user only set up subscriptions on the original site and hasn't added information to lists or libraries, his or her subscriptions won't get migrated. To resolve this problem, the user should create a new item in a list and then delete it. For more information about alerts, see Managing Alerts.
Remote Web discussions and subscriptions | Windows SharePoint Services does not support using a server running Windows SharePoint Services in an intranet to discuss content on the Internet, nor does it support creating alerts for content on the Internet. For example, you cannot use http://server1 to create discussion items or alerts for http://www.example.com.
Web discussions and subscriptions from unavailable user accounts | If the user account for a Web discussion or subscription cannot be determined at restore time, the Web discussion or alert are restored with the user name of the administrator restoring the site.
Security from a site based on FrontPage 2002 Server Extensions | If the original server is running FrontPage 2002 Server Extensions, the security information (such as user roles) cannot be migrated.
Created By/Modified By fields | If the original user account is not available on the new server when the site is restored, the Created By and Modified By fields are set to the account that performed the restore.
Subsites that have the same name as a wildcard inclusion or exclusion | If you have set up included and excluded paths for the server that hosts the migrated sites, ensure that the names of those paths do not conflict with the names of the sites to be migrated. For example, if you had a subsite named http://server1/sites, and the /sites path on the new server is a wildcard inclusion, the http://server1/sites subsite are not migrated. For more information about included and excluded paths, see Managing Paths.
Theme applied to site | If the original site was based on SharePoint Team Services v1.0 and had a theme applied, when you restore the site, you may notice formatting issues such as the Search box being sized differently than it was. To fix these issues, apply a new theme in Windows SharePoint Services.
Specific file permissions on the file system | If you set access control lists (ACLs) on specific files or folders in your Web site, those ACLs are not restored, and the files and folders are accessible to any user with access to your restored site.
Currencies | When migrating a site from SharePoint Team Services v1.0 to Windows SharePoint Services, Windows SharePoint Services converts some obsolete currencies to their modern equivalents. For example, German Deutschmarks are converted to Euros. However, only the format of the currency field is changed. The value for each entry is not altered and must be manually converted using the desired conversion rate.
SharePoint Team Services v1.0 sites based on customized schemas | SharePoint Team Services v1.0 sites that are based on customized schema files may not migrate properly to Windows SharePoint Services. Even though the Software Development Kit (SDK) documented how to customize schema files for SharePoint Team Services v1.0, the Smigrate.exe utility does not support migrating SharePoint Team Services v1.0 sites based on customized schema files.

For more information about how to migrate Web sites, see Migrating and Upgrading Web Sites.

Considerations for Upgrading from WMSDE to SQL Server

WMSDE has only a small subset of the capabilities available with SQL Server. For example, WMSDE does not include tools for backing up and restoring the database, and WMSDE doesn't provide full-text searching of site content as SQL Server does. Also, you cannot create a server farm with multiple back-end database servers if you are using WMSDE. If you are running Windows SharePoint Services, and you originally installed with WMSDE but now want to take advantage of these capabilities with SQL Server, you can upgrade your databases from WMSDE to SQL Server. For more information about switching to SQL Server, see Migrating from WMSDE to SQL Server.


Performance Implications of Windows SharePoint Services Features

Performance Implications of Windows SharePoint Services Features

Server performance can be affected by many variables; some are predictable, others are not. For example, you can't always anticipate periods of heavy demand on a week to week basis, but you can usually predict daily periods of heavy or light use. One way to gain better control of your server's performance is to minimize the performance impact of Microsoft Windows SharePoint Services features on your server.

As with any software, some features of Windows SharePoint Services take up more resources than others. For example, features that rely on the Microsoft SharePoint Timer service, such as alerts and usage analysis log processing, can have more of an impact on your server performance than other features. This is because features that use the SharePoint Timer service are run during specific time ranges, and most of these features sort through many files on each site. By default, the time ranges for SharePoint Timer service jobs are staggered, and set to times when Web site usage is typically low. Features that use the SharePoint Timer service tend to have cyclical performance impact. When the SharePoint Timer service starts the task, server performance is affected, but after the task has been completed, performance returns to normal. Other features can affect server resources for different reasons, but usually performance is impacted when a feature must be run on demand when a user performs a particular action.

Note For more information about the performance impact of specific run-time features or features that do not scale well, see Capacity Planning for Windows SharePoint Services.

By configuring appropriate settings for features, or choosing to disable them, you can control the impact they have on performance. The following features, because of their reliance on system processes, have a greater impact on performance than other features in Windows SharePoint Services:

  • Antivirus protection

    When you enable antivirus protection, each file on the server that is uploaded or downloaded is scanned for viruses and potentially cleaned if a virus is found. This process inherently impacts the download and upload time for files. You can minimize the performance impact by setting a quicker time out for scanning and by allocating more or fewer threads to the process. For more information about changing antivirus settings, see Configuring Antivirus Protection.

  • HTML viewing

    The HTML viewing service converts files and documents into viewable HTML format. Because this viewing happens on demand, it can take up a lot of resources. It is recommended that you always use a separate server to host the HTML viewing service so that the viewing service performance does not impact the performance of your Web server. For more information about changing HTML Viewer settings, see Managing HTML Viewers.

  • Usage analysis logging and processing

    Usage analysis logging has a fairly low impact on server performance — less than 10%. However, usage log processing runs separately from the main Windows SharePoint Services process, and is a resource-intensive task. Log processing relies on the SharePoint Timer service, so one thing you can do to minimize the performance impact is to schedule log processing for times when you know use of your sites is low. You can also increase the number of log files to improve logging performance, or decrease the number of log files to improve log file processing performance. For more information about changing usage analysis settings, see Configuring Usage Analysis.

  • Site use confirmation and auto-deletion

    This feature helps you monitor and delete Web sites that are not being used. It also relies on the SharePoint Timer service to check for unused sites, to send e-mail alerts about unused sites to site administrators, and to automatically delete sites. As with any other feature that uses the SharePoint Timer service, you can configure the process to run at an appropriate time when your server is less heavily used. Also, because this feature is controlled at the virtual server level, you can stagger the times for each virtual server, so that not all virtual servers are being checked for unused sites at the same time. For more information about changing settings for site use confirmation, see Managing Unused Web Sites.

  • Alerts

    Daily and weekly alerts do not impact performance heavily, but if you have a large number of immediate alerts being sent, it can slow your server down. This feature also relies on the SharePoint Timer service, so you can specify the times for daily and weekly alerts, and you can set a longer interval for immediate alerts (the default is every 5 minutes, but you may want to extend it to 15 minutes, for example). You can also limit the number of alerts each user can sign up for, so that your server is not flooded with alert requests. Also, because alerts are controlled at the virtual server level, you can stagger the time ranges for each virtual server, so that not all virtual servers are sending alerts at the same time. Keep in mind that the only way to determine the amount of server resources being taken up by sending alerts is to monitor your SMTP server for a lot of outbound traffic. For more information about changing alert settings, see Managing Alerts.


Capacity Planning for Windows SharePoint Services

Capacity Planning for Windows SharePoint Services

This topic describes performance and scalability guidelines for Microsoft Windows SharePoint Services. The goal is to provide administrators with the information they need to purchase hardware, choose a server configuration, and manage the capacity of their Windows SharePoint Services deployments.

There are two kinds of capacity guidelines for Windows SharePoint Services:

  • Throughput — The approximate number of transactions per second that a given server configuration for Windows SharePoint Services can handle. This guideline helps you determine how many simultaneous users can use a given server resource without negatively affecting performance.
  • Scale — The approximate number of objects that can be created in a given scope, for example, the number of documents per folder. This guideline helps you determine the server configuration required to host a given number of objects.

About Capacity and Throughput Guidelines

The goal of the throughput testing is to measure the number of transactions per second that a server running Windows SharePoint Services can handle. The measured throughput is then used to extrapolate the number of simultaneous users by using a model of typical user behavior.

A rough rule of thumb is that 1 transaction per second maps to 1000 users. This rule of thumb is derived by applying the following model for user behavior:

  • 1000 users

    10% peak concurrency

  • 100 simultaneous users (10% of 1000)

    100 seconds per request per user (36 requests per hour per user)

  • 100 simultaneous users/100 seconds per user per transaction
  • 1 transaction/second

Capacity Testing Methodology

The Windows SharePoint Services team tests throughput by using automated load generation tools that work in machine time, not user time. In other words, real user behavior is not modeled in the test lab; server capacity is measured using fictitious "super users" who issue requests as fast as the server can respond. This is done to ensure that we’re measuring the capacity of the server, not the capacity of the load generation tool.

There are two main variables in the throughput testing:

  • Transaction mix — The mix of user transactions, such as browse home page, save document, and edit list item, and so on.
  • Server configuration — The configuration, such as a single server or a server farm with two Web servers, and so on.

About the Transaction Mix

The transaction mix defines the types and frequency of operations seen by the server, such browse home page, edit document, and so on. This topic contains two different transaction mixes:

  • Read/write — This is the typical SharePoint site operation mix. Most of the load is browsing to pages and documents in the site, but there is a substantial amount of list and document authoring as well. For details on the read/write operation mix, see Tested Read/Write Transaction Mix.
  • Read only — This is the typical load of a reference site where the data on the server is changing very slowly. For this mix, the entire test load is on the home page of the site. The home page is one of the most expensive pages to render, so this is a fairly conservative read-only load.

About the Server Configuration

The server configuration describes how computers are configured to run the site. Windows SharePoint Services supports a server farm design where multiple Web servers can be used to serve the same content, as in the following illustration.

Server farm configuration

Administrators can add capacity to both the Web server and database server tiers by adding more server computers to the server farm. The total capacity of the server farm depends on the number of Web servers, the number of database servers, and the ratio of Web servers to database servers.

The following configurations were tested:

  • Single computer — One computer running both the Web server and database server.
  • N-by-one server farm — One to eight computers running the Web server and a separate computer running the database server. This covers the most common server farm scenarios. These tests determine the marginal throughput increase for each additional Web server and the optimum ratio of Web servers to database servers. As the test results show, adding Web servers to the server farm adds capacity linearly until the fourth or fifth Web server. Beyond five Web servers for each database server, the system bottleneck becomes the database server. To add even more capacity you need to add a database server to the server farm.
  • Eight-by-two server farm — Eight Web servers and two database servers. This test validates the database scale out. An 8x2 server farm has roughly twice the total throughput as a 4x1 server farm. Extending the scale out model to 12x3 and 16x4 becomes a matter of providing sufficient network bandwidth for the server farm.

For the test hardware specifications, see Tested Hardware and Software.

About Throughput to Users

The Windows SharePoint Services performance lab found the peak throughput for each combination of transaction mix and server configuration. The throughput is measured in transactions per second. These transactions-per-second measurements can be converted to the total number of users using a model of typical end-user behavior. Like many human behaviors, there is a broad range of "typical" behavior. The user model for Windows SharePoint Services has two variables:

  1. Concurrency — The maximum percentage of the total user base who will be using the system simultaneously. The Windows SharePoint Services models all use 10% concurrency.
  2. Request rate — The number of requests per hour an active user generates on average. Windows SharePoint Services uses four models for user behavior:
    • Light — 20 requests per hour. An active user will generate a request every 180 seconds. Each response per second of throughput supports 180 simultaneous users and 1,800 total users.
    • Typical — 36 requests per hour. An active user will generate a request every 100 seconds. Each response per second of throughput supports 100 simultaneous users and 1,000 total users.
    • Heavy — 60 requests per hour. An active user will generate a request every 60 seconds. Each response per second of throughput supports 60 simultaneous users and 600 total users.
    • Extreme — 120 requests per hour. An active user will generate a request every 30 seconds. Each response per second of throughput supports 30 simultaneous users and 300 total users.

Throughput Data

The following table shows the throughput results for each transaction mix, server configuration, and user model. The peak throughput point is highlighted in bold.

 | Transactions per second |  | Total user count |  |  |  |  |  |
 |  |  | Light |  | Typical |  | Heavy |  | Extreme |
Configuration | Mix | Read | Mix | Read | Mix | Read | Mix | Read | Mix | Read
Single Server | 34 | 43 | 61,200 | 77,400 | 34,000 | 43,000 | 20,400 | 25,800 | 10,200 | 12,900
1 by 1 | 65 | 70 | 117,000 | 126,000 | 65,000 | 70,000 | 39,000 | 42,000 | 19,500 | 21,000
2 by 1 | 121 | 132 | 217,800 | 237,600 | 121,000 | 132,000 | 72,600 | 79,200 | 36,300 | 39,600
3 by 1 | 156 | 194 | 280,800 | 349,200 | 156,000 | 194,000 | 93,600 | 116,400 | 46,800 | 58,200
4 by 1 | 161 | 256 | 289,800 | 460,800 | 161,000 | 256,000 | 96,600 | 153,600 | 48,300 | 76,800
5 by 1 | 164 | 279 | 295,200 | 502,200 | 164,000 | 279,000 | 98,400 | 167,400 | 49,200 | 83,700
6 by 1 | 157 | 278 | 282,600 | 500,400 | 157,000 | 278,000 | 94,200 | 166,800 | 47,100 | 83,400
7 by 1 | 163 | 280 | 293,400 | 504,000 | 163,000 | 280,000 | 97,800 | 168,000 | 48,900 | 84,000
8 by 1 | 153 | 279 | 275,400 | 502,200 | 153,000 | 279,000 | 91,800 | 167,400 | 45,900 | 83,700
8 by 2 | - | 462 | - | 831,600 | - | 462,000 | - | 277,200 | - | 138,600

The following chart shows that adding additional Web servers to a single database server farm increases the capacity of the server farm, but only to a certain point. For the read-only transaction mix, the capacity of the server farm increases steadily for up to four Web servers and stops increasing at six Web servers. For the read/write mix, the capacity does not increase significantly beyond three Web servers.

Single Database Server Throughput vs. Web Server Count

Total capacity does not increase because the throughput is now limited by the one database server computer. Extending capacity beyond this point requires adding another database server to the server farm.

The following chart shows that adding an additional database server to the farm can extend the total capacity of the farm if there are sufficient web servers to handle the load.

Multiple Database Server Throughput

About Capacity and Scale Guidelines

The capacity of Windows SharePoint Services is also affected by scalability (how many objects can be created in a given scope, such as number of documents per folder). There are very few hard limits in Windows SharePoint Services. Most of the scale guidelines are determined by performance. In other words, you can exceed these guidelines, but you may find the resulting performance to be unacceptable.

One of the most important scale dimensions is site collections per database. This scale dimension depends on the number of indexes on the database. As the number of site collections increases, the performance of the system degrades as it serves more and more different site collections. As you can see in following chart, there is no hard limit where performance becomes unacceptable, but performance does degrades faster beyond 10,000 site collections and drops below 100 responses per second beyond 50,000 site collections.

Throughput vs. Site Collections

The other scale guidelines are shown in the following table. None of these are hard limits enforced by the system. They are guidelines for designing a server that has good overall performance.

Object | Scope | Guideline for optimum performance | Comment
Site collections | Database | 50,000 | Total throughput degrades as the number of site collections increases.
Web sites | Web site | 2,000 | The interface for enumerating subsites of a given Web site does not perform well much beyond 2,000 subsites.
Web sites | Site collection | 250,000 | You can create a very large total number of Web sites by nesting the subsites. For example, 100 sites each with 1000 subsites is 100,100 Web sites.
Documents | Folder | 2,000 | The interfaces for enumerating documents in a folder do not perform well beyond a thousand entries.
Documents | Library | 2 million | You can create very large document libraries by nesting folders.
Security principals | Web site | 2,000 | The size of the access control list is limited to a few thousand security principals, in other words users and groups in the Web site.
Users | Web site | 2 million | You can add millions of people to your Web site by using Microsoft Windows security groups to manage security instead of using individual users.
Items | List | 2,000 | The interface for enumerating list items does not perform well beyond a few thousand items.
Web Parts | Page | 100 | Pages with more than 100 Web Parts are slow to render.
Web Part personalization | Page | 10,000 | Pages with more than a few thousand user personalizations are slow to render.
Lists | Web site | 2,000 | The interface for enumerating lists and libraries in a Web site does not perform well beyond a few thousand entries.
Document size | File | 50 MB | The file save performance degrades as the file size grows. The default maximum is 50 MB. This maximum is enforced by the system, but you can change it to any value up to 2 GB (2047 MB) if you have applied Windows SharePoint Services Service Pack 1. For more information, see Configuring large file support in Installing and Using Service Packs for Windows SharePoint Services.

Tested Read/Write Transaction Mix

The following table describes the mix of operations that make up the read/write transaction mix. The Windows SharePoint Services team counted only meaningful end-user operations in the throughput numbers, but the load on the server includes supporting transactions as well, such as getting the images, style sheets, and JavaScript files for the home page.

End user operation | Percentage
Get home page | 9.0%
Get list page (HTML) | 9.0%
Get list page (grid) | 9.0%
Get list form | 6.0%
Get static document | 15.0%
Insert list item | 1.5%
Edit list item | 1.5%
Delete list item | 1.5%
Insert document | 1.5%
Open document for edit | 1.5%
Save document | 1.5%
Delete document | 1.5%
List URLs | 1.5%
Short term check-out | 15.0%
Get cached document | 15.0%
404 errors | 10.0%

Note There are roughly two supporting transactions for each end-user transaction. In other words, the end-user operations make up about a third of the total transaction load on the server.

Tested Hardware and Software

The following hardware was used to gather the performance and scalability data in this topic.

Web Servers

The Web server computers were Compaq DL360s with two 1 GHz Pentium 3 processors and 1 GB of memory. The computers were running a prerelease version of Microsoft Windows Server 2003, Enterprise Edition, build 3718.

Note The single computer tests were run on Web server hardware.

Database Servers

The database server computers were Compaq DL380s with two 1 GHz Pentium 3 processors and 2 GB of memory. The computers were running Microsoft SQL Server 2000 SP2 and a prerelease version of Windows Server 2003, Enterprise Edition, build 3718.


Language Considerations

Language Considerations

You use two methods to control the language settings available for Web sites based on Microsoft Windows SharePoint Services:

  • Language template packs

    Language template packs allow you to use site templates designed for specific languages. When you create a site based on a site template in a language template pack, the navigation and pages for that site are displayed in that language.

  • Regional settings

    Regional settings allow you to control how dates, times, and lists are displayed in a particular Web site. Regional settings do not control the language used for the navigation or pages in the site. For more information about regional settings, see Configuring Regional Settings.

About Languages and Locales

Windows SharePoint Services uses the following terms to describe the language settings that are used for a Web site:

  • Language ID

    The language ID specified when a Web site is created controls the language used in the Web site itself. For example, if the site was created in French (language ID 1036), all of the toolbars, navigation bars, list and form pages, and so on, appear in French. If the site was created in Arabic (1025), the text is in Arabic, and the default left-to-right orientation of the site is change to right-to-left to properly display Arabic text.

    By default, Windows SharePoint Services has language packs that contain site templates for many language IDs. You can install one or more of these language packs to your Web server to support users creating sites in as many languages as you need. For example, if you have a server running the Japanese version (language ID 1041) of Windows SharePoint Services, you can install a U.S. English (1033) language pack with templates that allow your users to create sites configured for U.S. English. New para

  • Locale ID

    The locale ID is specified on the Regional Settings page, and affects how numbers, calendars, sorting, and time are displayed in the site. For example, if you have a U.S. English language site (language ID 1033), and you change the locale ID to French (Canada) (locale ID 3084), the Events list and Calendar views reflect the French notations for dates, numbers, time, and so on. The locale ID does not affect the orientation of the site. Choosing Arabic (Egypt) (locale ID 3073) does not change the site to right-to-left orientation, but does allow you to display the Events list with dates in Arabic notation. Each language template has a default locale ID. For example, in the U.S. English (1033) template, the default locale ID is also 1033.

    Windows SharePoint Services supports all of the locale IDs supported by the Microsoft Windows Server 2003 family, which is a much larger set than the set of language IDs.

For more information about supported language IDs and locale IDs, see Regional and Language Settings.

Customizing Sites to Display Multiple Languages

When you create a site, you choose which language it is displayed in. You cannot display a site in more than one language, or change which language is used. If you need to create a site that can display more than one language, for example if you needed a site for both English and Spanish speakers, use the following method:

  1. Install the language packs that you need (in this example, US English and Spanish) to your server.
  2. Create sites based on each language pack you need (for example, one site in US English, one in Spanish).
  3. Customize one of the sites to include the strings you need from the other site.

    For example, on the US English site, use a Web page editor compatible with Windows SharePoint Services to edit the navigation strings to include both the English strings and the strings from the Spanish site. In this example, "Home" would become "Home/Pagina principal".

  4. Save the customized site as a site template, if you expect to use it again.

Because Windows SharePoint Services uses Unicode encoding, the strings from all of the languages should display correctly on the site you customize.

Installing Language Template Packs

Language template packs for Windows SharePoint Services are available as downloadable files from Windows Update. There are language template packs that you can install to support Web sites in many languages. For a list of supported languages, see Regional and Language Settings.

To install a language template pack, you simply download it from Windows Update, and then run the setup program. Note that at the end of setup, Internet Information Services (IIS) is automatically restarted. If you are in a server farm environment, you must install the language template packs to each front-end Web server in your server farm.

During installation, the site templates are added to the Windows SharePoint Services installation directory, under the \TEMPLATE\LCID directory, where LCID is the locale ID for the language. For more information about where the language template files are stored on the server, see Special Directories and Storage Locations. After installation, server administrators, members of the SharePoint administrators group, and users with the Create Subsites right or the Use Self-Service Site Creation right can create Web sites based on the language templates by selecting the language on the Create Top-Level Web Site page or the New SharePoint Site page.

If you no longer need a language template pack, you can uninstall it by using Add or Remove Programs in Control Panel. Uninstalling removes the language template files from the \TEMPLATE\LCID directories.

Caution When you uninstall a language template pack, any sites based on that language no longer work. You can reinstall the language template pack to restore the sites.


Single Server Deployment

Single Server Deployment

The quickest way to get started with Microsoft Windows SharePoint Services is to install it on a single server computer. This allows you to set up a small scale installation to host several Web sites, without performing a lot of steps. When you install Windows SharePoint Services on a single server, you can choose between the following options:

  • Using the default options during Setup, you can install Windows SharePoint Services and publish a working Web site (based on WMSDE) in minutes.

    When you install Windows SharePoint Services using the default settings, the Setup program automatically installs Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) and uses it to create the database for your Web sites. You don't have to perform any other configuration steps to create the database. This installation scenario offers you the ability to host several Web sites without a lot of overhead.

  • Using the remotesql=yes property, you can install Windows SharePoint Services to work with an existing installation of Microsoft SQL Server 2000 Service Pack 3 or later.

    This installation scenario allows you to support a larger set of Web sites. When you use this method, you must perform additional steps to configure SQL Server and Windows SharePoint Services to work together. Consider using SQL Server instead of WMSDE if you anticipate supporting more than 10 active and large Web sites.

    You can also use SQL Server on a remote server to handle larger scale installations. For more information about installing Windows SharePoint Services with a separate SQL Server computer, see Remote SQL Server Deployment.

Note The database size required for Windows SharePoint Services depends on the number and size of the Web sites your server supports.

Preparing the Server

Before you install and configure Windows SharePoint Services, you should check to make sure you meet the hardware and software requirements. The following sections help you review the requirements.

Hardware and Software Requirements

To be able to set up Windows SharePoint Services on a single server, you must meet the following criteria:

  • A computer running Microsoft Windows Server 2003 (Standard, Enterprise, Datacenter, or Web Edition). Note that the hardware requirements for Windows SharePoint Services are the same as the Windows Server 2003 installation requirements.
    • The computer must be configured as a Web server (running Internet Information Services (IIS) in IIS 6.0 worker process isolation mode) and must be running ASP.NET. For more information about installing and configuring IIS and ASP.NET, see the Windows Server 2003 documentation.
    • The computer must be using the NTFS file system. Microsoft Windows includes a conversion utility (Convert.exe) that you can use to convert an existing file allocation table (FAT) volume to NTFS — without losing data.
  • The client computers must be running Microsoft Internet Explorer 5.01 or later (best results with Microsoft Internet Explorer 5.5 or later) or Netscape Navigator 6.2 or later to use Windows SharePoint Services features.

For a complete list of hardware and software requirements, see Hardware and Software Requirements.

Configuring the Server as a Web Server

IIS is not enabled by default in Windows Server 2003. To make your front-end server into a Web server, you must enable IIS.

Enable IIS and configure it to use IIS 6.0 worker process isolation mode
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Manage Your Server.
  2. On the Manage Your Server page, click Add or remove a role.
  3. In the Preliminary Steps pane, click Next.
  4. In the Server Role pane, click Application server (IIS, ASP.NET), and then click Next.
  5. In the Web Application Server Options pane, accept the default of ASP.Net and then click Next.
  6. In the Summary of Selections pane, click Next.
  7. Click Finish.
  8. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  9. In Internet Information Services manager, click the plus sign (+) next to the server name, and then right-click the Web Sites folder and select Properties.
  10. In the Properties dialog box, click the Service tab.
  11. In the Isolation mode section, clear the Run WWW service in IIS 5.0 isolation mode check box, and then click OK.

    Note The Run WWW in IIS 5.0 isolation mode check box is only selected if you have upgraded to IIS 6.0 on Windows Server 2003 from IIS 5.0 on Windows 2000. New installations of IIS 6.0 use IIS 6.0 worker process isolation mode by default.

Installing Windows SharePoint Services with WMSDE

Because you are installing to a single, stand-alone server, you can run the Setup program as is, accepting all the defaults. In the default installation, WMSDE is installed as part of the Setup program.

Caution During Setup, in a default installation, Windows SharePoint Services extends the default virtual server (Default Web site in IIS) with Windows SharePoint Services. If you have a Web site running on the default Web site in IIS, that Web site will be taken over by Windows SharePoint Services during installation. Also, before installing Windows SharePoint Services, verify that FrontPage 2002 Server Extensions from Microsoft are not running on the virtual server on port 80. If FrontPage 2002 Server Extensions are running on the default virtual server, the virtual server will not be extended when you install Windows SharePoint Services. (If you upgraded from Windows 2000 to Windows Server 2003, FrontPage 2002 Server Extensions were installed by default to port 80.) For more information, see Installation Considerations for Windows SharePoint Services.

Install Windows SharePoint Services with default settings
  1. Download STSV2.exe to your computer.

    You can download STSV2.exe from the Microsoft Web site.

  2. Run STSV2.exe to extract the installation files and start the installation.
  3. On the End-User License Agreement page, review the terms, and then select the I accept the terms in the License Agreement check box, and then click Next.
  4. On the Type of Installation page, click Typical Installation, and then click Next.
  5. On the Summary page, click Install.
  6. Setup runs and installs Microsoft Windows SharePoint Services and WMSDE.
Install Windows SharePoint Services specifying the location of the WMSDE database

If you want to specify the location to install the WMSDE database, use the /datadir= option with the setupsts.exe command line tool.

The syntax is as follows:

setupsts.exe /datadir="path\\"

For example, to install the WMSDE database to the d:\program files\wmsdedata\ directory, type the command:

setupsts.exe /datadir="d:\program files\wmsdedata\\"

Download and install Windows SharePoint Services, specifying the location of the WMSDE database
  1. Download STSV2.exe to your computer.

    You can download STSV2.exe from the Microsoft Web site.

  2. Run STSV2.exe to extract the installation files.
  3. When the Windows SharePoint Services installation starts, click Cancel.
  4. Click Start, and then click Run.
  5. In the Open box, type c:\program files\STS2Setup_<LCID>\setupsts.exe /datadir="<path>\\" (where "LCID" is the locale ID for the version you installed, and "path" is the path where you want to install WMSDE).

    For example, if you installed the US English version of STSV2.exe, then the folder is c:\program files\STS2Setup_1033.

  6. Click OK.

    The Windows SharePoint Services Setup program opens.

  7. On the End-User License Agreement panel, review the terms, and then select the I accept the terms in the License Agreement check box, and then click Next.
  8. On the Type of Installation panel, click Typical Installation, and then click Next.
  9. On the Summary panel, click Install.
  10. Setup runs and installs Microsoft Windows SharePoint Services and WMSDE to the specified path.

After Installing Windows SharePoint Services with WMSDE

After Setup finishes, your default Web site is extended with Windows SharePoint Services. Your browser window opens to the home page of your new Web site, and you can start adding content right away, or you can customize the site or set administrative options by using HTML Administration pages. Some actions you can take to get users working with your site are:

  • Adding users to the site (for more information, see Managing Users and Cross-Site Groups).
  • Customizing the home page and other pages in the site (for more information, see Customizing a Web Site Based on Windows SharePoint Services).
  • Setting up version control (for more information, see Managing Versions and Checking Documents In and Out).

If you have multiple virtual servers, you can extend additional virtual servers with Windows SharePoint Services. To extend a virtual server, you use HTML Administration pages. For more information, see Extending Virtual Servers.

Note If you had a previous version of SharePoint Team Services or FrontPage Server Extensions, you will need to upgrade the virtual server, rather than extend it. For more information, see Upgrade Considerations.

After you have used Windows SharePoint Services with WMSDE for some time, you may run into performance or storage problems, and you may need to move to a more scaled out solution. If you find yourself in this situation, you can switch to using Microsoft SQL Server 2000 as your database instead of WMSDE. For more information, see Migrating from WMSDE to SQL Server.

Installing Windows SharePoint Services to Use SQL Server

Before you are ready to install Windows SharePoint Services, you must be sure that SQL Server 2000 is installed with Service Pack 3 or later and ready to host Windows SharePoint Services data.

If you want to use Windows SharePoint Services with SQL Server 2000 on the same computer, you must take specific steps to configure your server computer before, during, and after installing Windows SharePoint Services. For example, to set up Windows SharePoint Services, you must run Setup from the command line, using the remotesql=yes property. This topic describes the steps needed to configure a single server running both Windows SharePoint Services and SQL Server 2000. This topic does not cover using a remote SQL Server computer. For more information about using SQL Server on a remote computer, see Remote SQL Server Deployment.

Preparing SQL Server

You must configure your SQL Server installation to work with Windows SharePoint Services. For Windows SharePoint Services to be able to connect to your SQL Server database, it is recommended that you configure the SQL Server database to use Windows authentication.

Enable Windows authentication for SQL Server
  1. On your server computer, click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. In Enterprise Manager, click the plus sign (+) next to Microsoft SQL Servers.
  3. Click the plus sign (+) next to SQL Server Group.
  4. Right-click the SQL Server name, and then click Properties.
  5. In the Properties dialog box, click the Security tab.
  6. Under Authentication, select Windows only, and then click OK.

Running Setup

By default, when you install Windows SharePoint Services, the Setup program installs WMSDE. To use Windows SharePoint Services with SQL Server, you must install Windows SharePoint Services without installing WMSDE. To do so, you run the Setup program with the remotesql command-line option. For more information about the remotesql option and other Windows SharePoint Services Setup options, see Command-Line Options for Setupsts.exe. If you prefer, you can also install Windows SharePoint Services without WMSDE by running a quiet, command-line installation, rather than running the full Setup program. For more information about a quiet installation, see Performing a Quiet Installation.

Install Windows SharePoint Services without installing WMSDE
  1. Download STSV2.exe to your computer.

    You can download STSV2.exe from the Microsoft Web site.

  2. Run STSV2.exe to extract the installation files.
  3. When the Windows SharePoint Services installation starts, click Cancel.
  4. Click Start, and then click Run.
  5. In the Open box, type c:\folder\setupsts.exe remotesql=yes (where c:\folder is the path to the Setupsts.exe file on your local computer).

    For example, if you installed the US English version of STSV2.exe, then the folder is c:\program files\STS2Setup_1033.

  6. Click OK.

    The Windows SharePoint Services Setup program opens.

  7. On the End-User License Agreement page, review the terms, and then select the I accept the terms in the License Agreement check box, and then click Next.
  8. On the Type of Installation page, click Server Farm, and then click Next.
  9. On the Summary page, verify that only Windows SharePoint Services will be installed, and then click Install.
  10. Setup runs and installs Windows SharePoint Services.

After Installation

After the Setup process is complete, you can configure your administrative virtual server (including specifying an application pool to use for the virtual server processes), connect to SQL Server, and then configure your virtual servers with Windows SharePoint Services. You perform these steps by using HTML Administration pages.

Configure the administrative virtual server
  1. On the Configure Admin Virtual Server page, in the Application Pool section, select Create a new application pool.

    Note You can also use an existing application pool, but any Web application that is using the same application pool can modify the Windows SharePoint Services databases. This is a potential security risk.

  2. Type the name to use for the new application pool, and then specify whether to use a predefined or configurable security account for the application pool.
    • If you selected Predefined, select the security account to use.
    • If you selected Configurable, type the user name and password to use.

    The account you use must have rights to create databases in SQL Server. In other words, this account must be a member of the Security Administrators and Database Creators roles in SQL Server.

  3. Click OK.

If you have used an account that does not already have database creation rights in SQL Server, you can give the account this access in SQL Server Enterprise Manager. This is a one-time-only change. Once you have granted database creation permissions to the account used by the Windows SharePoint Services administration virtual server, this account can create databases for any subsequent virtual servers.

Grant database creation rights in SQL Server
  1. On your server computer, click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. In Enterprise Manager, click the plus sign (+) next to Microsoft SQL Servers, click the plus sign (+) next to SQL Server Group, and then click the plus sign (+) next to your SQL Server computer.
  3. Click the plus sign (+) next to Security, and then right-click Logins, and click New Login.
  4. In the Name box, type the account in the form DOMAIN\name.
  5. Click the Server Roles tab.
  6. In the Server Role list, select the Security Administrators and Database Creators check boxes, and then click OK.

After you configure the administrative virtual server (and grant SQL Server rights to the new application pool account, if necessary), you must restart Internet Information Services (IIS) by typing iisreset on the command line. After IIS is reset, you can click the link on the Application Pool Changed page to continue configuring Windows SharePoint Services to work with SQL Server.

Connect to SQL Server
  1. On the Set Configuration Database Server page, in the Configuration Database section, enter the server name and database name to use.
  2. Under Database connection type, select Use Windows integrated authentication (more secure, recommended).
  3. Click OK.

Extending a Virtual Server with Windows SharePoint Services

After you set up the connection to SQL Server, you are ready to extend your virtual servers with Windows SharePoint Services. When you extend a virtual server, Windows SharePoint Services is applied to a virtual server and a top-level Web site is created. To extend a virtual server, you use HTML Administration pages.

Extend a virtual server with Windows SharePoint Services and connect to SQL Server
  1. On the SharePoint Central Administration page, click Extend or upgrade virtual server.
  2. On the Virtual Server List page, click the name of the virtual server to extend.
  3. On the Extend Virtual Server page, in the Provisioning Options section, select Extend and create a content database.
  4. In the Application Pool section, select either Use an existing application pool or Create a new application pool.

    Note It is recommended that you create a new application pool for each virtual server, so that they run in separate processes. This application pool should use a domain account, but it does not need to have database creation rights in SQL Server — the administration virtual server account will create any databases required.

    If you selected Use an existing application pool, select the application pool to use. If you selected Create a new application pool, enter the new application pool name, user name, and password to use.

  5. In the Site Owner section, in the Account name box, type the user name for the site owner (in the format DOMAIN\username if the user name is part of a Windows domain group).
  6. In the E-mail address box, type the e-mail address that corresponds to the account.
  7. In the Database Information section, select the Use default content database server check box, or type the database server name and database name to use for a new content database.
  8. If you want to specify a path for the URL, in the Custom URL path box, type the path to use.

    Note If you are using quotas, you can also specify the quota template to apply in the Quota Settings section.

  9. In the Site Language section, select the language to use.
  10. Click OK.

After a few moments, the virtual server is extended and a confirmation page is displayed. You can open the home page for your new Web site in your browser by using a link on the confirmation page. You can continue to extend other virtual servers or configure Self-Service Site Creation so users can create their own sites. For more information about allowing users to create their own Web sites based on Windows SharePoint Services, see Configuring Self-Service Site Creation.


Remote SQL Server Deployment

Remote SQL Server Deployment

If you plan to host many Web sites (more than 1,000) using Microsoft Windows SharePoint Services, it is recommended that you use Microsoft SQL Server on a separate server from your Web server. Using SQL Server on its own server allows you to host all of your databases together and manage them with SQL Server management tools. Using SQL Server on its own server also allows your Windows SharePoint Services server to devote its processor, memory, and disk resources to providing pages and files. For more information about SQL Server and Windows SharePoint Services, see Windows SharePoint Services Architecture.

If you want to run SQL Server on a separate server from Windows SharePoint Services, you must take specific steps to configure both your Web server computer and your SQL Server computer before, during, and after installing Windows SharePoint Services. For example, to set up Windows SharePoint Services, you must run Setup from the command line, using the remotesql=yes property. This topic describes the steps needed to configure one server running Windows SharePoint Services and one server running SQL Server 2000, Service Pack 3 or later, working together across a network connection. This topic does not cover setting up a server farm, with multiple front-end and back-end servers. For more information about setting up a server farm, see Server Farm with Multiple Host Names Deployment.

Note Using WMSDE may be more secure than using SQL Server, because WMSDE cannot be connected to remotely.

Before Installing Windows SharePoint Services

Before you are ready to install Windows SharePoint Services, you must be sure that your Web server computer meets certain software and hardware requirements, and be able to connect to your SQL Server computer. You must also configure your SQL Server computer to be ready to host Windows SharePoint Services data.

Preparing the Web Server Computer

Before you install and configure Windows SharePoint Services, you should check to make sure you meet the hardware and software requirements. The following sections help you review the requirements.

Hardware and Software Requirements

To be able to set up Windows SharePoint Services with remote SQL Server, you must meet the following criteria:

  • One computer running Microsoft Windows Server 2003 (Standard, Enterprise, Datacenter, or Web Edition). Note that the hardware requirements for Windows SharePoint Services are the same as the Windows Server 2003 installation requirements.
    • The computer must be configured as a Web server (running Internet Information Services (IIS) in IIS 6.0 worker process isolation mode) and must be running ASP.NET. For more information about installing and configuring IIS and ASP.NET, see the Windows Server 2003 documentation.
    • The computer must be using the NTFS file system. Microsoft Windows includes a conversion utility (Convert.exe) that you can use to convert an existing file allocation table (FAT) volume to NTFS — without losing data.
  • Another computer with SQL Server 2000 Service Pack 3 or later. You can use SQL Server 2000 Standard or Enterprise edition with Windows SharePoint Services. For more information about installing SQL Server, see the SQL Server 2000 documentation.
  • The client computers must be running Microsoft Internet Explorer 5.01 or later (best results with Microsoft Internet Explorer 5.5 or later) or Netscape Navigator 6.2 or later to use Windows SharePoint Services features.

For a complete list of hardware and software requirements, see Hardware and Software Requirements.

Configuring the Intranet Server as a Web Server

IIS is not enabled by default in Windows Server 2003. To make your front-end server into a Web server, you must enable IIS.

Enable IIS and configure it to use IIS 6.0 worker process isolation mode
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Manage Your Server.
  2. On the Manage Your Server page, click Add or remove a role.
  3. In the Preliminary Steps pane, click Next.
  4. In the Server Role pane, click Application server (IIS, ASP.NET), and then click Next.
  5. In the Web Application Server Options pane, accept the default of ASP.Net, and then click Next.
  6. In the Summary of Selections pane, click Next.
  7. Click Finish.
  8. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS).
  9. In Internet Information Services manager, click the plus sign (+) next to the server name, and then right-click the Web Sites folder and select Properties.
  10. In the Properties dialog box, click the Service tab.
  11. In the Isolation mode section, clear the Run WWW service in IIS 5.0 isolation mode check box, and then click OK.

    Note The Run WWW service in IIS 5.0 isolation mode check box is only selected if you have upgraded to IIS 6.0 on Windows Server 2003 from IIS 5.0 on Windows 2000. New installations of IIS 6.0 use IIS 6.0 worker process isolation mode by default.

Preparing the SQL Server Computer

Besides configuring the connection from your Web server computer to the SQL Server computer, you must also configure your SQL Server installation to work with Windows SharePoint Services. For Windows SharePoint Services to be able to connect to your SQL Server database from the remote Web server computer, it is recommended that you configure the SQL Server database to use Windows authentication.

Enable Windows authentication for SQL Server
  1. On your SQL Server computer, click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. In Enterprise Manager, click the plus sign (+) next to Microsoft SQL Servers.
  3. Click the plus sign (+) next to SQL Server Group.
  4. Right-click the SQL Server name, and then click Properties.
  5. In the Properties dialog box, click the Security tab.
  6. Under Authentication, select Windows only, and then click OK.

    Note You can also select SQL Server and Windows but it is recommended that you use Windows authentication to connect to your SQL Server database.

Running Setup

By default, when you install Windows SharePoint Services, the Setup program installs Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE). To use Windows SharePoint Services with a remote SQL Server computer, you must install Windows SharePoint Services without installing WMSDE. To do so, you run the Setup program with the remotesql command-line option. For more information about the remotesql option and other Windows SharePoint Services Setup options, see Command-Line Options for Setupsts.exe. If you prefer, you can also install Windows SharePoint Services without WMSDE by running a quiet, command-line installation, rather than running the full Setup program. For more information about a quiet installation, see Performing a Quiet Installation.

Install Windows SharePoint Services without installing WMSDE
  1. Download STSV2.exe to your computer.

    You can download STSV2.exe from the Microsoft Web site.

  2. Run STSV2.exe to extract the installation files.
  3. When the Windows SharePoint Services installation starts, click Cancel.
  4. Click Start, and then click Run.
  5. In the Open box, type c:\folder\setupsts.exe remotesql=yes (where c:\folder is the path to the Setupsts.exe file on your local computer).

    For example, if you installed the US English version of STSV2.exe, then the folder is c:\program files\STS2Setup_1033.

  6. Click OK.

    The Windows SharePoint Services Setup program opens.

  7. On the End-User License Agreement page, review the terms, and then select the I accept the terms in the License Agreement check box, and then click Next.
  8. On the Type of Installation page, click Server Farm, and then click Next.
  9. On the Summary page, verify that only Windows SharePoint Services will be installed, and then click Install.
  10. Setup runs and installs Windows SharePoint Services.

After Installation

After the Setup process is complete, you can configure your administrative virtual server (including specifying an application pool to use for the virtual server processes), connect to your SQL Server computer, and then provide your virtual servers with Windows SharePoint Services. You perform these steps by using the SharePoint Central Administration pages, which open automatically when Setup is complete.

Configure the administrative virtual server
  1. On the Configure Admin Virtual Server page, in the Application Pool section, select Create a new application pool.

    Note You can also use an existing application pool, but any Web application that is using the same application pool can modify the Windows SharePoint Services databases. This is a potential security risk.

  2. Type the name to use for the new application pool, and then specify whether to use a predefined or configurable security account for the application pool.
    • If you selected Predefined, select the security account to use.
    • If you selected Configurable, type the user name and password to use.

    It is recommended that you use a domain account, so that the account has rights to both the front-end Web server and the back-end database server. The account you use must have rights to create databases in SQL Server. In other words, this account must be a member of the Security Administrators and Database Creators roles in SQL Server.

  3. Click OK.

If you have used a domain account that does not already have database creation rights in SQL Server, you can give the account this access in SQL Server Enterprise Manager. This is a one-time only change. Once you have granted database creation permissions to the account used by the Windows SharePoint Services administration virtual server, this account can create databases for any subsequent virtual servers.

Grant database creation rights in SQL Server

Note To use SQL Server Enterprise Manager, you must be a SQL Server database administrator.

  1. On your SQL Server computer, click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. In Enterprise Manager, click the plus sign (+) next to Microsoft SQL Servers, click the plus sign (+) next to SQL Server Group, and then click the plus sign (+) next to your SQL Server computer.
  3. Click the plus sign (+) next to Security, and then right-click Logins, and click New Login.
  4. In the Name box, type the account in the form DOMAIN\name.
  5. Click the Server Roles tab.
  6. In the Server Role list, select the Security Administrators and Database Creators check boxes, and then click OK.

After you configure the administrative virtual server (and grant SQL Server rights to the new application pool account, if necessary), you must restart Internet Information Services (IIS) by typing iisreset on the command line. After IIS is reset, you can click the link on the Application Pool Changed page to continue configuring Windows SharePoint Services to work with your remote SQL Server computer.

Connect to the remote SQL Server computer
  1. On the Set Configuration Database Server page, in the Configuration Database section, enter the server name and database name to use.
  2. Under Database connection type, select Use Windows integrated authentication (more secure, recommended).
  3. Click OK.

Extending a Virtual Server with Windows SharePoint Services

After you set up the connection to your SQL Server computer, you are ready to extend the virtual servers on your Web server computer with Windows SharePoint Services. When you extend a virtual server, Windows SharePoint Services is applied to a virtual server and a top-level Web site is created. To extend a virtual server, you use HTML Administration pages.

Note If you had a previous version of SharePoint Team Services or FrontPage Server Extensions, you will need to upgrade the virtual server rather than extend it. For more information, see Upgrade Considerations.

Extend a virtual server with Windows SharePoint Services and connect to a remote SQL Server computer
  1. On the SharePoint Central Administration page, click Extend or upgrade virtual server.
  2. On the Virtual Server List page, click the name of the virtual server to extend.
  3. On the Extend Virtual Server page, in the Provisioning Options section, select Extend and create a content database.
  4. In the Application Pool section, select either Use an existing application pool or Create a new application pool.

    Note It is recommended that you create a new application pool for each virtual server, so that they run in separate processes. This application pool should use a domain account, but it does not need to have database creation rights in SQL Server — the administration virtual server account will create any databases required.

    If you selected Use an existing application pool, select the application pool to use. If you selected Create a new application pool, enter the new application pool name, user name, and password to use.

  5. In the Site Owner section, in the Account name box, type the user name for the site owner (in the format DOMAIN\username if the username is part of a Windows domain group).
  6. In the E-mail address box, type the e-mail address that corresponds to the account.
  7. In the Database Information section, select the Use default content database server check box, or type the database server name and database name to use for a new content database.
  8. If you want to specify a path for the URL, in the Custom URL path box, type the path to use.
  9. If you are using quotas, select a template in the Select a quota template box of the the Quota Settings section.
  10. In the Site Language section, select the language to use.
  11. Click OK.

After a few moments, the virtual server is extended and a confirmation page is displayed. You can open the home page for your new Windows SharePoint Services Web site in your browser by using a link on the confirmation page. You can continue to extend other virtual servers or configure Self-Service Site Creation so users can create their own sites. For more information about allowing users to create their own Web sites based on Windows SharePoint Services, see Configuring Self-Service Site Creation.


Server Farm with Multiple Host Names Deployment

Server Farm with Multiple Host Names Deployment

You can install and configure Microsoft Windows SharePoint Services to allow your server farm to host several sites on the same virtual server using the same IP address, but multiple site names and separate content. This configuration is known as a server farm serving multiple host names. In this configuration, you have a single IP address (111.11.111.11, for example), but this same IP address can point to the following, distinct, sites:

  • Mary.MyServer.com
  • John.MyServer.com
  • ProjectTeam.MyServer.com
  • Information.MyServer.com

Each of these sites has its own content, its own set of users, and a different site owner, and can use different Windows SharePoint Services features, as the owner desires. They only share the same virtual server using the same IP address; the Web servers and configuration database make the appropriate content available, depending on the URL requested.

This topic describes the steps you need to take to configure the servers in your server farm to serve multiple host names with Windows SharePoint Services.

Note This is an advanced scenario, meant for experienced server farm administrators and Internet service providers. This is only one of several hosting choices for Windows SharePoint Services. For more information about hosting choices, see "Structuring the URL Namespace" in Windows SharePoint Services Architecture. For more information about setting up other hosting choices, see the the following topics: Single Server Deployment, Remote SQL Server Deployment, Configuring Two Virtual Servers to Host the Same Contentand Separate Active Directory Organization Unit Deployment.

Preparing the Servers

Before you can install and configure Windows SharePoint Services in your server farm, you must be sure you meet the hardware and software requirements and plan out your server farm configuration. The following sections help you determine the configuration to use.

Hardware and Software Requirements

To be able to set up Windows SharePoint Services in a server farm configuration, you must meet the following criteria:

  • The front-end Web servers must be running Microsoft Windows Server 2003 (Standard, Enterprise, Datacenter, or Web Edition). Note that the hardware requirements for Windows SharePoint Services are the same as the Windows Server 2003 installation requirements.
    • The front-end Web servers must be configured as Web servers (running Internet Information Services in IIS 6.0 worker process isolation mode) and must be running ASP.NET. For more information about installing and configuring IIS and ASP.NET, see the Windows Server 2003 documentation.
    • The front-end Web servers must be using the NTFS file system. Microsoft Windows includes a conversion utility (Convert.exe) that you can use to convert an existing file allocation table (FAT) volume to NTFS — without losing data.
  • The back-end servers must be running Microsoft SQL Server 2000 Service Pack 3 or later.
  • The client computers must be running Microsoft Internet Explorer 5.01 or later (best results with Microsoft Internet Explorer 5.5 or later) or Netscape Navigator 6.2 or later to use Windows SharePoint Services Web site features.
  • To use SQL Server Enterprise Manager, you must be a SQL Server database administrator. To configure IIS, you must be an administrator on the local computer.

For a complete list of hardware and software requirements, see Hardware and Software Requirements.

Planning for Scale

When you decide to implement a server farm, it is generally because you want to support a large-scale Web environment. Achieving scalability depends on a number of factors, each of which must be regulated in its own way. These factors include:

  • The amount of processing power available for each Web site.

    You can manage processing power by ensuring that you have appropriate load balancing up front, and a good balance between the number of front-end Web servers and SQL Server back-end servers. A recommended minimum configuration for a server farm includes three front-end Web servers and two back-end database servers.

  • The amount of disk space available for Web site content and data.

    You can manage disk space issues by using quotas to limit Web site size, and by specifying maximum sizes for content databases. For more information about using quotas and content databases, see Configuring Site Quotas and Locks and Managing Content Databases.

  • Protection from single-box failure.

    Using multiple front-end Web servers to serve the same content gives you protection from failure on the front end. You can use the failover protection included with SQL Server 2000 to help protect your back-end servers. For more information about SQL Server failover protection, see the SQL Server documentation.

  • The number of sites stored in each content database.

    You will get better results by limiting the size of each content database and simply adding more content databases when you add more sites. Smaller content databases make it easier to back up and restore or move sites. Note that database performance may degrade if you add too many databases. Balance your needs for backup and restore performance against those for database performance.

Balancing the load for the front-end Web servers is also part of the scalability equation. Windows SharePoint Services supports two methods of load balancing:

  • Software, such as Network Load Balancing (NLB) services in Windows Server 2003. NLB runs on the front-end Web servers, and uses the TCP/IP networking protocol to route requests. Because NLB (and other software load balancing solutions) runs on the front-end Web servers, it uses the front-end Web system resources, trimming the resources you can use for serving Web pages. However, the impact on system resources is not great, and a software solution can handle up to 32 front-end Web servers.
  • Hardware, such as a router or switch box. Load balancing hardware uses your network to direct Web site traffic between your front-end Web servers. Load balancing hardware is more expensive to set up than software, but does not use any of your front-end Web server resources to run. Windows SharePoint Services can be used with any load balancing hardware.

There is a third method of load balancing, round-robin load balancing with Domain Name System (DNS). Round-robin DNS load balancing uses a lot of resources on the front-end Web servers, is slower than either load balancing software or hardware, and is not recommended for use with Windows SharePoint Services.

Preparing the Back-End Database Servers

To set up your back-end database servers, you must perform the following steps.

  • Install SQL Server 2000, Service Pack 3.

    You can use SQL Server 2000 Standard or Enterprise edition with Windows SharePoint Services. Be sure to install the latest service pack for SQL Server 2000. For more information about installing SQL Server, see the SQL Server 2000 documentation.

  • Set a secure password for your SQL Server administration account.

    You must know both the administrator user account and password to be able to connect between Windows SharePoint Services on the front-end Web servers and SQL Server on the back-end servers. It is recommended that you set a secure password for the administration account. If you are using Windows authentication (recommended), you should use a domain account with permissions to create databases in SQL Server. At a minimum you must grant the account Security Administrators and Database Creators roles. If you are using SQL Server authentication, this means that the "sa" account should have a secure password. For more information about setting the administrator user name and password, see the SQL Server 2000 documentation.

  • Configure the authentication method for connections between the Web servers and SQL Server.

    For better security in your server farm, it is recommended that you use Windows NT authentication, rather than SQL Server authentication, for connections between your front-end Web servers and the back-end database servers. Windows NT authentication uses a domain user account to control access to SQL Server, rather than storing credentials in the registry and passing them across the network as in SQL Server authentication.

You configure the authentication method for SQL Server by using the SQL Server Enterprise Manager.

Configure authentication for SQL Server
  1. On the back-end database servers, click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. Click the plus sign (+) next to Microsoft SQL Servers.
  3. Click the plus sign (+) next to SQL Server Group.
  4. Right-click the SQL server name, and click Properties.
  5. In the Properties dialog box, click the Security tab.
  6. Under Authentication, select Windows only, and then click OK.

Preparing the Front-End Web Servers

To prepare your front-end Web servers for Windows SharePoint Services, you must configure them as Web servers. You must be running Internet Information Services (IIS) 6.0 on your Web servers, and you must set it to run in IIS 6.0 worker process isolation mode instead of IIS 5.0 isolation mode.

IIS is not enabled by default in Windows Server 2003. To make your front-end servers into Web servers, you must enable IIS.

Enable IIS and configure it to use IIS 6.0 worker process isolation mode
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Manage Your Server.
  2. On the Manage Your Server page, click Add or remove a role.
  3. In the Preliminary Steps pane, click Next.
  4. In the Server Role pane, click Application server (IIS, ASP.NET), and then click Next.
  5. In the Web Application Server Options pane, accept the default of ASP.Net and then click Next.
  6. In the Summary of Selections pane, click Next.
  7. Click Finish.
  8. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  9. In Internet Information Services manager, click the plus sign (+) next to the server name, and then right-click the Web Sites folder and select Properties.
  10. In the Properties dialog box, click the Service tab.
  11. In the Isolation mode section, clear the Run WWW service in IIS 5.0 isolation mode check box, and then click OK.

    Note The Run WWW service in IIS 5.0 isolation mode check box is only selected if you have upgraded to IIS 6.0 on Windows Server 2003 from IIS 5.0 on Windows 2000. New installations of IIS 6.0 use IIS 6.0 worker process isolation mode by default.

Installing and Configuring Windows SharePoint Services

After you have prepared the back-end database and front-end Web servers, you can install and configure Windows SharePoint Services on the front-end Web servers. To install and configure Windows SharePoint Services on your front-end Web servers, you perform the following steps:

  • Install Windows SharePoint Services.

    You must install Windows SharePoint Services on each front-end Web server. Using the remote SQL Server option allows you to install Windows SharePoint Services without also installing Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE).

  • Create the administration virtual server and configuration database.

    You only need to create the configuration database when you configure the first front-end Web server; for subsequent front-end servers, you can simply connect to the database.

  • Create and extend a virtual server.

    Before you can create sites, you must create a virtual server to contain them in IIS. You can create multiple virtual servers with different IP addresses, or host all of your sites using the same IP address and virtual server.

  • Create sites.

    Creating sites for users is the final step. You can also enable Self-Service Site Creation so users can create their own sites. For more information, see Configuring Self-Service Site Creation.

To perform these steps for a server farm, it is recommended that you use the command-line administration tool, Stsadm.exe. For more information about using Stsadm.exe, see Introducing the Administration Tools for Windows SharePoint Services.

Install Windows SharePoint Services with the remote SQL Server option
  1. Download STSV2.exe to your computer.

    You can download STSV2.exe from the Microsoft Web site.

  2. Run STSV2.exe to extract the installation files.
  3. When the Windows SharePoint Services installation starts, click Cancel.
  4. Click Start, and then click Run.
  5. In the Open box, type c:\folder\setupsts.exe remotesql=yes (where c:\folder is the path to the Setupsts.exe file on your local computer).

    For example, if you installed the US English version of STSV2.exe, then the folder is c:\program files\STS2Setup_1033.

  6. Click OK.

    The Windows SharePoint Services Setup program opens.

  7. On the End-User License Agreement page, review the terms, and then select the I accept the terms in the License Agreement check box, and then click Next.
  8. On the Type of Installation page, click Server Farm, and then click Next.
  9. On the Summary page, verify that only Windows SharePoint Services will be installed, and then click Install.
  10. Setup runs and installs Windows SharePoint Services.

After setup, the HTML Administration pages open so you can create the administration virtual server and configuration database. For a server farm environment, you must use the command-line administration tool to create the configuration database rather than HTML Administration. The host header (-hh) parameter is only available from the command line.

Note The host header (-hh) parameter is a one-time-only configuration choice that you only need to use when creating the configuration database for a server farm. This parameter puts Windows SharePoint Services in the scalable hosting mode and only host named sites should be created in this configuration.

Create the administration virtual server and configuration database
  1. Open a command prompt window, and navigate to the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\bin folder.
  2. Run the following command to create the administration virtual server:
    stsadm.exe -o setadminport -port <port> -admapcreatenew
  -admapidname <id for application pool>
  -admapidtype <configurableid/NetworkService/LocalService/LocalSystem>
  -admapidlogin <user account for the application pool>
  -admapidpwd <password>

    Note that you can use any unused port between 1023 and 32767.

  3. Run the following command to create the configuration database:
    stsadm.exe -o setconfigdb -ds <database server name>
  -du <database user> -dp <password> -dn sts_config -hh

    Note If you are using Windows authentication, you do not need to specify the du or dp parameter.

To connect to the configuration database from subsequent front-end Web servers, use the Set Configuration Database page in HTML Administration, or the following syntax:

stsadm.exe -o setconfigdb -ds <database server name>
  -du <database user> -dp <password> -dn sts_config -connect

Note If you are using Windows authentication, you do not need to specify the du or dp parameter.

With the administration virtual server and configuration database in place, you can create the virtual server to provide sites for your users. Each front-end Web server needs at least one virtual server for Web sites. If you do not want to use the existing default Web site you can create a new virtual server by using the following steps.

Create a virtual server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Click the plus sign (+) next to the server name you want to add a virtual server to.
  3. Right-click the Web Sites folder, click New, and then click Web site.
  4. Click Next.
  5. In the Description box, type the description of your virtual server, and then click Next.
  6. In the Enter the IP address to use for this Web site box, click All Unassigned.

    Note You can create multiple virtual servers by using IIS Host Headers with All Unassigned if necessary, but IP-bound virtual servers are not supported.

  7. In the TCP port this web site should use (Default: 80) box, type the port number to assign to the virtual server.

    You do not need to assign a host header, because the hosting is being handled through Windows SharePoint Services.

  8. Click Next.
  9. In the Path box, type or browse to the path on your hard disk where the site content will go.
  10. If you do not want to allow anonymous access to your virtual server, clear the Allow anonymous access to this Web site check box.
  11. Click Next.
  12. On the Permissions panel, select the permissions to use, and then click Next.

    The default permissions, Read and Run Scripts (such as ASP), are recommended. The Execute (such as ISAPI applications or CGI) permission will be added automatically to the appropriate folders by Windows SharePoint Services.

  13. Click Finish.

For more information about creating virtual servers, see the Adding Sites topic in the Help system for Internet Information Services.

Now that the virtual server has been created, you can extend it with Windows SharePoint Services. You can use either the command line or HTML Administration pages to extend the virtual server.

Extend the virtual server from the command line
  1. Open a command prompt window, and navigate to the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\bin folder.
  2. Run the following command to extend the virtual server:
    stsadm -o extendvs -url http://servername
  -ds <database server name> [-du <database user> -dp <password>
  -dn <database name> -ownerlogin <DOMAIN\user>
  -owneremail <email address> -ownername <display name>
  -donotcreatesite -apcreatenew -apidname <application pool name>
  -apidtype <configurableid/NetworkService/LocalService/LocalSystem>
  -apidlogin <app pool user account> -apidpwd <app pool password>

Be sure to use the donotcreatesite parameter when you extend the virtual server. Without this parameter, a site is automatically created when you extend the virtual server, and the site will not be affiliated with a host name.

Note that the du and dp parameters are not needed if you are using Windows authentication to connect to SQL Server. It is recommended that you create a new application pool to use for your virtual servers, so that they run in separate processes from the administrative virtual server. Use the same application pool for each server farm virtual server on each front-end Web server. This application pool should use a domain account, but it does not need to have database creation rights in SQL Server. The administration virtual server account will create any databases required.

Extend the virtual server using HTML Administration pages
  1. On the SharePoint Central Administration page click Extend or upgrade virtual server.
  2. On the Virtual Server List page, click the name of the virtual server to extend.
  3. On the Extend Virtual Server page, in the Provisioning Options section, select Extend and create a content database.
  4. In the Application Pool section, select either Use an existing application pool or Create a new application pool.

    Note It is recommended that you create a new application pool for each virtual server, so that they run in separate processes. This application pool should use a domain account, but it does not need to have database creation rights in SQL Server. The administration virtual server account will create any databases required.

  5. If you selected Use an existing application pool, select the application pool to use. If you selected Create a new application pool, enter the new application pool name, user name, and password to use.

  6. In the Site Owner section, in the Account name box, type the user name for the site owner (in the format DOMAIN\username if the user name is part of a Windows domain group).
  7. In the E-mail address box, type the e-mail address that corresponds to the account.
  8. In the Database Information section, select the Use default content database server check box, or type the database server name and database name to use for a new content database.
  9. If you want to specify a path for the URL, in the Custom URL path box, type the path to use.
  10. If you are using quotas, select a template in the Select a quota template box of the the Quota Settings section.
  11. In the Site Language section, select the language to use.
  12. Click OK.

Creating Sites

After following the steps above, you are ready to create sites for your users. This is the last step in the process for setting up your server farm; after this step, you can start adding users and managing the sites.

If you are setting up the multiple host names model for your server farm, you need to create the mapping for the sites you will create for users. The following example shows one way to set up a test environment with multiple host named sites. In a real deployment, you would map the host names in the Domain Name System (DNS).

Add host names for the IP address and create sites
  1. Open the c:\WINNT\system32\drivers\etc\hosts file.
  2. Add the IP address for the virtual server that will host your sites, and then add the host names to use. By default, the IP address assigned to your server will be the IP address you enter into the hosts file. You can get this IP address by opening a command prompt window and running the IPCONFIG command.

    For example,

    111.11.111.11 site1.myserver.com

    111.11.111.11 user2.myserver.com

    111.11.111.11 site2.myserver.com

    111.11.111.11 team1.myserver.com

  3. Save and close the hosts file.
  4. Open a command prompt window, and navigate to the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\bin folder.
  5. Run the following command to create a site:
    stsadm.exe -o createsite -url http://site1.myserver.com
  -ownerlogin <DOMAIN\user> -owneremail <email address>
  [-ownername <display name> -lcid <lcid>
  -sitetemplate <site template> -title <title>
  -description <description>]

  6. Repeat this step for every site you want to create.

Optionally, you may want to remove the original top-level Web site for the virtual server. To do so, use the following command line syntax:

stsadm.exe -deletesite -url http://servername

If you are setting up any of the other hosting models for your server farm, you can just create the sites.

Create a site
  1. Open a command prompt window, and navigate to the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\bin folder.
  2. Run the following command to create a site:
    stsadm.exe -o createsite -url <url>
  -ownerlogin <DOMAIN\user> -owneremail <email address>
  -ownername <display name>
  3. Repeat this step for every site you want to create.

Next Steps

Your server farm is now set up to serve Windows SharePoint Services Web sites with multiple host names. You can start adding users and managing sites, or you can perform the following optional but recommended steps:

  • It is recommended that you help protect your administration virtual server either by using a firewall to block access or by using Secure Sockets Layer (SSL) for the port. For more information, see Configuring Authentication.
  • As your sites increase in number and size, you will want to be able to add content databases or change connections to the content databases. For more information about content databases, see Managing Content Databases.


Configuring Two Virtual Servers to Host the Same Content

Configuring Two Virtual Servers to Host the Same Content

You can install and configure Microsoft Windows SharePoint Services to allow your server farm to provide the same content to two sites. In this scenario, the content is shared by the two sites, not duplicated. For example, this type of configuration would be helpful when setting up an intranet and extranet configuration. This topic discusses configuring virtual servers to share content, using an intranet/extranet deployment as an example.

Important This example does not contain explicit information about setting up firewalls or other methods of safeguarding data or resources in an extranet. To set up a more secure extranet, follow the guidelines in the Internet Information Services and Microsoft Windows Server 2003 documentation.

Note This is only one of several hosting choices for Windows SharePoint Services. For more information about hosting choices, see "Structuring the URL namespace" in Windows SharePoint Services Architecture.

Preparing the Servers

Before you can install and configure Windows SharePoint Services for both an intranet and an extranet, you must be sure you meet the hardware and software requirements. The following sections help you review the requirements.

Hardware and Software Requirements

To be able to set up Windows SharePoint Services in an intranet and extranet configuration, you must meet the following criteria:

  • The Web front-end servers must be running Microsoft Windows Server 2003 (Standard, Enterprise, Datacenter, or Web Edition). Note that the hardware requirements for Windows SharePoint Services are the same as the Windows Server 2003 installation requirements.
    • The Web front-end servers must be configured as Web servers (running Internet Information Services in IIS 6.0 worker process isolation mode) and must be running ASP.NET. For more information about installing and configuring IIS and ASP.NET, see the Windows Server 2003 Family documentation.
    • The Web front-end servers must be using the NTFS file system. Microsoft Windows includes a conversion utility (Convert.exe) that you can use to convert an existing file allocation table (FAT) volume to NTFS — without losing data.
  • The back-end servers must be running Microsoft SQL Server 2000 Service Pack 3 or later.
  • The client computers must be running Microsoft Internet Explorer 5 or later (best results with Microsoft Internet Explorer 5.5 or later) or Netscape Navigator 6.2 or later to use Windows SharePoint Services Web site features.
  • To complete the procedures that involve SQL Server in the following sections, you must be logged on using an account that is a member of the db_owner role in SQL Server.
  • To complete the procedures that involve IIS in the following sections, you must be logged on as a member of the Administrators group on the local computer, or you must be logged on using an account that is both a member of the SharePoint administrators group and that has been granted permissions to administer IIS.

For a complete list of hardware and software requirements, see Hardware and Software Requirements.

Planning for Scale

You can use the same Web front-end server to host both your intranet and extranet virtual servers, or you can split them across two separate servers. If you anticipate a heavy load on either your intranet or extranet, it is recommended that you use separate Web front-end servers for each environment, so that heavy use of your extranet server does not affect the availability of your intranet server and vice versa. This topic describes the steps to use separate Web front-end servers for each environment. You can also use multiple Web front-end servers to host both virtual servers, as in a standard server farm, to reduce potential downtime. For more information about server farms, see Server Farm with Multiple Host Names Deployment.

Preparing the Database Back-end Servers

To set up your database back-end servers, you must perform the following steps.

  • Install SQL Server 2000, Service Pack 3.

    You can use SQL Server 2000 Standard or Enterprise edition with Windows SharePoint Services. For more information about installing SQL Server, see the SQL Server 2000 documentation.

  • Set a strong password for your SQL Server administration account.

    You must know both the administrator user account and password to be able to connect between Windows SharePoint Services on the Web front-end servers and SQL Server on the back-end servers. It is recommended that you set a strong password for the administration account. If you are using Windows Authentication (recommended), then you should use a domain account with permissions to create databases in SQL Server. If you are using SQL Server authentication, this means that the "sa" account should have a strong password. For more information about setting the administrator username and password, see the SQL Server 2000 documentation.

  • Configure the authentication method for connections between the Web servers and SQL Server.

    For better security in your server farm, it is recommended that you use Windows NT authentication, rather than SQL Server authentication, for connections between your Web front-end servers and the database back-end servers. Windows NT authentication uses a domain user account to control access to SQL Server, rather than storing credentials in the registry and passing them across the network as in SQL Server authentication.

You configure the authentication method for SQL Server by using the SQL Server Enterprise Manager.

Configure Authentication for SQL Server
  1. On the database back end servers, click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. Click the plus sign (+) next to Microsoft SQL Servers.
  3. Click the plus sign (+) next to SQL Server Group.
  4. Right-click the SQL server name, and click Properties.
  5. In the Properties dialog, click the Security tab.
  6. Under Authentication, click Windows only, and then click OK.

Configuring the Intranet Front-end Server

To configure your intranet Web front-end server, you must perform the following steps.

  • Configure the intranet server as a Web server.

    You must be running Internet Information Services (IIS) 6.0 on your Web server, and you must set it to run in IIS 6.0 worker process isolation mode instead of IIS 5.0 isolation mode. To communicate with SQL Server 2000 on the back-end servers, you must also configure the front-end Web server to use the TCP/IP protocol, rather than Named Pipes (the default).

  • Create the intranet virtual server and configure the authentication method.

    If you are not using the default virtual server in IIS, you must create a new virtual server and map it to the host name of the server that will provide the content. The simplest way to set up an extranet is to use the default virtual server in IIS. Whichever method you choose, you must specify the authentication method (Integrated Windows authentication in this case) to use for the virtual server.

  • Install Windows SharePoint Services in the server farm configuration and create the administration virtual server and configuration database.

    You must install Windows SharePoint Services on each Web front-end server. Using the remote SQL Server option allows you to install Windows SharePoint Services without also installing Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE). You must also create the administration virtual server and configuration database. You only need to create the configuration database when you configure the first Web front-end server; for subsequent front-end servers (including the extranet server), you can simply connect to the database.

  • Extend the intranet virtual server.

    Before you can create sites, you must extend the intranet virtual server. The intranet virtual server is connected to the same content databases as the extranet virtual server, so that they provide the same site content.

To perform these steps for a server farm, it is recommended that you use the command-line administration tool, Stsadm.exe. For more information about using Stsadm.exe, see Introducing the Administration Tools for Windows SharePoint Services.

Configuring the Intranet Server as a Web Server

IIS is not enabled by default in Windows Server 2003. To make your front-end server into a Web server, you must enable IIS.

Enable IIS and Configure it to use IIS 6.0 worker process isolation mode
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Manage Your Server.
  2. On the Manage Your Server page, click Add or remove a role.
  3. On the Preliminary Steps pane, click Next.
  4. On the Server Role pane, click Application server (IIS, ASP.NET), and then click Next.
  5. On the Web Application Server Options pane, accept the default of ASP.Net and then click Next.
  6. On the Summary of Selections pane, click Next.
  7. Click Finish.
  8. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS).
  9. In Internet Information Services manager, click the plus sign next to the server name, and then right-click the Web Sites folder and select Properties.
  10. In the Properties dialog box, click the Service tab.
  11. In the Isolation mode section, clear the Run WWW service in IIS 5.0 isolation mode check box, and then click OK.

    Note The Run WWW service in IIS 5.0 isolation mode checkbox is only selected if you have upgraded to IIS 6.0 on Windows Server 2003 from IIS 5.0 on Windows 2000. New installations of IIS 6.0 use IIS 6.0 worker process isolation mode by default.

Creating the Intranet Virtual Server and Configuring Authentication

When IIS is configured and ready to work with SQL Server, you can create the virtual server you need to host the intranet sites.

Create a Virtual Server
  1. Click Start, point to Programs, point to Administration Tools, and then click Internet Information Services.
  2. Click the plus sign (+) next to the server name you want to add a virtual server to.
  3. Right-click the Web Sites folder, click New, and then click Web site.
  4. Click Next.
  5. In the Description box, type the description of your virtual server, and then click Next.
  6. In the Enter the IP address to use for this Web site box, click All Unassigned.

    Note You can create multiple virtual servers by using IIS Host Headers with All Unassigned if necessary, but IP-bound virtual servers are not supported.

  7. In the TCP port this web site should use (Default: 80) box, type the port number to assign to the virtual server.

    You do not need to assign a host header, because the hosting is being handled through Windows SharePoint Services.

  8. Click Next.
  9. In the Path box, type or browse to the path on your hard disk where the site content will go.
  10. If you do not want to allow anonymous access to your virtual server, clear the Allow anonymous access to this Web site check box.
  11. Click Next.
  12. On the Permissions panel, select the permissions to use, and then click Next.

    The default permissions, Read and Run Scripts (such as ASP), are recommended. The Execute (such as ISAPI applications or CGI) permission will be added automatically to the appropriate folders by Windows SharePoint Services.

  13. Click Finish.

Now you can configure the authentication method to use for the intranet virtual server.

Configure the Authentication Method for the Intranet Virtual Server
  1. On the intranet Web front-end server, in Internet Information Services, right-click the virtual server that will be used for the intranet site, and then click Properties.
  2. On the Directory Security tab, under Authentication and access control, click Edit.
  3. Select the Integrated Windows authentication check box, and clear all other authentication method check boxes.
  4. Click OK to close the Authentication Methods dialog box.
  5. Click OK again to close the Properties dialog box.

Installing and Configuring Windows SharePoint Services on the Intranet Web Front-end Server

You must install Windows SharePoint Services in the server farm configuration. To do so, you use setupsts.exe command with the remotesql property on the command line.

Install Windows SharePoint Services with the Remote SQL Server Option
  1. Download STSV2.exe to your computer.

    You can download STSV2.exe from the Microsoft Web site.

  2. Run STSV2.exe to extract the installation files.
  3. When the Windows SharePoint Services installation starts, click Cancel.
  4. Click Start, and then click Run.
  5. In the Open box, type c:\folder\setupsts.exe remotesql=yes (where c:\folder is the path to the Setupsts.exe file on your local computer).

    For example, if you installed the US English version of STSV2.exe, then the folder is c:\program files\STS2Setup_1033.

  6. Click OK.

    The Windows SharePoint Services Setup program opens.

  7. On the End-User License Agreement page, review the terms, and then select the I accept the terms in the License Agreement check box, and then click Next.
  8. On the Type of Installation page, click Server Farm, and then click Next.
  9. On the Summary page, verify that only Windows SharePoint Services will be installed, and then click Install.
  10. Setup runs and installs Windows SharePoint Services.
  11. Follow the prompts to install Windows SharePoint Services using the Server Farm installation option.

After setup, you can create the administration virtual server and configuration database. If you want to set up a server farm environment, you can use the command line administration tool to create the configuration database and include the -hh parameter. This is an advanced scenario, and is not covered in this topic. For more information, see Server Farm with Multiple Host Names Deployment.

Create the Administration Virtual Server from the Command Line
  1. Open a command prompt window, and navigate to the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\bin folder.
  2. Run the following command to create the administration virtual server:
    stsadm.exe -o setadminport -port <port> -admapcreatenew
  -admapidname <id for application pool>
  -admapidtype <configurableid/NetworkService/LocalService/LocalSystem>
  -admapidlogin <user account for the application pool>
  -admapidpwd <password>

    Note that you can use any unused port between 1023 and 32767. The application pool account must have database owner (DBO) rights to the SQL Server computer to be able to create the configuration database. It is recommended that you use a dedicated domain account for this account, rather than a user's login account. Also, it is recommended that you use the same account for each application pool that hosts the same content.

If you have used a domain account that does not already have database creation rights in SQL Server, you can give the account this access in SQL Server Enterprise Manager. This is a one-time only change. Once you have granted database creation permissions to the account used by the Windows SharePoint Services administration virtual server, this account can create any subsequent databases. You do not need database creation rights to connect to a configuration database, which you will do when you set up the Web front-end server for the extranet.

Grant Database Creation Rights in SQL Server
  1. On your SQL Server computer, click Start, point to Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. In Enterprise Manager, click the plus sign (+) next to Microsoft SQL Servers, click the plus sign (+) next to SQL Server Group, and then click the plus sign next to your SQL Server.
  3. Click the plus sign (+) next to Security, and then right-click Logins, and click New Login.
  4. In the Name box, type the account in the form DOMAIN\name.
  5. Click the Server Roles tab.
  6. In the Server Role list, select the Security Administrators and Database Creators check boxes, and then click OK.

After you configure the administrative virtual server (and grant SQL Server rights to the new application pool account, if necessary), you must restart Internet Information Services (IIS), by typing iisreset on the command line. After IIS is reset, you can continue configuring Windows SharePoint Services to work with your remote SQL Server.

Create the Configuration Database from the Command Line
  • Run the following command to create the configuration database:
    stsadm.exe -o setconfigdb -ds <database server name> -dn sts_config

The syntax above is for Windows authentication. If you are using SQL Server authentication, you must also specify the -du and -dp parameters with the database username and password. To connect to the configuration database from subsequent Web front-end servers, use the following syntax:

stsadm.exe -o setconfigdb -ds <database server name> [-du <database user>
-dp <password>] -dn sts_config
Create the Administration Application Pool and Configuration Database using HTML Administration Pages
  1. When Setup finishes, you are taken to the Configure Admin Virtual Server page.
  2. In the Application Pool section, select Create a new application pool.
  3. Under Select a security account for this application pool, select Configurable.
  4. In the User name box, type the domain account to use for the application pool.

    This account must have database owner (DBO) rights to the SQL Server computer to be able to create the configuration database. It is recommended that you use a dedicated account for this account, rather than a user's login account. Also, it is recommended that you use the same account for each application pool that hosts the same content.

  5. In the Password box, type the password for the account, and then confirm it, and click OK.

    The application pool is created, and you are taken to a confirmation page. You must restart IIS to accept the change.

  6. After restarting IIS, click the link to continue, and on the Create Configuration Database page, in the Configuration Database section, enter the server name and database name to use.
  7. Select Use Windows integrated authentication (more secure, recommended).
  8. In the Active Directory Account Creation section, select Users already have domain accounts if you are using a Windows domain, or Automatically create active directory accounts for users of this site if you are using Active Directory outside of a Windows domain.
  9. If you selected Automatically create active directory accounts for users of this site, you must fill in the Active Directory Domain and Organization Unit information.
  10. Click Submit.
  11. On the SharePoint Central Administration page, under Server Configuration, click Set default content database server.
  12. On the Content Database Server page, in the Content Database Server section, enter the server name, administrator account username, and password.
  13. Click Submit.

Extending the Intranet Virtual Server

With the administration virtual server and configuration database in place, you can extend the virtual server to host the intranet sites. You can use either the command line or HTML Administration pages to extend the virtual server.

Extend the Virtual Server using the Command Line
  1. Open a command prompt window, and navigate to the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\bin folder.
  2. Run the following command to extend the intranet virtual server:
    stsadm.exe -o extendvs -url http://servername
  -ownerlogin <DOMAIN\username> -owneremail <e-mail address>
  [-du <database user> -ds <database server> -dn <database name>
  -dp <database password> -lcid <locale ID> -sitetemplate <template name>
  -apcreatenew -apidname <application pool name>
  -apidtype <configurableid/NetworkService/LocalService/LocalSystem>
  -apidlogin <DOMAIN\username> -apidpwd <password>]

Note that while the apid... parameters are optional, it is recommended that you create a new application pool for the virtual server. Use a dedicated application pool account, not a user login account. The application pool account for a virtual server does not need database owner rights on the SQL Server computer. Note that the -du and -dp parameters are not needed if you are using Windows authentication to connect to SQL Server.

Extend the Virtual Server using HTML Administration Pages
  1. On the SharePoint Central Administration page click Extend or upgrade virtual server.
  2. On the Virtual Server List page, click the name of the virtual server to extend.
  3. On the Extend Virtual Server page, in the Provisioning Options section, select Extend and create a content database.
  4. In the Application Pool section, select Create a new application pool.
  5. Under Select a security account for this application pool, select Configurable.
  6. In the User name box, type the domain account to use for the application pool.

    It is recommended that you use a dedicated account for this account, rather than a user's login account. Also, it is recommended that you use the same account for each application pool that hosts the same content.

  7. In the Password box, type the password for the account, and then confirm it.
  8. In the Site Owner section, in the Account name box, type the user name for the site owner (in the format DOMAIN\username if the username is part of a Windows domain group).
  9. In the E-mail address box, type the e-mail address that corresponds to the account.
  10. In the Database Settings section, enter the following database connection information:
    • In the Database server box, type the server name for your SQL Server.
    • In the Database name box, type the name to use for your content database.
  11. If you want to specify a path for the URL, in the Custom URL path box, type the path to use.
  12. If you are using quotas, select a template in the Select a quota template box of the Quota Settings section.
  13. In the Site Language section, select the language to use.
  14. Click OK.

Note For a basic test scenario where you are hosting the same content from two virtual servers, you can create a second virtual server on the intranet front-end server and extend it using the Extend and connect to an existing content database. On the Extend and Connect to an Existing Content Database page, select the first virtual server you extended. When you click OK, the content will be hosted from both virtual servers.

Configuring the Extranet Front-end Server

To configure your extranet Web front-end server, you must perform the following steps.

  • Configure the server as a Web server.

    You must be running Internet Information Services (IIS) 6.0 on your Web server, and you must set it to run in IIS 6.0 worker process isolation mode instead of IIS 5.0 isolation mode.

  • Switch to using the TCP/IP protocol for the connections between the Web servers and SQL Server.

    To communicate with SQL Server 2000 on the back-end servers, you must configure the front-end Web servers to use the TCP/IP protocol, rather than Named Pipes (the default).

  • Create a virtual server and configure the authentication method.

    Before you can create sites for your extranet, you must create the virtual server to contain them in IIS, and specify the authentication method to use (Basic authentication with Secure Sockets Layer in this case).

  • Install Windows SharePoint Services in the server farm configuration.

    You must install Windows SharePoint Services on each Web front-end server. Using the remote SQL Server option allows you to install Windows SharePoint Services without also installing Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE). You must also create an application pool for the extranet sites and connect to the configuration database after installation.

  • Extend the virtual server.

    Before you can create sites, you must extend the extranet virtual server. The extranet virtual server is connected to the same content databases as the intranet virtual server, so that they provide the same site content.

To perform these steps for a server farm, it is recommended that you use the command-line administration tool, Stsadm.exe. For more information about using Stsadm.exe, see Introducing the Administration Tools for Windows SharePoint Services.

IIS is not enabled by default in Windows Server 2003. To make your front-end servers into Web servers, you must enable IIS.

Enable IIS and configure it to use IIS 6.0 worker process isolation mode
  1. Click Start and then click Manage Your Server.
  2. On the Manage Your Server page, click Add or remove a role.
  3. On the Preliminary Steps pane, click Next.
  4. On the Server Role pane, click Application server (IIS, ASP.NET), and then click Next.
  5. On the Web Application Server Options pane, accept the default of ASP.Net and then click Next.
  6. On the Summary of Selections pane, click Next.
  7. Click Finish.
  8. Click Start, point to Administrative Tools, and then click Internet Information Services (IIS).
  9. In Internet Information Services manager, click the plus sign next to the server name, and then right-click the Web Sites folder and select Properties.
  10. In the Properties dialog box, click the Service tab.
  11. In the Isolation mode section, clear the Run WWW service in IIS 5.0 isolation mode check box, and then click OK.

When IIS is configured and ready to work with SQL Server, you can create the virtual server you need to host the extranet sites.

Create a Virtual Server
  1. Click Start, point to Programs, point to Administration Tools, and then click Internet Information Services.
  2. Click the plus sign (+) next to the server name you want to add a virtual server to.
  3. Right-click the Web Sites folder, click New, and then click Web site.
  4. Click Next.
  5. In the Description box, type the description of your virtual server, and then click Next.
  6. In the Enter the IP address to use for this Web site box, choose All Unassigned.

    Note You can create multiple virtual servers using IIS Host Headers with All Unassigned if necessary, but IP bound virtual servers are not supported.

  7. In the TCP port this web site should use (Default: 80) box, type the port number to assign to the virtual server.
  8. In the Host Header for this site (Default: None) box, type the header you want to use, and then click Next.
  9. In the Path box, type or browse to the path on your hard disk where the site content will go.
  10. Clear the Allow anonymous access to this Web site check box, and then click Next.
  11. On the Permissions panel, select the permissions to use, and then click Next.

    If other users are allowed to contribute to the site, you must select at least the Read, Write, and Browse check boxes. If your virtual server allows scripts to be run, you must also select the Run scripts (such as ASP) check box. If you want to allow ISAPI applications or CGI scripts to be used on your virtual server, you must also select the Execute (such as ISAPI applications or CGI) check box.

  12. Click Finish.

Now you can configure the authentication method to use for the extranet virtual server.

Configure the Authentication Method for the Extranet Virtual Server
  1. On the extranet Web front-end server, in Internet Information Services, right-click the virtual server that will be used for the extranet site, and then click Properties.
  2. On the Directory Security tab, under Authentication and access control, click Edit.
  3. Select the Basic authentication check box, and clear all other authentication method check boxes.
  4. Click OK to close the Authentication Methods dialog box.
  5. On the Directory Security tab, under Secure communications, click Edit.
  6. On the Secure Communications dialog box, select the Require secure channel (SSL) check box, and then click OK.
  7. Click OK again to close the Properties dialog box.

Note You must have a certificate before you can enable SSL. For more information about SSL certificates, see the topics About Certificates and Setting Up SSL on Your Server in IIS 6.0 online Help. For more information about IIS authentication methods, see the topic About authentication in IIS 6.0 online Help.

After you have configured the authentication method, you can install Windows SharePoint Services.

Installing and Configuring Windows SharePoint Services on the Extranet Web Front-end Server

You must install Windows SharePoint Services in the server farm configuration. To do so, you use setupsts.exe command with the remotesql property on the command line.

Install Windows SharePoint Services with the Remote SQL Server Option
  1. Download STSV2.exe to your computer.

    You can download STSV2.exe from the Microsoft Web site.

  2. Run STSV2.exe to extract the installation files.
  3. When the Windows SharePoint Services installation starts, click Cancel.
  4. Click Start, and then click Run.
  5. In the Open box, type c:\folder\setupsts.exe remotesql=yes (where c:\folder is the path to the Setupsts.exe file on your local computer).

    For example, if you installed the US English version of STSV2.exe, then the folder is c:\program files\STS2Setup_1033.

  6. Click OK.

    The Windows SharePoint Services Setup program opens.

  7. On the End-User License Agreement page, review the terms, and then select the I accept the terms in the License Agreement check box, and then click Next.
  8. On the Type of Installation page, click Server Farm, and then click Next.
  9. On the Summary page, verify that only Windows SharePoint Services will be installed, and then click Install.
  10. Setup runs and installs Windows SharePoint Services.

After setup, you can create the administration virtual server and connect to the configuration database. You can use either the command line or HTML Administration pages to create the administration virtual server and connect to the configuration database.

Set the Application Pool for the Administration Virtual Server and Connect to the Configuration Database from the Command Line
  1. Open a command prompt window, and navigate to the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\bin folder.
  2. Run the following command to create the administration virtual server:
    stsadm.exe -o setadminport -port <port> -admapcreatenew
  -admapidname <id for application pool> -admapidtype configurableid
  -admapidlogin <DOMAIN\username> -admapidpwd <password>

    Note that you can use any unused port between 1023 and 32767. It is recommended that you use a dedicated account for the application pool account, rather than a user's login account. Also, it is recommended that you use the same account for each application pool that hosts the same content.

  3. Restart IIS by running iisreset on the command line.
  4. Run the following command to connect to the configuration database:
    stsadm.exe -o setconfigdb -ds <database server name>
  [-du <database user> -dp <password>] -dn sts_config

The syntax above is for Windows authentication. If you are using SQL Server authentication, you must also specify the -du and -dp parameters with the database username and password.

Set the Application Pool for the Administration Virtual Server and Connect to the Configuration Database using HTML Administration Pages
  1. When Setup finishes, you are taken to the Security and Configuration Database page.
  2. In the Application Pool section, select Define a new application pool.
  3. Under Select a security account for this application pool, select Configurable.
  4. In the User name box, type the domain account to use for the application pool.

    This account must have database owner (DBO) rights to the SQL Server computer to be able to create the configuration database. It is recommended that you use a dedicated account for this account, rather than a user's login account. Also, it is recommended that you use the same account for each application pool that hosts the same content.

  5. In the Password box, type the password for the account, and then confirm it, and click OK.

    The application pool is created, and you are taken to a confirmation page. You must restart IIS to accept the change. To restart IIS, type iisreset on the command line.

  6. After restarting IIS, click the link to continue, and on the Create Configuration Database page, in the Configuration Database section, enter the server name and database name for the existing configuration database.
  7. Select Use Windows integrated authentication (more secure, recommended).
  8. Select the Connect to existing database check box.
  9. In the Active Directory Account Creation section, select Users already have domain accounts if you are using a Windows domain, or Automatically create active directory accounts for users of this site if you are using Active Directory outside of a Windows domain.
  10. If you selected Automatically create active directory accounts for users of this site, you must fill in the Active Directory Domain and Organization Unit information.
  11. Click Submit.
  12. On the SharePoint Central Administration page, under Central Configuration Settings and Defaults, click Set default content database server.
  13. On the Content Database Server page, in the Content Database Server section, enter the server name, administrator account username, and password.
  14. Click Submit.

Extending the Extranet Virtual Server

With the administration virtual server and configuration database in place, you can extend the virtual server to host the extranet sites. You can use either the command line or HTML Administration pages to extend the virtual server.

Extend the extranet virtual server
  1. Open a command prompt window, and navigate to the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\bin folder.
  2. Run the following command to extend the extranet virtual server.
    stsadm.exe -o extendvsinwebfarm
  -url https://www.servername.extranet.com
  -vsname <virtual server name> [-apcreatenew
  -adpidname <application pool name> -apidtype configurableid
  -apidlogin <DOMAIN\name> -apidpwd <password>]

    The -vsname parameter is the IIS name of the internal virtual server you extended earlier. For example, if you are using a site named "mysite" in IIS, then the -vsname value would be mysite. It is recommended that you create a new application pool for the virtual server. Use a dedicated application pool account, not a user login account. The application pool account for a virtual server does not need database owner rights on the SQL Server computer. Note that the -du and -dp parameters are not needed if you are using Windows authentication to connect to SQL Server.

Extend the Virtual Server using HTML Administration Pages
  1. Click Start, point to Programs, point to Administration Tools, and then click SharePoint Central Administration.
  2. Click Extend or upgrade virtual server.
  3. On the Virtual Server List page, click the virtual server you want to extend.
  4. On the Extend Virtual Server page, click Extend and connect to existing content database.
  5. On the Extend and Connect to Existing Content Database page, in the Server Mapping section, in the Host name or IIS virtual server name box, select the name of the host or virtual server that you want to use.
  6. In the Application Pool section, select Create a new application pool.
  7. Under Select a security account for this application pool, select Configurable.
  8. In the User name box, type the domain account to use for the application pool.

    It is recommended that you use a dedicated account for this account, rather than a user's login account. Also, it is recommended that you use the same account for each application pool that hosts the same content.

  9. In the Password box, type the password for the account, and then confirm it.
  10. Click Submit.

Creating Sites

After following the steps above, you are ready to create sites for your users. This is the last step in the process for setting up your intranet/extranet server farm. After this step, you can start adding users and managing the sites.

Create a Site
  1. Open a command prompt window, and navigate to the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\bin folder.
  2. Run the following command to create a site:
    stsadm.exe -o createsite -url <url>  -ownerlogin <DOMAIN\username>
  -owneremail <email address> [-ownername <display name>
  -lcid <lcid> -sitetemplate <site template> -title <title>
  -description <site description>]

Repeat this step for every site you want to create. Note that because both your intranet and extranet virtual servers connect to the same content database, the same sites are available in each environment.

Next Steps

Your server farm is now set up for serving the same content on both an intranet and extranet. You can start adding users and managing sites, or you can perform the following optional, but recommended steps:

  • It is recommended that you help protect your administration virtual server by either using a firewall to block access, or by using Secure Sockets Layer (SSL) for the port. For more information, see Configuring Authentication.
  • As your sites increase in number and size, you will want to be able to add content databases or change connections to the content databases. For more information about content databases, see Managing Content Databases.


Separate Active Directory Directory Service Organization Unit Deployment

Separate Active Directory Directory Service Organization Unit Deployment

A new feature of Microsoft Windows SharePoint Services is account creation mode for Active Directory directory service. This feature replaces the local account creation feature in SharePoint Team Services v1.0 from Microsoft. Use Active Directory account creation mode when it is necessary to create new user accounts rather than using existing domain accounts. For example, an Internet service provider (ISP) may need the ability to allow SharePoint site owners the capability to create user accounts or invite users to collaborate on a Web site where existing domain accounts for those users do not already exist.

In order to run Windows SharePoint Services in Active Directory account creation mode, your Web servers must be members of a Microsoft Windows 2000 or Microsoft Windows Server 2003 domain.

Note Active Directory account creation mode is not supported when you install Windows SharePoint Services to a domain controller computer.

There are two modes that you can choose from when you install and configure Windows SharePoint Services with a separate Microsoft Active Directory directory service organizational unit:

  • Nonscalable hosting mode — a simple configuration with one server running Microsoft SQL Server 2000 Service Pack 3 or later and Windows SharePoint Services and one domain controller.
  • Scalable hosting mode — an advanced configuration with a server farm containing multiple front-end Web servers running Windows SharePoint Services and one or more back-end database servers running SQL Server 2000 Service Pack 3 or later, plus one or more domain controllers.

To configure either mode, you follow the same process. First, you prepare the domain controller by:

  1. Creating a domain controller account for Windows SharePoint Services processes.
  2. Creating an organizational unit (OU) for the user accounts.
  3. Delegating permissions to the organizational unit.

Then you prepare the Web server computers by:

  1. Installing Windows SharePoint Services with the remotesql=yes property.
  2. Creating the administration virtual server application pool.
  3. Configuring SQL Server with permissions for Windows SharePoint Services.
  4. Creating the configuration database and specifying Active Directory account creation mode.
  5. Specifying the e-mail server settings.
  6. Extending a virtual server.
  7. Specifying the host name for the first site (scalable hosting mode only).
  8. Creating a site.

The steps for preparing the domain controller are the same for either mode. The steps for preparing the Web server computers differ slightly. When you are using scalable hosting mode you must be sure to use the hh parameter when you create the configuration database.

You must have at least one member Web server with SQL Server 2000 Service Pack 3 or later installed and at least one domain controller to be able to configure Windows SharePoint Services in Active Directory account creation mode following the steps below.

Preparing the Domain Controller

Whether you are planning a smaller installation of Windows SharePoint Services (nonscalable hosting mode) or a large server farm (scalable hosting mode), you follow the same steps to prepare your domain controller computer.

Create a domain controller account for Windows SharePoint Services processes
  1. On the domain controller, create an account that will be used by Windows SharePoint Services to create new domain accounts.

    For example, create a new account called SharePoint_admin.

  2. Configure the account such that the password does not need to be changed at the next logon and does not expire.

The account must be a member of the Domain Users group, which is the default group for new accounts. For more information about creating an account on your domain controller, see the Windows Server 2003 Help system.

After the domain controller account has been created, you need to define an organizational unit within which Windows SharePoint Services can create new user accounts. You must use the same organizational unit for all user accounts for Windows SharePoint Services within a server farm.

Caution When configuring your server in Active Directory account creation mode, it is recommended that the server administrator account is not in the same organizational unit as the one used for creating accounts. The application pool identities associated with each virtual server must have permissions to change account properties in the defined organizational unit. This configuration allows site collection administrators to have the right to change some properties (such as the password) in that organizational unit. Because of this, it is strongly recommended that you do not add any accounts in the defined Windows SharePoint Services account creation organizational unit, and only allow the accounts that Windows SharePoint Services creates.

Create an organizational unit (OU) for the user accounts
  1. On your Active Directory server, click Start, point to All Programs, point to Administrative Tools, and then click Active Directory Users and Computers.
  2. Right-click the Active Directory domain name, click New, and then click Organizational Unit.
  3. Type a name for the organizational unit.

    For example, name the organizational unit "sharepoint_ou" for simplicity.

  4. Click OK.

For more information about creating an organizational unit, see the Windows Server 2003 Help system.

In order for Windows SharePoint Services to have permissions to create accounts in the sharepoint_ou organizational unit, the domain controller account must have the correct permissions delegated to it.

Note The steps below reflect the user interface for Windows Server 2003 and may vary from a Windows 2000 domain controller. For more information about delegating permissions to an organizational unit, see the Help system for Windows Server 2003 or Windows 2000.

Delegate permissions to the organizational unit
  1. On your Active Directory server, click Start, point to All Programs, point to Administrative Tools, and then click Active Directory Users and Computers.
  2. Right-click the new organizational unit, and then click Delegate control.
  3. In the Welcome pane, click Next.
  4. In the Users and Groups pane, click Add.
  5. In the Enter the object names to select box, type the user name that you are planning to use for the administration application pool identity, and then click OK.
  6. Click Next.
  7. In the Tasks to Delegate pane, select the Create, delete, and manage user accounts check box and the Read all user information check box, and then click Next.
  8. Click Finish.

Configuring the Web Server Computers

To use Active Directory account creation mode, you must install Windows SharePoint Services without installing WMSDE. To do so, you use the remotesql=yes property. Note that this property is used even if your SQL Server installation is on the same computer.

Install Windows SharePoint Services with the remotesql=yes property
  1. Download STSV2.exe to your computer.

    You can download STSV2.exe from the Microsoft Web site.

  2. Run STSV2.exe to extract the installation files.
  3. When the Windows SharePoint Services installation starts, click Cancel.
  4. Click Start, and then click Run.
  5. In the Open box, type c:\folder\setupsts.exe remotesql=yes (where c:\folder is the path to the Setupsts.exe file on your local computer).

    For example, if you installed the US English version of STSV2.exe, then the folder is c:\program files\STS2Setup_1033.

  6. Click OK.

    The Windows SharePoint Services Setup program opens.

  7. On the End-User License Agreement page, review the terms, and then select the I accept the terms in the License Agreement check box, and then click Next.
  8. On the Type of Installation page, click Server Farm, and then click Next.
  9. On the Summary page, verify that only Windows SharePoint Services will be installed, and then click Install.
  10. Setup runs and installs Windows SharePoint Services.

After the Setup process is complete, you can configure your administrative virtual server (including specifying an application pool to use for the virtual server processes), connect to your SQL Server computer, and then provide your virtual servers with Windows SharePoint Services. For Active Directory account creation mode, it is recommended that you use the command-line operations to configure your Web servers.

For more information about the operations used in these steps, see Command-Line Operations.

When creating the administrative virtual server's application pool, specify that application pool to run under the account you created when you prepared the domain controller.

Create the administration virtual server application pool

Administration processes for Windows SharePoint Services must run under the domain controller account you created earlier. You use the setadminport operation to create the administration virtual server, and create an application pool for the administration virtual server that uses the domain controller account you created.

Stsadm.exe -o setadminport -port 8080 -admapcreatenew
-admapidname stsadmin -admapidtype configurableid
-admapidlogin domain\account -admapidpwd password

If you have used a domain account that does not already have database creation rights in SQL Server, you can give the account this access in SQL Server Enterprise Manager. This is a one-time only change. Once you have granted the Security Administrators and Database Creators roles to the account used by the Windows SharePoint Services administration virtual server, this account can create databases for any subsequent virtual servers.

Configure SQL Server with permissions for Windows SharePoint Services
  1. On your SQL Server computer, click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. In Enterprise Manager, click the plus sign (+) next to Microsoft SQL Servers, click the plus sign (+) next to SQL Server Group, and then click the plus sign (+) next to your SQL Server computer.
  3. Click the plus sign (+) next to Security, and then right-click Logins, and click New Login.
  4. In the Name box, type the account you created earlier, in the format DOMAIN\name.
  5. Click the Server Roles tab.
  6. In the Server Role list, select the Security Administrators and Database Creators check boxes, and then click OK.

You are now ready to create the configuration database.

Create the configuration database and specify Active Directory account creation mode

When you create the configuration database, you specify that Windows SharePoint Services uses Active Directory account creation mode. If you are using scalable hosting mode, you must also use the hh parameter with the setconfigdb operation.

To create the configuration database in nonscalable hosting mode, use the following syntax:

Stsadm.exe -o setconfigdb -ds <database server name> -dn sts_config
  -adcreation -addomain <domain_name> -adou sharepoint_ou

Note Be sure to use server name or netbios name for the Active Directory domain, not the fully-qualified domain name. For example, use the form server_name_test, not server_name_test.example.com.

To create the configuration database in scalable hosting mode, use the following syntax:

Stsadm.exe -o setconfigdb -ds <database server name> -dn sts_config
  -hh -adcreation -addomain <domain_name> -adou sharepoint_ou
Specify the e-mail server settings

You must specify an SMTP server to use in order for invitation e-mail to work in Active Directory account creation mode. To specify an e-mail server, you use the email operation.

stsadm.exe -o email -outsmtpserver <SMTP server>
  -fromaddress <someone@example.com> -replytoaddress <someone@example.com>
  -codepage <codepage>
Extend a virtual server

After you set up the connection to your SQL Server computer, you are ready to extend the virtual servers on your Web server computer with Windows SharePoint Services. When you extend a virtual server, Windows SharePoint Services is applied to a virtual server and a top-level Web site is created. For either mode, you must extend the virtual server without creating a site. You use the donotcreatesite parameter with the extendvs operation to extend a virtual server without creating a site.

To extend the virtual server without creating the default top-level Web site use the following syntax:

Stsadm.exe -o extendvs -url http://server_name.domain -ds sqlservername
  -dn sts_content -donotcreatesite -apcreatenew -apidname stscontent
  -apidtype configurableid -apidlogin DOMAIN\name -apidpwd password

For the apidlogin parameter, enter a domain account in the format DOMAIN\name. It is recommended that you use a different account than the account you used for the application pool for the administration virtual server.

Note This account must also have the correct permissions delegated to it. This account must be able to create, delete, and manage accounts in the organizational unit for Windows SharePoint Services.

Specify the host name for the first site (scalable hosting mode only)

For scalable hosting mode, you must create the first host-named site for each virtual server. To specify the host name for the site, open the \WINDOWS\system32\drivers\etc\hosts file and add an entry for the site. For example:

xxx.xxx.xxx.xxx www.example.com

Where the x's are the IP address of the server.

Note If Domain Name Service (DNS) is not configured, it is still possible to simulate the real environment. You can ping the Web server name to find the IP address.

After the host name is configured, you can create a site.

Create a site

You can create a site in either scalable or nonscalable hosting mode by using the createsite operation with the following syntax:

stsadm -o createsite -url http://www.example.com
  -owneremail someone@example.com

Be sure to use a valid e-mail address for the owneremail address. This address will be used to send account credentials to new users who access the site.


Installation Considerations for Windows SharePoint Services

Installation Considerations for Windows SharePoint Services

There are certain choices that you must make either before or during your installation of Microsoft Windows SharePoint Services. Some of these choices, such as the database type you use, can be changed later without causing a lot of extra work. Other choices, such as the user account mode you will use, cannot be changed unless you uninstall and reinstall Windows SharePoint Services. If you are installing Windows SharePoint Services in a large scale environment, such as a server farm, it is critical that you make the right choices at the very beginning. Be sure that you carefully consider the following before you install Windows SharePoint Services.

Note If you are upgrading from SharePoint Team Services 1.0 from Microsoft, there are additional options to consider before installing. For more information, see Upgrade Considerations.

Choosing a User Account Mode

When you install Windows SharePoint Services, you must choose which mode you want to use for user accounts. Windows SharePoint Services can work with either of the following user account modes:

  • Domain account mode

    This mode is used inside organizations to grant access to users with existing Microsoft Windows domain accounts.

  • Active Directory account creation mode

    This mode is used by Internet Service Providers to create unique accounts for customers in Active Directory directory service.

You cannot mix modes — you must choose either Domain account mode or Active Directory account creation mode. The difference between these two modes is the method you use to create user accounts. In Domain account mode, you use existing domain user accounts. In Active Directory account creation mode, accounts are automatically created in the Active Directory organizational unit you specify. In either mode, you use the same methods to manage users of a site. You add them to the site using their existing domain or Active Directory accounts, and then assign them to site groups to give them the rights they need to use the site.

The choice between user account modes is a one-time-only choice, because it affects how the configuration database for your server or server farm is created. You cannot change user account modes after creating the configuration database, and this step is either part of installation (if installing with WMSDE), or one of the first choices you make after installation (if using SQL Server).

For more information about user account modes, see Managing Users and Cross-Site Groups.

Notes

  • When you are in Active Directory account creation mode, there are certain administrative tasks that are unavailable in the HTML Administration pages. For example, you cannot create a top-level Web site, you cannot enable Self-Service Site Creation, and you cannot add a user to a site from the Central Administration pages. To perform these actions in Active Directory account creation mode, you must use the command line or the object model. For more information, see Using the Object Model to Manage Windows SharePoint Services.
  • The Minimum Password Age group policy on the domain controller must be set to 0 days. Failure to do so will result in users being unable to change their passwords, unless they have administrator rights on the server. For information on setting the Minimum Password Age group policy, see Microsoft Windows 2003 Server online help.

Choosing a Database Type

Windows SharePoint Services relies on a database to store all site data and content, plus server configuration information. Windows SharePoint Services can work with either of the following databases:

  • Microsoft SQL Server 2000 Service Pack 3

    SQL Server includes many tools for managing database processes, such as backup and restore, and allows you to use multiple back-end database servers to store as much content as you need and balance the load across the servers.

  • Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE), Service Pack 3

    WMSDE 2000 has only a small subset of the features available with SQL Server. For example, WMSDE does not include tools for backing up and restoring the database, and only allows you to use a limited amount of storage space.

    Note Windows Server 2003, Web Edition, requires the full version of Microsoft SQL Server rather than WMSDE.

You choose which type of database to use when you install Windows SharePoint Services. By default, Windows SharePoint Services installs WMSDE during setup. If you have SQL Server, either on the same computer or on a separate server computer, you can choose not to install WMSDE. Then, after Windows SharePoint Services is installed, you can connect to the SQL Server database to continue configuring Windows SharePoint Services.

Note Using WMSDE may be more secure than using SQL Server, because WMSDE cannot be connected to remotely.

If you install Windows SharePoint Services on a single server with WMSDE, anticipating only light usage of your Web sites, and later find that you require more database power, you can migrate your data to a SQL Server database.

For more information about changing database types after installation, see Migrating from WMSDE to SQL Server. For more information about databases and architecture, see Windows SharePoint Services Architecture.

Choosing an Authentication Type for SQL Server

If you choose to use SQL Server with Windows SharePoint Services, you must also choose the authentication method to use for connections between Windows SharePoint Services and the SQL Server databases. You can use either Windows authentication or SQL Server authentication for these connections.

  • Windows authentication is more secure, because it depends on the domain credentials for an Internet Information Services (IIS) application pool to connect to the SQL Server database. The username and password are not sent between servers, but are abstracted through the IIS application pool.
  • SQL Server authentication is less secure, because when you connect to the database, the username and password for the database administrator account are sent from server to server in unencrypted format.

You make the database authentication choice after installation, when you connect to the SQL Server databases for the first time.

For more information about security, see Windows SharePoint Services Security Model. For more information about authentication methods for SQL Server 2000, see the SQL Server 2000 documentation.

About WMSDE and Authentication Types

When you install Windows SharePoint Services with the default settings, WMSDE is also installed to provide database support. By default, the authentication for connections between Windows SharePoint Services and WMSDE is set to Windows authentication.

During setup, the password for the system administrator (sa) account for WMSDE is set to a random string. This password is not stored by Windows SharePoint Services. If you want to use SQL Server authentication or mixed authentication for connecting to the databases in WMSDE, and you are going to use the sa account for the connection, you must first change the sa password.

Because the sa password created during setup is not stored, you cannot log in as the sa account to change this password — you must be authenticated as a member of the system administrator (sysadmin) role for WMSDE. By default, the administrators of the local computer are added to the sysadmin role for WMSDE (which also includes the sa account), and have full administrative access to WMSDE, including the ability to change the sa password.

Caution Be sure that you do not remove the local administrators from this role, or you will not be able to change the sa password. If you remove all users except sa from the sysamin role, without changing the sa password, the WMSDE instance will be unusable.

Choosing an IIS Application Pool Configuration

Internet Information Services (IIS) introduced application pools in IIS 6. With application pools, you can use an isolated process to run your Web applications. Each application pool has unique credentials on the server, so you can identify which applications are performing which actions. If that application fails, it does not affect other applications that are also running.

Windows SharePoint Services supports the new application pool model in IIS 6. When you configure your server or your server farm, you can choose from the following options:

  • One application pool for the administrative virtual server

    The administrative virtual server must always have its own, separate application pool.

  • Shared application pools for all virtual servers hosting Web sites

    You can choose to use the same application pool for all other virtual servers you use in Windows SharePoint Services. If you do so, however, you lose the security and failure protection measures that multiple application pools help provide. Applications running on one virtual server can potentially read or write data from another virtual server's application, and if one virtual server fails, they all fail.

  • Separate application pools for each virtual server hosting Web sites

    With separate application pools for each virtual server, you gain the security and failure protection measures that application pools help provide. If one virtual server fails, it does not affect the others. And no application running in a unique application pool can read another application's data if the application is on another virtual server. However, separate application pools create more complexity in management, since unique domain accounts must be created and maintained for each application pool.

  • "Shared" application pools for all virtual servers hosting the same Web sites

    In a server farm environment, you can also choose to use the same application pool accounts for any virtual servers that are hosting the same Web sites. For example, if your server farm has three servers, each of which has at least one virtual server that hosts the same Web site (http://www.example.com/site), you can use the same application pool account for all of the virtual servers hosting that site. This way, you only need to remember one set of credentials for that group of Web sites, and you can perform tasks across a set of virtual servers in your server farm.

    Note If you choose this configuration, you must be sure to use a domain account for the application pool account.

You specify the application pool to use for your administrative virtual server when you install Windows SharePoint Services to a server and set the configuration database. You specify any other application pools to use when you extend a virtual server on that server. For more information about application pools, see the IIS 6.0 Help system.

In situations where there is an extremely heavy load and large numbers of simultaneous users, you should consider the following special configuration steps for the content virtual servers.

  • Use a specially-configured domain account for the application pool account.

    When the account is created, ensure that the domain account is configured with the host name for the virtual server (for example, http://my.corp.net or http://virtualserver) and that the host name is registered as a Service Principal Name (SPN) for the account on the Kerberos domain. If there are multiple host names represented by this virtual server, each host name must be registered as a Service Principal Name with this account. For more information about registering Service Principal Names for specific accounts in a Kerberos domain, see the topic Delegating authentication in the Windows Server 2003 Help system.

  • Change the IIS authentication method to be Negotiate/NTLM Authentication.

    By default, Windows SharePoint Services configures virtual servers with Integrated Windows authentication. Note that you must be using Active Directory to use Negotiate/NTLM.

You can use a script to change to Negotiate/NTLM authentication.

Change to Negotiate/NTLM authentication
  1. Open a command prompt windows and change to the \inetpub\adminscripts directory.
  2. Run the following command:

    cscript adsutil.vbs get w3svc/##/NTAuthenticationProviders

    Where ## is the virtual server ID number (1 for the default virtual server) to verify the current authentication setting. The following string should be returned:

    ntauthenticationproviders: (STRING) "NTLM"

  3. Run the following command to change to Negotiate/NTLM:

    cscript adsutil.vbs set w3svc/##/NTAuthenticationProviders "Negotiate,NTLM"

    Where ## is the virtual server ID number (1 for the default virtual server).

Verifying that FrontPage 2002 Server Extensions are not Running on Port 80

If you are installing Windows SharePoint Services with the default options (you are not using remotesql=yes), verify that FrontPage 2002 Server Extensions from Microsoft are not installed and running on the virtual server on port 80 before you install. (If you upgraded from Windows 2000 to Windows Server 2003, FrontPage 2002 Server Extensions were installed by default to port 80.)

If FrontPage 2002 Server Extensions are using port 80, and you are using the site on that virtual server, you must back up the site to preserve your data, and then unextend the virtual server by using Microsoft SharePoint Administrator before installing Windows SharePoint Services. After installation, you can restore the site to a different virtual server to continue using FrontPage 2002 Server Extensions, or to the same virtual server to upgrade it to Windows SharePoint Services. If you are not using the site, you can simply unextend the virtual server, and then install Windows SharePoint Services. For more information about backing up and restoring Web sites, see Migrating and Upgrading Web Sites.

Related Topics

For more information about installing Windows SharePoint Services, see the following topics:

  • Single Server Deployment
  • Remote SQL Server Deployment
  • Server Farm with Multiple Host Names Deployment
  • Configuring Two Virtual Servers to Host the Same Content
  • Separate Active Directory Organization Unit Deployment
  • Performing a Quiet Installation


Installation Points for Windows SharePoint Services

Installation Points for Windows SharePoint Services

This topic helps you find the installation points and update locations for features and components of Windows SharePoint Services and other products and technologies that work with Microsoft Windows SharePoint Services.

Installation Points for Administrators of Windows SharePoint Services

The following table lists the components of Windows SharePoint Services and related Microsoft offerings that an administrator of Windows SharePoint Services may want to install. The table includes the Web download locations, as well as the location for any updates (hotfixes, service packs, and so on), and information about CD availability.

Component | Web download location | CD availability | Update location
Windows SharePoint Services | Microsoft Download Center | Yes, on the Microsoft SharePoint Portal Server CD | Critical and security fixes will be on Microsoft Windows Update and the Microsoft Download Center. Other updates will be on the download center.
Windows SharePoint Services Language Packs | Microsoft Download Center | No | None
SharePoint Migration Tool (smigrate.exe) | Included with Windows SharePoint Services or Microsoft Windows Update | No | Microsoft Windows Update* See note following this table
Virus Scanner | See the partner list on the Microsoft Web site | No | Updates to the core virus scanning code in Windows SharePoint Services will be posted to Microsoft Windows Update.
Microsoft SQL Server 2000 | No download available for the full product | Yes | Microsoft SQL Server download center
Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) | Included with Windows SharePoint Services | No | Microsoft SQL Server download center or Microsoft Windows Update
Internet Information Services (IIS) version 6.0 | Included with Windows Server 2003 | Yes - included on Windows Server 2003 CD | Microsoft Download Center or Microsoft Windows Update
ASP.NET (Microsoft .NET Framework version 1.1.4322 or later) | Microsoft Download Center | Yes - included with Microsoft .NET Framework CD or Microsoft Windows Server Family | Microsoft Windows Update
Microsoft Exchange Server 2000 or later (for use with e-mail-enabled document libraries) | No | Yes | Microsoft Exchange Downloads

Note To find the SharePoint Migration tool on the Windows Update site, click Windows Update Catalog. Click Find updates for Microsoft Windows operation systems. In the Operating system list, click Windows Server 2003 family. In the Language list, click the language you need, and then click Search. The SharePoint Migration tool is available in the Recommended Updates, if it is not already installed.

Installation Points for Client Applications Compatible With Windows SharePoint Services

Some features of Windows SharePoint Services work best when a compatible client application is installed. The following table lists some of the client applications that work with Windows SharePoint Services, and the download locations, update locations, and CD availability for each.

Component | Web download location | CD availability | Update location
Microsoft Office 2003, a suite of productivity applications compatible with Windows SharePoint Services | No | Yes | Microsoft Office Online Web site
Microsoft Office InfoPath 2003, an XML forms editor compatible with Windows SharePoint Services | No | Yes | Microsoft Office Online Web site
Microsoft Office FrontPage 2003, a Web page editor compatible with Windows SharePoint Services Also includes Microsoft Office Picture Manager, an image editor compatible with Windows SharePoint Services | No | Yes | Microsoft Office Online Web site
Microsoft Windows Messenger 4.6 or later or MSN Messenger 4.6 or later (for use with online presence features in Windows SharePoint Services) | Microsoft Windows Messenger: Microsoft Download Center MSN Messenger: Microsoft Download Center | No | Microsoft Windows Messenger: Microsoft Windows Update MSN Messenger: MSN Messenger Web site

Installation Points for Complimentary Server Applications

If your organization uses the client applications in the previous table, you may want to install the following applications.

Component | Web download location | CD availability | Update location
Microsoft Office HTML Viewer Service | Microsoft Download Center or the Microsoft Office Resource Kit Web site | Yes - included as part of the Microsoft Office 2003 Editions Resource Kit book and CD. To order a copy, see the Microsoft Learning Web Site. | Microsoft Office Online Web site or Microsoft Office Resource Kit Web site
Office 2003 Add-in: Web Parts and Components | Microsoft Download Center | Yes - included with Microsoft SharePoint Portal Server CD | Microsoft Office Online Web site


Performing a Quiet Installation

Performing a Quiet Installation

You might prefer to install Microsoft Windows SharePoint Services without any user intervention. During a quiet (or unattended) installation, the user is never prompted to supply information and never sees any messages. You can perform a quiet installation from the command line. You can run a quiet installation by itself or as part of a script for distribution across several servers. Any output from the Setupsts.exe program is stored in the log file in the Temp directory of the Microsoft Windows volume.

To perform the unattended installation, use the Setupsts.exe command with the /q command-line option. There are several variations of the /q option that you can use. The following table lists and explains the quiet installation options available for Windows SharePoint Services.

Quiet installation option | Description
q or qn | Run Setupsts.exe in quiet mode (unattended setup with no user intervention).
qb | Run Setupsts.exe in basic mode (limited user intervention). Includes a progress bar.
qf | Run Setupsts.exe in full mode (user must fill in options during setup). This is the default option.
qr | Run Setupsts.exe in reduced mode. Displays reduced UI during installation.
qn+ | Run Setupsts.exe in quiet mode (unattended setup with no user intervention). Displays a Setup complete dialog box at the end of the installation.
qb+ | Run Setupsts.exe in basic mode (limited user intervention). Includes a progress bar and a Setup complete dialog box at the end of the installation. If you cancel the installation, the dialog box is not displayed.
qb- | Run Setupsts.exe in basic mode (limited user intervention). Does not display a Setup complete dialog box.

For more information about the options and properties you can use with Setupsts.exe, see Command-Line Options for Setupsts.exe.

Performing a Quiet Installation with WMSDE

If you want to perform a quiet installation of Windows SharePoint Services with Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE), you can run Setupsts.exe with any of the above command-line options. For example, if you wanted to install Windows SharePoint Services with WMSDE and see a progress bar and completion dialog box, you would type:

setupsts.exe /qb+

Performing a Quiet Installation with SQL Server

If you want to use Microsoft SQL Server instead of WMSDE, you must use the remotesql=yes property when you perform a quiet installation. You can use any of the quiet installation options in combination with the remotesql=yes property. For example, to perform a quiet installation with no user interface options of Windows SharePoint Services to use with an existing SQL Server installation or a remote computer running SQL Server, you would type:

setupsts.exe remotesql=yes /q

When you perform a quiet installation with the remotesql=yes parameter, you must perform some additional configuration steps after setup before Windows SharePoint Services is ready to use. For more information, see Remote SQL Server Deployment.


Extending Virtual Servers

Extending Virtual Servers

Microsoft Windows SharePoint Services uses virtual servers to host Web sites on your server. The process of applying Windows SharePoint Services to a virtual server is called extending. You must extend a virtual server with Windows SharePoint Services before you can create a Web site based on Windows SharePoint Services. When you install Windows SharePoint Services on a single server by using the simple installation method, your default virtual server is extended automatically and a Web site is created. If you are installing Windows SharePoint Services in a more complex environment (for example, hosting multiple sites on a single server, or many sites in a server farm), you must extend each virtual server individually. To extend a new virtual server, you must perform the following steps:

  1. Create the virtual server in Internet Information Services (IIS).
  2. If necessary, connect to the configuration database for the server farm.
  3. Extend the virtual server using HTML Administration pages or the command line.

Note To complete this procedure, you must be logged on as a member of the Administrators group on the local computer, or you must be logged on using an account that is both a member of the SharePoint administrators group and that has been granted permissions to administer IIS.

How Does Extending a Virtual Server Interact with the Databases?

Windows SharePoint Services relies on databases to store all data for a virtual server, including both configuration settings and site content. When you extend a virtual server and configure a site, you interact with two different databases:

  • Configuration database

    The configuration database maintains connections between servers and content databases, stores server settings, and identifies which content is to be provided by which virtual servers. There is one configuration database per stand-alone server or per server farm. For more information about the configuration database, see Managing the Configuration Database.

  • Content database

    Content databases store data from the sites: both site management data, such as user names and permissions, and content, such as list data and documents from document libraries. You can create as many content databases as you need to support the Web sites on your servers. For a departmental server, you may need only one content database. For a server farm, you may need thousands. For a Web site that is available to members both behind and outside of a firewall (an extranet), you may have one content database linked to two virtual servers with very different URLs. For more information about content databases, see Managing Content Databases.

Before you extend the first virtual server on a server computer, you must create or connect to a configuration database; subsequent virtual servers do not have to be separately registered with the configuration database. When you extend a virtual server, you choose whether to create a new content database or map to an existing virtual server.

Creating a New Virtual Server in Internet Information Services (IIS)

If you are adding a new virtual server to an existing server, you must create the virtual server first. This means creating a folder on your hard disk (usually under the \Inetpub folder) to store the virtual server's files, and then adding the virtual server in Internet Information Services (IIS).

Create a virtual server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Click the plus sign (+) next to the server name you want to add a virtual server to.
  3. Right-click the Web Sites folder, click New, and then click Web site.
  4. Click Next.
  5. In the Description box, type the description of your virtual server, and then click Next.
  6. In the Enter the IP address to use for this Web site box, click All Unassigned.

    Note You can create multiple virtual servers by using IIS Host Headers with All Unassigned if necessary, but IP-bound virtual servers are not supported.

  7. In the TCP port this Web site should use (Default: 80) box, type the port number to assign to the virtual server.

    You do not need to assign a host header, because the hosting is being handled through Windows SharePoint Services.

  8. Click Next.
  9. In the Path box, type or browse to the path on your hard disk where the site content will go.
  10. If you do not want to allow anonymous access to your virtual server, clear the Allow anonymous access to this Web site check box.
  11. Click Next.
  12. On the Web Site Access Permissions panel, select the permissions to use, and then click Next.

    The default permissions, Read and Run Scripts (such as ASP), are recommended. The Execute (such as ISAPI applications or CGI) permission will be added automatically to the appropriate folders by Windows SharePoint Services.

  13. Click Finish.

For more information about creating new Web sites on servers running the Windows Server 2003 family, see the Adding Sites topic in the Help system for Internet Information Services.

Connecting to a Configuration Database (Server Farm Only)

If you are adding a server to a server farm, and provisioning the first virtual server for that server, you must connect to the configuration database for your server farm before you can extend the virtual server. To connect to a configuration database, use the Set Configuration Database Server page. For more information, see Managing the Configuration Database. After you have connected to the configuration database, you can extend the virtual server.

Extending a Virtual Server that is Already Running Microsoft FrontPage 2002 Server Extensions

If you have an existing virtual server running FrontPage 2002 Server Extensions that you would like to upgrade to Windows SharePoint Services, you must uninstall FrontPage Server Extensions and then extend the virtual server. If you wish to preserve the content from your FrontPage 2002 Server Extensions-based site, use the smigrate.exe tool to migrate the content to your new Windows SharePoint Services-based site before uninstalling. For information on smigrate, see "Migrating and Upgrading Web Sites" in the Windows SharePoint Services Administrator's Guide.

Remove FrontPage Server Extensions (if installed)

  1. Click Start, and then click Run.
  2. In the Run window, type cmd and then click OK.
  3. Change to the directory where FrontPage Server Extensions are installed. For example:

    cd ..\..\program files\common files\microsoft shared\web server extensions\50\bin

  4. Type the owsadm.exe command to uninstall FrontPage Server Extensions:

    owsadm.exe -o fulluninstall -p <port number>

    Where "<port number>" represents the port number used by the virtual server running FrontPage Server Extensions.

Extending a Virtual Server

Generally, you extend a virtual server because you need to add more capacity to your server, whether that server is a departmental server or one of many in your server farm. More capacity can mean either more space for Web site content or more connections to existing Web sites. For example, if you have a site with a lot of visitors, you can have several virtual servers hosting the same content to increase the number of concurrent users you can support and balance the load for your servers. You can extend a virtual server to do one of the following:

  • Contain new content

    If you need to provide space for users to create new Web sites, you can extend a new virtual server to contain new content. Note that you can also add space for users by adding more site collections or new content databases to an existing virtual server. For more information about creating site collections, see "Creating Sites and Subsites" in the Windows SharePoint Services Administrator's Guide. For more information about content databases, see Managing Content Databases.

  • Map to existing content

    If you want your new virtual server to point to a Web site that is already in use, either to allow for more connections to a site or to allow more than one URL to point to a site, you can map your new virtual server to an existing virtual server. The new virtual server connects to the same content databases as the existing virtual server, and they both host the same content. You can choose from the list of all virtual servers that currently exist on the server (in a single-server setting), or in the server farm. This list is generated by querying the configuration database, which is why you must be connected to the configuration database before you can extend a virtual server.

    When you extend and map to an existing virtual server, all of the configuration data about the existing virtual server is applied to the new virtual server. Any managed paths are also applied. This means that if you have virtual server A that contains the paths /teams, /sites, and /users, when you extend virtual server B and map to virtual server A, virtual server B now also has the /teams, /sites, and /users paths. A user can be directed to either virtual server A or B and see the same content — they are essentially mirrored virtual servers. For more information about URLs in Windows SharePoint Services, see "Windows SharePoint Services Architecture" in the Windows SharePoint Services Administrator's Guide.

When you extend a virtual server, you must supply the following information:

  • The application pool to use for the virtual server.
  • The user account and e-mail address for the owner of the default top-level Web site for the virtual server.
  • The content database to use for storing data for sites on the virtual server.
  • Which URL to use for your top-level Web site (optional). The default is to create the top-level Web site at the root of the virtual server, but you can specify a custom URL path instead.
  • Which quota template to apply, if you are using quotas on your server (optional).
  • The language to use for the default top-level Web site (select from the set of Windows SharePoint Services languages installed on your server).
  • Which site template to apply to the top-level Web site (optional). On the command line, you can specify which template to apply to the top-level Web site in the same command that you use to extend the virtual server. You can choose the template from HTML Administration pages as well, but you must navigate to the site to do so.

After you extend the virtual server, you can specify default settings for top-level Web sites created under that virtual server. For more information, see Configuring Virtual Servers.

The following sections show you how to extend a virtual server using HTML Administration pages or the command line. You can use either method to extend a virtual server and map to an existing virtual server or create a content database.

Note You can also extend a virtual server by using a script during a quiet installation. For more information, see "Performing a Quiet Installation" in the Windows SharePoint Services Administrator's Guide.

Extending a Virtual Server by Using HTML Administration Pages

If you are adding a new virtual server on a stand-alone server, or the first virtual server for a server farm, you need to create a place to store the content your Web site users will create. This means that when you extend your virtual server, you need to create a content database.

Extend and create a content database by using HTML Administration pages
  1. On the SharePoint Central Administration page, click Extend or upgrade virtual server.
  2. On the Virtual Server List page, click the name of the virtual server to extend.
  3. On the Extend Virtual Server page, in the Provisioning Options section, select Extend and create a content database.
  4. In the Application Pool section, select either Use an existing application pool or Create a new application pool.

    Notes

    • When using Windows SharePoint Services with SharePoint Portal Server, re-use the MSSharePointPortalServerAppPool application pool created by SharePoint Portal Server. This application pool can be managed by clicking on Configure Server Farm Account Settings in SharePoint Portal Server Central Administration.
    • In most other installations, it is recommended that you create a new application pool for each virtual server, so that they run in separate processes. This application pool should use a domain account, but it does not need to have database creation rights in Microsoft SQL Server — the administration virtual server account creates any databases required.

  5. If you selected Use an existing application pool, select the application pool to use. If you selected Create a new application pool, enter the new application pool name, user name, and password to use.

  6. In the Site Owner section, in the User name box, type the user name for the site owner (in the format DOMAIN\username if the username is part of a Windows domain group).
  7. In the E-mail box, type the e-mail address that corresponds to the account.
  8. In the Database Information section, enter the following database connection information or select the Use default content database server check box:
    • In the Database server box, type the server name for your server computer.
    • In the Database name box, type the name to use for your content database.
  9. If you want to specify a path for the URL, in the Custom URL path box, type the path to use.
  10. If you are using quotas, select a template in the Select a quota template box of the Quota Settings section.
  11. In the Site Language section, select the language to use.
  12. Click OK.

The virtual server is extended, a site is created at the root of the virtual server, and the browser window returns to the Virtual Server Settings page, where you can configure default settings for new top-level Web sites.

When you map to an existing virtual server, you do not need to create a top-level Web site. After you extend the virtual server, the virtual server hosts the existing sites in the database.

Extend and map to an existing virtual server by using HTML Administration pages
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Click Extend or upgrade virtual server.
  3. On the Virtual Server List page, click the virtual server you want to extend.
  4. On the Extend Virtual Server page, click Extend and map to another virtual server.
  5. On the Extend and Map to Another Virtual Server page, in the Server Mapping section, in the Host name or IIS virtual server name box, select the name of the host or virtual server that you want to use.
  6. In the Application Pool section, select either Use an existing application pool or Create a new application pool.

    Notes

    • When using Windows SharePoint Services with SharePoint Portal Server, re-use the MSSharePointPortalServerAppPool application pool created by SharePoint Portal Server. This application pool can be managed by clicking on Configure Server Farm Account Settings in SharePoint Portal Server Central Administration.
    • In most other installations, it is recommended that you create a new application pool for each virtual server, so that they run in separate processes. This application pool should use a domain account, but it does not need to have database creation rights in Microsoft SQL Server — the administration virtual server account creates any databases required.

  7. If you selected Use an existing application pool, select the application pool to use. If you selected Create a new application pool, enter the new application pool name, user name, and password to use.

  8. Click Submit.

The virtual server is extended and can now provide the same content as the other virtual server. You can add a new top-level Web site to your new virtual server if you need to, and it will also be hosted by the virtual server that you mapped to.

Extending a Virtual Server from the Command Line

You can extend virtual servers from the command line by using the extendvs operation. The extendvs operation allows you to extend a virtual server and either map to an existing virtual server or create a new content database, specify the language for the top-level Web site, and specify a template to use for the top-level Web site. The extendvs operation takes the following required parameters: url, ownerlogin, owneremail and the following optional parameters: ownername, databaseserver (ds), databaseuser (du), databasepassword (dp), databasename (dn), lcid, sitetemplate, donotcreatesite, apcreatenew, apidname, apidtype, apidlogin, and apidpwd.

The lcid parameter allows you to specify a language to use for the default top-level Web site. For example, to specify U.S. English as the language to use, you would type -lcid 1033 on the command line. If you do not specify a locale ID (LCID) using the lcid parameter, the language of the server is used for the default top-level Web site.

The donotcreatesite parameter allows you to extend a virtual server and create a content database without a top-level Web site. Use this parameter when you are setting up a server farm and hosting sites with URLs like http://server_name/site1, http://server_name/site2, and so on. (To use this site naming scheme, you must create a wildcard inclusion for the path under which you create the sites. For more information about inclusions, see Managing Paths.)

The sitetemplate parameter allows you to extend a virtual server, create a top-level Web site, and apply a site template to the top-level Web site during site creation. If you do not use the sitetemplate parameter, the site owner can choose a site template when he or she first browses to the site.

To extend a virtual server and use the default content database server and default application pool, use the following syntax:

Stsadm –o extendvs -url <url> -ownerlogin DOMAIN\username -owneremail
 someone@example.com [-ownername <full name>]

To extend a virtual server, specify a content database name and server, and create a new application pool, use the following syntax:

stsadm -o extendvs -url <url> -ownerlogin DOMAIN\user -owneremail
 someone@example.com [-ownername <full name>] -ds <database server name>
 [-du <database user name> -dp <password>] -dn <database name>
 -lcid <lcid> -sitetemplate sts -apcreatenew -apidname <application pool name>
 -apidtype <configurableid/NetworkService/LocalService/LocalSystem>
 -apidlogin <DOMAIN\name> -apidpwd <password>

Note that the -du and -dp parameters are not needed if you are using Windows authentication to connect to the SQL Server databases.

If you are in a server farm environment, you can use the extendvsinwebfarm operation. The extendvsinwebfarm operation uses the following syntax:

stsadm -o extendvsinwebfarm -url <url> -vsname <virtualservername>
 [-apcreatenew] [-apidname <app pool id>]
 [-apidtype <configurableid/NetworkService/LocalService/LocalSystem>]
 [-apidlogin <app pool user account>]
 [-apidpwd <app pool password>]

Related Topics

For more information about the extendvs and extendvsinwebfarm operations, see Command-Line Operations.

After you have extended a virtual server, you can configure settings for the virtual server. For more information, see Configuring Virtual Servers.

As your organization's use of Windows SharePoint Services grows, you may find that you need additional database capacity for your site content. You can create additional content databases to store site data. For more information, see Managing Content Databases.


Installing and Using Service Packs for Windows SharePoint Services

Installing and Using Service Packs for Windows SharePoint Services

Service packs are intended to help you keep your installation up to date with the latest security enhancements, product feature enhancements, and fixes for common problems. The following service packs have been released for Microsoft Windows SharePoint Services:

  • Windows SharePoint Services Service Pack 1 (SP1) - September 2004

Installing and Using Windows SharePoint Services Service Pack 1

Windows SharePoint Services SP1 includes fixes for several issues, including the following:

  • Formatted text moved after plain text after relinking form. When you relink a form in your Windows SharePoint Services Web site that contains rich text, all formatted text is moved from its original position to after the plain text.
  • Cannot search past or future events in your Windows SharePoint Services Web site. When you try search for events in your Windows SharePoint Services Web site, past and future events are not found. The search results include only the next event.
  • Cannot add a Web Part to your online Web Part gallery. When you try to add a Web Part to your online Web Part gallery, the Web Part is not added. This issue may occur when the file name of the Web Part contains international or language-specific characters.
  • Error 403.1 when creating Web site in Windows Server 2003. When you try to create a new Windows SharePoint Services Web site on a computer running Microsoft Windows Server 2003, you receive the following error message: HTTP Error 403.1 - Forbidden: Execute access is denied. Internet Information Services (IIS).
  • Oldest item always listed first in discussion board. When you try to sort items in Threaded view in a discussion board, the oldest item is always listed first.
  • Links at root of Web site are broken after restoring Microsoft SQL Server database. When you restore your SQL Server database to your Windows SharePoint Services Web site, links contained at the root of your Web site are broken.
  • Language of template pack does not appear in Select Language list. After you install a language-specific Windows SharePoint Services template pack, the language of the pack does not appear in the Select Language list of the Sites and Workplaces page.
  • Cannot upload large files to your Windows SharePoint Services Web site. When you try to upload a large file to your Windows SharePoint Services Web site, you may receive an error message.

Note Windows SharePoint Services SP1 also includes several security updates that are not included in this list.

For a complete list of fixes included in Windows SharePoint Services SP1, see the Microsoft Knowledge Base article number 841876.

Install Windows SharePoint Services Service Pack 1
  1. Download Windows SharePoint Services SP1 from the Microsoft Download Center Web site.
  2. Run the Service Pack executable on a server that is running the original version of Windows SharePoint Services.

    Note If you are running a server farm configuration you must install the Service Pack to each front-end Web server.

Configuring Large File Support

The biggest change included in Windows SharePoint Services SP1 is the support for uploading large files. By default, the maximum size for uploading files is set to 50 MB. If you need to be able to upload larger files (such as when you use smigrate.exe to migrate a site between servers), you can change this setting to any value up to 2 GB (2047 MB).

To configure large file support you must increase the default upload size in SharePoint Central Administration. You may also need to perform the following additional actions (depending on your hardware configuration):

  • Tune the Microsoft Internet Information Services (IIS) connection timeout setting.

    The default timeout for connections in IIS is 120 seconds (2 minutes). Depending on your maximum file size and how long it takes for the file to be uploaded, you may not need to change this setting. If, however, IIS is timing out when you upload large files, you can change this property to ensure that larger files can be uploaded successfully.

  • Increase the default chunk size for large files.

    The large-file-chunk-size property sets the amount of data that can be read from server running SQL Server at one time. If you have a file that is greater than your chunk size (such as 70 MB when the chunk size is set to 5 MB), the file would be read in 14 chunks (70 / 5). The chunk size is not related to the maximum upload file size. The chunk size simply specifies the amount of data that can be read from a file at one time. By default, the large-file-chunk-size property is set to 5 MB. If you notice performance or scale problems on the client or server, then you may need to tune this setting to get the performance you are targeting. Note that if you raise the chunk size too high, the files might use up too much front-end memory and you may need to lower this setting.

  • Increase the maximum size limit for Web Parts.

    By default, the maximum size limit for a Web Part is 1 MB. If you need to accomodate large Web Parts, you can change this setting in the web.config file for your server or servers running Windows SharePoint Services.

Increase the maximum upload size
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, click the virtual server you want to change.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Virtual server general settings.
  5. Under Maximum upload size, type the maximum file size (in MB) that you want to allow to be uploaded.
  6. Click OK.

If IIS is timing out when you upload large files, you can configure the Connection timeout setting in IIS to allow more than the default 120 seconds (2 minutes).

Tune the IIS connection timeout
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Right-click the virtual server you want to configure, and then click Properties.
  3. Click the Web Site tab.
  4. In the Connections section, in the Connection timeout box, type the number of seconds you want IIS to wait before timing out.
  5. Click OK.
Increase the default chunk size for large files

The large-file-chunk-size property must be set from the command line. This property is configured for a server or server farm, and cannot be configured for an individual virtual server. To set this property, use the following syntax:

Stsadm.exe –o setproperty –pn large-file-chunk-size –pv <size in bytes>

After making a change to this property, you must restart IIS. You can restart IIS by typing iisreset on the command line.

Increase the maximum limit for Web Parts

This change is required only when working with large Web Parts. The maximum limit for Web Parts is set to 1048576 bytes by default.

  1. On your server computer running Windows SharePoint Services, open Notepad.
  2. In Notepad, navigate to the %HomeDrive%\Inetpub\wwwroot folder and open the web.config file.
  3. Locate the PropertySize attribute in the configuration\SharePoint\WebPartLimits element.
  4. Change the PropertySize attribute to the maximum size you need.
  5. Save and close the web.config file.

Large file support limitations

The following features do not support files larger than 50 MB:

  • Virus checking.
  • Picture libraries.
  • Streaming files.
  • Client-side restoration of smigrate backup files (limited to 2 GB). The manifest files for an smigrate backup cannot be larger than 2 GB.
  • Site templates (limit of 10 MB per site template, including content).


Uninstalling Windows SharePoint Services

Uninstalling Windows SharePoint Services

There are different degrees to which you can uninstall Microsoft Windows SharePoint Services. Depending on your needs, you can choose from the following options:

  • Remove Windows SharePoint Services from a virtual server and preserve the site content.

    You can choose to remove Windows SharePoint Services, but keep the site content in the content database. This allows you to extend the virtual server again later and reconnect to the site content. If you leave the content databases intact, you can reconnect to them, from the same virtual server or from a different virtual server, and continue hosting the site content using the same URL. Use this method to temporarily remove and then restore a virtual server, or to change which virtual servers are hosting which content in a server farm setting.

  • Remove Windows SharePoint Services from a virtual server and delete the site content.

    You can choose to remove Windows SharePoint Services and delete the site content in the database. Use this method to remove a virtual server permanently, but continue using Windows SharePoint Services on other virtual servers. For example, use this method if you are finished with a project and no longer need the associated Web sites.

    Caution When you use this method, you cannot reconnect to the site content later. If you choose to delete the content databases, you are permanently deleting the site content, and cannot recover the site data except from a backup.

  • Uninstall Windows SharePoint Services completely from a server.

    You can choose to uninstall Windows SharePoint Services by using the Add/Remove Programs control panel. This method does not delete site content. You can reinstall and reconnect to the site content. Use this method to repair an installation or to remove a Web front-end server from a server farm.

All of these methods leave the virtual server or server in a clean state, ready to be used for other Web sites or applications; however, each method affects the content and configuration databases in a different way. The following table explains what happens when you use each of these remove or uninstall methods.

Method What happens to the databases Actions during removal
Remove and preserve content The content databases associated with the virtual server remain untouched. You can reconnect to the site content.

The entry for the virtual server remains in the configuration database.

 The Windows SharePoint Services ISAPI filter is uninstalled, and the virtual directories for Windows SharePoint Services are removed from the virtual server.

Any physical directories created by Windows SharePoint Services under the physical home directory of the virtual server are removed.

The Port section in the registry for the virtual server is removed. This means that any managed paths and any URL mapping are removed.
Remove and delete content The content databases are deleted. You cannot reconnect to the site content.

The entry for the virtual server is removed from the configuration database.

 The Windows SharePoint Services ISAPI filter is uninstalled, and the virtual directories for Windows SharePoint Services are removed from the virtual server.

Any physical directories created by Windows SharePoint Services under the physical home directory of the virtual server are removed.

The Port section in the registry for the virtual server is removed. This means that any managed paths and any URL mapping are removed.
Uninstall The content and configuration databases associated with the server remain untouched. You can reinstall Windows SharePoint Services later and reconnect to databases. If you do not want to reconnect, you can delete the databases by using the Microsoft SQL Server or Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) database administration tools. Windows SharePoint Services is removed from any virtual servers.

The Windows SharePoint Services administration virtual server is removed.

The Windows SharePoint Services DLL files are removed from the installation directory.

Removing Windows SharePoint Services from a Virtual Server

You can remove Windows SharePoint Services from a virtual server by using HTML Administration or the command line administration tool. Both of these tools allow you to either preserve or delete content when you remove Windows SharePoint Services.

Removing Windows SharePoint Services from a Virtual Server by Using HTML Administration

To remove Windows SharePoint Services from a virtual server by using HTML Administration, you use the Remove Windows SharePoint Services from Virtual Server page.

Remove Windows SharePoint Services from a virtual server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Remove Windows SharePoint Services from Virtual Server.
  5. On the Remove Windows SharePoint Services from Virtual Server page, select one of the following:
    • Remove without deleting content databases

      This removes only the Windows SharePoint Services folders from the virtual server — the content database remains intact, so you can reconnect to it later using the same virtual server or a different one.

    • Remove and delete content databases

      This both removes the Windows SharePoint Services folders from the virtual server and deletes the content database. You will not be able to reconstruct the sites previously stored on that virtual server unless you have a backup.

  6. Click OK.

Removing Windows SharePoint Services from a Virtual Server by Using the Command Line

You can use the unextendvs operation with the Stsadm.exe command line utility to remove Windows SharePoint Services from a virtual server. The unextendvs operation takes the -url parameter and the optional -deletecontent parameter. When you use unextendvs without the -deletecontent parameter, it leaves the content databases in place, so that you can reconnect to the content for a virtual server. When you include the -deletecontent parameter, the content databases are removed and the virtual server is removed from the configuration database.

For example, to remove Windows SharePoint Services from a virtual server, but preserve the content databases, use the unextendvs operation with syntax like the following:

stsadm -o unextendvs -url http://servername

To remove Windows SharePoint Services from a virtual server and remove the content databases permanently, use the unextendvs operation with syntax like the following:

stsadm -o unextendvs -url http://servername -deletecontent

When you use the unextendvs operation with the -deletecontent parameter, you cannot reconnect to the site content later.

Uninstalling Windows SharePoint Services from the Server Computer

Note You must be an administrator on the server computer to uninstall Windows SharePoint Services.

If you want to remove Windows SharePoint Services from a server computer entirely, you can uninstall by using the Add or Remove Programs control panel. Uninstalling Windows SharePoint Services does not remove any chained products that were installed, such as WMSDE. You must uninstall these programs separately.

Uninstall Windows SharePoint Services
  1. On the server computer, click Start, click Control Panel, and then click Add or Remove Programs.
  2. Select Windows SharePoint Services, and then click Remove.

When you use the Add or Remove Programs control panel to remove Windows SharePoint Services from a server, it calls a command-line operation, stsadm -o uninstall, to perform the task. The uninstall operation does not remove any chained products that were installed. The uninstall operation takes the optional -deletecontent parameter. When uninstall is used without the -deletecontent parameter, it leaves the content and configuration databases in place, so that Windows SharePoint Services can be reinstalled, and you can reconnect to the databases and continue hosting sites. When the -deletecontent parameter is used, the content and configuration databases are removed, and you cannot recover the site content.


Windows SharePoint Services Security Model

Windows SharePoint Services Security Model

Microsoft Windows SharePoint Services includes or takes advantage of the following elements that interact with and affect your security for Web site content:

  • User authentication — The process used to validate the user account that is attempting to gain access to a Web site or network resource. You manage security using Microsoft Windows NT users and security groups (DOMAIN\user and DOMAIN\security group). You cannot use distribution lists to control access to content in Windows SharePoint Services, because distribution lists are not used for authentication in Windows.
  • SharePoint administrators group — A Microsoft Windows user group authorized to perform administrative tasks for Windows SharePoint Services.
  • Site groups — A means of controlling the rights assigned to particular users or groups in a Web site based on Windows SharePoint Services. There is a pre-defined list of site groups for each Web site (Administrators, Web Designers, and so on). To grant a user access to a Web site, you assign that user to a site group.

    Windows SharePoint Services also uses cross-site groups. Cross-site groups are a group of users that can be assigned to a site group on any Web site in a site collection. There are no cross-site groups defined by default in Windows SharePoint Services.

  • Administrative port security — A means of controlling access to the administrative port for Windows SharePoint Services. Help secure the administrative port by using Secure Sockets Layer (SSL) security or by configuring the firewall to not allow external access to the administration port, or both.
  • Microsoft SQL Server connection security — A way to help secure your data. Use either Windows NT Integrated authentication or SQL Server authentication to connect you to your configuration database and content database.
  • Firewall protection — A firewall helps protect your data from exposure to other people and organizations on the Internet. Windows SharePoint Services can work inside or through your organization's firewall.

User Authentication

User authentication for Windows SharePoint Services is based on Internet Information Services (IIS) authentication methods. Windows SharePoint Services can be used with the following forms of user authentication:

  • Anonymous authentication
  • Basic authentication
  • Integrated Windows authentication
  • Certificates authentication (SSL)

You choose the authentication method you want to use when you set up your Web server. You cannot change the authentication method by using the Windows SharePoint Services administration tools; you must use the Internet Information Services administration tool for your server computer to change the authentication method. For more information about setting an authentication method, see Configuring Authentication.

Note For more information about IIS authentication methods, see the topic About authentication in IIS 6.0 Help.

Anonymous Authentication

Anonymous authentication provides access to users who do not have Windows NT server accounts on the server computer (for example, Web site visitors). IIS creates the anonymous account for Web services, which is often named IUSR_computername. When IIS receives an anonymous request, it impersonates the anonymous account.

You can enable or disable anonymous access in IIS for a particular virtual server, and enable or disable anonymous access for a site on that virtual server by using HTML Administration pages. Anonymous access must be enabled in IIS before you can enable it for a Web site on that virtual server. For more information about configuring anonymous access for a site, see Managing Site Groups and Permissions.

Basic Authentication

Basic authentication is an authentication protocol supported by most Web servers and browsers. Although Basic authentication transmits user names and passwords in easily decoded clear text, it has some advantages over more secure authentication methods, in that it works through a proxy server firewall and ensures that a Web site is accessible by almost any Web browser. If you use Basic authentication in combination with Secure Sockets Layer (SSL) security, you can help protect the user names and passwords, making your user information more secure.

Integrated Windows Authentication

Integrated Windows authentication (also known as Windows NT Challenge Response) encrypts user names and passwords in a multiple transaction interaction between client and server, thus making this method more secure than Basic authentication. Disadvantages are that this method cannot be performed through a proxy server firewall, and some Web browsers (most notably, Netscape Navigator) do not support it. You can, however, enable both this method and Basic authentication at the same time, and most Web browsers will select the most secure option (for example, if both Basic and Integrated Windows authentication are enabled, Microsoft Internet Explorer will try Integrated Windows authentication first).

Certificates Authentication (SSL)

Certificates authentication (also known as Secure Sockets Layer (SSL) security) provides communications privacy, authentication, and message integrity for a TCP/IP connection. By using the SSL protocol, clients and servers can communicate in a way that prevents eavesdropping, tampering, or message forgery. With Windows SharePoint Services, SSL helps secure authoring across firewalls and allows more secure remote administration of Windows SharePoint Services. You can also specify that SSL be used when opening any Web site based on Windows SharePoint Services.

The SharePoint Administrators Group

To install Windows SharePoint Services, you must be a member of the local administrators group on the server computer. This group also gives users the permissions needed to control settings on the Central Administration pages, and to run the command-line tool Stsadm.exe. You can also identify a specific domain group to allow administrative access to Windows SharePoint Services, in addition to the local administrators group. You can add users to this group rather than to the local administrators group, to separate administrative access to Windows SharePoint Services from administrative access to the local server computer.

Members of the SharePoint administrators group do not have access to the IIS metabase, so they cannot perform the following actions for Windows SharePoint Services:

  • Extend virtual servers (they can, however, create top-level Web sites or change settings for a virtual server).
  • Manage paths.
  • Change the SharePoint administrators group.
  • Change the configuration database settings.
  • Use the Stsadm.exe command-line tool.

Members of the SharePoint administrators group can perform any other administrative action using the HTML Administration pages or object model for Windows SharePoint Services.

Members of both the SharePoint administrators group and the local administrators group have rights to view and manage all sites created on their servers. This means that a server administrator can read documents or list items, change survey settings, delete a site, or perform any action on a site that the site administrator can perform.

Windows SharePoint Services Site Groups

Windows SharePoint Services includes site groups to help you assign particular rights to users and cross-site groups. With site groups, you do not have to control the file and folder permissions separately, or worry about keeping your local groups synchronized with your list of Web users. You use site groups to give users permissions on your Web site, and use Windows SharePoint Services administration tools to add new users directly.

In effect, user management is delegated from server administrators to the site owners and administrators. Site administrators control site access and, by default, have rights to add, delete, or change site group membership for users. Inside an organization, this typically means that site administrators can select users from the list of the organization's users, and grant them access to varying degrees. For example, if the Web site is for members of a particular workgroup to share documents and information, the site administrator adds members of that workgroup to the site and assigns them to the Contributor site group, so that they can add documents and update lists.

In an ISP or extranet environment, a site owner can add new users and create accounts in an Active Directory group, using separate user lists for each site collection. The site administrator adds the users to the Web site and Windows SharePoint Services automatically adds the users to the Active Directory directory service.

Members of the Administrator site group for a top-level Web site can control more options than administrators of a subsite. Administrators of a top-level Web site can perform actions such as enabling or disabling Web document discussions or alerts, viewing usage and quota data, and changing anonymous access settings.

Note The owner and secondary owner of a top-level Web site may be members of the Administrator site group for their site, but they are also identified separately in the configuration database as site collection owners. This owner flag can only be changed by using the Manage Site Collection Owners page in Central Administration or by using the siteowner operation with Stsadm.exe. If you remove an owner from the Administrator site group for the site, the owner retains the owner flag in the database, and can still perform site collection administration tasks.

For more information about user accounts and Active Directory account creation mode, see Managing Users and Cross-Site Groups. For more information about site groups, see Managing Site Groups and Permissions.

Securing the Administrative Port

If a malicious user can gain access to your administrative port, he or she can potentially block other users from accessing their sites, or can change or delete content from the sites, or even completely disable your Web server. When you install Windows SharePoint Services, the administration port is assigned to a random port number. It is important to restrict access to the Windows SharePoint Services administration port, and you can do so by using the following methods:

  • Use Secure Sockets Layer (SSL) encryption.

    If you want to be able to manage Windows SharePoint Services across an Internet connection, use SSL to provide more secure communication between a client machine and the server, even across the Internet. To use SSL, you must first configure SSL in IIS, and then use the command line to configure Windows SharePoint Services. Note that when you use SSL, the URL for SharePoint Central Administration changes from http:// to https://. For more information about configuring SSL, see Configuring Authentication.

  • Use a firewall or IIS to restrict external access to certain domains.

    You can use the settings for your firewall to block access to the administrative port altogether (if you don't need to allow administration over the Internet), or to restrict access to the administrative port to certain domains. Use the stsadm -o setadminport operation to set each server in your server farm to the same port number, and configure the firewall to help protect that port on all servers. Alternatively, you can use the IP and name restrictions feature in IIS to restrict access to specific domains (you must set this for each virtual server that you want to restrict access to). For more information about helping to protect a port in IIS, see the Securing Your Site with IP Address Restrictions topic in the IIS Help system.

  • Use the SharePoint administrators group to restrict internal access.

    Use the SharePoint administrators group to control which users can access SharePoint Central Administration. Only the domain group you specify, and local administrators, can then access the administrative port. Limit the local administrator access to only a few computer operators.

  • Use Integrated Windows authentication instead of Basic authentication.

    When you use Integrated Windows authentication, you avoid having passwords sent in clear text, as can happen when Basic authentication is used. Basic authentication is less secure because it uses clear text.

  • Disable anonymous access.

    Allowing anonymous access makes your server inherently less secure. If anonymous users can get access to your server, they can change settings or content, and their actions cannot be traced to a real user account. Anonymous access is disabled by default for the administration port.

Securing SQL Server Connections

If you are using SQL Server instead of WMSDE for your databases, you can choose between the following two security methods for your interactions between Windows SharePoint Services and SQL Server:

  • Windows NT Integrated authentication — Connect to SQL Server using an IIS application pool. This method is the more secure option, and is the default authentication type for Windows SharePoint Services installations with SQL Server.

    Note that if you are using SQL Server on a separate server from the server running Windows SharePoint Services, you must use a domain account (or the Local System or Network Service account) as the IIS application pool account. If you are using a local account, it will not be able to access the SQL Server computer. For the administration virtual server, the IIS application pool account must also have rights to create new databases in SQL Server. In other words, this account must be a member of the Security Administrators and Database Creators roles in SQL Server. If you use Local System or Network Service, you must grant the SQL Server privileges to the machine account for the Web server computer. Application pool accounts for other virtual servers do not need database creation rights; they rely on the administration virtual server to create databases.

  • SQL Server authentication — Connect to SQL Server using credentials you type in Windows SharePoint Services administrative controls.

About Windows NT Integrated Authentication

With Windows NT Integrated authentication, you use the IIS application credentials and the IIS application process (called an application pool) to connect to the database. The credentials are stored securely in the IIS metabase with other IIS worker processes. When Windows SharePoint Services connects to the SQL Server database, it runs under its usual process, and uses the IIS process for the connection. This configuration can require a few more steps in a server farm environment on occasion. For example, if your domain has a policy requiring frequent password resets, you must remember to change the password in IIS for every server computer in your server farm.

You can have a single process for all of your virtual servers, or you can isolate each virtual server with its own application pool. Using separate processes is more secure. For example, if you have a custom script running for one virtual server, it could potentially be written to access pages in another virtual server if they are sharing an application pool. If they have separate application pools, the script is unable to authenticate for the database across virtual servers.

About SQL Server Authentication

SQL Server authentication uses an administrator account and password (often the default sa account) stored in the SQL Server database to connect between Windows SharePoint Services and the databases. This same user name and password are used for all updates to the databases, no matter which server (in a server farm) or virtual server (server farm or single server) requests the update. Also, when you use SQL Server authentication, the password for the administrator account is sent over the network, and can potentially be detected by malicious users. It is recommended that you use Windows NT Integrated authentication for connections between Windows SharePoint Services and the SQL Server databases.

Caution When you use SQL Server authentication, the user name and password you specify is available to all members of the STS_WPG group, which may include accounts associated with other applications on your server.

About Firewalls

Windows SharePoint Services supports connectivity through firewalls. Depending on your configuration, you must make sure your firewall is open for the standard HTTP ports 80 and 443. When using a firewall, you must configure your Web sites with Basic authentication because Integrated Windows authentication cannot pass through a firewall.

Related Topics

For more information about site groups in Windows SharePoint Services, see Managing Site Groups and Permissions and Managing Users and Cross-Site Groups.


Security Considerations for Server and Site Configurations

Security Considerations for Server and Site Configurations

When you host content on a Web service, you must make decisions about how best to protect the content from unauthorized users, and to what degree the content needs to be protected. The decisions you make influence the way you configure your servers and sites. There are pros and cons to each configuration, and your organization's requirements for security will always be different than another organization's requirements.

Microsoft Windows SharePoint Services, like most other Web services, supports multiple configurations, each of which has different tradeoffs in functionality, performance, ease of deployment, and security. This topic discusses eight specific ways of deploying content with Windows SharePoint Services, and lists each method's pros and cons from a security standpoint. Choose the configuration that best meets the needs of your data and your organization.

1. Physical Isolation: Separate Networks

The most secure way of deploying Windows SharePoint Services content is to isolate the content from all untrusted users. You can do this by removing all network connections from the server running Windows SharePoint Services or by creating a separate physical network dedicated to the Windows SharePoint Services content.

This option has obvious drawbacks in functionality and ease of deployment. Users will not be able to use their existing network credentials to authenticate on the server running Windows SharePoint Services and creating multiple physically isolated networks is a costly deployment option.

2. Physical Isolation: Separate Server Computers

The next most secure way to deploy Windows SharePoint Services content is to put each site on its own server computer. This helps mitigate a security exploit on one site that grants the attacker control of the server computer from being used to attack other sites based on Windows SharePoint Services.

Again, this option has serious drawbacks for ease and cost of deployment. Each new Windows SharePoint Services site requires a new server computer. This is a waste of server resources if the sites cannot keep the server computers busy all the time, and it is an administrative drain to manage multiple server computers.

3. Process Isolation: Separate Application Pools

The next most secure way to deploy Windows SharePoint Services is to put each site in its own application pool on the same server computer. Application pools in Internet Information Services (IIS) provide a way for multiple sites to run on the same server computer but still have their own worker processes. This mitigates an exploit on one site which allows the attacker to inject code onto the server from attacking other sites. Each site has its own worker process and identity which prevents two processes from interacting.

While this configuration is easier to deploy than separate server computers, deploying Windows SharePoint Services sites using separate application pools still has significant performance and deployment issues. Because each application pool has its own process, you can’t deploy more than 10 to 20 Windows SharePoint Services sites on a server by using different application pools. The memory overhead of each application pool is about 30 to 50 MB. Beyond ten to twenty sites, the server will run out of memory to hold all the site processes.

4. Logical Isolation: Separate Virtual Servers

The next most secure way to deploy Windows SharePoint Services is to put each site into its own virtual server with a unique domain name but using the same application pool. This method gives each site its own domain name, which helps prevent cross-site scripting attacks.

However this method still suffers from the scalability limitations of multiple virtual servers. Each ASP.NET page generates a separate DLL for each virtual server, even if the source file of the ASP.NET pages is the same. The separate DLLs consume memory and will prevent more than 100 Windows SharePoint Services sites from running on the same server.

5. Logical Isolation: Separate Host Headers

Windows SharePoint Services also supports hosting multiple domain-named sites in a single virtual server. This is called host header mode because Windows SharePoint Services uses the host header or domain name to resolve the different sites. This scales much better than separate virtual servers and still helps prevent cross-site scripting attacks between two Windows SharePoint Services sites. Windows SharePoint Services can host up to two million sites per server computer in host header mode.

The downside of this configuration is in the additional deployment costs. In this configuration, each site requires a separate DNS entry in the domain controller.

6. SharePoint Site Isolation: Separate Site Collections

Windows SharePoint Services also supports hosting multiple site collections using the same virtual server and the same domain name. Site collections can be scaled out across multiple database servers for additional storage capacity and throughput. The upside of this configuration is scalability and ease of deployment. Windows SharePoint Services can host up to 2 million sites in a single domain. Creating a site collection does not require any DNS entry and can be easily automated and delegated to end-users. Windows SharePoint Services includes Self-Service Site Creation so users can even create their own sites.

However, while Windows SharePoint Services enforces security on the site, the sites are still vulnerable to cross-site scripting attacks from other sites within the domain.

7. SharePoint Site Isolation: Separate Sites

Windows SharePoint Services also supports multiple subsites and workspace sites within a single site collection. Windows SharePoint Services can host up to 250,000 subsites within a given site if the subsites are organized into folders of no more than 1000 subsites each.

The upside of this configuration is seamless navigation around the site collection. There is no built-in navigation from one site collection to another, but there is navigation from one subsite to another within a site collection.

The downside is reduced scalability - because all sites must be stored in the same content database, it is difficult to increase either storage capacity or throughput. Also, as with site collections, separate sites are vulnerable to cross-site scripting attacks from other sites within the domain.

8. SharePoint Site Isolation: Separate Lists

Finally, Windows SharePoint Services supports list- and library-level security. You can deploy content in a single site using separate lists and document libraries for different content. The upside of this configuration is seamless navigation around the site and global visibility of all objects. Users will be able to see that a library exists, even if they have no permission to read documents inside the library.

However, this is the least secure way to deploy Windows SharePoint Services content. The content is vulnerable to cross-security scripting attacks. Users in parent sites can also delete or deny access to content in subsites.

For more information about list-level security, see the Windows SharePoint Services Help system.

Other Security Issues

In addition to the eight deployment configurations list above, there are two other security issues worth mentioning that apply to all configurations: secure sockets layer and anonymous access.

  • Secure Sockets Layer (SSL)

    All of the deployment configurations above are vulnerable to network sniffing attacks unless the communication between the client and server is encrypted. Windows SharePoint Services supports the standard IIS SSL functionality to encrypt content between client and server. There is a substantial performance penalty for using SSL, but it the only way to protect data from hackers who can monitor the network. When using basic authentication, SSL is highly recommended because basic authentication sends user names and passwords over the network and SSL protects that data.

  • Anonymous Access

    Windows SharePoint Services supports anonymous access, but it is disabled by default. Any server that allows anonymous access is more vulnerable than a server that requires authentication. Anonymous sites can be attacked by anyone. Servers that require authentication can only be attacked by users who have some permission on the network.

Related Topics

For more information about Windows SharePoint Services architecture, including server farms, virtual servers, application pools, site collections, and sites, see the following topics:

  • Microsoft Windows SharePoint Services 2.0 Architecture
  • Installation Considerations for Windows SharePoint Services
  • Creating Sites and Subsites

For information about SSL and anonymous access in Windows SharePoint Services, see the following topics:

  • Configuring Authentication
  • Windows SharePoint Services Security Model

For more information about installing Windows SharePoint Services, see the following topics:

  • Single Server Deployment
  • Remote SQL Server Deployment
  • Server Farm with Multiple Host Names Deployment
  • Configuring Two Virtual Servers to Host the Same Content
  • Separate Active Directory Organization Unit Deployment


Internet Explorer Enhanced Security and Windows SharePoint Services

Internet Explorer Enhanced Security and Windows SharePoint Services

By default, Microsoft Windows Server 2003 provides a set of security settings called Internet Explorer Enhanced Security Configuration. These settings limit the types of content that a user at the server computer can view using Microsoft Internet Explorer, except for sites listed in the Local intranet and Trusted sites zones. For example, by default, scripting on Internet pages won't run. The goal of these settings is to help ensure that a local user on a computer that is also running as a server will not download a virus or other harmful files from the Internet and infect the server. Internet Explorer Enhanced Security Configuration doesn't affect remote users viewing content on the server, only users running Internet Explorer on the server computer itself. For more information about Internet Explorer Enhanced Security Configuration, see Help in Windows Server 2003.

Using Internet Explorer Enhanced Security Configuration on a Web server running Microsoft Windows SharePoint Services prevents some code that is necessary for viewing site pages or HTML administration pages from running. Again, remote users with proper access rights can still view the pages correctly, but a user running Internet Explorer on the server computer will be unable to view or manage the site. Note also that the user at the server computer will be unable to view and manage a remote SharePoint site, because of the security settings.

Workarounds

You can use one or more of the following workarounds to ensure that Windows SharePoint Services works properly in your environment.

Browse to your SharePoint site as http:// localhost

For basic installations, simply running Windows SharePoint Services by using the default host name localhost will allow you to view the pages. However, this is not a good option for more complex installations, such as host header-based sites or server farms. Note that the SharePoint Central Administration link uses the localhost host name method. For more information about this option, see Help in Windows Server 2003.

Add the SharePoint sites to the list of local intranet sites

A more time-consuming but potentially more secure solution is for a server administrator to add the URLs of all virtual servers that are being hosted to the Internet Explorer Local intranet zone. In a server farm, the administrator must also add the URLs of all domain-named sites to the list of local intranet sites. For example, if a server farm is hosting the sites http://site1 and http://site2, both "site1" and "site2" need to be added to the list of local intranet sites. Additionally, the name of each front-end Web server that is a member of the server farm needs to be added to the list of local intranet sites. For example, if you have a server farm that has two servers running SQL Server named sql1 and sql2, and three front-end Web servers named it1, it2, and it3, then it1, it2, and it3 need to be added to the list of intranet sites. It is important to note that all these server names and domain-named sites need to be added to the list of local intranet sites on each front-end Web server. For more information about adding to the list of local intranet sites, see Help in Internet Explorer.

Uninstall Internet Explorer Enhanced Security Configuration

If you are not concerned about users working locally at the Web server, an administrator can uninstall Internet Explorer Enhanced Security Configuration by opening Control Panel, clicking Add or Remove Programs, and then clicking Add Remove Windows Components. This option is good for host header-based sites or server farms, because it requires less time spent configuring each server's settings. For more information about this option, see Help in Windows Server 2003.

Caution Uninstalling this feature greatly increases the "attack surface" presented by Internet Explorer. Removing the Internet Explorer Enhanced Security feature could compromise the server by allowing malicious code to be executed. Uninstalling this feature does not remove the Internet Explorer security enhancements included with Service Pack 1, including Pop-up Blocker, Add-on Management, and Local Machine Zone Lockdown. For additional information about this feature, download the Windows Server 2003 Service Pack 1 Product Overview Guide. Note that Windows Server 2003 Service Pack 1 includes new administrative templates that enable Group Policy management of Internet Explorer. These settings might override any changes made locally, which means that you might be unable to uninstall Internet Explorer Enhanced Security Configuration.


Configuring Authentication

Configuring Authentication

You configure authentication for Web sites based on Microsoft Windows SharePoint Services by configuring authentication methods in Internet Information Services (IIS). Windows SharePoint Services uses the authentication method you specify for a virtual server in IIS to control authentication for all top-level Web sites and subsites of that virtual server. Windows SharePoint Services works with the following authentication methods in IIS:

  • Anonymous authentication
  • Basic authentication
  • Integrated Windows authentication
  • Certificates authentication (SSL)

You can change authentication methods for virtual servers hosting Web sites based on Windows SharePoint Services, and you can change the authentication method used for the SharePoint Central Administration site. You can also enable Secure Sockets Layer (SSL) security in IIS to help protect your sites or the administration port for your server.

Changing Authentication Methods

Each virtual server can use a different authentication method in Internet Information Services (IIS). You can even enable multiple authentication methods if you are using the same Web site content in more than one environment. For example, if you have a Web site that is primarily for internal use within your organization, you would most likely choose Integrated Windows authentication. If, however, your use of the site changes, and you must allow your organization's members to access the site externally through a firewall, you might also want to enable Basic authentication.

Note Basic authentication is less secure than Integrated Windows authentication. For this scenario it is recommended that you use Basic authentication with SSL to help make your environment more secure.

When you change authentication methods in IIS, you do not need to change any settings in Windows SharePoint Services. For example, if you decide to use Integrated Windows authentication instead of Basic authentication, you make the change only in IIS.

Change authentication methods
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Click the plus sign (+) next to the server name that contains the virtual server you want to change.
  3. Click the plus sign (+) next to Web sites.
  4. Right-click the virtual server, and then click Properties.
  5. On the Directory Security tab, under Authentication and access control, click Edit.
  6. Select the check boxes for the authentication methods you want to enable, and clear the check boxes for the authentication methods you want to disable.
  7. Click OK to close the Authentication Methods dialog box.
  8. Click OK again to close the Properties dialog box.

Note For more information about IIS authentication methods, see the topic About Authentication in IIS 6.0 Help.

Enabling Secure Sockets Layer (SSL)

To enable SSL for a virtual server hosting Web sites based on Windows SharePoint Services, you can simply turn on SSL in IIS. If you want to use SSL for the SharePoint Central Administration virtual server, you must also use the setadminport command-line operation to enable SSL in Windows SharePoint Services.

Enabling SSL in IIS

You can enable SSL for a virtual server by using Internet Information Services (IIS) Manager. Note that you must have a certificate before you can enable SSL. For more information about SSL certificates, see the topics About Certificates and Setting Up SSL on Your Server in IIS 6.0 Help.

Enable SSL in IIS
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Click the plus sign (+) next to the server name that contains the virtual server you want to change.
  3. Click the plus sign (+) next to Web sites.
  4. Right-click the virtual server, and then click Properties.
  5. On the Directory Security tab, under Secure communications, click Edit.
  6. In the Secure Communications dialog box, select the Require secure channel (SSL) check box, and then click OK.
  7. Click OK again to close the Properties dialog box.

Enabling SSL for the SharePoint Central Administration Pages

After you have enabled SSL for the SharePoint Central Administration virtual server in IIS, you must use the command line to configure Windows SharePoint Services to use SSL. Perform the following steps to configure Windows SharePoint Services to use SSL for the Central Administration pages.

Enable SSL for the SharePoint Central Administration pages
  1. If you have a server farm, you must set all of the servers in your server farm to use the same administration port by using syntax similar to the following:
    stsadm.exe –o –setadminport –p 443

    Replace the port number in the example syntax with the port number you want to use for remote administration. Run this command on each Web front-end server in your server farm. Note that this step is for server farms only; you do not need to change the administration port if you are running Windows SharePoint Services on a single server.

  2. Configure the administration pages to use SSL by using syntax similar to the following:
    stsadm.exe –o –setadminport –ssl

If you have a server farm, you must run this command on each Web front-end server in your server farm.

Note If you want a more secure administration port, it is recommended that you also use your firewall or the IIS IP and domain restrictions feature to restrict access to the administration port. With either the firewall or IP and domain restrictions, you can specify that requests from unauthorized IP addresses or network domain names be ignored. For more information about configuring IP and domain restrictions in IIS, see the IIS Help system. For more information about configuring your firewall to reject unauthorized requests, see the documentation for your firewall.

Related Topics

For more information about authentication methods or SSL, see "Windows SharePoint Services Security Model" in the Windows SharePoint Services Administrator's Guide.

For more information about using command-line operations such as setadminport, see Command-Line Operations.


Managing the SharePoint Administration Group

Managing the SharePoint Administration Group

Two sets of users are allowed to perform administrative functions for Microsoft Windows SharePoint Services: members of the administrators group for the local server computer and members of the SharePoint administration group. The SharePoint administration group is a Microsoft Windows domain group that is registered with Windows SharePoint Services. Members of this domain group can perform Central Administration tasks without having to be given administrator rights to the local server computer. This is particularly useful in a server farm, because you can grant rights across the server farm, rather than individually for each computer in the server farm. This is also useful for applications that call into the administrative object model for Windows SharePoint Services. If the application process can be configured to run as a member of the SharePoint administration group, it can create new sites, modify quota values for sites, and so on.

Members of the Administrators group on the local server computer have full control of all applications running on that server, including Internet Information Services (IIS), Microsoft SQL Server, Microsoft ASP.NET, and Windows SharePoint Services. These administrators can perform any task on that server, including all administration tasks for Windows SharePoint Services, such as controlling administrative functions, configuring settings at the server or virtual server level, and creating or changing sites and lists.

Members of the SharePoint administration group can perform SharePoint Central Administration tasks, but do not have access to the file system of the server or the IIS metabase, so they cannot perform actions on other applications running on the server, such as IIS, Microsoft SQL Server, ASP.NET, and so on. Specifically, members of the SharePoint administration group cannot perform the following actions for Windows SharePoint Services:

  • Extend virtual servers (they can, however, create top-level Web sites or change settings for a virtual server).
  • Remove Windows SharePoint Services from a virtual server.
  • Manage paths.
  • Change the SharePoint administration group.
  • Change the configuration database settings.
  • Set the default content database server or manage the content databases.
  • Enable full-text searching.
  • Configure the SharePoint Central Administration virtual server.
  • Use the Stsadm.exe command-line tool.

Members of the SharePoint administration group can perform any other administrative action using the HTML Administration pages or object model for Windows SharePoint Services. For example, members of the group can view and manage all sites created on their servers. This means that a member of the SharePoint administration group can read documents or list items, change survey settings, delete a site, or perform any action on a site that the site administrator can perform.

Note To manage the SharePoint administration group, you must be a member of the Administrators group of the local server computer.

Specify the SharePoint administration group

  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Security Configuration, click Set SharePoint administration group.
  3. In the Group account name box, type the domain group you want to allow to administer Windows SharePoint Services.
  4. Click OK.

Changing the Group or Changing Group Membership

You can only register one domain group as the SharePoint administration group, so if you want to include other members, you must add them to the group using the user and group management tools for your domain. If you want to change which group is registered, you can follow the steps to specify a group and specify a different domain group. When you specify a new group, the old group's rights are removed, and the members of that group can no longer manage the servers running Windows SharePoint Services.


Managing Users and Cross-Site Groups

Managing Users and Cross-Site Groups

Every Web site has users, and part of your job as administrator is to make sure the users of a Web site have the appropriate rights to use the site. To grant access to a site, users must be added to the site (either individually or as part of a cross-site group) and assigned to a site group. In Microsoft Windows SharePoint Services, users and cross-site groups can be added by using one of two modes:

  • Domain account mode — Used inside organizations to grant access to users and groups with existing domain accounts
  • Active Directory account creation mode — Used by Internet service providers to create unique accounts for customers

You determine which mode to use when you first install and configure Windows SharePoint Services, and you cannot switch between modes later. Whichever mode you use, you can add users and cross-site groups to your site by using either the command-line tool or HTML Administration pages for your Web site.

Note Mixing account modes is not supported. You must choose either domain account mode or Active Directory account creation mode. Some organizations may need to be able manage accounts for both internal employees (in the organization’s Active Directory directory service) and external customers (not in organization’s Active Directory directory service). In these cases, one option is to choose domain account mode, use a separate forest for the external users, and then configure the external forest to trust the internal domain for adding internal users.

About Domain Account Mode

If you are using Windows SharePoint Services inside an organization that uses Microsoft Windows domain accounts, you can use domain account mode for user and cross-site group accounts. With domain account mode, you add users and cross-site groups to your site using their existing domain account information, including their account names and e-mail addresses. And you can add Windows NT domain groups to your site, which is not possible in Active Directory account creation mode. Domain account mode is the standard mode for Windows SharePoint Services. Note that you can use Active Directory directory service to manage domain accounts — the difference between the modes is the type of account you use and when they are created, not the tool you use to manage them.

About Active Directory Account Creation Mode

If you host Web sites based on Windows SharePoint Services for customers on the World Wide Web, you can configure Windows SharePoint Services to automatically create Active Directory accounts for new users and cross-site groups. You must enable Active Directory account creation mode when you first configure Windows SharePoint Services. When you use Active Directory account creation mode, you cannot use pre-existing domain accounts; instead, new accounts are created whenever you add users.

Creating users and cross-site groups with Active Directory account creation mode is the same as creating users with domain account mode, except that you only enter the e-mail address or group name, not a domain account, when adding the user or cross-site group to a site. Windows SharePoint Services checks Active Directory to see if an account with that e-mail address or group name already exists. If the user or cross-site group already has an account in Active Directory, the account is used. If the user or cross-site group is new, an account is created for them in Active Directory, using the Windows SharePoint Services credentials, and they are notified of their account name and password through e-mail.

Notes

  • When you are in Active Directory account creation mode, there are certain administrative tasks that are unavailable in the HTML Administration pages. For example, you cannot create a top-level Web site, you cannot enable Self-Service Site Creation, and you cannot add a user to a site from the Central Administration pages. To perform these actions in Active Directory account creation mode, you must use the command line or the object model. For more information, see Using the Object Model to Manage Windows SharePoint Services.
  • The Minimum Password Age group policy on the domain controller must be set to 0 days. Failure to do so will result in users being unable to change their passwords, unless they have administrator rights on the server. For information on setting the Minimum Password Age group policy, see Microsoft Windows 2003 Server online help.

Using HTML Administration Pages to Manage Users and Cross-site Groups

The steps for adding users and cross-site groups are the same, no matter which account mode you are using. Using either method, you can manage users and cross-site groups from the Site Settings page for your Web site.

To manage users and cross-site groups, you follow the Manage users link on the Site Settings page to the Manage Users page. By using this page, you can view a list of users and cross-site groups, check which site group a user or cross-site group is assigned to, add new users and cross-site groups, delete users and cross-site groups, or assign users and cross-site groups to site groups. When you add new users or cross-site groups, you also have the option to send an e-mail message to them, inviting them to use the site. You can even include a custom message in the invitation e-mail message. For example, you can describe your site and what it should be used for, or add a personal message to the default e-mail invitation.

Note If you do not see the Manage users link on your Site Settings page, you are probably in a subsite that uses the permission settings of a higher-level Web site of the server or virtual server. To work with user accounts and permissions, either go to the parent-level Web site, or change to using unique permissions for the subsite. For more information about subsite permissions, see Managing Site Groups and Permissions.

If you want to view which site groups a user is a member of, you use the Manage Users page.

View site group membership for a user or cross-site group
  • On the Web site you want to manage, click Site Settings.
  • On the Site Settings page, under Administration, click Manage users.

    The users and cross-site groups added to the Web site and the site groups they are a member of are displayed on the Manage Users page.

From the Manage Users page, you can change which site group a user or cross-site group is a member of.

Change site group membership for a user or cross-site group
  1. On the Manage Users page, select the check box next to the user or cross-site group name you want to change.
  2. Click Edit Site Group of Selected Users.
  3. In the Site Group Membership area, select the site group you want the user or cross-site group to be a member of.
  4. Click OK.

You can also add new users and cross-site groups to your site from the Manage Users page.

Add a new user or cross-site group
  1. On the Manage Users page, click Add Users.
  2. In the Step 1: Choose Users section specify the users that you would like to add, separated by semicolons. You can enter:
    • E-mail addresses (for example, someone@example.com)
    • User names (for example, DOMAIN\user_name)
    • Microsoft Active Directory directory service security group names (for example, DOMAIN\security_group_name)
    • Domain group names (for example, DOMAIN\group_name)
    • Cross-site group names (for example, Accounting)

    Notes

    • When running Windows SharePoint Services in a server farm, you cannot add local accounts.
    • Local accounts must exist before you attempt to add them. Windows SharePoint Services does not create local accounts like SharePoint Team Services v1.0 does.
    • When using Active Directory account creation mode, you cannot add local accounts or security groups.
  3. In the Step 2: Choose Permissions section, select the site group that the user or group will belong to, and then click Next.
  4. In the Step 3: Confirm Users section, verify the e-mail addresses, user names, and display names.
  5. In the Step 4: Send E-mail section, if you want to send an invitation, select Send the following e-mail to let these users know they've been added, and type the subject and body text information to send in the e-mail message.
  6. Click Finish.

You can delete users or cross-site groups from all site groups by using the Manage Users page. Note that this does not delete the user or cross-site group account, but does remove all rights to the Web site.

Add all users from an e-mail distribution list

Note To complete the steps in this section you must have a Windows SharePoint Services-compatible address book program such as Microsoft Office Outlook 2003 installed on the computer you are running.

  1. On the Web site you want to manage, click Site Settings.
  2. On the Site Settings page, in the Administration section, click Manage Users.
  3. On the Manage Users page, click Add Users.
  4. In the Step 1: Choose Users section, click Address Book.
  5. Select the distribution list you want to add from the address book.

    Note You can add only distribution lists that reside on the same e-mail server as your current e-mail account. For example, in Office Outlook 2003 the names of distribution lists that reside on the same e-mail server appear in bold text.

    The list of users from the distribution list appears in the Users field.
  6. In the Step 2: Choose Permissions section, select the site group to which you want to add the members of the distribution list, and then click Next.
  7. In the Step 3: Confirm Users section, verify the e-mail addresses, user names, and display names.
  8. In the Step 4: Send E-mail section, if you want to send an invitation, select Send the following e-mail to let these users know they've been added, and type the subject and body text information to send in the e-mail message.
  9. Click Finish.

Note Adding or removing users from the e-mail distribution list will not add or remove them from the site. You must manually add or remove users from the site after changing your distribution list membership.

Delete a user or cross-site group from all site groups
  1. On the Manage Users page, select the check box next to the user or cross-site group you want to delete.
  2. Click Remove Selected Users.
  3. On the confirmation message that appears, click OK to remove the users.

Managing Users in a Site Collection

Every Web site with unique permissions has a Manage Users page that the site's administrator can use to add, modify, or delete users. In addition to this page, the top-level Web site in a Web site collection also includes a page that server administrators or the site collection administrator can use to view and delete users. This page lists all users for the site collection, including the users of the top-level Web site and users of any subsites in the site collection. When you remove a user from this list, the user is removed from all sites and subsites in the site collection.

Remove a user from a top-level Web site
  1. On the top-level Web site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. On the Top-Level Site Administration page, under Site Collection Administration, click View site collection user information.
  4. Select the check box next to the user you want to remove, and then click Remove Selected Users.

Managing Users from SharePoint Central Administration

If you are an administrator on the server computer or a member of the SharePoint administrators group, you may have administrative rights to change settings on the Site Settings page for any individual site on your server. What happens when a top-level Web site owner leaves your organization, or a user must be added to or removed from a site that you do not have administrative rights for? The SharePoint Central Administration page includes a link for managing users for sites even if the administrator does not have rights to the site. You can add users or cross-site groups, remove users or cross-site groups, change site group membership, and change owners, without having to be an administrator on a specific site. You do, however, need to know the URL for the site, and the specific user name that you want to change.

Change the owner of a site collection
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, under Security Configuration, click Manage site collection owners.
  3. On the Manage Site Collection Owners page, in the Site URL box, type the URL to the site, and then click View.

    The information for the current site owner and secondary owner is automatically filled in on the page when you click View.

  4. In the Site Owner section, in the User name box, type the account name for the new owner.
  5. If you have a new secondary contact name, type the account name in the Secondary Owner section.
  6. Click OK.

If you are an administrator on the server computer, and need to change the owner of a site that you do not have administrative access to, you can make the change from the SharePoint Central Administration page.

Add a new site user or group
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, in the Security Configuration section, click Manage Web site users.
  3. On the Manage Web Site Users page, in the Site URL box, type the URL to the site, and then click View.
  4. In the Add a User section, specify the users that you would like to add, separated by semicolons. You can enter:
    • E-mail addresses (for example, someone@example.com)
    • User names (for example, DOMAIN\name)
    • Microsoft Active Directory directory service security group names (for example, DOMAIN\security_group_name)
    • Domain group names (for example, DOMAIN\group_name)
    • Cross-site group names (for example, Accounting)

    Notes

    • When running Windows SharePoint Services in a server farm, you cannot add local accounts.
    • Local accounts must exist before you attempt to add them. Windows SharePoint Services does not create local accounts like SharePoint Team Services v1.0 does.
    • When using Active Directory account creation mode, you cannot add local accounts or security groups.
  5. In the Display name box, type the full name.
  6. In the E-mail address box, type the e-mail address.
  7. In the Site group box, select a site group to which to add the user or group, and then click Add User.

You can also delete a user or change a user's site group membership from this page.

Delete a site user or change site group membership
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, under Security, click Manage Web site users.
  3. On the Manage Web Site Users page, in the Site URL box, type the URL to the site, and then click View.
  4. In the Change Existing User section, in the Account name box, type the user account you want to change or delete, and then click View user.
  5. To change site group membership, select the check box for the site group you want the user to be a member of, and then click Update.
  6. To remove the user from all site groups, click Delete User.

Using the Command Line to Manage Users

You can add a user account to your site by using the adduser operation. The adduser operation takes the url, userlogin, useremail, username, and role parameters, plus the optional parameter siteadmin. You use the siteadmin parameter to specify that the user is the site collection administrator or owner of the site collection. Note that if you are using Active Directory account creation mode, you do not need to specify the userlogin parameter; you would use the useremail parameter to identify the user instead.

For example, to add User1 as an administrator for http://server1/site1 in domain account mode, you would type:

stsadm.exe -o adduser –url http://server1/site1
–userlogin DOMAIN1\User1 -useremail user1@domain.com
-username "User 1" -role administrator

You use the deleteuser operation to remove users from a site. The deleteuser operation takes the url and userlogin parameters. To remove User1 from http://server1/site1, you would type:

stsadm.exe -o deleteuser –url http://server1/site1
–userlogin DOMAIN1\User1

You can assign a user to a site group from the command line by using the userrole operation. The userrole operation takes the url, userlogin, role, and add or delete parameters. For example, to add the user User1 to the Contributor site group for site http://server1/site1, you would type:

stsadm.exe -o userrole –url http://server1/site1 –userlogin DOMAIN1\User1
-role contributor -add

Note that this does not remove the user from any site groups they were previously members of.

Related Topics

For information about creating, editing, or deleting site groups and controlling Web site permissions, see Managing Site Groups and Permissions.

For more information about security, see Windows SharePoint Services Security Model .

With Windows SharePoint Services, you can set quotas and determine how many new user accounts can be created for each virtual server. For more information about setting quotas, see Configuring Site Quotas and Locks.


Managing Site Groups and Permissions

Managing Site Groups and Permissions

When you set up a Web site, you need a way to specify who has access to it. For a typical Internet site, you probably want everyone who comes to the site to be able to view your content, but you don't want them to be able to change that content. For a company intranet site, you may want a few people controlling the structure of the site, but many more people who can add new content, or participate in group calendars or surveys. For an extranet, you want to carefully control which people can view the site at all. Generally, access to Web sites is controlled by combining user accounts with some sort of permissions structure that controls the specific actions users can perform.

Microsoft Windows SharePoint Services provides the ability to control site access through the following means:

  • Site groups

    Site groups let you specify which of your users can perform specific actions in your site. For example, a user who is a member of the Contributor site group can add content to Windows SharePoint Services lists, such as the Task list, or a document library.

  • Anonymous access control

    You can enable anonymous access to allow users to contribute anonymously to lists and surveys, or to view pages anonymously. Most Internet Web sites allow anonymous viewing of the site, but may ask for authentication when someone wants to edit the site or buy an item on a shopping site.

    Note You can also grant access to "all authenticated users" to allow all members of your domain to access a Web site, without having to enable anonymous access.

  • Per-list permissions

    You can manage permissions more finely by setting unique permissions on a per-list basis. For example, if you have a document library containing sensitive financial data for the next fiscal year, you can restrict access to that list so that only the appropriate users can view it. Per-list permissions override site-wide permissions for the lists.

  • Subsite permissions

    Subsites can either use the same permissions as the parent Web site (inheriting both the site groups and users available on the parent Web site), or use unique permissions (so you can create your own user accounts and add them to site groups).

  • Site creation rights

    There are two rights that control whether users can create top-level Web sites, subsites, or workspaces: Use Self-Service Site Creation and Create Subsites.

Defining Site Groups

Windows SharePoint Services uses site groups to manage site-wide security. Each user is a member of at least one site group. Each site group possesses corresponding rights. Rights are actions that users can perform, such as Manage Lists. With Windows SharePoint Services, you can use the following default site groups: Guest, Reader, Contributor, Web Designer, and Administrator. In addition, Windows SharePoint Services allows you to edit the rights assigned to a site group, create a new site group, or delete an unused site group. You manage site groups in Windows SharePoint Services with either HTML Administration pages or the command-line administration tool. Note that you cannot change the rights assigned to the Guest and Administrator site groups, and you cannot assign users directly to the Guest site group.

Note It is possible to add user accounts to a Web site without assigning them to a site group. For example, if you are creating new user accounts for the Web site, you can create the user accounts and then assign the users to site groups later. You can also remove a member from all site groups. However, a user who is not assigned to a site group has no access to the Web site.

Windows SharePoint Services includes the following site groups by default:

  • Guest — Has limited rights to view pages and specific page elements. This site group is used for giving users access to a particular page, or list, without granting them rights to view the entire site. Users cannot be explicitly added to the Guest site group, rather users who are given access to lists or document libraries by way of per-list permissions are automatically added to the Guest site group. The Guest site group cannot be customized or deleted.
  • Reader — Has rights to view items, view pages, and create a top-level Web site using Self-Service Site Creation. Readers can only read a site; they cannot add content. Note that when a reader creates a site using Self-Service Site Creation, he or she becomes the site owner and a member of the Administrator site group for the new site. This does not affect the user's site group membership for any other site.
  • Contributor — Has Reader rights, plus rights to add, edit, and delete items, browse directories, manage personal views, add or remove personal Web Parts, update personal Web Parts, and create cross-site groups. Contributors cannot create new lists or document libraries, but they can add content to existing lists and document libraries.
  • Web Designer — Has Contributor rights, plus rights to cancel check-out, manage lists, add and customize pages, define and apply themes and borders, and apply style sheets. Web Designers can modify the structure of the site and create new lists or document libraries.
  • Administrator — Has all rights from other site groups, plus rights to manage site groups, manage list permissions, create sites and Workspaces sites, and view usage analysis data. The Administrator site group cannot be customized or deleted, and there must always be at least one member of the Administrator site group. Members of the Administrator site group always have access to, or can grant themselves access to, any item in the Web site.

    Note The owner and secondary owner of a site collection are members of the Administrator site group for their site, but they are also identified separately in the configuration database as site collection owners. This owner flag can only be changed by using the Manage Site Collection Owners page in Central Administration or by using the siteowner operation with Stsadm.exe. If you remove an owner from the Administrator site group for the site, the owner retains the owner flag in the database, and can still perform Web site administrative tasks.

These site groups are defined per Web site. Users assigned to the Administrator site group are administrators only for a particular Web site. To perform any administrative tasks that affect settings for all Web sites and virtual servers on the server computer, a user must be an administrator for the server computer (also known as a local machine administrator) or a member of the SharePoint administrators group, rather than a member of a site's Administrator site group.

For a complete list of user rights and to see which are included in each site group by default, see User Rights and Site Groups.

Customizing Rights for Site Groups

You can create a new site group or customize an existing site group (except for the Guest and Administrator site groups, which cannot be customized) to include only the rights you want. For example, if you want only the Web Designers to be able to edit lists on the site, you can remove the Edit Items right from the Contributor site group.

Some rights depend on other rights. You must be able to view items before you can edit items. If a right is deleted from a site group, any rights dependent on that right are also deleted. For example, when the View Items right is deleted, the Add Items, Edit Items, and Delete Items rights are also deleted. In the same way, if you add a right that requires another right, the required right is also added. So, if you grant the Edit Items right to a user, the View Items right is granted automatically.

Note For more information about dependencies in user rights, see User Rights and Site Groups.

Security and User Rights

User rights grant users the ability to perform certain actions on a Web site, and restrict other users from performing those actions. Some rights do not completely restrict certain actions. The Apply Themes and Borders and Apply Style Sheets rights allow users to make changes to an entire Web site. Any user with the Add and Customize Pages right, however, can perform the same changes on a page-by-page basis in the actual HTML code. Be aware that if you give a user the Add and Customize Pages right (by assigning them to a site group that contains the right), you are also giving them the ability to change the theme, border, and style sheets for individual pages in your Web site.

When you assign rights to site groups, be sure that you assign the appropriate rights, and do not unintentionally allow members of the site group to perform more actions that you want on your Web site. Conversely, be sure that members of the site group are not unintentionally restricted from performing the actions they need to perform.

Using HTML Administration Pages to Manage Site Groups

You can manage site groups from the Site Administration page for your Web site. To manage site groups, follow the Manage site groups link on the Site Administration page to the Manage Site Groups page. On this page, you can view a list of site groups, change which rights are included in a site group, add a new site group, or delete a site group.

View a list of site groups
  1. On the Site Settings page for your Web site, under Administration, click Go to Site Administration.
  2. On the Site Administration page, under Users and Permissions, click Manage site groups.

    The site groups available for the Web site are displayed on the Manage Site Groups page.

You can add new site groups for use on your site from the Manage Site Groups page.

Add a new site group
  1. On the Manage Site Groups page, click Add a Site Group.
  2. In the Site Group Name and Description area, type the name and description for your new site group.
  3. In the Rights area, select the rights you want to include in the new site group.
  4. Click Create Site Group.

You can create a new site group based on an existing site group, and even copy the members of the existing site group into your new site group.

Copy an existing site group
  1. On the Manage Site Groups page, click the site group you want to copy.
  2. On the Members of "Site group name" page, click Edit Site Group Permissions.
  3. On the Edit Site Group "Site group name" page, click Copy Site Group.
  4. On the Copy the Site Group "Site group name" page, in the Site Group Name and Description area, type the name and description for your new site group.
  5. If you want to copy the users from the existing site group into your new site group, select the Copy users from "site group name" check box.
  6. In the Rights area, select any additional rights that you want the site group to contain, and clear any rights that you do not want the site group to contain.
  7. Click Create Site Group.

You can also edit an existing site group to change the rights assigned to that site group.

Edit an existing site group
  1. On the Manage Site Groups page, click the site group you want to change.
  2. On the Members of "Site group name" page, click Edit Site Group Permissions.
  3. On the Edit Site Group "Site group name" page, select the rights you want to include and clear any rights that you do not want.
  4. Click OK.

If you find that a site group is not used, you can delete the site group.

Delete an existing site group
  1. On the Manage Site Groups page, select the check box next to the site group you want to delete.
  2. Click Delete Selected Site Groups.

Using the Command Line to View Site Groups

You can view the list of site groups from the command line in Windows SharePoint Services by using the enumroles operation. This operation takes the -url parameter, and then simply lists the names of the site groups for that URL, so you can use the correct site group name when assigning permissions to users. For example, to view the list of site groups for a site at http://myserver/site1, you would type the following command:

stsadm -o enumroles -url http://myserver/site1

Assigning Per-List Permissions

Windows SharePoint Services provides the ability to control permissions on a per-list basis. If you have sensitive information stored in a list, and you do not want to expose the information to all members of your site, you can set permissions for just that list to control which users can view, edit, or add items to that list. You can grant permissions to a list or document library to individual users, to groups of users, or to a site group. Per-list permissions work for any list or document library in a Web site based on Windows SharePoint Services (for example, Announcements, Tasks, Shared Documents, and so on).

List permissions can be changed by any user who has the Manage List Permissions right (by default, included in the Administrator site group) or Full Control permissions for that list. By default, all members of a Web site (all users assigned to a site group, except for the Guest site group) have access to all lists and document libraries on that Web site. Each site group has a predefined level of permissions for all lists and document libraries. The default list permissions are:

  • View items (given to the Reader site group by default)
  • View, insert, edit, delete items (given to the Contributor site group by default)
  • View, insert, edit, delete items; change list settings (given to the Web Designer site group by default)
  • View, insert, edit, delete items; change list settings; change list security

In addition, you can set advanced permissions, which allows you to grant any of the following rights for a user or site group:

  • Manage Lists (given to the Web Designer site group by default)
  • Manage List Permissions
  • Manage Personal Views (given to the Contributor site group by default)
  • Cancel Check-Out (applies only to document libraries; given to the Web Designer site group by default)
  • Add List Items, Edit List Items, and Delete List Items (given to the Contributor site group by default)
  • View List Items (given to the Reader site group by default)

Note Members of the Administrator site group always have the highest level of permissions for all lists and document libraries. You cannot change list or document library permissions for the Administrator site group. Also, any site group that has the View List Items right (such as Reader) can continue to see the list name, description, number of items, and time when the list was last modified, even though they cannot view the list contents directly.

To control permissions for a list, go to the list itself or to the Customize "Listname" page for the list.

View permissions for a list
  1. Navigate to the list, and then in the left pane, click Modify settings and columns.
  2. On the Customize "Listname" page, in the General Settings section, click Change permissions for this <list/document library>.

    The Change Permissions:"Listname" page displays the users and groups that have access to the list, and shows the permissions level each user or group is assigned.

You can change the list permissions for all members of a particular site group by modifying that site group's permissions.

Change list permissions for a particular site group
  1. Navigate to the list, and then in the left pane, click Modify settings and columns.
  2. On the Customize "Listname" page, in the General Settings section, click Change permissions for this <list/document library>.
  3. Select the check box next to the site group you want to change.

    For example, click the check box next to Web Designer to change the permissions for all members of the Web Designer site group.

  4. Click Edit Permissions of Selected Users.
  5. In the Choose Permissions section, select the level of permissions to allow, and then click OK.

You can also grant permissions to individual users, or to user groups, instead of to all members of a site group. Remember that when you grant a user or group permissions to a specific list in your site, they are added to the Guest site group if they are not already members of the site. Note that members of the Guest site group cannot navigate to a page within the site unless you give them the exact page URL.

Assign list permissions to a specific user or group
  1. Navigate to the list, and then in the left pane, click Modify settings and columns.
  2. On the Customize "Listname" page, in the General Settings section, click Change permissions for this <list/document library>.
  3. On the list toolbar, click Add Users.
  4. In the Step 1: Choose Users section, in the Users area, in the text box, type the network domain name or e-mail address for the user or group you want to assign permissions.
  5. In the Step 2: Choose Permissions section, under Permissions, select the level of permissions for the user or group, and then click Next.
  6. In the Step 3: Confirm Users section, verify that the e-mail address, user name, and display name for the user or group are correct.
  7. If you want to notify the user or group of their permissions with an e-mail message, in the Step 4: Send E-Mail section, select the Send the following e-mail to let these users know they've been added check box, and fill in the text you want to send.
  8. Click Finish.

If you want to restrict your list to a specific set of users, you must both grant access to the individual users and remove access from other site members.

Remove list permissions for a user, group, or site group
  1. Navigate to the list, and then in the left pane, click Modify settings and columns.
  2. On the Customize "Listname" page, in the General Settings section, click Change permissions for this <list/document library>.
  3. Select the check box next to the site group, user, or group you want to remove permissions for, and then click Remove Selected Users.

If you no longer want to use unique permissions for a particular list, you can reset the permissions to use the Web site's general permissions.

Reset permissions to the default state
  1. Navigate to the list, and then in the left pane, click Modify settings and columns.
  2. On the Customize "Listname" page, in the General Settings section, click Change permissions for this <list/document library>.
  3. Click Inherit permissions from the parent Web site.
  4. Click OK to change to inherited permissions.

Note The Inherit permissions from the parent Web site link does not appear unless the list permissions have already been customized.

Controlling Access for All Authenticated Users

If you want all authenticated users of your intranet to be able to access your Web site, rather than adding each user individually or in groups, you can configure your site to allow all users on your network rights to use the site. You can also specify which site group (either Reader or Contributor) to assign to all authenticated users.

Allow all authenticated users rights to a top-level Web site
  1. On your site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. On the Site Administration page, under Users and Permissions, click Manage anonymous access.
  4. In the All Authenticated Users section, under Allow all authenticated users to access site, select Yes.
  5. Under Assign these users to the following site group, select a site group.
  6. Click OK.

Controlling Anonymous Access to a Web Site

If you want users to be able to contribute to your site anonymously, you can configure your site to allow anonymous access. Anonymous access is used to allow users to browse sites without authenticating (a standard Internet scenario), respond anonymously to surveys, or even contribute to a list or document library anonymously.

Anonymous access relies on the anonymous user account on your Web server. This account is created and maintained by your Web server (Internet Information Services (IIS)), not by Windows SharePoint Services. On IIS, the anonymous user account is usually IUSR_ComputerName. When you enable anonymous access in Windows SharePoint Services, you are enabling that user account for your Web site.

Enabling Anonymous Access

Anonymous access is disabled by default, and is controlled at the site level. If you want to allow anonymous access (such as for an Internet site, where you want visitors to be able to browse without authenticating), you must enable anonymous access by assigning rights to the anonymous user. To enable anonymous access, you must first be sure that IIS is configured to allow anonymous access, and then on the Site Administration pages for your Web site, you can enable anonymous access.

Allow anonymous access for a virtual server in Internet Information Services
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Right-click the virtual server you want to enable anonymous access for, and then click Properties.
  3. Click the Directory Security tab.
  4. In the Authentication and access control section, click Edit.

    The Authentication Methods dialog box appears.

  5. Select the Enable anonymous access check box.
  6. Click OK to close the Authentication Methods dialog box.
  7. Click OK to close the Properties dialog box.

You may need to restart IIS for this change to take effect. After anonymous access has been turned on for the virtual server in IIS, you can enable anonymous access for a specific top-level Web site.

Enable anonymous access for a top-level Web site
  1. On your site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. On the Site Administration page, under Users and Permissions, click Manage anonymous access.
  4. In the Anonymous Access section, select a level of access to allow:
    • Entire Web site
    • Lists and libraries
    • Nothing
  5. Click OK.

Per-List Permissions and Anonymous Access

You can control anonymous access for your entire site by using the Manage Anonymous Access page, or you can control anonymous access for specific lists by using the per-list permissions feature. If anonymous access is disabled for your site, it cannot be enabled for a particular list in the site.

Enable anonymous access for a list
  1. Verify that anonymous access is enabled for your site.
  2. Navigate to the list, and then in the left pane, click Modify settings and columns.
  3. On the Customize "Listname" page, in the General Settings section, click Change permissions for this <list/document library>.
  4. In the Action pane, click Change anonymous access.
  5. On the Change Anonymous Access Settings page, click the check box for the level of permissions that you want to grant to anonymous users.

    Note If Internet Information Services (IIS) is not configured to allow anonymous access, these check boxes are unavailable.

  6. Click OK.

Creating Unique Permissions for a Subsite

When you create a subsite, you can choose whether to inherit the permissions from the parent Web site or to create unique permissions for your subsite. Depending on your choice, you get different results:

  • If you choose unique permissions, the default site groups are created (Guest, Reader, Contributor, Web Designer), but are not populated. The Administrator site group is also created, and the subsite creator is assigned to this site group. You can add users to the subsite and assign them to site groups, and they will have permissions only on your subsite, not on the parent Web site.
  • If you choose to inherit permissions, all of the security from the parent Web site is used for the subsite, with the exception of per-list permissions. If you add a user to a list, the user is added to the parent Web site.

Switching to a Different Permissions Model

If you set up your subsite with unique permissions, but find that you need to share permissions with your parent Web site instead, you can switch to inherited permissions. There are some drawbacks to making this switch, however, such as:

  • Switching from unique to inherited permissions is not reversible. The users and site groups from your subsite are deleted when you switch to inherited, and your subsite reverts to the permissions set for the parent Web site.
  • Items that have per-list permissions set lose those permissions. All lists revert to the site-wide permissions.

You can also switch from using inherited permissions to using unique permissions. In this case, the transition is simpler. The current permissions are duplicated when you switch, and the link to the parent Web site's permissions structure is broken. From that point on any changes you make to the permissions affect only the subsite. When you switch from inherited to unique permissions, per-list permission settings remain intact.

Note Switching between permissions models can create some strange scenarios. For example, any user who has the Create Subsites right can create a subsite. By default this right is included only in the Administrator site group, but if you assign it to another site group, members of that group can create subsites with unique permissions and become administrators of the new subsites. If such a user then chooses to switch to using the parent Web site's permissions, the user will no longer be an administrator of the subsite.

You use the Site Administration page for your subsite to switch to a different permissions model.

Set unique permissions by using HTML Administration pages
  1. On the subsite, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. On the Site Administration page, under Users and Permissions, click Manage permission inheritance.
  4. In the Permissions section, select Use unique permissions.
  5. Click OK.

If you want to return to using the same permissions as the parent Web site, you can also change back by using HTML Administration pages.

Return to the parent Web site's permissions
  1. On the subsite, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. On the Site Administration page, under Users and Permissions, click Manage permission inheritance.
  4. In the Permissions section, select Use the same permissions as the parent site.
  5. Click OK.
  6. Click OK to verify the change of permissions.

Managing Site Creation Rights

By default, when Self-Service Site Creation is enabled, all members of the Reader, Contributor, Web Designer, and Administrator site groups have the Use Self-Service Site Creation right. They can use this right to create a top-level Web site on a virtual server from the Create Web Site page. Another right, the Create Subsites right, is available to members of the Administrator site group by default. This right allows the user to create a subsite or a Workspace site from the Create page or the Manage Sites and Workspaces page.

You control which users have the Use Self-Service Site Creation right by changing the rights in a site group. You can control which users have the ability to create sites and Workspace sites by changing which site groups have the Create Subsites right, or by using the Configure Site and Workspace Creation page in Site Settings. You must be a member of the Administrator site group for a site to control these rights.

Specify which users can create subsites
  1. On a site, click Site Settings.
  2. On the Site Settings page, click Configure site and workspace creation.
  3. On the Configure Site and Workspace Creation page, select the check boxes next to the site groups you want to be able to create subsites.
  4. Click OK.

Related Topics

For information about assigning users to site groups, see Managing Users and Cross-Site Groups.

For more information about security, see "Windows SharePoint Services Security Model" in the Windows SharePoint Services Administrator's Guide.

For more information about Self-Service Site Creation, see Configuring Self-Service Site Creation.


Controlling User Rights and Assigning Tasks

Controlling User Rights and Assigning Tasks

As a server administrator, you have control over which actions users can perform for sites on your server, such as adding users to a Web site. You control their actions by controlling their rights. With Microsoft Windows SharePoint Services, you control rights in the following ways:

  • Limit the rights available for any site group on the virtual server.

    You use a rights mask to specify which rights can be included in site groups.

  • Allow anonymous access.

    You can determine whether anonymous users can use a particular Web site.

  • Assign rights to customized site groups, and include users in those site groups.

    You can include a specific right, such as Manage Lists, in a custom site group for users.

  • Allow users to request access.

    You can determine whether users can request access to a site, list, or document library.

Limiting Available Rights

As an administrator, if you want to allow or limit certain actions your users perform, you can disable or enable the associated right on the virtual server. For example, if you do not want users to be able to add pages to a Web site, you can disable the Add and Customize Pages right. When you disable a right on a virtual server, it cannot be assigned to any site group and, as a result, cannot be granted to any user of a site on the virtual server. Note that if a user already has a right, and you disable that right, the right is also disabled for that user.

Use the Manage User Rights for Virtual Server page in the Virtual Server Settings pages to specify which rights are available for site groups per virtual server.

Limit the rights for a virtual server
  1. On your server computer, click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Adminsitration.
  2. On the SharePoint Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the virtual server you want to affect.
  4. Under Security Settings, click Manage user rights for virtual server.
  5. Select the check boxes next to the rights you want to enable, and clear the check boxes next to those rights you want to disable.

    You can select all rights by selecting the Select All check box. You can clear all rights by clearing the Select All check box.

  6. Click OK.

Allowing Anonymous Access

You can control anonymous access at the virtual server level and at the Web site level. At the virtual server level, you can enable or disable anonymous access in IIS. For more information about configuring anonymous access in Internet Information Services (IIS), see Configuring Authentication.

If you have enabled anonymous access for a virtual server, you can configure anonymous access for each Web site on that virtual server. To do so, you use the Site Administration page for the Web site.

Change anonymous access for a Web site
  1. On your site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Users and Permissions, click Manage anonymous access.
  4. To enable or disable anonymous access to the site, in the Anonymous Access section, under Anonymous users can access, select one of the following:
    • Entire Web site
    • Lists and libraries
    • Nothing
  5. Click OK.

Assigning Administration Tasks

If you manage multiple Web sites or virtual servers, you may find that performing tasks such as adding users, managing subsites, or managing check-in and check-out for each virtual server or Web site can become burdensome — especially if you manage more than five Web sites. With Windows SharePoint Services, you can use site groups and rights to assign such administrative tasks to trusted users and keep server-level administrator tasks (such as extending a new virtual server or setting defaults) to yourself.

By default, a user who is a member of the Administrator site group can:

  • Manage the Web site
  • Create subsites.
  • Manage list permissions.
  • Manage site groups.
  • View usage data.

By default, a user who is a member of the Web Designer site group can:

  • Add and customize pages.
  • Manage lists.
  • Theme a site, add borders, and link style sheets.
  • Cancel check-outs.

If you want a user, such as a Contributor, to be able to perform a single Administrator or Web Designer task, you can either assign them to the Administrator or Web Designer site group, or assign them to another site group that has the user right needed to perform the task.

Although the simplest way to delegate Administrator or Web Designer rights is to make a user a member of the Administrator or Web Designer site group, this potentially allows the user more access than you intended. If you want to delegate only a few tasks or limit tasks, assign only the necessary user rights. To do this, create a custom site group with the necessary rights, or edit an existing site group to contain those rights.

For example, if you want a user to be able to approve items before they are added to lists, create a Moderator site group, add the Manage Lists right to that site group, and then assign the user to the site group.

Note Users can be members of more than one site group, so you do not need to remove their old site group membership before adding them to a new one. Neither do you have to replicate all of their existing rights in the new site group. So, Joe User can be a member of both the Contributor and Moderator site groups at the same time.

The following table lists some tasks you may want to delegate, as well as the user rights required to perform those tasks.

Task to delegate | User right required
Adding users to the site | Manage Site Groups
Changing user site groups | Manage Site Groups
Adding, editing, or removing lists | Manage Lists
Approving items to be added to a list | Manage Lists
Creating, deleting, or merging subsites | Create Subsites
Adding ASP, ASPx, or HTML pages to a site | Add and Customize Pages
Break a document check-out or force a check-in | Cancel Check-Out

Allowing Users to Request Access

You determine whether users can request access to a site collection, list, or document library by configuring settings for that site collection, list, or document library. If the request access feature is enabled, when users attempt to perform an action (such as create a page or add an item to a list) for which they do not have permission, they see a page that allows them to request access to the site. When they fill in the request form and click Send Request, their request is sent as an e-mail message to the e-mail address you specified when you configured the feature. The recipient of the e-mail message can then use the links in the e-mail message to grant access to that user or change the request access settings.

If you have configured an SMTP server in SharePoint Central Administration, by default the request access feature is enabled for site collections and the reply-to address is set to the e-mail address of the user who entered the SMTP server name. If you want to use a different e-mail address, you can specify a different individual or group e-mail account to receive access requests. Note that request for access is configurable only for subsites with unique permissions. Subsites with inherited permissions also inherit the request access settings from the parent site and the Manage Access Requests link is not displayed on the Site Administration page for those sites.

Important You must be a site collection administrator to change request access settings for a site collection.

If you are a site collection administrator, you can allow users to request access to the sites in your site collection from the Top-level Site Administration page.

Configure access requests for a site collection
  1. On the Top-level Site Administration page for your site collection, under Users and Permissions, click Manage access requests.
  2. Select the Allow requests for access check box to enable access requests, or clear the check box to disable requests.
  3. If you enabled requests, in the Send all requests for access to the following e-mail address box, type the e-mail address to use for requests.

    You can specify an individual or group e-mail address, but be sure that the address is monitored, and that the individual or members of the group are site collection administrators.

  4. Click OK.

You can allow users to request access to a particular list or document library by changing settings for that list. If access request is enabled for a site collection, by default it is enabled for all lists in that site collection. If access request is disabled for the site collection, you cannot enable it for a specific list. You cannot configure a separate e-mail address to use for access requests at the list level — requests are automatically sent to the e-mail address specified on the Manage Request Access page for the site collection.

Important You must be a member of the Web Designer or Administrator site groups for a site to change request access settings for a list.

Configure access requests for a list or document library
  1. Browse to the list, and then in the Actions list, click Modify settings and columns.
  2. Under General Settings, click Change permissions for this list/document library.
  3. On the Change Permissions: List_Name page, on theActions list, click Manage request access.
  4. Select or clear the Allow requests for access check box to enable or disable requests.
  5. Click OK.

Related Topics

For information about creating, editing, and deleting site groups, see "Managing Site Groups and Permissions" in the Windows SharePoint Services Administrator's Guide.

For the complete list of rights available in Windows SharePoint Services, see User Rights and Site Groups.


Specifying Central Administration Settings

Specifying Central Administration Settings

After you have installed Microsoft Windows SharePoint Services on your Web server and created the configuration database for your server or server farm, you can begin configuring settings for your server. You can configure settings from the SharePoint Central Administration page for your server. This page controls settings for a particular server in a server farm, and also contains links to other servers in the server farm, so that you can configure settings for those servers as well. You can also manage the list of servers in your server farm from the SharePoint Central Administration pages. To use the SharePoint Central Administration pages, you must be logged on either as a member of the Administrators group of the local server, or as a member of the SharePoint administrators group. Most of these settings can also be controlled from the command line, using the Stsadm.exe tool. For more information about the operations available with Stsadm.exe, see Command-Line Operations.

To set up Windows SharePoint Services and Microsoft SQL Server 2000 you must be a member of the Administrators group on the computer running Windows SharePoint Services and on the computer running SQL Server. To use SQL Server Enterprise Manager you must be a member of the db_owner role in SQL Server. To configure Microsoft Internet Information Services, you must be a member of the Administrators group on the local computer.

The following actions can be taken from the SharePoint Central Administration page:

  • Extend or upgrade a virtual server. For more information, see Extending Virtual Servers.
  • Create a site collection or delete a top-level Web site. For more information, see Creating Sites and Subsites.
  • Link to the virtual server settings pages. For more information, see Configuring Virtual Servers.
  • Set the administrative group for Windows SharePoint Services. For more information, see Windows SharePoint Services Security Model.
  • Manage site owners and users. For more information, see Managing Users and Cross-Site Groups.
  • Manage blocked file types. For more information, see Configuring Blocked File Extensions.
  • Configure antivirus settings. For more information, see Configuring Antivirus Protection.
  • Configure e-mail server settings. These settings can also be controlled at the virtual server level. For more information, see Configuring E-Mail Settings.
  • Manage the list of servers in your server farm. For more information, see Managing a Server Farm Running Windows SharePoint Services.
  • Set the default content database server. For more information, see Managing Content Databases.
  • Set the configuration database server. For more information, see Managing the Configuration Database.
  • Specify HTML viewer settings. These settings can also be controlled at the virtual server level. For more information, see Managing HTML Viewers.
  • Configure the virtual server for SharePoint Central Administration. For more information, see Changing the Application Pool Identity for the Administration Virtual Server.
  • Configure full-text search. For more information, see Managing and Customizing Search.
  • Configure usage analysis processing. For more information, see Configuring Usage Analysis.
  • Manage quotas and locks. For more information, see Configuring Site Quotas and Locks.
  • Configure data retrieval service settings. For more information, see Configuring Data Retrieval Services.

To configure settings and perform administration tasks for a server running Windows SharePoint Services, you use the SharePoint Central Administration page in HTML Administration.

Open the SharePoint Central Administration page
  • Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.


Configuring Virtual Servers

Configuring Virtual Servers

After you have installed Microsoft Windows SharePoint Services and extended a virtual server, you can configure settings for the virtual server. The following options can be set at the virtual server level and affect all sites on that virtual server:

  • Self-Service Site Creation settings

    Enable or disable Self-Service Site Creation. When enabled, this option allows users to create sites on their own. For more information, see "Configuring Self-Service Site Creation" in the Windows SharePoint Services Administrator's Guide.

  • Site use confirmation and auto-deletion settings

    Determine whether to require confirmation of site use, or whether to automatically delete unused Web sites. For more information, see Managing Unused Web Sites.

  • User right settings

    Specify which rights to make available to users of sites on your virtual server. For more information, see "Managing Site Groups and Permissions" in the Windows SharePoint Services Administrator's Guide.

  • Web Part Page security settings

    Specify whether users can create connections between Web Parts in a Web site, and whether the Microsoft Office 2003 Web Part gallery is available. For more information, see Managing Web Parts on Virtual Servers.

  • Virtual server general settings

    Configure settings to use as defaults for all sites that are created on your virtual server. For more information, see "Specifying General Settings for a Virtual Server" below.

  • E-mail settings

    Specify the outbound e-mail server to use, and the e-mail addresses to use when sending e-mail from the server. E-mail settings can also be configured at the server level, and used as the default settings. For more information, see Configuring E-Mail Settings.

In addition, you can perform the following administrative tasks from the virtual server level:

  • Manage content databases

    You can create or delete content databases, or change the capacity settings for a particular content database. For more information, see Managing Content Databases.

  • Remove Windows SharePoint Services from the virtual server

    You can remove Windows SharePoint Services either permanently or temporarily. For more information, see "Uninstalling Windows SharePoint Services" in the Windows SharePoint Services Administrator's Guide.

  • Define managed paths

    You can add or remove included and excluded paths to control which areas of the URL namespace are managed by Windows SharePoint Services. For more information, see Managing Paths.

  • Create a top-level Web site or delete a site collection

    You can create a new top-level Web site or delete an existing site collection. For more information, see "Creating Sites and Subsites" in the Windows SharePoint Services Administrator's Guide.

To configure settings and perform administration tasks for a virtual server, use the Virtual Server Settings page in HTML Administration.

Open the Virtual Server Settings page
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, click the name of the virtual server you want to configure.

Specifying General Settings for a Virtual Server

The Virtual Server General Settings page contains several options that apply to any sites that you create for the virtual server. When you configure a setting for a virtual server, it takes priority over settings applied on specific sites of that virtual server. For example, if you disable alerts for a virtual server, no site or subsite can use alerts. However, if you enable alerts on the virtual server, each top-level Web site can either enable or disable alerts for that Web site and its subsites. For more information about how each setting is treated at different levels, see the specific topic for that setting.

You can configure the following settings on the Virtual Server General Settings page:

  • Time zone to use for the virtual server

    Select a time zone to use for all sites created on this virtual server.

  • Default quota template for sites created under the virtual server

    Specify the default quota template to use. When you create a top-level Web site, you can create it using the default template or a different template. For more information about quotas, see "Configuring Site Quotas and Locks" in the Windows SharePoint Services Administrator's Guide.

  • Person Name Smart Tag and presence settings

    Enable or disable presence information for site members. For more information, see Configuring Online Presence Settings.

  • Maximum upload size

    Specify the maximum file size to allow when files are uploaded to a Web site on this virtual server. The default value is 50 MB, but this can be changed to any value up to 2 GB (2047 MB), if you have applied Windows SharePoint Services Service Pack 1. For more information, see Configuring large file support in Installing and Using Service Packs for Windows SharePoint Services.

  • Alert settings

    Enable or disable alerts for all sites under the virtual server, and configure default settings for alerts. For more information about alerts, see Managing Alerts.

  • Web page security validation

    Enable or disable security validation for Web site pages, and specify how long to wait before the validation expires for a given page.

  • Sending user names and passwords in e-mail

    Specify whether user names and passwords are sent in e-mail messages to new users. This setting is used for Active Directory user account creation mode only.

  • E-mail enabled document libraries

    Enable or disable e-mail-enabled document libraries, and specify the public folder path for e-mail attachments and how frequently to check for new attachments. For more information, see Configuring E-Mail-Enabled Document Libraries.

  • Event handlers

    Enable or disable event handlers. For more information, see Binding to a Document Library Event Handler.

Specify general settings for a virtual server
  1. On the Virtual Server Settings page, under Virtual Server Management, click Virtual server general settings.
  2. In the Default Time Zone section, select the time zone to use for all sites and subsites under the virtual server.
  3. In the Default Quota Template section, select the quota template to use as a default for sites.

    If there are no templates, you can create a template by using the Manage Quota Templates page. Note that when you specify a default template for the virtual server, you can still select a different template when you create a site.

  4. In the Person Name Smart Tag and Presence Settings section, select Yes or No next to Enable Person Name smart tag and Online Status for members to show that information for all sites under the virtual server.
  5. In the Maximum Upload Size section, type the maximum file size to allow.
  6. In the Alerts section, specify settings for alerts:
    • Select On or Off to enable or disable alerts for all sites under this virtual server.
    • If you choose to enable alerts, and want to limit the number of alerts that users can create, under Maximum number of alerts that a user can create, select Unlimited, or type the number of alerts to allow.
    • If you choose to enable alerts, specify the times to send immediate, daily, or weekly alerts.
  7. In the Web Page Security Validation section, specify the following settings:
    • Select On or Off to enable or disable Web Page Security Validation.
    • To set the expiration time, select After, and then type the length of time to wait before the validations expire, or select Never to keep the validations from expiring.
  8. In the Send User Name and Password in E-Mail section, select Yes or No to control this option.
  9. In the E-Mail Enabled Document Libraries section, specify the following options:
    • Next to Document libraries on this virtual server can accept e-mail attachments, select Yes or No.
    • In the Public folder server name and root path box, type the name of the Microsoft Exchange server and the path to the root folder for Exchange public folders on that server.
    • If you choose to enable e-mail attachments, specify the frequency and times to check for e-mail attachments in the public folder.
  10. In the Event Handlers section, select On or Off to enable or disable event handlers.
  11. Click OK.


Creating Sites and Subsites

Creating Sites and Subsites

You can use top-level Web sites and subsites to divide site content into distinct, separately manageable sites. Top-level Web sites can have multiple subsites, and subsites can also have multiple subsites, down as many levels as your users need. The entire structure of a top-level Web site and all of its subsites is called a Web site collection. The following diagram shows this hierarchy of sites and subsites.

Windows SharePoint Services Logical Architecture

This hierarchy allows your users to have a main working site for the entire team, plus individual working sites or shared sites for side projects. Top-level Web sites and subsites allow different levels of control over the features and settings for sites.

The administrator of a site collection can control settings and features for both the top-level Web site and any subsites beneath it. For example, an administrator of a site collection can:

  • Add, delete, or change user permissions.
  • View usage statistics.
  • Change regional settings.
  • Manage Web Part and template galleries.
  • Manage Web discussions and alerts.
  • Change the site name and description, theme, and home page organization.
  • Configure settings, such as regional settings, for the top-level Web site and all subsites.

The administrator of a subsite can control settings and features only for that subsite, and the administrator of the next subsite down can control settings and features for only that subsite. For example, an administrator of a subsite can:

  • Add, delete, or change user permissions, if unique permissions have been set (for more information, see Managing Site Groups and Permissions).
  • View usage analysis data.
  • Change regional settings.
  • Manage Web discussions and alerts.
  • Change the site name and description, theme, and home page organization.

Allowing Users to Create Their Own Top-Level Web Sites and Subsites

Depending on the amount of customization and control you want to allow your users, you can let them create either top-level Web sites or subsites. The Self-Service Site Creation feature gives users the ability to create top-level Web sites on their own. For more information, see Configuring Self-Service Site Creation.

Users can also create subsites of any site for which they have the Create Subsites right. The Create Subsites right is included in the Administrator site group by default, so any member of the Administrator site group for a site can create a subsite of that site. You can assign this right to other site groups by using the Manage Site and Workspace Creation page. For more information about managing site and workspace creation, see Managing Site Groups and Permissions.

Creating Top-Level Web Sites for Users

You can give users the ability to create their own top-level Web sites by enabling Self-Service Site Creation. If you want to control top-level Web site creation yourself, however, you can disable Self-Service Site Creation and create top-level Web sites on your users' behalf from SharePoint Central Administration. To create a top-level Web site outside of Self-Service Site Creation, you must be an administrator of the local machine on which the site will reside or a member of the SharePoint administrators group.

Note When you are running a server farm with multiple host names or are in Active Directory account creation mode, you cannot create a top-level Web site from SharePoint Central Administration. To perform this action in Active Directory account creation mode, you must use the command line or object model. For more information, see Using the Object Model to Manage Windows SharePoint Services.

Create a top-level Web site from SharePoint Central Administration
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Virtual Server Configuration, click Create a top-level Web site.
  3. On the Virtual Server List page, click the virtual server under which you want to create the top-level Web site.
  4. To create a site under a predefined URL path for the virtual server, on the Create Top-level Web Site page, select Create site under this URL; in the Site name box, type the name for the top-level Web site; and then in the URL path box, select the path to use.

    The name and URL path are combined with the server name to create the full URL to the site. For example, on http://servername, if you create a top-level Web site at the /sites URL path, and use Site001 as the name, the full path to the new top-level Web site is http://servername/sites/site001.

  5. To create a site at a predefined URL path, select Create site at this URL, and then in the URL path box, select the URL to use for the top-level Web site.

    The site is created at the top level of the URL path you select. For example, on http://servername, if you select /portal as the path, the site is created at http://servername/portal.

  6. In the Site Collection Owner section, type the user name (in the form DOMAIN\username) and e-mail address (in the form someone@example.com) for the user who will be the site owner and administrator.
  7. If you want to identify a user as the secondary owner of the new top-level Web site (recommended), in the Secondary Owner section, type the user name and e-mail address for a secondary owner and administrator of the new site.
  8. If you are using quotas, in the Quota Template section, select a quota template to use.
  9. In the Site Language section, select the language to use for the top-level Web site.
  10. Click OK.

The site owner can select a template for the site when first browsing to the URL, or you can browse to the URL on the confirmation page and select one yourself. You must alert the site owner and secondary owner when you have created the site with the URL. They are not notified automatically when you create a site.

Creating Subsites

You can create a subsite of a current site by using the Manage Sites and Workspaces page.

Create a subsite
  1. On a site, click Site Settings.
  2. Under Administration, click Manage sites and workspaces.
  3. On the Manage Sites and Workspaces page, click Create.
  4. On the New SharePoint Site page, in the Title and Description section, type the title and description for the new subsite.
  5. In the URL name box, type the URL for your subsite.
  6. In the User Permissions section, select either Use same permissions as parent site or Use unique permissions.

    Select Use same permissions as parent site if you want to share users with the parent site, or Use unique permissions if you want to maintain a separate list of users for your subsite. For more information, see Managing Site Groups and Permissions.

  7. In the Language section, select the language to use.
  8. Click Create.
  9. On the Template Selection page, select a template to use, and then click OK.

Creating Sites and Subsites from the Command Line

If you are an administrator of the server computer, you can also create sites and subsites by using the Stsadm.exe command-line tool. To create a top-level Web site, use the createsite operation. To create a subsite, use the createweb operation.

Note You can also use the createsiteinnewdb operation to create a top-level Web site and a new content database at the same time. For more information about this operation, see Command-Line Operations.

The createsite operation takes the following required parameters: url, ownerlogin, owneremail, and the following optional parameters: ownername, lcid, sitetemplate, title, description, and quota. For example, to create a top-level Web site called site1 on http://server_name/sites, you would use syntax similar to the following:

stsadm.exe -o createsite -url http://server_name/sites/site1
 -ownerlogin <DOMAIN\user> -owneremail <someone@example.com>
 -ownername <display name>

The createweb operation requires the url parameter and takes the following optional parameters: lcid, sitetemplate, title, description, and unique (used to specify unique permissions for the subsite). To create a subsite called subsite1 under the site you just created, you would use syntax similar to the following:

stsadm.exe -o createweb -url http://server_name/sites/site1/subsite1

For more information about using the createsite and createweb operations, see Command-Line Operations.


Configuring E-Mail Settings

Configuring E-Mail Settings

Microsoft Windows SharePoint Services sends alerts and other administration messages by using an SMTP server. You can specify which SMTP server to use and set the e-mail address to use for sending alerts and receiving replies for all sites by using the SharePoint Central Administration e-mail settings. You can also specify different settings for a specific virtual server. At either level, you can specify the following settings: outbound SMTP server, from address, reply-to address, and character set.

About Character Sets and E-Mail

When you configure e-mail settings, one of the settings you specify is the character set (also called "codepage") to use in e-mail messages. The default character set is 65001 (Unicode UTF-8), a standard character set that works well for most languages. You can choose a specific language code to apply instead, such as 1256 (Arabic (Windows)), but be aware that changing to a specific language code may cause the e-mail messages to be unreadable to clients of other language codes, for example, 1252 (Western European (Windows)).

Configuring an SMTP Server in Internet Information Services

If you want to use an SMTP server in Internet Information Services (IIS) to send outbound e-mail messages from Windows SharePoint Services, you must configure the SMTP server to allow anonymous access and to allow e-mail messages to be relayed. Note that the SMTP server you use must have Internet access to be able to send messages to external e-mail addresses.

Note The SMTP service for IIS is not installed by default. If you want to use the SMTP service that comes with IIS and have not installed the SMTP service, or you do not see the default SMTP virtual server in IIS, you must install the SMTP service manually. For more information about installing, configuring, and managing the SMTP service, see the Help system for Internet Information Services (IIS) Manager.

To complete this procedure, you must be logged on as a member of the Administrators group on the local computer, or you must be logged on using an account that is both a member of the SharePoint administrators group and that has been granted permissions to administer IIS.

Configure an SMTP server in IIS for use with Windows SharePoint Services
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Click the plus sign (+) next to the server name that contains the SMTP server you want to configure.
  3. Right-click the SMTP virtual server you want to configure, and then click Properties.
  4. On the Access tab, under Access control, click Authentication.
  5. In the Authentication dialog box, under Select acceptable authentication methods for this resource, verify that Anonymous access is selected.
  6. Click OK.
  7. On the Access tab, under Relay restrictions, click Relay.
  8. Under Select which computer may relay through this virtual server, select Only the list below.
  9. Under Computers, click Add.
  10. In the Computer dialog box, select Single computer, and then, in the IP address box, type the IP address for your front-end Web server or single server running Windows SharePoint Services.
  11. Click OK to close the Computer dialog box.
  12. Repeat steps 9 through 11 for any additional front-end Web servers in your server farm.

    Note You do not need to add the IP addresses for the back-end database servers in your server farm.

  13. Click OK to close the Relay Restrictions dialog box.
  14. Click OK to close the Properties dialog box.

Using HTML Administration to Configure E-Mail Settings for Windows SharePoint Services

You use the Configure Default E-mail Server Settings page to specify e-mail settings for your server.

Specify e-mail settings for a server or server farm
  1. On the SharePoint Central Administration page, under Server Configuration, click Configure default e-mail server settings.
  2. In the Outbound SMTP server box, type the name of the SMTP mail server to use for sending messages.
  3. In the From e-mail address box, type the e-mail address to send e-mail messages from.

    This address appears in the From box of any e-mail messages from the server. No e-mail messages are sent to this address, so you can use an unmonitored e-mail address if you want.

  4. In the Reply-to e-mail address box, type the e-mail address that users can reply to.

    If a user replies to an e-mail message from the server, it will be sent to this address. You should use an address that is monitored for the reply-to address.

  5. In the Character set box, select the character set to use.
  6. Click OK.

You can also specify e-mail settings for a particular virtual server. The virtual server settings override the settings specified on the SharePoint Central Administration pages. Use these steps when you want a virtual server to use a different SMTP server for alerts than the one specified in the server settings.

Specify e-mail settings for a virtual server
  1. On the SharePoint Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  2. On the Virtual Server List page, click the name of the virtual server you want to configure.
  3. Under Virtual Server Management, click Virtual server e-mail settings.
  4. In the Mail Settings section, in the Outbound SMTP server box, type the name of the SMTP mail server to use for sending messages.
  5. In the From address box, type the e-mail address to send e-mail messages from.

    This address appears in the From box of any e-mail messages from the server. No e-mail messages are sent to this address, so you can use an unmonitored e-mail address if you want.

  6. In the Reply-to address box, type the e-mail address that users can reply to.

    If a user replies to an e-mail message from the server, it will be sent to this address. You should use an address that is monitored for the reply-to address.

  7. In the Character set box, select the character set to use.
  8. Click OK.

Using the Command Line to Configure E-Mail Settings for Windows SharePoint Services

You can also configure e-mail settings from the command line, by using the email operation with Stsadm.exe. The email operation takes the following required parameters: outsmtpserver (the out-going SMTP server), fromaddress (the e-mail address to send messages from — can be an unmonitored address), replytoaddress (the e-mail address to send replies to — must be a monitored address), and codepage (the codepage to use).

In addition, you can use the optional url parameter to specify settings for a particular virtual server.

Note The valid codepages are listed on the Configure Default E-mail Server Settings page in SharePoint Central Administration, in the Character set box. To specify a codepage on the command line, use the number for the character set, rather than the full name. For example, use the number 65001 to specify the codepage for 65001 (Unicode UTF-8).

The email operation uses the following syntax:

stsadm.exe -o email -outsmtpserver <smtp server>
  -fromaddress <from address> -replytoaddress <reply-to address>
  -codepage <codepage> [-url <url>]

For example, to configure the e-mail settings to use the server \\SMTPServer, and to use someone@example.com as both the from and reply-to address, you would use syntax similar to the following.

stsadm.exe -o email -outsmtpserver SMTPServer
  -fromaddress someone@example.com
  -replytoaddress someone@example.com
  -codepage 65001

To set the http://myserver virtual server to use codepage 65001, you would use syntax similar to the following.

stsadm.exe -o email -outsmtpserver SMTPServer
  -fromaddress someone@example.com -replytoaddress someone@example.com
  -codepage 65001 -url http://server_name


Configuring E-Mail-Enabled Document Libraries

Configuring E-Mail-Enabled Document Libraries

Microsoft Windows SharePoint Services includes the ability to link a document library with a public folder based on Microsoft Exchange 2000 or later. Any documents attached to messages in the public folder can be automatically inserted into the document library, and the document library displays the document, plus the From address, the subject line, and the date and time that the attachment was inserted into the document library. Note that the body text of the e-mail message is not preserved. It remains in the public folder, but is not transferred to the document library.

A user can simply send e-mail to the public folder, with an attached document, and the document will be automatically added to the correct document library on a SharePoint site. For example, if you were using an XML template to store invoice information, a user could fill out the XML invoice and send it in-email to the public folder. The XML file would then be posted to the document library and would be available for rolling up into larger reports on invoices, or for easy retrieval.

About E-Mail and Document Library Security

This feature relies on e-mail to transport documents, and it uses the same security rules as all e-mail messages. Before enabling this feature, you should be aware of the following issues and vulnerabilities:

  • Because e-mail messages can cross firewalls, external users can use this method to send documents to an internal SharePoint site. This is useful for many scenarios, such as sending expense reports in from the field, but can also open your site up to unwanted junk e-mail messages. For information about controlling junk e-mail messages in public folders, see the Exchange 2000 documentation.
  • Because e-mail messages can carry documents with viruses, you might end up with a virus-laden document on your site. However, documents inserted into a document library from e-mail attachments can be scanned for viruses like any other documents in document libraries. For more information about virus scanning in Windows SharePoint Services, see Configuring Antivirus Protection.
  • Because e-mail addresses can be spoofed, the From address is preserved in the document properties and displayed in the document library. Trust the From address as much or as little as you trust other e-mail addresses.
  • To allow this feature to work, the document libraries allow anonymous insertions from e-mail attachments. You cannot control who has rights to add attached documents to this document library. However, you can control who can add documents directly to the document library, and you can control who has rights to post to the public folder by using the Exchange user management tools.
  • As with any public folder or document library, there is the possibility that a malicious user could add so many documents that the site or server's storage capacity is filled, thus blocking other users from accessing the site or server. Be sure to control the list of users with access to the public folder, and consider using quotas to control the size of the site. For more information about quotas, see "Configuring Site Quotas and Locks" in the Windows SharePoint Services Administrator's Guide.

This feature adheres to the blocked file extension rules for a document library. Any documents with file extensions that are blocked at the server level are also blocked from being added to an e-mail-enabled document library. For example, if you have a file with an .exe file extension, and you send it to the public folder, it will not be transferred to the document library. For more information about blocked file types, see Configuring Blocked File Extensions.

How It Works

The Microsoft SharePoint Timer service controls when the public folder is checked for new attached documents. When the SharePoint Timer service event runs, the service checks the public folder for new documents and inserts them into the document library. The SharePoint Timer service simply inserts documents. It does not update, overwrite, or delete documents. If the same document is added to the public folder more than once, it will also appear more than once in the document library. However, each document in the document library will have a unique file name (which is automatically generated by adding numbers, such as "1", to the end of the file name, so that filename.doc when added again becomes filename1.doc).

You can use this feature with any document library, or any list based on a document library template such as a custom document library, except picture library, which is not supported. The data sent to the document library along with the document is fixed. Any additional fields (even required fields) that you specify in the document library properties are ignored when documents are inserted.

Managing the Public Folder

You must configure the Exchange public folder to work with Windows SharePoint Services before you can enable this feature. And after you configure the feature, you must continue to perform the public folder administration tasks from within Exchange.

To use this feature, you must use the Exchange 2000 administration tools to:

  • Create the public folder.
  • Grant read access to the appropriate Windows SharePoint Services application pool accounts. If you are using one account for all virtual servers, grant access to that account. If you are using separate accounts for each virtual server, you must grant the virtual server accounts access to the appropriate public folders.

    If you prefer not to grant access to the application pool accounts, you can instead give the anonymous user account access to read the public folder. This is a less secure method than granting access to the application pool account.

  • Determine which e-mail distribution list to allow to post to the public folder, and grant that list appropriate access to the public folder.
  • Create an e-mail address for the public folder and enable the public folder to receive e-mail messages.
  • Continue to manage the public folder and the access to the public folder.

For more information about managing public folders and managing user access in Exchange 2000, see the Microsoft Exchange 2000 documentation.

Enabling E-Mail Access to Document Libraries

To enable this feature, you must be a local server administrator or a member of the SharePoint administrators group. You enable or disable this feature by selecting options on the Virtual Server General Settings page. After you have enabled this feature for a virtual server, any administrator of a site on that virtual server can enable the feature for a document library in his or her site.

Configure a virtual server to allow e-mail-enabled document libraries
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the virtual server you want to use.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Virtual server general settings.
  5. In the E-Mail-Enabled Document Libraries section, next to Document libraries on this virtual server can accept e-mail attachments, click Yes.
  6. In the Public folder server and root path box, type the path to the root folder on the Exchange server that hosts public folders.

    Note You must specify the server name for the public folder server, not the fully-qualified domain name. For example, use http://server_name/public, not http://server_name.domain.company_name.com/public.

  7. Under Check for new e-mail in the public folder, specify how frequently the public folders are checked for attachments by selecting one of the following:
    • Every ___ minutes

      Type the number of minutes to wait before checking again.

    • Hourly between ___ and ___ minutes past the hour

      Type the times between which you want to check. For example, between 10 and 20 past the hour would specify that the public folder is checked at a random time between 1:10 and 1:20, 2:10 and 2:20, and so on. Specifying the range allows each Web server to process e-mail attachments at different times within the range, so that all of the front-end Web servers in a server farm do not check the Exchange server at the same time.

    • Daily between ___ and ___

      Type the times between which to process daily e-mail attachments.

    The default value is hourly, between 0 and 59 minutes past the hour.

  8. Click OK.

If this feature has been enabled at the virtual server level, any administrator (or other user with the Manage Lists Permissions right) of any site on that virtual server can configure a document library to link to a public folder.

Configure a document library to allow e-mail insertion
  1. Navigate to the document library you want to use.
  2. Under Actions, click Modify settings and columns.
  3. Under General Settings, click Change advanced settings.
  4. On the Document Library Advanced Settings: Library name page, under E-Mail Settings, in the Public folder address box, type the path to the Exchange public folder you want to link to.

    This path is relative to the path specified on the Virtual Server General Settings page. For example, if the virtual server has http://server_name/public as the root path for public folders, and the full path to the folder is http://server_name/public/folder_name, you would type /folder_name in the Public folder address box.

  5. Click OK.


Configuring Online Presence Settings

Configuring Online Presence Settings

Online presence allows users of your site to see if other users are online and send instant messages to them. To use online presence, your users must have Microsoft Office 2003 installed, must be running Microsoft Windows Messenger version 4.6 or later or MSN Messenger version 4.6 or later on their client computers, and they must have valid accounts with the .NET Messenger or Microsoft Exchange Instant Messaging service. Note that the e-mail address for the instant messaging account must be compatible with the e-mail address for the user account in Windows SharePoint Services.

To see presence information for people with .NET Passport accounts, the e-mail address for the messenger contact must be the same as the e-mail address for the user account in Windows SharePoint Services. To see presence information for people with Exchange Instant Messaging service accounts, the user name must be the same, although the address may vary (for example, someone@example.com for the e-mail address, and someone@im.example.com for the instant messaging address), depending on your organization's Exchange configuration. For best results, it is recommended that users use their primary SMTP address for both instant messaging and their user account in Windows SharePoint Services. For more information about configuring Exchange Instant Messaging for your organization, see the Microsoft Exchange 2000 documentation.

The Office 2003 installation includes an ActiveX control that allows Microsoft Windows SharePoint Services to render online status for site users. This control checks the e-mail address on record for the user and directs a query to the presence server for that client to see if they are online. The ActiveX control does not store online information or e-mail addresses; it simply directs queries from the site to the e-mail address and renders the appropriate status.

You can enable or disable online presence information at the virtual server level. When you enable online presence for a virtual server, it is enabled for all sites and subsites of that virtual server.

Enable online presence for a virtual server
  1. On the SharePoint Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  2. On the Virtual Server List page, click the name of the virtual server you want to configure.
  3. Under Virtual Server Management, click Virtual server general settings.
  4. In the Person Name Smart Tag and Presence Settings section, next to Enable Person Name smart tag and Online Status for members, select Yes.
  5. Click OK.


Configuring Site Quotas and Locks

Configuring Site Quotas and Locks

If you are using Microsoft Windows SharePoint Services in a large environment, such as at an Internet Service Provider (ISP) or in a large intranet, you need to be able to maintain control over your server resources and carefully monitor areas such as storage space and site security. You must be able to ensure that one user's site cannot use so many resources that other sites can no longer function. Windows SharePoint Services allows you to specify quotas for sites, so that you can manage your site and server resources. You can set quota limits for the following items:

  • Storage

    When you set a quota limit for storage, you can set two values: a warning value and a maximum value. When a site passes the warning limit, an e-mail message is sent to the site administrator and owner notifying them that their site is near to their storage quota. E-mail messages are sent daily until the storage level drops below the warning level. When a site meets the maximum limit, another e-mail message is sent to the owner and administrator, and no new content can be added to the site. Note that before e-mail messages can be sent, you must configure the e-mail server settings and be running the Microsoft SharePoint Timer service. For more information, see Configuring E-Mail Settings and Scheduling Timed Jobs.

    Note The size of the data reported by quotas does not necessarily match the size of the storage in the database. This is because the quota feature estimates storage figures for empty sites (sites that contain no user content) and includes those figures in the quota, as well as the actual storage from the database. The estimated size of an empty site includes the real size of the template pages for Windows SharePoint Services, such as the forms pages and pages in the _layouts directory, which are not normally counted, since there is only one copy of these pages for all sites. Although each site has a unique URL to the pages, the site does not have a unique instance of the page.

  • Users

    In Active Directory account creation mode, you have the ability to limit the number of users that are added to Microsoft Active Directory directory service from any single SharePoint site collection. When you set a quota for user accounts, you specify a maximum limit only. When the maximum number of users for a site has been reached, no additional user accounts can be added unless one or more user accounts are deleted from the site collection.

You can create multiple sets of quotas, called quota templates, and use them in different areas or your server farm, or to suit different users. For example, in an ISP setting, you could have the following quota templates:

  • Free — Applied to free or demo sites, restricts users to 10 MB of storage and five users.
  • Standard — Applied to monthly-fee sites, allows site owners up to 25 MB of storage and 50 registered users.
  • Premium — Applied to extranet sites for large corporate customers, allows organizations up to 10 GB of storage and unlimited user accounts.

You must be an administrator of the local server computer or a member of the SharePoint administrators group to be able to manage quotas and quota templates.

Enabling Quotas

The quota feature is disabled by default in Windows SharePoint Services — there are no default quota values or templates. To enable quotas, you use the following methods:

  • To use quotas for your server or server farm, you create a quota template.
  • To use quotas for a particular virtual server, you assign a default quota template to that virtual server.
  • To use quotas for a particular site collection, you assign a quota template to the site collection when you create the site collection.
  • To use a set of quota values for a single site only, you can apply specific quota limits to the site itself, independent of any quota template.

You can reverse your decision to use quotas at any point in the hierarchy. For example, applying a default quota template to a virtual server does not mean that all site collections under that virtual server must use the quota limits — it only means that they can. Settings that you apply to a single site can be cleared if you no longer want to use quotas.

About Quota Templates

Quota templates and the settings specified in them are stored in the configuration database for your server or server farm. Quota values apply to site collections and are applied when you create a site collection. You can specify a default template to use for all site collections created on a virtual server, for example, or you can specify the template to use when you create the site collection. The values listed in the quota template are copied into the database for the site collection and are referenced from there.

If you change the values for a quota template, those changes apply only to new site collections created by using that template, not to existing site collections. To update the quota values for large numbers of existing site collections, you can use the object model or an SQL query. For details on using the object model, see the SPSite object in the Windows SharePoint Services Software Development Kit. You can run queries similar to the following against your content databases to update quota values:

  • To update the storage quota:
    Update sites set diskquota=<new storage amount> where <search criteria>
  • To update the number of users quota:
    Update sites set userquota=<new # users limit> where <search criteria>

    For the where <search criteria> clause, it is recommended that you use "QuotaTemplateId=<ID for the modified quota template>". To find a quota template ID, check the database for a site that uses the quota template, and then make a note of the template ID. You can also use the current value for the diskquota or userquota to locate the sites that need to be updated; however, this method does not restrict the update to sites based on the changed quota template.

To update all sites that use a quota template, you must run the query for all content databases in the server farm.

When you delete a quota template, the template is removed from the configuration database, but any site collections created using that template retain the quota values. If you want to remove quotas from all sites using a particular quota template, you must use the object model or perform an SQL query. For more information about using the Windows SharePoint Services object model, see the Windows SharePoint Services Software Development Kit.

Managing Quota Templates

You manage quota templates from the SharePoint Central Administration pages for your server or server farm. You can create or delete templates or change the values in the templates.

Create a quota template
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Component Configuration, click Manage quotas and locks.
  3. On the Manage Quotas and Locks page, click Manage Quota Templates.
  4. On the Manage Quota Templates page, in the Template name area, select Create a new quota template.
  5. In the Template to start from box, select a template to base your new template on.
  6. In the New template name box, type the name to use for your new quota template.
  7. In the Storage Limit Values section, select the Limit site storage to a maximum of: ___ MB check box, and then type the amount of storage to allow at a maximum.
  8. Select the Send warning e-mail when site storage reaches ___ MB check box, and then type the amount of storage to allow before sending a warning e-mail message.
  9. In the Invited User Limits section, select the Limit invited users to a maximum of: ___ users, and then type the number of users to allow.

    Note The user limit option is available only in Active Directory account creation mode.

  10. Click OK.

    When you click OK, the new template is added to the list of available templates, and the page is refreshed.

You can delete a quota template if you change your quota structures. However, remember that deleting a quota template will not delete quota values from sites that were created using the quota template. If you want to remove quotas from all sites using a particular quota template, you must use the object model or perform a SQL query.

Delete a quota template
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Component Configuration, click Manage quotas and locks.
  3. On the Manage Quotas and Locks page, click Manage Quota Templates.
  4. On the Manage Quota Templates page, in the Template name area, select Edit an existing template.
  5. In the Template to modify box, select the quota template you want to delete.
  6. Click Delete.

    When you click OK, the template is removed from the list of available templates, and the page is refreshed.

You can change individual quota values in a template. The new values apply only to new site collections created using the quota template. The changed values are not applied to existing sites unless you use the object model to update the values in the database.

Change an existing quota template
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Component Configuration, click Manage quotas and locks.
  3. On the Manage Quotas and Locks page, click Manage Quota Templates.
  4. On the Manage Quota Templates page, in the Template name area, select Edit an existing template.
  5. In the Template to modify box, select the quota template you want to change.
  6. Update the options you want to change, and then click OK.

    When you click OK, the template is updated, and the page is refreshed.

Specifying a Quota Template for a Virtual Server

When you extend a new virtual server, you can specify a quota template to use as the default quota template for that virtual server on the Extend and Create Content Database page. Any new site collections that you create under the virtual server will automatically use the values in the default quota template. You can change the default quota template for a virtual server from the Virtual Server Settings page. Keep in mind that changing the default quota template does not change quota values for existing site collections. Only newly created site collections will use the new quota template.

Change the default quota template for a virtual server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the name of the virtual server you want to change.
  4. Under Virtual Server Management, click Virtual server general settings.
  5. In the Default Quota Template section, select the quota template to use as the default template when new site collections are created.
  6. Click OK.

Specifying Quota Values for a Specific Site

If you want to specify a different set of limits for a particular site, you can do so. Specifying quota values for a single site is an easy way to turn on quotas on a site-by-site basis. Similarly, if you need to make an exception to a quota template for a particular site, you can change the quota value for just that site. Keep in mind, however, that it is possible to lock a site simply by changing the quota value. If you already have quotas set for a particular site, and want to update the value, be sure to check the site's current quota levels before making the change. For example, suppose the current quota level for site storage is 25 MB, and a site has 21 MB. If you change the value to 20 MB, the site will be locked as soon as you save the change. To prevent locking a site accidentally, be sure to check the current storage or invited user count for the site before making a change to the quota values.

If you do not know what the existing quota values are for a site, you can use the SharePoint Central Administration page to view the current values and the current data (storage used and number of users) for the site.

View current quota values and data for a site collection
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Component Configuration, click Manage quotas and locks.
  3. On the Manage Quotas and Locks page, click Manage site collection quotas and locks.
  4. In the Select a Top-level Web Site section, type the URL in the Enter the top-level Web site URL box, and then click View Data.
  5. In the Site Quota Information section, view the settings listed to see the quota settings and current values.

To view the current data for a site collection, you can also use the Site Collection Usage Summary page for the top-level Web site.

View quota data for a site
  1. On the site collection you want to view data for, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Site Collection Administration, click View site collection usage summary.

After you have checked the site quota data, you can change the quota values for a site. Note that this action does not change the quota template, and the change does not affect any site except the site you specify.

Change quota values for a site
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Component Configuration, click Manage quotas and locks.
  3. On the Manage Quotas and Locks page, click Manage site collection quotas and locks.
  4. In the URL of Top-level Web Site section, type the URL in the Enter the top-level Web site URL box, and then click View Data.
  5. In the Site Quota Information section, change the Limit storage to a maximum of __ MB amount, Send warning e-mail when site storage reaches __ MB amount, or Limit invited users to a maximum of amount setting.

    Note The user limit option is available only in Active Directory account creation mode.

  6. Click OK.

Removing Users for Quotas

In Active Directory account creation mode, you can set quota limits for the number of users allowed for a site collection. If this quota is exceeded, no more users can be added to any site within the site collection until a user has been removed from the site collection or the quota limit is changed. To have any effect on the user quota, users must be removed at the site collection level. Removing users from individual sites does not affect the quota, and does not allow you to add more users.

To remove users from a site collection, you use the Manage Site Collection Users page in Site Administration.

To remove site collection users
  1. On the Site Settings page, in the Administration section, click Go to Site Administration.
  2. In the Site Collection Administration section, click View site collection user information.
  3. Click the box next to the users that you want to delete, and then click Remove Selected Users.

    Note You must be a member of a site group with the Manage Web Site right to perform this action. This right is included by default in the Administrators site group.

Managing Locks

You can use locks to stop sites from exceeding your storage quota limits, and to block all users from accessing a site if necessary. Sites are locked to block new content automatically when they exceed the maximum storage quota. You can also lock a site manually to block all access, if, for example, it is in violation of your site use policies. Depending on the type of lock, the result of a locked site is different:

  • When a site is locked for exceeding a storage quota limit, users who attempt to upload new content see a disk full error.
  • When a site is locked manually to block all access, users who attempt to view the site will see an access denied message. When a site is locked manually to block new content, users who attempt to add content see a disk full error.

Sites can be unlocked by different methods, depending on the reason for the lock. Site administrators can unlock sites by themselves if the sites are locked for exceeding quota limits. Only a server administrator can clear a manual lock. The following table lists the lock reasons and methods for unlocking sites.

Lock reason | Server administrator action to unlock | Site administrator action to unlock
Storage limit exceeded | Change the quota value. | Delete excess site content or documents.
Manual lock by server administrator | Clear the Adding content prevented or No access lock. | None.

If you need to lock a site and deny all users access to it, either temporarily or permanently, you do so by using the Manage Site Collection Quotas and Locks page.

Lock a site manually
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Component Configuration, click Manage quotas and locks.
  3. On the Manage Quotas and Locks page, click Manage site collection quotas and locks.
  4. In the URL of Top-level Web Site section, type the URL in the Enter the top-level Web site URL box, and then click View Data.
  5. In the Site Lock Information section, select Adding content prevented or No access.

  6. If you lock a site with Adding content prevented or No access, you must type an explanation in the Additional lock information box.

  7. Click OK.

When a site has been locked manually, you can unlock it by using the Manage Site Collection Quotas and Locks page.

Unlock a site
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Component Configuration, click Manage quotas and locks.
  3. On the Manage Quotas and Locks page, click Manage site collection quotas and locks.
  4. In the URL of Top-level Web Site section, type the URL in the Enter the top-level Web site URL box, and then click View Data.
  5. In the Site Lock Information section, select Not locked, and then click OK.

Related Topics

Quota data is captured along with the usage analysis data for a site. For more information about the usage analysis process, see Configuring Usage Analysis.


Configuring Self-Service Site Creation

Configuring Self-Service Site Creation

Microsoft Windows SharePoint Services allows members of the Administrator site group to create subsites off of their Web sites. These subsites can be fully-functioning SharePoint sites, complete with a home page, document libraries, and so on, and they can even have their own unique permissions. Self-Service Site Creation is a feature which is enabled by administrators and allows users to create their own top-level Web sites. The user does not need administrator permissions on the server or virtual server, only permissions on the Web site where Self-Service Site Creation is hosted. The user simply enters some basic information and the new top-level Web site is created with the user as the owner and administrator. When you enable Self-Service Site Creation, you free yourself from having to create top-level Web sites on demand for your users — they can do it themselves.

You turn on Self-Service Site Creation from the Configure Self-Service Site Creation page for the virtual server you want to enable. When you turn on Self-Service Site Creation, an announcement is added to the home page of the top-level Web sites on that virtual server, with a link to the signup page (Scsignup.aspx). Users can click the link to go to the signup page and create their sites. This announcement is set to never expire but if the Announcements list is long, or is removed from the home page of your site, the announcement may not appear. If you want to ensure that the link always appears on the home page, you can customize the home page in a Web page editor compatible with Windows SharePoint Services to include the link in a prominent position, such as the top link bar.

Note When you are in Active Directory account creation mode, or are using host headers for your virtual servers, you cannot enable Self-Service Site Creation from SharePoint Central Administration. To perform this action in Active Directory account creation mode, you must use the command line or the object model. For more information, see Using the Object Model to Manage Windows SharePoint Services.

Security and Self-Service Site Creation

Self-Service Site Creation allows users to create and manage their own top-level Web sites automatically. This capability can obviously affect the security for your Web server running Windows SharePoint Services. Self-Service Site Creation is disabled by default — you must turn on the feature to use it. You enable Self-Service Site Creation for a single virtual server at a time. If you want to use it on all virtual servers in your server farm, you must enable it for every virtual server individually.

The Administration pages for Self-Service Site Creation are part of the virtual server administration pages, which can only be accessed by local computer administrators or members of the SharePoint administrators group. Access to the signup page follows the same security rules as other Web site pages. By default, the Use Self-Service Site Creation right is included in all site groups except the Guest site group, and gives users access to the signup page and the ability to use Self-Service Site Creation to create their own top-level Web sites.

Note that because Self-Service Site Creation simply creates new top-level Web sites on an existing virtual server, any new sites automatically conform to the virtual server's quota settings, unused Web site notification settings, and other administrative policies.

Managed Paths and Self-Service Site Creation

By default, when you install Windows SharePoint Services, a URL path called /sites is added to your virtual server. When you enable Self-Service Site Creation, that path is the default path for sites that your users create. For example, a user can create "MyTeamSite" under /sites on Server 1. Using the defaults, the path for this site would be similar to the following: http://server/sites/MyTeamSite. You can use the default /sites path for users' Self-Service Site Creation sites, or you can create additional paths. You specify which URL paths are available for users to create sites under by adding managed paths. If you do add more URL paths for Self-Service Site Creation to use, when users go to the Scsignup.aspx page, they see a drop-down box listing the various paths available, and they can choose which path to create their site under. For more information about defining a URL path, see Managing Paths.

Enabling Self-Service Site Creation

You can use either HTML Administration pages or the command-line tool to enable and configure Self-Service Site Creation. Either method allows you to turn Self-Service Site Creation on or off, and allows you to specify required information for each site.

Configuring Self-Service Site Creation from HTML Administration Pages

To enable Self-Service Site Creation for a virtual server, use the Configure Self-Service Site Creation page for that virtual server.

Enable Self-Service Site Creation
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, click the virtual server to enable.
  4. On the Virtual Server Settings page, under Automated Web Site Collection Management, click Configure Self-Service Site Creation.
  5. In the Enable Self-Service Site Creation section, next to Self-Service Site Creation is, select On.
  6. If you want to require two contact names for each site, select the Require secondary contact check box.

    Requiring a secondary contact is highly recommended if you are using site use confirmation and have enabled automatic Web site deletion. For more information, see Managing Unused Web Sites.

  7. Click OK.

To disable Self-Service Site Creation, go to the Configure Self-Service Site Creation page; next to Self-Service Site Creation is, select Off, and then click OK.

Configuring Self-Service Site Creation from the Command Line

You use the enablessc operation to enable and configure Self-Service Site Creation from the command line. The enablessc operation requires the URL parameter, and optionally takes the requiresecondarycontact parameter. For example, to enable Self-Service Site Creation for a server called MyServer and require two contact names for each site, you would use syntax like the following:

stsadm -o enablessc -url http://MyServer -requiresecondarycontact

You can disable Self-Service Site Creation by using the disablessc operation. The disablessc operation takes only the URL parameter. So, to disable Self-Service Site Creation for MyServer, the syntax would be:

stsadm -o disablessc -url http://MyServer

Related Topics

For more information about using command-line operations, see Command-Line Operations.


Managing and Customizing Search

Managing and Customizing Search

Microsoft Windows SharePoint Services enables users to search all Web site content on your server or server farm — a broader search capability than offered in SharePoint Team Services v1.0. In that version, searching was implemented using Internet Information Services (IIS) catalogs and limited to documents on the file system; users were not able to search through lists, such as tasks and contacts, or through discussion board items. Because all site information (including documents) is now stored in a database, the search model has been changed to allow searching of all site content.

Search features are only available for Windows SharePoint Services with Microsoft SQL Server 2000. If you are running Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) for your database, no search features are available. If you want to allow full-text searching on your Web sites, you must upgrade to SQL Server 2000.

Understanding Search in Windows SharePoint Services

Search is available per server or server farm. This means that search is either turned on or off for all top-level Web sites and subsites in your server farm or server. If search has not been enabled, the search links will not appear in the Web sites in your server farm or server.

Search can query most lists and all document libraries on your site. Search cannot query lists of lists (such as the Quick Launch bar) or surveys. Users can search the entire site or a single list within the site (for example, to search for a particular contact in the Contacts list).

Searching with SQL Server 2000

If you are using SQL Server 2000, you can enable full-text searching for your Web sites. SQL Server 2000 full-text searching is a good solution for searching Windows SharePoint Services Web sites in small or medium organizations; however, SQL Server 2000 full-text search does not scale well to large server farms. Search catalogs can use up to 40 percent of the hard disk space that data uses. There is a hard limit of 256 search catalogs per server; plus you will encounter performance issues when you reach 1 million rows in the search catalog table. If you are running a large server farm, it is not advisable to offer search features for all of the Web sites in your server farm. Consider adding search for premium customers if you are an Internet service provider (ISP) or Application service provider (ASP), or for only a limited number of sites if you are hosting Web sites based on Windows SharePoint Services inside a large organization.

SQL Server 2000 full-text search supports only one language for each database. If you are supporting Windows SharePoint Services Web sites in several languages and you want to enable full-text search in those languages, consider hosting each language on a separate virtual server with a separate database per language.

SQL Server 2000 uses language resources packages with full-text search catalogs. The following list includes the languages for which language resources are available:

  • Neutral
  • Dutch
  • English (UK)
  • English (US)
  • French
  • German
  • Italian
  • Japanese
  • Korean
  • Simplified Chinese
  • Spanish (Modern Sort) - Spain
  • Swedish
  • Traditional Chinese
  • Thai

The neutral language resources package is provided for use with languages not on this list. For more information about SQL Server, full-text searching, and languages, see the SQL Server 2000 documentation.

When you enable full-text search in Windows SharePoint Services, a new, empty catalog is created by default and named ix_databasename. Content is added to this catalog as it is added to your new Web site. Aside from enabling and disabling full-text search, any search management or monitoring must be done from within SQL Server 2000 with the SQL Server administration tools. For more information about managing full-text search in SQL Server 2000, see "Administering Full-Text Features Using SQL Enterprise Manager" in the SQL Server Books Online system.

About Searching Features

When you search SharePoint sites by using SQL Server full-text searching, the search is performed by using a FREETEXT statement. Using FREETEXT allows searching by intent — all terms are stemmed, so that the query looks for all inflectional forms of each query term. For example, if you query for "swim", the query also returns results including "swam", "swum", "swimming", and so on.

The following table lists and describes the searching features available when you use SQL Server full-text searching.

Search targets | Searched with SQL Server?
List items | Yes
Documents | Yes
Lists | Yes
Boolean searches (AND, OR, Near, NOT) | No
File types other than .doc, .xls, .ppt, .txt, and .htm | Not by default. You can install customized SQL Server search filters to search other file types.
Searching for subsite content on a top-level Web site | No. You must go to the subsite to perform the search.
Non-text list fields (such as currency, number, lookup, Yes/No) | No
Attachments to lists | No
File properties used by Office 2003 documents (such as "Author" and "Company") | No
Survey lists | No
Hidden lists | No
Site administrators, site groups, users, or cross-site groups | No
External Web sites, file shares, documents | No
Narrowing search results by searching through previous results | No
Displaying the total number of items matching a search string | No

Enabling Search

You must enable search before your site members can use it. If you want to enable SQL Server 2000 searching, you must install the full-text searching feature for SQL Server 2000 and then enable search in Windows SharePoint Services.

Note Full-text searching is enabled by default when you install Windows SharePoint Services using the remotesql=yes property.

Enabling Search for SQL Server 2000

To use search with Windows SharePoint Services and SQL Server 2000, you must have full-text searching installed on your SQL Server computer. Full-text searching is usually installed by default, but if it is not installed on your server, you can install it easily with the SQL Server Setup tools.

Install full-text searching with SQL Server 2000

Note You must be a member of the Administrators group on the computer running SQL Server to install full-text searching with SQL Server 2000.

  1. On your SQL Server computer, run the SQL Server 2000 Setup program.
  2. On the setup screen, click SQL Server 2000 Components, and then click Install Database Server.

    The Microsoft SQL Server 2000 Installation Wizard opens.

  3. On the Welcome screen, click Next.
  4. On the Computer Name screen, select the computer type, and then click Next.
  5. On the Installation Selection panel, select Upgrade, remove, or add components to an existing instance of SQL Server, and then click Next.
  6. On the Instance Name panel, clear the Default check box, and then in the Instance Name box, select your SQL Server instance for Windows SharePoint Services and click Next.
  7. Select Add components to your existing installation, and then click Next.
  8. On the Select Components panel, in the Sub-Components list, select Full-Text Search, and then click Next.
  9. Click Next again to begin the installation.
  10. Click Finish.

Enabling Search in Windows SharePoint Services

After you have configured SQL Server 2000 to support full-text searching, you are ready to enable search for Windows SharePoint Services.

Enable search for Windows SharePoint Services
  1. On your server computer running Windows SharePoint Services, click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Component Configuration, click Configure full-text search.
  3. In the Search Settings section, select the Enable full-text search and index component check box.
  4. Click OK.


Configuring Regional Settings

Configuring Regional Settings

Every Web site (both top-level Web sites and subsites) based on Microsoft Windows SharePoint Services can be customized to use specific regional settings that apply to the users of your site. You can specify the following regional settings:

  • Locale

    Controls how numbers and dates are displayed in the site.

  • Sort order

    Controls the sort orders used for lists and libraries.

  • Time zone

    Controls the time zone for the Web site.

    Note You cannot configure a client's view to see document information in their time zone if it is different than the site's time zone. For example, if you have a site set to Eastern Time (US and Canada), and a user in Amsterdam adds a document at 1:00 PM (or 13:00) local time, the document properties show that it was added at 7:00 AM Eastern Time. If this is a problem for your site, you may want to consider creating a personalizable Web Part to show all documents and list items in a specific time zone. For example, the Web Part could list all document libraries and lists in the site, and then the user could select which document library or list to display and the time zone to display it in, and then they would see the data from that document library or list converted to their time zone. For more information about creating custom Web Parts, see the Windows SharePoint Services Software Development Kit.

  • Time format

    Specifies whether to display times in 12-hour or 24-hour format.

To specify the locale ID for a site, you can use either HTML Administration pages or the command line. To change the sort order, time zone, or time format for a site, you must use HTML Administration pages. For more information about language settings in Windows SharePoint Services, see Language Considerations.

Changing Regional Settings in HTML Administration Pages

You can change the locale ID, sort order, time zone, and time format for an individual site by using the Regional Settings page in the Site Administration pages.

Server administrators and members of the SharePoint administrators group can also specify a default time zone to use for all sites on a virtual server. For more information, see Configuring Virtual Servers.

Change the regional settings for a site
  1. On the site, click Site Settings.
  2. On the Site Settings page, under Administration, click Go to Site Administration.
  3. On the Site Administration page, under Management and Statistics, click Change regional settings.
  4. On the Regional Settings page, select the settings to use, and then click OK.

Specifying Locale IDs on the Command Line

When you extend a virtual server, create a new top-level Web site, or create a new subsite from the command line, you can specify the locale ID to use. The extendvs, createsite, createsiteinnewdb, and createweb operations all accept the lcid parameter. To enter a locale ID in any of these operations, you type the numerical value for the locale (such as 1033 for U.S. English or 1036 for French/France). For example, to create a new subsite and use the French locale ID for France, you would use the following syntax:

stsadm.exe -o createweb -url http://server_name/site1/subsite1 -lcid 1036

All of these operations take several other parameters. For more information about these operations, see Command-Line Operations.


Configuring Usage Analysis

Configuring Usage Analysis

Usage analysis allows you to track how Web sites on your server are being used. You configure the settings for processing the usage log by using commands in HTML Administration pages. From the SharePoint Central Administration page, you can control:

  • Whether or not to log usage data.

    Usage analysis is not enabled by default. If you want to use the usage analysis features for your server, you must enable the usage analysis logging process. Log files are created daily to track usage information. When the log file is processed, a flag is added to indicate that is has been processed. If you do not want to track usage analysis data and you want to conserve disk space, you can turn off data logging for usage analysis.

  • Where the log files are stored and how many log files to create.

    By default, the log files are in %windir%\system32\LogFiles\STS. Inside this folder is a folder for every virtual server, and under those folders, folders for each day. You can specify any other location you prefer. You can specify that up to 30 log files are created.

    Note If you choose a different log file location, you must be sure to give the STS_WPG user group Read, Write, and Update permissions to the directory. Without these permissions, the usage log files cannot be created or updated. For more information about setting permissions for a directory, see the Microsoft Windows Help system.

  • Whether or not to process the usage logs and when to do so.

    By default, the log files are set to be processed every day at 1:00 A.M. You can schedule the usage log to be processed at a more convenient downtime for your Web sites. If your Web sites are primarily used by internal employees, for example, you might schedule the log to be processed at night, when demand on the sites is lower than during working hours. If you have multiple servers, you can stagger the processing. For example, you can configure the processing to start at midnight, and stagger it by 15 minutes, so that server1 starts at 12:00, server2 starts at 12:15, server3 at 12:30, and so on.

In Microsoft Windows SharePoint Services, usage analysis data is gathered from the front-end Web servers and collected into temporary files. When the daily log processing takes place, the data is merged into the content databases on the back-end servers. Usage data is collected for an entire site collection on a server at a time. Even though the data is logged and stored for an entire site collection, when you view the data in HTML Administration pages, you can see only the data for a particular Web site or subsite, not for the entire site collection.

Note Although you can see the total number of hits for a site collection on the Site Collection Usage Summary page, for detailed information you must use the Site Usage Report page for the individual site or subsite.

For more information about the type of data gathered in the usage analysis logs and how to view the usage analysis reports, see Analyzing Web Site Usage.

Usage data is stored for 31 months. Daily information is stored for 31 days. The log files will not be deleted, even after processing. Note that usage analysis processes rely on the Microsoft SharePoint Timer service to manage the timing of log processing. For more information about the SharePoint Timer service, see Scheduling Timed Jobs.

Note Because usage analysis processing runs only once a day, when you enable usage analysis processing, you will not see any data until the next day. Log processing is only done for a single day's worth of data. If you turn off the log processing for a week but leave the data logging turned on, the next time you turn on processing, it will only process one day's worth of log files. The log files for all of the days before that will remain unprocessed.

You control settings for usage analysis processing from the SharePoint Central Administration page. You must be an administrator of the local server computer or a member of the SharePoint administrators group to configure usage analysis settings.

Note When you configure usage analysis processing for a server, it takes effect for any existing virtual servers. If you later add a virtual server, you must configure usage analysis processing again to enable usage analysis for the new virtual server.

Configure usage analysis processing for a server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Component Configuration, click Configure usage analysis processing.
  3. In the Logging Settings section, select the Enable logging check box.
  4. In the Log file location box, type the location to store the log file.

    The default location for the log file is c:\Windows\system32\LogFiles\STS.

  5. In the Number of log files to create box, type a number between 1 and 30.

    In general, you should use a number that is one to three times the number of database servers in your server farm, with a maximum number of 30 log files.

  6. In the Processing Settings section, select the Enable usage analysis processing check box.
  7. Under Run processing between these times daily, specify the range of times to start the usage analysis log processing. In the Start box, select the earliest time of day to begin running log processing. In the End box, select the latest time to begin running log processing.
  8. Click OK.

Related Topics

For more information about viewing usage reports, see "Analyzing Web Site Usage" in the Windows SharePoint Services Administrator's Guide.

For more information about configuring and viewing quota information, see "Configuring Site Quotas and Locks" in the Windows SharePoint Services Administrator's Guide.


Configuring Antivirus Protection

Configuring Antivirus Protection

Microsoft Windows SharePoint Services now allows you to help protect your users from uploading or downloading files that contain viruses. When you have installed an antivirus scanner that is compatible with Windows SharePoint Services, you can enable the antivirus protection feature for your server. When you enable the antivirus protection feature, files are checked for viruses when a user adds a document to a document library or list, or when a user views a document in a document library or list. If a virus is found, the scanner attempts to clean the file, or if the file cannot be cleaned, blocks the file from being added or viewed.

Note If a file is uploaded, and is later identified as containing a virus, users will not be able to open the file. In this situation, however, users may still be able to save the file locally and open it from their computer.

You enable and configure antivirus protection at the server level. When enabled, antivirus protection is available for all document libraries on all sites and subsites on your server, or for all servers in your server farm. You can use HTML Administration pages or the command line tool to configure antivirus protection.

You must install Windows SharePoint Services-compatible antivirus software on any server computer running Windows SharePoint Services before you can enable antivirus protection in Windows SharePoint Services. If you are in a server farm configuration, antivirus software must be installed on every Web front-end server in the server farm. Consult your antivirus software vendor to find out whether they offer a virus scanner for use with Windows SharePoint Services and for information about installing the virus scanner. Or, for a list of antivirus software vendors that support antivirus protection for Windows SharePoint Services, see the Windows SharePoint Services Partners Site.

Using HTML Administration Pages to Configure Antivirus Settings

You use the Configure Antivirus Settings page in the SharePoint Central Administration pages to enable and configure antivirus protection.

Enable antivirus protection for your server or server farm
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, under Security Configuration, click Configure antivirus settings.
  3. Select the Scan documents on upload check box.
  4. Select the Scan documents on download check box.
  5. If desired, select the Attempt to clean infected documents check box.
  6. If you want to allow users to save infected files locally, select the Allow users to download infected documents check box.

    Note This option is disabled by default to prevent users from saving potentially infected files to their client computers.

  7. In the Time out scanning after ___ seconds box, type the number of seconds to allow before timing out the scanning process.

    The default time is 300 seconds, or 5 minutes. This should be enough time to allow the antivirus processes to finish without affecting performance. The default time is recommended, but you can adjust this time if you are experiencing performance issues.

  8. In the Allow scanner to use up to ___ threads box, type the number of threads to allow the scanning process to take up.

    By default, the number of threads is set to 5, which should be sufficient for even a large number of sites. The default number of threads is recommended, but you can adjust the number of threads if you are experiencing performance issues.

  9. Click OK.

Using the Command Line to Configure Antivirus Settings

You can also configure antivirus protection by setting properties on the command line. To set a property, you use the Stsadm.exe tool with the setproperty operation. The following properties are available for use in configuring antivirus protection.

Property name | Description | Values
avallowdownload | Specifies whether users can download infected documents to their client computers. | yes/no
avcleaningenabled | Specifies whether antivirus cleaning is enabled or disabled. | yes/no
avdownloadscanenabled | Specifies whether documents are scanned on download. | yes/no
avnumberofthreads | Specifies the number of threads to use for antivirus processes. | A numerical value, the number of threads to use.
avtimeout | Specifies how long to wait before timing out an antivirus process. | A numerical value, in seconds.
avuploadscanenabled | Specifies whether documents are scanned on upload. | yes/no

The following example shows the syntax to use when setting an antivirus property:

stsadm.exe -o setproperty -pn <property name> -pv <property value>

For example, to set the avtimeout property to 200, you would use the following syntax:

stsadm.exe -o setproperty -pn avtimeout -pv 200

For more information about setting properties using the command line, see "Introducing the Administration Tools for Windows SharePoint Services" in the Windows SharePoint Services Administrator's Guide.


Configuring Data Retrieval Services

Configuring Data Retrieval Services

A data retrieval service implements a new data-binding technology that enables data consumers and data sources to communicate with each other through SOAP and XML. Data retrieval services are XML Web services that return XML data from different data sources. A data retrieval service is installed and runs on a server extended with Microsoft Windows SharePoint Services. Windows SharePoint Services comes with a default set of data retrieval services for working with data in SharePoint lists, OLEDB, and XML data sources. Client applications and data-bound Web Parts, such as the Spreadsheet Web Part, can use a data retrieval service to query the data source supported by the particular data source.

Note If your data retrieval service is attempting to connect to a remote Microsoft SQL Server database that is configured to use Microsoft Windows authentication, the server with the data retrieval service, the remote server running SQL Server, and the client initially making the request against the data retrieval service must be using Kerberos authentication. For more information about setting up Kerberos authentication, see the Help system for Internet Information Services (IIS) 6.0.

Configuring Data Retrieval Services from HTML Administration

You can enable or disable data retrieval services and configure settings for data retrieval services for an entire server or server farm by using the SharePoint Central Administration page.

Enable data retrieval services and configure settings for a server or server farm
  1. On the SharePoint Central Administration page, under Component Configuration, click Configure data retrieval services settings.
  2. On the Data Retrieval Services Settings page, in the Enable Data Retrieval Services section, select Enable these data retrieval services.
  3. In the Limit Response Size section, in the Response size limit box, specify the size, in kilobytes (KB), to use as the upper size limit for responses from the data retrieval services.
  4. To allow updatable queries, in the Update Support section, select the Enable update query support check box.
  5. In the Data Source Time-out section, in the Request time-out box, specify the length of time to allow the data retrieval service to respond before timing out, in seconds.
  6. Click OK.

You can also use HTML Administration pages to specify settings for a particular virtual server.

Enable data retrieval services and configure settings for a virtual server
  1. On the SharePoint Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  2. On the Virtual Server List page, click the name of the virtual server that you want to configure.
  3. On the Virtual Server Settings page, under Component Configuration, click Configure data retrieval service settings.
  4. On the Data Retrieval Service Settings page, in the Customize Virtual Server section, clear the Inherit the global settings check box to specify different settings for the virtual server.
  5. In the Enable Data Retrieval Services section, select Enable these data retrieval services.
  6. In the Limit Response Size section, in the Response size limit box, specify the size, in kilobytes (KB), to use as the upper size limit for responses from the data retrieval services.
  7. To allow updatable queries, in the Update Support section, select the Enable update query support check box.
  8. In the Data Source Time-out section, in the Request time-out box, specify the length of time to allow the data retrieval service to respond before timing out, in seconds.
  9. Click OK.

Configuring Data Retrieval Services from the Command Line

If you are using a third-party data retrieval service, you can register a service by using the command line. Register these services by using Stsadm.exe with the binddrservice and removedrservice operations. The binddrservice and removedrservice operations register individual data retrieval services for specific settings. When you register a service, it appears on the HTML Administration pages under the appropriate setting. For each operation, you specify the following required parameters: servicename and setting. The setting parameter takes any of the following values: enabled, responsesize, timeout, update.

For example, to register a data retrieval service called Service1 to the list of services that an administrator may enable or disable, you would use the following syntax:

            stsadm.exe -o binddrservice -servicename Service1 -setting enabled

And to remove Service1 from the list of services that may allow data updates, you would use the following syntax:

            stsadm.exe -o removedrservice -servicename Service1 -setting update

For more information about command-line operations, see Command-Line Operations.


Configuring Blocked File Extensions

Configuring Blocked File Extensions

Microsoft Windows SharePoint Services provides the ability to restrict certain kinds of files from being uploaded or retrieved, based on the file extension. For example, a file with the .exe file extension could potentially contain code that runs on client computers when it is downloaded. Because it has the .exe file extension, the file can be run on demand when it is downloaded. If files with the .exe file extension are blocked, users can neither upload nor download a file with the .exe extension, and potentially dangerous content in the .exe file cannot be downloaded. This feature does not prevent all exploits based on file types, nor is it designed to do so.

By default, several standard file extensions are blocked, including any file extensions that are treated as executable files by Windows Explorer. Files with curly braces { or } are also blocked automatically. The file extensions blocked by default are:

File extension | File type
.ade | Microsoft Access project extension
.adp | Microsoft Access project
.app | Application file
.bas | Microsoft Visual Basic class module
.bat | Batch file
.chm | Compiled HTML Help file
.class | Java class file
.cmd | Microsoft Windows NT Command Script
.com | Microsoft MS-DOS program
.cpl | Control Panel extension
.crt | Security certificate
.dll | Windows dynamic link library
.exe | Excutable program
.fxp | Microsoft Visual FoxPro compiled program
.hlp | Help file
.hta | HTML application
.ins | Internet Naming Service
.isp | Internet Communication settings
.jse | JScript Encoded Script file
.lnk | Shortcut
.mda | Microsoft Access add-in program
.mdb | Microsoft Access program
.mde | Microsoft Access MDE database
.mdt | Microsoft Access data file
.mdw | Microsoft Access workgroup
.mdz | Microsoft Access wizard program
.msc | Microsoft Common Console Document
.msi | Microsoft Windows Installer package
.msp | Windows Installer patch
.mst | Visual Test source files
.ops | Microsoft Office profile settings file
.pcd | Photo CD image or Microsoft Visual Test compiled script
.pif | Shortcut to MS-DOS program
.prf | System file
.prg | Program source file
.reg | Registration entries
.scf | Windows Explorer command file
.scr | Screen saver
.sct | Windows Script Component
.shb | Windows shortcut
.shs | Shell Scrap Object
.url | Uniform Resource Locator (Internet shortcut)
.vb | VBScript file
.vbe | VBScript Encoded Script file
.vbs | VBScript file
.wsc | Windows Script Component
.wsf | Windows Script file
.wsh | Windows Script Host Settings file

The list of file extensions is controlled for the entire server or server farm and is recorded in the configuration database. Because the list of blocked file types is maintained by file extension, all files that use a file extension on the list cannot be uploaded or downloaded, irrespective of the file's intended use. If .asp is on the list of extensions to block, the feature blocks all .asp files on the server, even if they're used to support Web site features on another server in the server farm. If a file ends in a period (.), the preceding characters are checked against the list of blocked file extensions as well. For example, if .exe is on the list of blocked file extensions, a file called "filename.exe." is also blocked. The following list shows different ways of representing the same file, all of which are blocked if the .hta extension is on the list of blocked file extensions:

  • filename.hta
  • filename.hta.
  • filename.hta.{3050F4D8-98B5-11CF-BB82-00AA00BDCE0B}
  • filename.hta::$DATA

You can determine which files are blocked for Web sites on your servers by modifying the list of blocked file extensions. You can block additional file extensions (up to 1024 file types) by adding them to the list in the SharePoint Central Administration pages, or remove a block by deleting the file extension from the list. When you change the list of file extensions, the change affects both new files being added to a Web site and files already posted to a Web site. For example, if a document library contains a .doc file, and you add the .doc file extension to the list of blocked file extensions, users will no longer be able to open the .doc file in the document library. Users will be able to rename or delete a file with a blocked file extension, but will not be able to perform any other actions.

Add or remove a file type from the list of blocked file extensions
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, under Security Configuration, click Manage blocked file types.
  3. On the Manage List of Blocked File Types page, perform one of the following actions:
    • To add a file type, click in the list and type the extension.
    • To delete a file type, delete the file extension from the list.
  4. Click OK.


Scheduling Timed Jobs

Scheduling Timed Jobs

Several features of Microsoft Windows SharePoint Services rely on scheduled background processes. For example, to be able to review usage analysis information, you must first gather the information, preferably when your site is not being heavily used. With Windows SharePoint Services, you can schedule the following operations to occur automatically at specific times.

Operation | Frequency | Scope
Processing the usage analysis log files | Daily | Web server
Sending alert notifications | Immediately, daily, or weekly | Content database
Checking for and automatically deleting unused Web sites | Daily, weekly, or monthly | Content database
Checking for and automatically adding e-mail attachments from a specific public folder to a specific document library | Every few minutes, hourly, or daily | Content database

Scheduled times apply to all Web sites on a particular virtual server. The scope determines how the job is run. If a job is scoped to the Web server level, it is run for each Web server computer, independently of any other Web servers that might be hosting the same content. If an operation is scoped to the content database level, it is run once for the content database, which means once for the each content database in the entire server or server farm.

The Microsoft SharePoint Timer service, a background utility, handles scheduled jobs in Windows SharePoint Services. This utility is installed to your Web server when you set up Windows SharePoint Services. The SharePoint Timer service relies on the Gregorian calendar for scheduling. For every job you schedule, you must specify a beginning time for that job based on a 24-hour clock. You specify the time in local time versus an offset from Universal Coordinated Time (UCT), and the time is stored in that format as well.

The dates used by the SharePoint Timer service are not stored in context. This means that you cannot schedule jobs to run every X days/weeks/months/years, where X is greater than 1. So, while you can schedule jobs to run every day, every week, or every month, you cannot schedule a process for every two days, and so on. Neither can you schedule jobs for relative days in a month, such as the third Monday of every month.

When you schedule a timed job, you schedule the beginning time for the job. For example, you can schedule a job to be run daily, beginning between 1:00 A.M. and 2:00 A.M. You always schedule jobs to begin within a time range, rather than at a specific time. This allows the SharePoint Timer service to be run at a random time in that range, so that not every server in a server farm is running the scheduled job at the same time. For example, if you set usage analysis processing to be done during the range 1:00 A.M. to 2:00 A.M., each front-end Web server starts processing usage analysis sometime between 1:00 and 2:00 A.M.

Using HTML Administration Pages to Schedule Jobs

You can schedule timed jobs by using HTML Administration pages. To schedule a timed job, go to the page that contains the settings for the job you want to schedule, and then select the day, date, month, year, and time that you want the job performed. For example, if you want to schedule usage analysis processing to be performed daily at 3:00 A.M., you would use the Configure Usage Analysis Processing page to specify the time to run the log processing. For more information about scheduling specific timed jobs by using HTML Administration pages, see the following topics:

  • Managing Alerts
  • Configuring Usage Analysis
  • Managing Unused Web Sites
  • Configuring E-Mail-Enabled Document Libraries

Using Command-Line Properties to Schedule Jobs

You can also set properties on the command line to schedule timed jobs. Alert and site use confirmation jobs can both be scheduled by using command-line properties. You use the setproperty operation with Stsadm.exe to schedule timed jobs. The setproperty operation takes the propertyname and propertyvalue parameters, as well as the -url parameter. For a timed job, the propertyvalue parameter is the frequency and time when you want the job to be performed.

When you schedule a job from the command line, you use one of the following formats to specify the frequency and time:

Job frequency | Example time format
Immediate | "every 5 minutes between 0 and 59"
Daily | "daily between 22:00:00 and 06:00:00"
Weekly | "weekly between Fri 22:00:00 and Mon 06:00:00" or "weekly at Sat 0:00:00"

For example, to schedule a job to be processed daily between midnight and 1:00 A.M., you would specify the propertyvalue parameter as:

-pv "daily between 0:00:00 and 01:00:00"

For more information about scheduling timed jobs from the command-line, see Command-Line Properties.

Restarting the SharePoint Timer Service

If you need to restart the SharePoint Timer service on a Web server computer, you can do so by using the Services control panel.

Note To restart the SharePoint Timer service you need to be a member of the local computer's Administrators group or you need to have been granted permissions to manage services on the local computer.

Restart the SharePoint Timer service
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Services.
  2. In the Services (Local) pane, right-click SharePoint Timer Service, and then click Restart.


Managing Sites and Subsites

Managing Sites and Subsites

Web sites in Microsoft Windows SharePoint Services are organized into site collections. Each site collection has a top-level Web site. This top-level Web site can have multiple subsites, and each subsite can have multiple subsites. Because sites are nested in a hierarchy within the site collection, it can be challenging to manage them all.

Note Local server administrators and members of the SharePoint administrators group can perform any task that a site collection administrator can perform for a site collection.

You can use two methods to manage sites and subsites:

  • HTML Administration pages

    When you use HTML Administration pages to manage sites in a site collection, be aware that some features are only available from the top-level Web site. These features include managing site collection galleries, viewing storage space allocation, viewing the site heirarchy, and listing all users in the site collection.

  • Command-line administration

    If you use the command line to manage sites in a site collection, the levels are not as important, because you can always specify the full URL path for a site you want to manage, and you can adjust the URL to list sites and subsites at any level in the site collection. However, you must be a member of the administrators group for the local server computer to use the command-line tools.

Managing Sites and Subsites by Using HTML Administration Pages

You can use the HTML Administration pages to view a list of subsites within a site collection or for a particular subsite. You can also use HTML Administration pages to delete a site or subsite. Depending on your administrative access level, you can perform different actions.

  • Members of the local server's administrator group and members of the SharePoint administrators group can delete a site collection from SharePoint Central Administration. Site collection administrators can also delete a site collection by using the Top-Level Site Administration page. Deleting the site collection deletes the top-level Web site in that site collection, as well as any subsites.
  • Members of the site collection administrators group can view a list of all subsites below the top-level Web site in that site collection from the View Site Hierarchy page. They can delete a specific subsite in the site collection or the entire site collection by navigating from the View Site Hiearchy page to the Site Administration page for the subsite or top-level Web site (to delete a site collection).
  • Members of the Administrator site group for a subsite can only see the immediate subsites below their subsite. They can delete the subsites they see, provided that the subsites have no subsites beneath them.

Viewing Subsites

If you are a member of the Administrator site group for a site, you can view a list of subsites from the Manage Sites and Workspaces page in Site Settings. This list displays only the immediate set of subsites for the current site (one level down).

View the list of immediate subsites for a site
  1. On the site, click Site Settings.
  2. On the Site Settings page, under Administration, click Manage sites and workspaces.

If you are a site collection administrator, you can see the full list of subsites for the site collection (any subsites of the top-level Web site, plus any of their subsites) by using the View Site Hierarchy page in Site Administration.

View the entire list of subsites within a site collection
  1. On the top-level Web site for the site collection, click Site Settings.
  2. On the Site Settings page, under Administration, click Go to Site Administration.
  3. Under Site Collection Administration, click View site hierarchy.

Deleting a Site Collection

If you are an administrator of the local server computer on which a site resides or a member of the SharePoint administrators group, you can use the Delete Site Collection page in the Central Administration or Virtual Server Administration pages to delete a site collection (a top-level Web site and any subsites beneath it).

Caution When you delete a top-level Web site, you also delete any subsites beneath it. Before you delete a site, be sure to verify that there are no subsites beneath it, or that you no longer need the subsites beneath it. You cannot recover a subsite unless you have a backup version of the subsite. For more information about backing up a site, see "Backing Up and Restoring Databases by Using the SQL Server 2000 Tools" in the Windows SharePoint Services Administrator's Guide.

Delete a site collection from SharePoint Central Administration
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Delete site collection.
  3. In the URL of the site to delete box, type the full URL to the site.
  4. Click OK.

If you are the owner of or a site collection administrator for a top-level Web site, you can delete the top-level Web site by using the Delete This Site page in the Site Administration pages.

Delete a site collection from Site Administration
  1. On the subsite, click Site Settings.
  2. On the Site Settings page, under Administration, click Go to Site Administration.
  3. Under Management and Statistics, click Delete this site.
  4. On the confirmation page, click Delete.

Deleting a Subsite

Depending on your administrative access level, you can use different methods to delete a subsite:

  • If you are a member of the Administrator site group for the subsite you want to delete, you can use the Delete This Site page in Site Administration.
  • If you are a member of the Administrator site group for the site one level up from the subsite you want to delete, you can use the Manage Sites and Workspaces page in Site Settings for your subsite.

Caution You cannot recover a subsite unless you have a backup version of the subsite. For more information about backing up a site, see "Backing Up and Restoring Databases by Using the SQL Server 2000 Tools" in the Windows SharePoint Services Administrator's Guide.

Delete a subsite using the Delete This Site page
  1. On the subsite, click Site Settings.
  2. On the Site Settings page, under Administration, click Go to Site Administration.
  3. Under Management and Statistics, click Delete this site.
  4. On the confirmation page, click Delete.

To delete a subsite from the Manage Sites and Workspaces page, you must use the Site Settings page for the site immediately above the subsite you want to delete.

Delete a subsite using the Manage Sites and Workspaces page
  1. On the site above the subsite you want to delete, click Site Settings.
  2. On the Site Settings page, under Administration, click Manage Sites and Workspaces.
  3. On the Manage Sites and Workspaces page, next to the subsite you want to delete, click the Delete icon.
  4. On the confirmation page, click Delete.

Managing Sites and Subsites from the Command Line

You can use the following operations with the Stsadm.exe command-line tool to manage sites and subsites.

Operation | Description
enumsites | Lists all top-level Web sites for a specific virtual server.
enumsubwebs | Lists all subsites of a specific top-level Web site or subsite.
renameweb | Renames a subsite.
deletesite | Deletes a top-level Web site and any subsites beneath the top-level Web site.
deleteweb | Deletes a subsite. If the subsite contains other subsites, an error will be returned, and the subsite will not be deleted.

You can also use the following operations to manage sites and subsites: createsite, creatsiteinnewdb, and createweb. For more information, see "Creating Sites and Subsites" in the Windows SharePoint Services Administrator's Guide.

The enumsites and enumsubwebs operations take the url parameter. Their syntax is simple, just the operation and URL, as in the following examples:

stsadm.exe -o enumsites -url <URL>
stsadm.exe -o enumsubwebs -url <URL>

The enumsites and enumsubwebs operations provide the list of sites and subsites as XML text. For example, a list of sites generated by running enumsites would look like:

<Sites Count="2">
  <Site URL="http://site_name1" Owner="DOMAIN\userA"/>
  <Site URL="http://site_name2" Owner="DOMAIN\userB"/>
</Sites>

The deletesite and deleteweb operations also take only the url parameter and follow the same syntax:

stsadm.exe -o deletesite -url <URL>
stsadm.exe -o deleteweb -url <URL>

The renameweb operation takes the url and newname parameters. The syntax for renameweb is as follows:

stsadm.exe -o renameweb -url <URL> -newname <new subsite name>

For more information about using the command-line operations, see Command-Line Operations.

Related Topics

Part of managing sites and subsites is creating sites when you need to. For more information, see "Creating Sites and Subsites" in the Windows SharePoint Services Administrator's Guide.

You can also delete unused sites automatically. For more information, see Managing Unused Web Sites.


Managing Paths

Managing Paths

When you extend a virtual server, create a top-level Web site, or configure Self-Service Site Creation, you may also need to define managed paths. Managed paths allow you to perform two important tasks:

  • Indicate which pieces of the URL namespace are controlled by Microsoft Windows SharePoint Services.

    Many organizations installing Windows SharePoint Services already have a Web server or server farm in use, and must be able to identify areas of the existing URL namespace that should not be managed by Windows SharePoint Services. For example, if you have a Web application on your Web server already, and you install Windows SharePoint Services, you need a way to tell Windows SharePoint Services not to attempt to control content in or settings for that path.

  • Specify paths to use for Self-Service Site Creation.

    You can restrict Self-Service Site Creation users to specific paths when they create sites. By default, the path /sites is created and added as a path for Self-Service Site Creation users when you enable Self-Service Site Creation. You can create other paths for Self-Service Site Creation users, or remove the /sites path when you manage paths.

There are two categories of paths you can manage: included and excluded paths. An included path indicates that Windows SharePoint Services manages that path. An excluded path indicates that the path is managed by a different application, and that Windows SharePoint Services should leave it alone. Included paths can be further broken down into the following two types:

  • Explicit inclusions — Includes only the specific path you set. Use explicit inclusions, for example, if you want Windows SharePoint Services to manage a specific path, such as /portal, but not any possible sites below it, such as /portal/webapp.
  • Wildcard inclusions — Includes any sites below the path you set, so you don't have to add them individually. This is the type of inclusion to use for Self-Service Site Creation, when you want users to be able to create top-level Web sites underneath a specific path, such as /sites.

Note Web server performance declines linearly with the number of inclusions and exclusions. You can minimize the performance impact by using wildcard inclusions rather than many explicit inclusions, and by putting as many excluded applications under the same excluded path as possible.

The following table lists example URLs and explains the types of paths.

Path type | Example URL | Path name | Comments
Explicit inclusion | http://server1/site1 | /site1 | Identifies the Web site at /site1 as a Windows SharePoint Services site.
Wildcard inclusion | http://server1/sites/* | /sites/* | Identifies all sites below the /sites/ path as Windows SharePoint Services sites.
Exclusion | http://server1/webapp | /webapp | Indicates that the /webapp directory is not handled by Windows SharePoint Services.
Top-level Web site explicit inclusion | http://server1 | / | Indicates an explicit inclusion for the top-level Web site. Only the top-level Web site is a Windows SharePoint Services site, not any other sites below the top-level Web site.
Top-level Web site wildcard inclusion | http://server1 | /* | Indicates a wildcard inclusion for the top level of the virtual server. Every directory under the specified path is a Windows SharePoint Services top-level Web site.

Included and excluded paths are used only for directories, not pages in a Web site, and they are recursive (for example, if you exclude /mango, Windows SharePoint Services will ignore any URL beginning with /mango/ or equal to /mango). Exclusions take precedence over inclusions, so if you accidentally set a particular path to be both included and excluded, the path will be excluded. Inclusions are evaluated by length; longer URLs are checked before shorter URLs, so an inclusion for http://server1/sites/teams will be evaluated before an inclusion for http://server1/teams.

You can manage paths by using either HTML Administration pages or the command line.

Managing Paths by Using HTML Administration Pages

To include or exclude a new path, use the Define Managed Paths page for the virtual server that contains the path.

Add a new path
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Define managed paths.
  5. In the Add a New Path section, in the Path box, type the path to add.
  6. Select Excluded path or Included path. If you select Included path, select a type (wildcard or explicit) in the Type box.
  7. Click OK.

If you change how you use the URL namespace, and no longer need a path to be included or excluded, you can remove the path.

Remove a path
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Define Managed Paths.
  5. Under Included Paths or Excluded Paths, select the check box next to the path you want to remove, and then click Remove selected paths.

Managing Paths from the Command Line

You can use the addpath and deletepath operations to manage paths on the command line. Both operations take the -url and -type parameters. The -type parameter has three values: exclusion, explicitinclusion, and wildcardinclusion. For example, to add a new wildcard inclusion to manage all sites at the top level of http://server1, you would use syntax like the following:

stsadm -o addpath -url http://server1/ -type wildcardinclusion

You can also remove an included or excluded path by using the command line. For example, to remove an exclusion for the site at http://server1/hrweb/webapp, you would use syntax like the following:

stsadm -o deletepath -url http://server1/hrweb/webapp

Related Topics

For more information about how managed paths affect extending a virtual server, creating sites, or allowing users to create sites by using Self-Service Site Creation, see Extending Virtual Servers, "Creating Sites and Subsites," and "Configuring Self-Service Site Creation" in the Windows SharePoint Services Administrator's Guide.


Managing the Configuration Database

Managing the Configuration Database

Microsoft Windows SharePoint Services uses a database to store configuration and site mapping information for your server computer, the virtual servers on your server computer, and for servers in a server farm. This database is called the configuration database. You need one configuration database for your server farm, whether your server farm is one server computer with everything on it, or several server computers.

If you install Windows SharePoint Services on a single server using Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE), the configuration database is created for you. If you install Windows SharePoint Services in a server farm environment, or with Microsoft SQL Server, the installation ends without creating a configuration database, and you must create the database using HTML Administration pages or the command line.

Using HTML Administration to Create or Connect to a Configuration Database

When you install Windows SharePoint Services without installing WMSDE, the setup program ends by opening Central Administration and displaying a page where you specify the application pool to use for administration tasks. After you specify the application pool, you go to the Set Configuration Database Server page where you specify whether to use existing domain accounts or use Active Directory directory service to create user accounts, and create the configuration database. For more information about account types, see "Managing Users and Cross-Site Groups" in the Windows SharePoint Services Administrator's Guide.

Create a configuration database after setting up Windows SharePoint Services
  1. When Setup finishes, you are taken to the Configure Admin Virtual Server page.
  2. In the Application Pool section, select Use an existing application pool or Create a new application pool.
    • If you selected Use an existing application pool, select the application pool to use.
    • If you selected Create a new application pool, under Application pool name, type a name for the application pool, and under Select a security account for this application pool, select a type, and then enter the required information.

      Note that if you select Configurable, be sure to specify an account that is a member of the Security Administrators and Database Creators roles for the SQL Server database. It is recommended that you use a dedicated account for this account, rather than a user's logon account. Also, it is recommended that you use the same account for each application pool that hosts the same content.

    • Click OK.

    After you configure the administrative virtual server, you must restart Internet Information Services (IIS), by typing iisreset on the command line. After IIS is reset, you can click the link on the Application Pool Changed page to continue configuring Windows SharePoint Services.

  3. After IIS has been restarted, on the Application Pool Changed page, click OK.
  4. On the Set Configuration Database Server page, in the Configuration Database section, enter the server name and database name to use.
  5. Under Database connection type, select Use Windows authentication (more secure, recommended) or Use SQL authentication (less secure).

  6. If you selected Use SQL authentication (less secure), you must also type the database account user name and password.

  7. In the Active Directory Account Creation section, select one of the following options:
    • If you are using a Microsoft Windows domain, select Users already have domain accounts. Do not create active directory accounts.
    • If you are using Active Directory directory service outside of a Windows domain, select Automatically create active directory accounts for users of this site.

  8. If you selected Automatically create active directory accounts for users of this site, you must fill in the Active Directory Domain and Organization Unit information.

  9. Click OK.

If you already have a configuration database for your server farm, you can use the Set Configuration Database Server page to connect to the existing configuration database. You must connect to the configuration database whenever you add a server to a server farm, and before you can extend any virtual servers on that server.

Connect to a configuration database
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Server Configuration, click Set configuration database server.
  3. In the Configuration Database section, enter the server name and database name for the existing configuration database.
  4. Under Database connection type, select Use Windows authentication (recommended security level) or Use SQL authentication (less secure).

  5. If you selected Use SQL authentication (less secure), type the database account user name and password.

  6. Select the Connect to existing configuration database check box.
  7. Click OK.

Using the Command Line to Create or Connect to a Configuration Database

You use the same operation on the command line to create or connect to a configuration database. The setconfigdb operation allows you to perform either action, depending on the parameters you include. The setconfigdb operation takes the following required parameters: databaseserver (ds), databaseuser (du), and databasepassword (dp). (Note that the -du and -dp parameters are only required if you are using SQL Server authentication; they are not used with Windows authentication.) In addition, you can use the following optional parameters: connect, databasename (dn), and hh, which specifies that you are in server farm mode.

To create a new configuration database and specify a name for the database, you would use the following syntax:

stsadm -o setconfigdb -ds <database server> -dn <database name>
-du <database user> -dp <database user password> -hh

For example, to create a new configuration database called "config1" at http://mydomain, on the Sql_02 database server, using Windows authentication, you would type:

stsadm -o setconfigdb -ds mydomain -dn config1

To connect to an existing configuration database, you would use syntax similar to the following:

stsadm -o setconfigdb -connect -ds <database server>
-dn <database name> -du <database user>
-dp <database user password>

Related Topics

After you have set up the configuration database, you can begin extending virtual servers. For more information, see Extending Virtual Servers.

For more information about using the setconfigdb operation, see Command-Line Operations.


Managing Content Databases

Managing Content Databases

Microsoft Windows SharePoint Services uses a database to store and manage site content. Just as each virtual server can host multiple top-level Web sites, each virtual server can rely on multiple content databases to store site content. If you are running Windows SharePoint Services on a single server, hosting just a few sites, you can probably use the same content database for all of your sites. If you want to add capacity in a server farm, you will most likely need several content databases to store site data for each virtual server.

To make it easier to manage site content for large server farms, you can also set a limit on how many top-level Web sites can store content in a content database. You can specify a warning limit and a maximum limit for the number of sites. When a warning limit or maximum limit is reached, an event is logged in the server's NT Event Log, so you can take action. When a maximum limit is reached, no more sites can be created using that content database.

When you create a new site, the databases are queried and the new site's content is added to the database which has the most available space. For example, suppose your virtual server has three content databases, all set to warn you when they reach 2000 sites, with a maximum of 2025 sites. When the first content database reaches 2000 sites, an event is logged. When it reached 2025 sites, no more sites can be created in that database. When you are close to the limit on two out of three of the content databases, and you know that you'll need to host more than 2000 additional sites, it is time to create another content database.

You can specify any number of sites for the warning and maximum number of sites. To determine an appropriate number for your situation, divide the amount of available disk space on the database server by the estimated size for each site (plus a buffer). If you are using quotas, divide the disk space by the disk space quota (plus a buffer).

A buffer allows the number of sites to grow beyond the warning level, but not exceed your disk space. The size of the buffer is up to you, but make sure to provide enough space for growth, so that you don't exceed the maximum number before you can react to a warning event. When the maximum number is reached, no more sites can be created in that content database. Be sure to create a buffer large enough so that your users can continue to create sites as required, without having to constantly create new content databases.

Content databases are created and managed at the virtual server level. When you create a new content database (or when you extend a virtual server), you specify the database connection settings for the content database. You can update these settings if, for example, the database server name changes.

You can create or delete content databases, and specify settings such as the database server to use for the content and how many top-level Web sites to allow per content database in a server farm setting, by using pages in HTML Administration. In HTML Administration, you can view the full list of content databases for your virtual server, and see the current, warning and maximum level of sites for the content database at a glance.

Managing Content Databases by Using HTML Administration

You can specify a default server to store content databases for all of your virtual servers. This allows you to create a new content database when you extend a virtual server, without having to specify a location or supply the user name and password.

Specify a default content database server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Server Configuration, click Set default content database server.
  3. In the Content Database Server section, fill in the database server name.

    If you are using Microsoft SQL Server authentication, you must also supply the administrator account user name and password.

  4. Click OK.

You can create multiple content databases for each virtual server. There are two situations in which you create a new content database: when you extend a new virtual server, and when your other content databases are getting full. You use a different method to create the content databases in each of these cases.

In most cases, you create a content database when you extend a virtual server. For information about extending a virtual server and creating a content database, see Extending a Virtual Server.

When you extend a virtual server, the warning level is set to 9,000 sites, and the maximum is set to 15,000 sites. To change this after the virtual server is extended, you use the Manage Content Databases page. You can also create additional content databases by using this page.

Create a new content database for a virtual server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, click the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Manage content databases.
  5. On the Manage Content Databases page, under Content Databases, click Add a content database.
  6. In the Database Information section, select either Use default content database server or Specify database server settings.

    If you select Specify database server settings, fill in the database server name and database name. If you are using SQL Server authentication, you must also supply the administrator account user name and password.

  7. In the Database Capacity Settings section, type a number in the Number of sites before a warning event is generated box.
  8. Type a number in the Maximum number of sites that can be created in this database box.
  9. Click OK.

You can also change database connection settings and warning and maximum site levels for a content database.

Change settings for a content database
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Manage content databases.
  5. On the Manage Content Databases page, under Content Databases, click the database you want to change.
  6. To change database status, in the Database Status box, select Ready or Offline.
  7. To change the number of sites allowed for a content database, in the Database Capacity Settings section, enter a new warning and maximum number.
  8. Click OK.

If you want to remove a content database, you do so from the Manage Content Databases page as well. Note that when you remove a content database, the site data stored in that database is not deleted. You can reconnect to the content database later to restore the sites.

Remove a content database
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Manage content databases.
  5. On the Manage Content Databases page, under Content Databases, select the database you want to change.
  6. On the Manage Content Database Settings page, in the Remove Content Database section, select the Remove content database check box.
  7. Click OK.

You can reconnect to a content database that you have removed by adding it again. To reconnect to an existing content database, you need to use the same database server and database name. There are additional steps if you are reconnecting to a content database after restoring the database to a new server farm. For more information, see "Backing Up and Restoring Databases by Using the SQL Server 2000 Tools" in the Windows SharePoint Services Administrator's Guide.


Managing Versions and Checking Documents In and Out

Managing Versions and Checking Documents In and Out

Microsoft Windows SharePoint Services gives users the ability to keep versions of documents, and to check documents in and out.

About Document Versioning

Document versioning allows you to keep multiple versions of a document. If a change needs to be reversed, you can restore the previous version and continue working. A Version History command is included on the drop-down list users see when they click the arrow next to a document name and on the toolbar in the Edit Properties page for the document. The Version History command is also available in client applications compatible with Windows SharePoint Services, such as Microsoft Office Word 2003, Microsoft Office Excel 2003, and Microsoft Office PowerPoint 2003. When the user clicks Version History, a list of the previous versions of the document appears. The user can open an old version, restore a version (replacing the current version), or delete an old version.

When versioning is enabled, versions are automatically created whenever a user updates a document in a document library. Versions are created in the following situations:

  • When a user checks out a file, makes changes, and checks the file back in.
  • When a user opens a file, makes changes, and then saves the file for the first time.

    Note If the user saves the file again, without closing the file, a new version is not created. If the user closes the application he or she is using to edit the file, and then opens it and saves the file again, another version is created.

  • When a user restores and old version of a file (and does not check it out).
  • When a user uploads a file that already exists, in which case the current file becomes an old version.

Members of the Administrator and Web Designer site groups for a site can determine whether document versioning is enabled for a particular document library. To enable document versioning, you use the settings page for that document library.

Enable versioning for a document library
  1. Navigate to the list, and on the left link bar, click Modify settings and columns.
  2. On the Customize "Document Library" page, click Change general settings.
  3. On the Document Library Settings page, in the Document Versions section, under Create a version each time you edit a file in this document library?, click Yes.
  4. Click OK.

About Checking Documents In and Out

Checking documents in and out allows users to obtain exclusive write access to a document, eliminating the need to merge changes from multiple authors. When a user checks a document out, that user is the only user who can save changes to the document. Other users can read the document, but they cannot make changes. The user who has the document checked out can update the document, and see the latest version of the document, but other users will not see the updates until the document has been checked back in. Members of the Administrator and Web Designer site groups (or members of any site group with the Cancel Check-out right) for a site can override a document check-out if necessary, and force the document to be checked in with the previous version.

To force a document to be checked in, you use the same command as the user would use to check in a document normally.

Cancel a check-out and return to the previous version
  1. Navigate to the document, click the down arrow next to the document's title, and then click Check In.
  2. On the Check In page, select Discard changes and undo check out, and then click OK.
  3. On the confirmation message that appears, click OK to check in the document.


Managing Web Discussions

Managing Web Discussions

Web sites based on Microsoft Windows SharePoint Services include Web discussions, a special collaboration feature that allows users to communicate with each other on the World Wide Web. Web discussions are threaded discussions that allow users to collaborate on HTML documents or on any document that can be opened with a browser (such as .htm, .xls, .doc, and .ppt files) on a server running Windows SharePoint Services. Users can add and view discussion items located within documents, or general discussion items located in the discussion pane.

About Web Discussions

Users can participate in discussions about documents created in word processing, spreadsheet, and presentation programs compatible with Windows SharePoint Services, such as Microsoft Word, Microsoft Excel, and Microsoft PowerPoint, as well as any HTML or Rich Text Format (RTF) file. The threaded discussions are maintained in the content database for the site.

To participate in a discussion, users click the Discuss button on the Microsoft Internet Explorer toolbar, or in a spreadsheet, word processing, or presentation program compatible with Windows SharePoint Services; or click the Web Discussions command (Online Collaboration submenu on the Tools menu). If the document is stored in a document library, you can also use the Discuss option on the Edit menu for the document. All user discussion items are displayed in a shared document that users can view either in the original application or in Internet Explorer.

Because discussion items are stored separately from the shared document, users can modify the document without affecting the collaborative discussion. This separation also allows multiple users to create and edit discussion items simultaneously. Users can also add discussion items to read-only documents.

By using the Web Discussions toolbar, users can view Web discussions, search for discussion items, or filter discussions by author or by date and time. Inline discussions print as part of the document, while discussions in a discussion pane print on a separate page when the document is printed. Users can view discussions offline, but they cannot add to them offline.

Editing Discussion Items

The logon authentication account identifies a user, and depending on the site group assigned to a user, the user has different rights for working with discussion items in a document library or list. For example, in a document library, a user with View Items rights can only view other users' discussion items but cannot contribute to the discussion. Whereas a user with Add Items, Edit Items, and Delete Items rights can participate in discussions, and can also edit or remove other users' discussion items.

With Windows SharePoint Services, and with the appropriate user rights, you can perform the following actions on an existing discussion item:

  • Reply — Append your discussion item to another user's discussion item.
  • Edit — Change your own or another user's discussion item.
  • Delete — Delete your own or another user's discussion item.
  • Close — Mark a discussion item as closed.
  • Close Item and Replies — Mark a discussion item and any replies as closed.
  • Activate — Restore a discussion item after it has been closed.

A user must have the correct rights to view, edit, reply to, or delete a discussion comment in a site. The following table explains the rights required to work with discussion comments within different environments in a Web site:

Action | Right Required (Web Site Page) | Right Required (Document or Attachment) | Right Required (List View and Form pages)
View discussions | View Pages | View Items | View Items
Insert a discussion | Add and Customize Pages | Add Items | Manage Lists
Edit a discussion | Edit Items | Edit Items | Manage Lists
Delete a discussion | Delete Items | Delete Items | Manage Lists
Close a discussion | Add and Customize Pages | Manage Lists | Manage Lists
Close an item and replies | Add and Customize Pages | Manage Lists | Manage Lists
Activate a discussion | Add and Customize Pages | Manage Lists | Manage Lists

For more information about which site groups include these rights, see User Rights and Site Groups.

Anyone with rights to view discussions (from View items on up) can close his or her own discussion items. When discussions are marked closed, they are not deleted from the database, and therefore there is no risk of losing important information. If the discussion is needed again, it can be restored by using the Activate command.

Modifying Documents That Contain Discussion Threads

Because discussion items are not stored in the document, users can modify the document independently from any discussions they create.

The following table explains how a modification to a document can affect threaded discussions in a document.

When a document is modified in this way | The discussion data is affected this way
The change is made in an area without a discussion item attached. | Inline and general discussions are not affected.
The change is made in an area with a discussion item attached. | Inline discussions attached to modified text are moved to the General discussions area and marked as "mismatched." General discussions are not affected.
The entire document is moved, renamed, or deleted. | All inline and general discussions are lost.

Managing Web Discussions

You can view and delete discussion threads on your discussion server. To manage discussion threads, you use the Manage Discussions page in the Site Administration pages for your site or subsite.

Manage Web discussion threads
  1. On the site, click Site Settings.
  2. On the Site Settings page, under Administration, click Go to Site Administration.
  3. On the Site Administration page, under Management and Statistics, click Manage Web discussions, and then do any of the following:
    • To see all discussion threads associated with your site, click All Web discussions, and then click Update.
    • To see discussion threads filtered by a particular URL, type a path in the Web discussions in folder http://server_name/ box, and then click Update.
    • To view a particular discussion thread, click the URL for the thread.
    • To delete a particular discussion thread, select the check box next to the thread, and then click Delete.
    • To delete all discussion threads on your site, click Delete all discussions.


Managing Alerts

Managing Alerts

Because Web sites based on Microsoft Windows SharePoint Services are meant to help groups of users work together, they tend to grow quickly and change often. Keeping up with these changes can be difficult for users, especially if they aren't checking on the site every day. To help users stay in touch with changes on a site, Windows SharePoint Services includes a feature called Alerts, an e-mail notification service. When documents, lists, or items in a list on a server running Windows SharePoint Services are created, modified, or deleted, users who sign up for alerts receive messages informing them that changes have been made.

Note In SharePoint Team Services v1.0 from Microsoft, alerts were called Web subscriptions, but the functionality has not changed significantly.

Users can create alerts to track items within a site, such as:

  • Lists — Users are notified of changes to the list, such as when an item is added, deleted, or changed in a list.
  • List items — Users are notified of changes to a particular item in a list.
  • Document libraries — Users are notified of changes to the document library, such as when a document is added, deleted, or changed in a document library or when Web discussions are added, changed, deleted, closed, or activated for a document.
  • Documents — Users are notified of changes in a particular document or when Web discussions are added, changed, deleted, closed, or activated for a document.

Important Before alerts can work for a particular site, the e-mail server settings must be configured at the server or virtual server level. For more information, see Configuring E-Mail Settings.

When a user creates an alert for one of these items, he or she can specify what types of events will trigger an alert. Alerts can be generated whenever a document or list item is added, updated, or deleted in a document library or list, or when a Web discussion on a document or list changes. A user can specify one of these events, or select all of them to be notified whenever anything changes on the list, list item, document, or document library they want to track.

Users also have the ability to decide how often they want to receive alerts: immediately, daily, or weekly. Immediate alerts are sent as individual e-mail messages, and daily or weekly alerts are combined into summary messages for the entire Web site.

Users can change their alerts by using the My alerts on this site link on the Site Settings page of their Web site.

Note A user must have the View Items right (included in the Contributor site group by default) to sign up for alerts.

Customizing the Message Text for Alerts

For Windows SharePoint Services, you can customize the contents of the alert messages. Keep in mind that while you can alter the contents of the message, there is still no mechanism for identifying and extracting exact text changes within a document or list item. You can, however, customize the text in the message and re-order, add, and remove fields from the message.

Note You must be an administrator on the local server computer to edit the XML templates for Windows SharePoint Services.

The message text for immediate, daily, and weekly alerts is based on content in a series of XML templates on the server computer. To customize the message text, you must edit the XML templates that contain the message text. The templates are stored on the front-end Web server at \\Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\Template\LCID\XML, where LCID is the locale ID. The templates that contain message text for alerts are described in the following table.

Template name | Description | Text and fields may include
notifsitehdr.xml | The header text used for each e-mail alert | Header information (such as site URL), message title information (such as Daily or Weekly Summary), and item information.
notiflisthdr.xml | The list header text | Summary information for daily or weekly changes to a list.
notifitem.xml | The event information | Body text for e-mail messages, including the text and placeholders "item in list has been changed by name at time."
notifsiteftr.xml | The footer text used for each e-mail alert | Footer information, including the string "Click here to manage alert settings."

Caution Editing any of the XML templates for Windows SharePoint Services can break the templates and, consequently, break the mechanism for sending alerts. Be sure to edit only the message text in the template and keep a backup copy of the original templates in case you need to revert to the originals. For more information about customizing XML templates, see the Windows SharePoint Services Software Development Kit.

You can edit the XML templates to include any of the following tags:

Tag | Description
SiteUrl | The full URL to the site.
SiteName | The name of the site.
SiteLanguage | The locale ID (LCID) for the language used in the site. For example, 1033 for U.S. English.
AlertFrequency | Immediate (0), Daily (1), or Weekly (2).
ListUrl | The full URL to the list.
ListName | The name of the list.
ItemUrl | The full URL to the item.
ItemName | The name of the item.
EventType | ItemAdded (1), Item Modified (2), Item Deleted (4), DiscussionAdded (16), Discussion Modified (32), Discussion Deleted (64), Discussion Closed (128), Discussion Activated (256).
ModifiedBy | The name of the user who modified an item.
TimeLastModified | The time the item was last modified.
MySubsUrl | The full URL to the My Alerts on this Site page in Site Settings.

Note In the XML templates, you use numerical values instead of text to specify frequency and event types. So, if you want to set the AlertFrequency to weekly, you would use the value 2 in the template, rather than typing "weekly."

You can use any XML editing tool, such as Notepad, to edit the templates. Keep in mind that any changes you make to this message text are used for all alert messages sent to all users of your server. If you are in a server farm environment, you must edit the templates on each server in the server farm, or copy the edited templates to each server in the server farm. You must be an administrator of the local server computer to edit the XML templates for Windows SharePoint Services.

Configuring and Managing Alerts

You can view alerts for a Web site or subsite and delete alerts that are no longer needed.

If you are a server administrator or a member of the SharePoint administrators group, you can also use SharePoint Central Administration pages to configure settings for alerts, such as the following:

  • View alert settings.
  • Turn alerts on or off.
  • Specify how many alerts users can create.

You can also use the Stsadm.exe command-line tool to configure alert settings if you are a server administrator. Using the command line, you can:

  • Turn alerts on or off.
  • Specify how many alerts users can create.

Alerts use the Windows SharePoint Services e-mail settings to send alert items. When you configure alert settings, be sure that you also double-check the e-mail settings for your virtual server. For more information, see Configuring E-Mail Settings.

Important When you remove a user from a Web site, site group, or cross-site group after he or she has created alerts, you must manually delete any alerts that he or she has set up. This is also true for any lists or libraries where you change security settings to limit access. If a user has set up alerts for the list or library, he or she will continue to receive them after you change the security settings. It is important to delete these alerts to prevent unauthorized users from having access to site and user information.

Managing Alerts for a Web Site

You can use HTML Administration pages to view and delete alerts on your site. To manage alerts, you use the Manage User Alerts page in the Site Administration pages.

Manage alerts
  1. On the Site Settings page for the Web site, under Administration, click Go to Site Administration.
  2. Under Management and Statistics, click Manage user alerts.
  3. On the Manage User Alerts page, select a user name in the Display alerts for ___ box, and then click Update.
  4. To delete an alert, select the check box next to the alert, and then click Delete Selected Alerts.

Configuring Alerts for a Virtual Server

You can also change alert settings for a virtual server. Changes you make on the virtual server affect all Web sites under that virtual server. To change settings for a virtual server, you use commands on the Virtual Server Settings page. You must be a member of the SharePoint administrators group or an administrator of the local computer to change virtual server settings.

Configure alerts for a virtual server
  1. On the server that contains the virtual server, click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, click the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Virtual server general settings.
  5. In the Alerts section, next to Alerts on this server are, click On or Off.
  6. Under Maximum number of alerts that a user can create, specify whether users can have a limited or unlimited number of alerts.
    • If you want to limit the number of alerts users can create, specify the number of alerts a user can create.
    • If you want users to be able to create as many alerts as they like, select Unlimited number.
  7. Click OK.

Using the Command Line to Configure Alerts

You can manage alerts from the command line by using the GetProperty and SetProperty operations with Stsadm.exe. You can set the following properties to configure how alerts work.

Property | Description
alerts-enabled | Turn alerts on or off.
alerts-limited | Specify whether users are limited to a specific number of alerts.
alerts-maximum | Specify the maximum number of alerts users can create.
job-immediate-alerts | Specify how often to check for immediate alerts (in minutes).
job-daily-alerts | Specify the time of day (using a 24-hour clock) to send out daily alerts.
job-weekly-alerts | Specify the day of the week and time of day (using a 24-hour clock) to send out weekly alerts.

The following example shows the syntax to use to turn off alerts:

stsadm.exe -o setproperty -url <url> -pn alerts-enabled
-pv false

Related Topics

For more information about using the administration tools or setting properties on the command line, see "Introducing the Administration Tools for Windows SharePoint Services" in the Windows SharePoint Services Administrator's Guide and Command-Line Properties.

The Alerts feature relies on the e-mail settings and timer service settings you configured for your server or virtual server. For more information about configuring e-mail settings, see Configuring E-Mail Settings. For more information about Microsoft SharePoint Timer Services, see Scheduling Timed Jobs.


Managing HTML Viewers

Managing HTML Viewers

Included with Microsoft Windows SharePoint Services is the ability to connect to an HTML viewing server. The HTML viewing server provides support for users who want to view the content of files on the Windows SharePoint Services Web site, but do not have Microsoft Word, Microsoft Excel, or Microsoft PowerPoint from Microsoft Office 97, or a later release of Office, installed on their local computer. Even users who only have a Web browser (Microsoft Internet Explorer or Netscape Navigator) can view content by having the native Office file format converted to HTML automatically. Although there is a slight delay while the transformation takes place, the converted file is extremely close to the WYSIWYG formatting of the original. In addition to making files available for viewing by users, administrators can use a batch process mode of HTML viewing to convert the contents of entire folders to HTML.

Note By default, the HTML viewing service supports only the following document types: .doc, .xls, .ppt, and .pps.

Transformation of a supported document can take between 1 and 30 seconds, depending on the complexity and size of the document as well as the speed and available resources of the dedicated computer. To provide for this ability and assure a fast response time, it is recommended that you dedicate a separate computer to this service.

After the server is set up, it can be managed through the Configure HTML Viewer page in the SharePoint Central Administration pages. For more information about setting up an HTML viewing server, see the Microsoft Office HTML Viewer Service for Windows SharePoint Services white paper on the Microsoft Office Resource Kit Web site.

Configure Windows SharePoint Services to use the HTML Viewer
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Server Configuration, click Configure HTML Viewer.
  3. Select the Allow HTML Viewing check box.
  4. In the Path to HTML Viewer Server box, type the full URL to the server hosting the HTML Viewer.
  5. In the Maximum cache size box, type the maximum size to allow for the HTML viewing cache.
  6. In the Maximum file size box, type the maximum file size to view.
  7. In the Timeout length box, type the length of time to wait before ending an HTML Viewer process.
  8. Click OK.


Managing Meeting Workspace Sites

Managing Meeting Workspace Sites

A Meeting Workspace site is a Microsoft Windows SharePoint Services subsite that is designed for centralizing all the information and materials for one or more meetings. Although some management tasks are specific to workspace sites, most of the tasks that you do for other types of SharePoint sites also apply to Meeting Workspace sites.

Enabling or Disabling Creation of Meeting Workspace Sites

By default, only users who are members of the Administrator site group are allowed to create, rename, or delete Meeting Workspace sites. As an administrator, you can enable or disable permissions to create workspace sites for a group of users. When you enable the creation of workspace sites, you give the Create Subsites right to the selected users or cross-site groups on the virtual server. This right allows users to create a subsite or a workspace site from the Create page, from the Manage Sites and Workspaces page, or from an events list under an existing SharePoint site. After the workspace site is created, no Meeting Workspace sites or other subsites can be created under the new Meeting Workspace site.

After you enable users to create workspace sites on the Windows SharePoint Services server, you can also allow users to create Meeting Workspace sites from your organization's calendaring and e-mail application. The application that you use must be compatible with Windows SharePoint Services, such as Microsoft Office Outlook 2003. This integration allows convenient collaboration and information sharing. To enable or disable the Meeting Workspace feature for the calendaring and e-mail application, use group policies for that application.

Templates

Windows SharePoint Services includes five Meeting Workspace site templates: Basic Meeting Workspace, Blank Meeting Workspace, Decision Meeting Workspace, Social Meeting Workspace, and Multipage Meeting Workspace. Workspace sites that the user creates from these templates have a different site definition ID than sites based on the Team Site template. As with other SharePoint templates, you can create new Meeting Workspace site or list templates for your users by saving an existing site or list as a site or list template. You can add new site templates to the central template gallery or the site collection template gallery, and you can add custom list templates to the site collection template gallery.

Accounts and Server Permissions

A Meeting Workspace site can either use the same permissions as the parent Web site (inheriting both the site groups and existing user accounts available on the parent Web site), or it can use unique permissions (so site administrators can create their own user accounts and add them to site groups). To use the same permissions as the parent Web site, a user who is a member of the local administrator group on the server or a user who is a member of the Administrator site group on the parent site must give the Meeting Workspace users permissions on the parent Web site.

If you need to create new user accounts, instead of using existing domain accounts, use Active Directory account creation mode. For example, an Internet service provider (ISP) may need to allow SharePoint site owners to create user accounts or invite users to collaborate on a Web site where existing domain accounts for those users do not already exist.

Related Topics

For more information about viewing, creating, and deleting sites and site collections, see Managing Sites and Subsites.

For more information about defining and customizing site groups and their rights, see Managing Site Groups and Permissions.

For more information about rights, allowing anonymous access, and assigning administration tasks, see Controlling User Rights and Assigning Tasks.

For more information about configuring Windows SharePoint Services with a separate Microsoft Active Directory directory service, see Separate Active Directory Directory Service Organization Unit Deployment.

For more information about site and list templates and the template gallery, see Working with Templates.


Managing a Server Farm Running Windows SharePoint Services

Managing a Server Farm Running Windows SharePoint Services

Microsoft Windows SharePoint Services was designed to be useful in large server farms, supporting hundreds or thousands of SharePoint sites and millions of users. When you manage a server farm environment for Windows SharePoint Services, you need to make certain choices about configuring your environment, and you need to be aware of how Windows SharePoint Services works in that environment. This topic explains those choices, and describes how to work with Windows SharePoint Services in a large-scale, server farm environment.

About Front-End Web Servers

In a server farm environment, the front-end Web servers contain only the files and settings required to route requests from clients to the appropriate sites in the database. Unlike in SharePoint Team Services v1.0 from Microsoft, they do not contain site data.

All site content and all configuration data is shared for all front-end Web servers in a server farm. To get the best performance and the best protection against hardware failure, you should configure Windows SharePoint Services identically on all the front-end Web servers in your server farm.

The exceptions to this rule are those cases where data must be stored or pulled from Internet Information Services (IIS). For example:

  • Usage analysis data is collected for each front-end Web server individually. You can view usage analysis reports for each site. The data for these reports is compiled from the information collected from each server in your server farm. For more information about usage analysis, see Configuring Usage Analysis and Analyzing Web Site Usage.
  • Some settings used for virtual servers in IIS, such as whether anonymous access is allowed for the virtual server, are stored in the IIS metadata on the server itself.

It is strongly recommended that you use the same application pool accounts across all of the front-end Web servers in your server farm. For example, on server1, virtual_server1 hosts http://site1. On server2, virtual_server1 hosts the same site. When you use the same application pool for virtual_server1 on both servers, you can be sure that the application pool always has the appropriate permissions to perform the Windows SharePoint Services administration tasks.

Replicating Configuration Settings

Most changes to configuration settings in Windows SharePoint Services are replicated automatically, without requiring software such as Microsoft Application Center. For example, when you change the e-mail server for Windows SharePoint Services, you do so either from the SharePoint Central Administration pages or the command-line tool, Stsadm.exe. You make this change only once, and the change is entered into the configuration database and automatically applied to all servers in the server farm.

Some configuration processes must be performed individually on each front-end Web server. These processes include:

  • Installing Windows SharePoint Services.

    You must install Windows SharePoint Services directly to any server computers that you want to include as front-end Web servers in your server farm.

  • Extending a virtual server with Windows SharePoint Services.

    Although this task is performed from either the SharePoint Central Administration pages or the command line, it adds files to the virtual server directory on the front-end Web server itself.

Windows SharePoint Services uses the SharePoint Central Administration virtual server on each front-end Web server to keep configuration data synchronized. To make automatic replication of other configuration settings work best, you should ensure that:

  • The SharePoint Central Administration virtual server for each front-end Web server is directly accessed by administrators, and not solely by a virtual Internet Protocol (IP) address.
  • If you are using hardware load balancing, the routers or switches you use in a multi-host environment are configured so that command-line operations work. For example, if you are using a virtual IP environment for the SharePoint Central Administration virtual server, you must be sure that each front-end Web server can ping every other front-end Web server.

Choosing a Load Balancer

To make the most of your server farm environment, you need some method of balancing the client requests across all of the front-end Web servers in your server farm. Windows SharePoint Services works with most of the standard load balancing methods available. Some methods work better, or scale up better than others. You can use any of the following methods with Windows SharePoint Services:

  • Software solutions, such as Network Load Balancing

    Network Load Balancing is included with Microsoft Windows Server 2003. This method is inexpensive, but offers only limited scalability. For more information about Network Load Balancing, see your Windows Server 2003 documentation.

  • Software configuration solutions, such as using the domain name system to route requests

    You can configure your domain name system (DNS) to create a basic load balancing system. For more information about DNS, see your Windows Server 2003 documentation.

  • Hardware load balancing

    You can also purchase load balancing hardware, such as a router, to distribute requests. The hardware method is more expensive, but it is also the most scalable method and it provides the best use of your front-end Web server resources.

You do not need to perform any configuration steps to make Windows SharePoint Services work with any of these load balancing methods. Simply set up the load balancing method in your server farm, and either install or continue using Windows SharePoint Services.

Managing the List of Servers in a Server Farm

In a server farm environment, you may frequently need to perform the same action across several front-end Web servers in your server farm. To make performing actions on multiple servers easier, the SharePoint Central Administration page includes a link to the Manage Web Server List page — which lists all of the servers in your server farm. All servers running Windows SharePoint Services that are registered with the server farm are listed on this page. From this page, you can navigate to another server and continue managing or configuring Windows SharePoint Services for your servers.

Switch to the SharePoint Central Administration page for a different server
  1. On the SharePoint Central Administration page for your server farm, under Server Configuration, click Manage Web server list.
  2. On the Manage Web Server List page, click the name of the server you want to manage.

If you need to remove a server from your server farm (either temporarily or permanently), you can do so from the Manage Web Server List page. Removing a server from this list does not uninstall Windows SharePoint Services on that server, or make any sites on that server inaccessible. It simply removes it from the server farm, and because you are in a server farm, all sites are still accessible from other front-end Web servers in the server farm.

Remove a server from the list
  1. On the SharePoint Central Administration page for your server farm, under Server Configuration, click Manage Web server list.
  2. On the Manage Web Server List page, next to the server name you want to remove, click Remove.
  3. Click OK to remove the server.

Cleaning Up Old Logging Data

When you run Windows SharePoint Services, several processes generate log files that reside on the front-end Web servers in your server farm. To ensure that your servers are running as efficiently as possible, you should periodically delete this old data. The following table lists the types of log files used by servers running Windows SharePoint Services and where these types of log files are stored on the front-end Web servers.

Log file type | Location
Usage analysis logs | %Windows%\system32\LogFiles\STS
Stsadm.exe logs | The %temp% directory for the user account running Stsadm.exe.
Smigrate.exe logs | The %temp% directory for the user account running Smigrate.exe.
Windows SharePoint Services setup logs | %Windows%\Temp
IIS logs | %Windows%\system32\LogFiles\Virtual_Server_ID Where Virtual_Server_ID is the IIS ID for the virtual server, such as W3SVC1 for the default virtual server.
W3wp.exe logs | %Windows%\Temp\w3wpApplication_Pool_ID Where Application_Pool_ID is the ID for the application pool, such as StsAdminAppPool for the default SharePoint Central Administration application pool.

For more information about the IIS and W3wp.exe logs, see the About Logging Site Activity topic in the IIS Help system.


About Web Parts

About Web Parts

A Web Part is a Microsoft ASP.NET server control that serves a particular purpose, such as displaying data from a spreadsheet or streaming stock quotations from an online Web service. Web Parts are inserted in Web Part zones on Web Part Pages. Web Part zones are containers for Web Parts that group and organize Web Parts and provide a set of properties that configure the Web Parts in that zone. Web Part Pages consolidate data and Web content through Web Part zones to create dynamic information portals.

Note Web Parts can be inserted outside of Web Part Zones. However, Web Parts outside of Web Part Zones have reduced functionality.

Web Part Pages can be built into site templates in Microsoft Windows SharePoint Services to implement dynamic, data-driven sites. Users interacting with a site can create Web Part Pages and add Web Parts. Users can connect Web Parts so that one Web Part can be driven by data from another. Web Part zones and part-to-part connections are exposed in the Windows SharePoint Services user interface, allowing users to build dynamic Web applications made up of Web Parts without having to write any code.

Windows SharePoint Services includes a default set of Web Parts that users can immediately use to customize their sites. For example, the Web Parts available with Windows SharePoint Services include:

  • Content Editor Web Part — Displays unstructured Web content, such as text or images.
  • Image Web Part — Displays a picture.
  • Form Web Part — Lets users add an HTML form.
  • Contacts — Lets users display their Contacts list on a Web Part Page.

Web Parts are made available to users from Web Part galleries, which are collections of Web Parts. Depending on how you configure the server, users can add Web Parts from any of the following galleries:

  • The Web Part Page gallery — A collection of Web Parts that are available to a specific Web Part Page but are currently inactive. Closing a Web Part on a page moves it to this gallery. Each Web Part Page has its own Web Part Page gallery.
  • The site collection Web Part gallery — The most central Web Part gallery for a work group. This gallery is typically managed by the site administrator of the site collection, who decides which Web Parts are available and safe for the team's sites. By default, the gallery name is the name of the site, such as "Our Team Site Web Part Gallery." There is only one site collection gallery for each site collection. For information about managing a site collection Web Part Gallery, see Managing a Site Collection Web Part Gallery.
  • The virtual server Web Part gallery — The central gallery available to all sites on a server or server farm. When an administrator installs a custom Web Part, the Web Part is available to users from this gallery. For information about installing custom Web Parts, see Managing Web Parts on Virtual Servers.
  • The online Web Part gallery — A set of Web Parts that are available over a Web service. This permits many servers to share access to a common, centrally maintained collection of Web Parts. You can optionally make one online gallery available to your site users. By default, SharePoint sites connect to the online gallery that Microsoft maintains at http://r.office.microsoft.com/r/hlidAwsGallery. For information about managing an online gallery, see Managing Web Parts on Virtual Servers.

Custom Web Part packages are distributed to server administrators as cabinet (.cab) files. You use the command-line tool Stsadm.exe to add Web Parts from a Web Part package (in cabinet file format) to one or more virtual servers. Stsadm.exe installs Web Part executable code in the Bin directory of each virtual server or in the global assembly cache (GAC). Any resources used by an assembly are installed in the \wpresources folder for assemblies installed in Bin directories, or \_wpresources for assemblies installed in the GAC. Web Part definition (.dwp) files are installed in the virtual server Web Part gallery.

Note On a server farm, you should install custom Web Parts identically on each front-end Web server. Use the SharePoint Configuration Analyzer utility to check each virtual server's Web Part configuration. For more information, see Using SharePoint Configuration Analyzer.

Related Topics

For information about installing, upgrading, and deleting custom Web Parts, along with descriptions of other Web Part configuration tasks at the virtual server level, see Managing Web Parts on Virtual Servers.

For information about using SharePoint Configuration Analyzer, see Using SharePoint Configuration Analyzer.

For information about managing a site collection Web Part Gallery, see Managing a Site Collection Web Part Gallery.


Managing a Site Collection Web Part Gallery

Managing a Site Collection Web Part Gallery

Administrators of a top-level Web site can determine which Web Parts are available to the users of sites in their site collection. They can use the site collection Web Part gallery page to add or remove Web Parts from the list of Web Parts available for use or to upload new Web Parts. Note that users may also have access to Web Parts in the online Web Part gallery or in the server Web Part gallery. The Web Part gallery for a site collection controls only a subset of all Web Parts available to users.

Make a Web Part available in the Web Part gallery
  1. On a top-level Web site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Site Collection Galleries, click Manage Web Part gallery.
  4. On the Web Part Gallery page, click New Web Part.
  5. Select the check box next to the Web Parts you want to include in the gallery, and then click Populate Gallery.

    Note The list of Web Parts that can be added to the Web Part gallery is derived from the list of safe Web Parts in the web.config file. There may be Web Parts in the web.config file that have never been in the gallery or that were deleted from the gallery.

    When you click Populate Gallery, the Web Parts you select are added to the gallery and are made available to all users.

If you have installed a Web Part package and need to add the Web Parts to the gallery, you can use the Upload Web Part button to add the new Web Parts to the gallery.

Web Parts can be organized into groups for easy filtering in the gallery. You can specify which group a Web Part belongs to when you add a Web Part to the Web Part gallery. Groups are optional — you can add a Web Part without specifying a group.

Add a Web Part to the Web Part gallery
  1. On the Web Part Gallery page, click Upload Web Part.
  2. In the Name box, type the name of the Web Part (including the full path to the .dwp file) or click Browse.
  3. In the Group box, select a group or, under Specify your own value, type a group name for the Web Part.
  4. Click Save and Close.

You can add several Web Parts to your gallery at once by using the Upload Multiple Files option on the Upload Web Part page.

Note You must be using a Windows SharePoint Services-compatible client application to use the Upload Multiple Files option.

Add multiple Web Parts to the Web Part gallery
  1. On the Web Part Gallery page, click Upload Web Part.
  2. Under Name, click Upload Multiple Files.
  3. Select the check boxes next to the Web Parts you want to upload, and then click Save and Close.

You can remove a Web Part from the gallery if you want to make it unavailable to users. If a user has already used a Web Part in the site, and you delete the Web Part from the site gallery, the Web Part will remain on the Web Part Page and will still work. However, if an administrator on the server computer removes the Web Part assembly that contains the Web Part from the server, or marks the assembly as unsafe in the Web.config file for the server, the Web Part will no longer run, and the user will see an error message.

Remove a Web Part from the Web Part gallery
  1. On the Web Part Gallery page, next to the Web Part you want to remove, click the Edit icon.
  2. On the Web Part Gallery: <Web Part Name> page, click Delete.
  3. Click OK to delete the Web Part.

Related Topics

For an overview of Web Parts, see About Web Parts.

For information about installing, upgrading, and deleting custom Web Parts, along with descriptions of other central administration Web Part configuration tasks, see Managing Web Parts on Virtual Servers.


Managing Web Parts on Virtual Servers

Managing Web Parts on Virtual Servers

This topic describes Web Parts administration on virtual servers. Web Part administration tasks include:

  • Installing Web Parts.
  • Upgrading Web Parts.
  • Deleting Web Parts.
  • Managing an online Web Part gallery.
  • Allowing part-to-part connections.
  • Setting additional Web Part configuration options.

For information about managing Web Parts for a site collection, see Managing a Site Collection Web Part Gallery.

Installing Web Parts

As a server administrator, you will be called on to install Web Parts on a server or server farm. To meet the needs of your organization, internal teams may develop Web Parts to deploy on some servers or across your entire intranet. Also, external software developers will build general purpose applications based on Web Parts technology and make them available to your user community. Installing a Web Part is a three-step process: evaluation, installation, and verification.

  • Evaluation

    Evaluate a custom Web Part before installing it on your server or server farm. You should be comfortable that installing the Web Part will not compromise your server's security or performance. Web parts should be coded and tested by following recommended best practices, and they must be configured to run with the minimum level of permissions required to access the system and other resources that they need. Microsoft Windows SharePoint Services takes advantage of the Microsoft .NET Framework code access security mechanism to provide server administrators with the flexibility to set permissions on Web Part assemblies tailored to their needs. For a complete discussion, see Microsoft Windows SharePoint Services and Code Access Security.

    The SharePoint Products and Technologies 2003 Software Development Kit contains guidelines for software developers that will help them implement their Web Parts following best security practices. For example, the SDK includes a topic, "Code Access Security For Administrators," that describes how code access security is used in Windows SharePoint Services and how an administrator can create custom security policy files if needed. Also, see the SharePoint Developer Center on MSDN for additional information on creating and testing Web Parts, and see the Microsoft Security Developer Center for information that helps developers create secure software. Make sure that your developer community uses these resources in designing, coding, and testing Web Parts before you agree to deploy them.

  • Installation

    Custom Web Part packages are distributed as cabinet (.cab) files. You use the command-line tool Stsadm.exe to add Web Parts from a Web Part package to one or more virtual servers.

    In addition to installing the Web Part assemblies, .dwp files, and resources needed by Web Parts, Stsadm.exe puts a copy of the Web Part package in the configuration database. In a server farm configuration, you use this centrally located Web Part package when installing the Web Parts from other servers.

    Note The Wppackager tool is an alternative method of packaging and installing custom Web Parts. This unsupported tool is available on the Microsoft Download Center at SharePoint Products and Technologies Tool: wppackager for packaging and deploying Web Parts. A whitepaper on this tool is published at Using Wppackager to Package and Deploy Web Parts for Microsoft SharePoint Products and Technologies.

    An important decision when adding a new Web Part assembly is whether to install it to the global assembly cache (GAC) or to the Bin directory (C:\inetpub\wwwroot\bin for the default virtual server). The Bin directory is the more secure option. When installed in the Bin directory, an assembly is only available to the virtual server. Because the administrator controls the trust level for the virtual server, assemblies installed in the Bin directory will run, by default, at a lower level of trust, such as WSS_Minimal, than they would in the GAC. (By default, assemblies installed in the GAC run at Full trust.)

    In some IIS configurations, you must install assemblies in the GAC. For example, when you configure an IIS virtual server, extended by using Windows SharePoint Services, that has a host header name, you must install Web Part assemblies in the GAC. But generally, you should install custom Web Parts in the Bin directory, and you should demand of your developer community that they develop Web Parts that work properly under the trust level that you want to enforce on your virtual servers.

  • Verification

    After installing Web Parts to each server, you can verify your installation by using the SharePoint Configuration Analyzer tool. Along with verifying that IIS and Windows SharePoint Services configurations are compatible, this tool reports on errors in Web Part and Web Control assemblies installations, mismatches between SafeControls lists (in web.config files) and the Web Parts that they reference, and Web Part assemblies that are missing from your server but referenced from pages in the database.

    After installing a new Web Part assembly, using SharePoint Configuration Analyzer to check the installation, and fixing any errors, you should run SharePoint Configuration Analyzer again with the Save state information option selected. When you select Save state information, SharePoint Configuration Analyzer creates a reference XML file that it uses to reconstruct the mappings between global unique identifiers (GUIDs) and type names, so that it can report the more readable type names of Web Parts in its reports.

    For information about installing and using SharePoint Configuration Analyzer, see Using SharePoint Configuration Analyzer.

Installing Web Parts By Using Stsadm.exe

To add a new Web Part package to your virtual server, use the following syntax:

stsadm.exe -o addwppack -filename <path to Web Part Package> [-url <URL>] [-globalinstall]
  • -filename specifies the path to the cabinet file containing the Web Parts and associated resources.
  • -url optionally specifies the URL of the virtual server on which to install the Web Parts. To install the Web Parts on every virtual server on a server, omit the -url parameter.
  • -globalinstall tells Stsadm.exe to install the Web Parts in the global assembly cache (GAC) rather than in the Bin directories of each virtual server.

    Assemblies installed in the GAC are available to all applications on the server. This is less secure than installing in Bin directories because it potentially grants a higher level of permission to your assemblies across a larger scope than might be necessary.

    Notes

    • Web Parts must be strongly named to be installed in the GAC. If one or more Web Parts in the Web Part package are not strongly named, the Web Part package will be installed in the Bin directory and not in the GAC. For more information, see the topic ”Code Access Security for Developers” in the SharePoint Products and Technologies 2003 Software Development Kit .
    • If you specify both the URL of a single virtual server and the -globalinstall parameter, the Web Part will only appear in the Web Part Gallery of the virtual server that you specified. However, the assembly will be installed in the GAC, will run at the Full Trust level by default, and will be available from other applications.

In a server farm configuration, if a Web Part package has already been installed on one front-end server, you can install the Web Part Package on another server from the configuration database by using the following syntax:

stsadm.exe -o addwppack -name <name of Web Part Package> [-url <URL>] [-globalinstall]
  • -name specifies the name of a Web Part Package.
  • -url optionally specifies the URL of the virtual server on which to install the Web Parts. To install the Web Parts on every virtual server on the server, omit the-url parameter.
  • -globalinstall specifies to install the Web Parts in the global assembly cache (GAC) rather than in the Bin directories of each virtual server. Use this flag consistently on all front-end servers of a server farm.

To enumerate the Web Part packages installed on a virtual server, use the following syntax:

stsadm.exe -o enumwppacks [-name <name of Web Part Package>] [-url <URL>]
  • -name specifies the name of a Web Part package. Omitting this parameter specifies to list all Web Part packages for the virtual server or virtual servers.
  • -url optionally specifies the URL of the virtual server for which to enumerate the Web Part packages. If -url is omitted, Stsadm.exe enumerates Web Part packages on every virtual server on the server.

Upgrading Web Parts

You may need to upgrade installed Web Parts on a server or server farm, either to introduce new functionality or to distribute repaired Web Parts in response to bugs or security issues. Upgrading Web Parts is a four-step process: evaluation, notification, installation, and verification.

  • Evaluation

    Evaluate changes to a custom Web Part before upgrading it. As when installing new Web Parts, you should verify that changes to the Web Part do not compromise your server security or performance. Make sure that your developer community uses the resources available at SharePoint Developer Center and in the SharePoint Products and Technologies 2003 Software Development Kit when designing, coding, and testing new or updated Web Parts before you agree to deploy them.

  • Notification

    Before upgrading a Web Part package, you should notify everyone in your user community who is using Web Parts from the package. An upgraded Web Part may function differently, and an upgraded Web Part description (.dwp) file may expose new properties. Failing to notify your user community could result in broken Web sites and the resultant support calls.

    To find all owners of pages containing a Web Part on a virtual server, use the SharePoint Configuration Analyzer tool. SharePoint Configuration Analyzer lists each Web Part installed on a virtual server and, for each Web Part, lists all of the pages that contain an instance of that Web Part in a Web Part Zone. Using this information, you can contact owners of pages containing Web Parts that are about to be upgraded. For more information about SharePoint Configuration Analyzer, including where to find this tool, see Using SharePoint Configuration Analyzer.

  • Installation

    Installing an upgraded Web Part package is similar to installing a new package. Use the Stsadm.exe command line tool to upgrade the Web Part package.

  • Verification

    As with new Web Parts packages, after upgrading Web Parts to each server, you can verify your installation by using the SharePoint Configuration Analyzer tool.

    After upgrading a Web Part assembly, using SharePoint Configuration Analyzer to check the upgrade, and fixing any errors, you should run SharePoint Configuration Analyzer again with the Save state information option selected. When you select Save state information, SharePoint Configuration Analyzer creates a reference XML file that it uses to reconstruct the mappings between GUIDs and type names, so that it can report the more readable type names of Web Parts in its reports.

Upgrading Web Parts By Using Stsadm.exe

You use the command-line tool Stsadm.exe to upgrade Web Parts from a Web Part package (in cabinet file format) to a virtual server. In addition to upgrading the Web Part assemblies and optional Web Part Definition (.dwp) files to the server, Stsadm.exe puts a copy of the Web Part package in the configuration database. In a server farm configuration, use this centrally located cabinet file when upgrading the Web Parts from other servers.

The syntax for upgrading a Web Part package on a virtual server is similar to the syntax for installing a new package:

stsadm.exe -o addwppack -filename <path to file> -force [-url <URL>] [-globalinstall]
  • -filename specifies the path to the cabinet file containing the Web Parts.
  • -force instructs Stsadm.exe to overwrite an existing Web Part package with a new version.
  • -url optionally specifies the URL of the virtual server on which to upgrade the Web Parts. If -url is omitted, Stsadm.exe upgrades the Web Parts in the Bin folder of every virtual server on the server. On servers where the Web Parts were not installed, this is equivalent to a new installation.
  • -globalinstall specifies to install the Web Parts in the global assembly cache (GAC) rather than in the Bin directories of each virtual server.

In a server farm, if a Web Part package has already been upgraded on one front-end server, you can upgrade the Web Part package from another server by using the following syntax, where -name specifies the name of the Web Part package:

stsadm.exe -o addwppack -name <name of Web Part Package> -force [-url <URL>] [-globalinstall]

When you upgrade a Web Part assembly that is currently in the global assembly cache, if you omit the -globalinstall parameter, the Web Part assembly will be moved to the Bin folder. When you upgrade a Web Part assembly that is currently in the Bin folder, adding the -globalinstall parameter will move the upgraded assembly to the global assembly cache.

Deleting Web Parts

When you delete a Web Part on a server, you delete the assembly (that part of the Web Part implementation that is executable code) and related resources. Users must remove the Web Part Definition file from any pages that use the Web Part. Deleting Web Parts is a three-step process: notification, deletion, and verification.

  • Notification

    Before deleting a Web Part assembly, you should notify everyone in your user community who is using the assembly. Deleting Web Parts that are in use will break the functionality of Web pages that are dependent on the Web Part. Failing to notify your user community could result in support calls as pages stop working as expected.

    To find all owners of pages containing a Web Part on a virtual server, use the SharePoint Configuration Analyzer tool, which lists each Web Part installed on a virtual server and, for each Web Part, lists all of the pages that contain an instance of the Web Part in a Web Part Zone. Using this information, contact owners of pages containing Web Parts that are to be deleted, so that they can remove instances of that Web Part from their pages. For more information about SharePoint Configuration Analyzer, see Using SharePoint Configuration Analyzer.

    Note Because SharePoint Configuration Analyzer does not report on the Web Parts that have been added to each site collection gallery, you should also contact all site administrators of site collection galleries to warn them to remove Web Parts that you are deleting from these galleries.

  • Deletion

    Use the Stsadm.exe tool to delete a Web Part assembly.

  • Verification

    After deleting Web Part assemblies from each server, you can verify the operation using the SharePoint Configuration Analyzer tool. By using this tool, you can find unwanted Web Part assemblies that remain on virtual servers along with pages that refer to deleted assemblies.

Deleting Web Parts By Using Stsadm.exe

To delete the Web Parts in a Web Part package, use the following syntax:

stsadm -o deletewppack -name <name of Web Part package> [-url <url>]
  • -name specifies the name of the Web Part package.
  • -url optionally specifies the URL of the virtual server on which to delete the Web Parts. If -url is omitted, Stsadm.exe deletes the Web Parts from the Bin folder of every virtual server on the server or from the global assembly cache.

Note When you delete the last instance of a Web Parts package on a server or server farm, Stsadm.exe also deletes the Web Part package from the configuration database.

Managing the Online Gallery

If your organization runs Windows SharePoint Services over multiple front-end servers, you may want to create your own online Web Part gallery as a central location for deploying Web Parts to all your sites.

For details on how to implement a custom online Web Part gallery, including the XML schema for communications between the server accessing the gallery and the server hosting the gallery, see the article Building an Online Web Part Gallery on MSDN.

Specifying an Online Web Part Gallery

To specify an online Web Part gallery for a virtual server:

  1. On the Web server, navigate to the folder containing the virtual server, and then, using a text editor such as Microsoft Notepad, open the web.config file under the following directory:

    \Inetpub\wwwroot

  2. In the web.config file, modify the following line, which is contained in the <SharePoint> element

    <OnlineLibrary Url="http://Server/Path"/>
    Where Server is the server hosting the online gallery and Path is the path to the .aspx page that implements the online gallery.

  3. Save and close the web.config file.
  4. Repeat steps 1 through 3 for each virtual server for which you want to specify an online Web Part gallery.

Adding Web Parts to an Online Web Part Gallery

As with all Web Part galleries, a new Web Part added to an online gallery can be implemented either as a Web Part description (.dwp) file or as a .dwp file along with a new assembly file. New Web Parts implemented as .dwp files provide their functionality by configuring existing assemblies to behave in new ways. New Web Parts that are implemented as both a .dwp file and an assembly file provide their functionality by implementing new code in the assembly file.

When a new Web Part that has a new assembly is added to an online gallery, the server administrator for each server that accesses the online gallery must install the assembly on each server. It is up the owner of the online gallery to contact each server administrator and provide a method for installing the new assembly, and the administrator of each server must evaluate the Web Part before installing its assembly, as with any custom Web Part.

Controlling Access to the Online Gallery

You can configure access to the online gallery for each virtual server. You must be an administrator of the local server computer or a member of the SharePoint Administrators group to configure access to the online gallery.

  1. On your server computer, click Start, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, click Configure virtual server settings.
  3. On the Virtual Server List page, click the virtual server you want to configure.
  4. On the Virtual Server Settings page, click Manage security settings for Web Part Pages.
  5. In the Online Web Part Gallery section, click Enabled to allow access to the online Web Part gallery, or click Disabled to prevent access to the gallery, and then click OK.

    You can also return to using the default server setting for enabling use of the Online Web Part gallery by clicking Restore Defaults.

Allowing Access to the Online Web Part Gallery from Behind a Proxy Server or Firewall

If your server is behind a proxy server or firewall, you must also edit the web.config file for each virtual server for which you want to enable an online Web Part gallery that is implemented outside of your firewall. In a server farm environment, you must edit this file for each virtual server in every front-end Web server in the server farm.

  1. On your Web front-end server computer, open Notepad, navigate to the folder containing the virtual server for which you want to enable the online Web Part gallery, and then open the web.config file under the following directory:

    \Inetpub\wwwroot

  2. In the web.config file, add the following lines.

    <system.net>
      <defaultProxy>
      <proxy proxyaddress="http://Proxy_Server:port" bypassonlocal = "true"/>
      </defaultProxy>
    </system.net>
    Where Proxy_Server:port is the proxy server or firewall used for your environment.

  3. Save and close the web.config file.
  4. Repeat steps 1 through 3 for each virtual server for which you want to enable access to the online Web Part gallery.

Allowing Part-to-Part Connections

You specify whether or not users can connect Web Parts to each other for each virtual server. You must be an administrator of the local server computer or a member of the SharePoint Administrators group to allow part-to-part connections.

  1. On your server computer, click Start, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, click Configure virtual server settings.
  3. On the Virtual Server List page, click the virtual server you want to configure.
  4. On the Virtual Server Settings page, click Manage security settings for Web Part Pages.
  5. Select the options you want to enable or disable, and then click OK.

    You can also return to using the default server setting for part-to-part connections by clicking Restore Defaults.

Additional Web Part Settings

There are additional Web Part options you can set in the Windows SharePoint Services web.config file. The web.config file is a text file containing custom XML elements. You can edit this file using a text editor, such as Microsoft Notepad. The web.config file for the default virtual server is located in the C:\Inetpub\wwwroot\ folder. When a virtual server is extended with Windows SharePoint Services, a top-level web.config file is placed within the content root folder of the extended virtual server.

The following is a summary of these additional Web Part options and their values.

Setting Safemode Attributes

There are two safe mode attributes:

  • MaxControls specifies the maximum number of server-side controls (controls with the HTML Element attribute runat = "server") on a Web Part Page, including Web Parts, static Web Parts (that is, Web Parts not in a zone), and Web Form Controls. The default value is 50.

  • CallStack shows or hides many (but not all) ASP.NET exceptions that may occur in addition to the initial error reported in the SharePoint Error page. You can do the following:

    • To show these messages, set CallStack to "true".
    • To hide these messages, set CallStack to "false". This is the default.

    You might set this attribute to "true" for developers who are testing Web Parts so they can view these messages on a remote computer. You must also set the customErrors mode in the <system.web> section to "On".

    Setting CallStack to "true" also enables stack tracing.

Note Except when debugging, CallStack should be set to "false." Setting CallStack to "true" on a production Web server will make your Web server less secure.

The following example sets the safe mode attributes to their default values:

<SharePoint>
    <SafeMode MaxControls="50" CallStack="False" />
</SharePoint>
<system.web>
    <customErrors mode="On" />
</system.web>

Setting WebPartLimits Attributes

There are two Web Part limit attributes:

  • MaxZoneParts specifies the total number of Web Parts allowed within all Web Part zones on a Web Part Page.
  • PropertySize specifies the maximum number of bytes used to store Web Part properties on the server.

The following example sets the Web Part limit attributes to their default values:

<SharePoint>
    <WebPartLimits MaxZoneParts="50" PropertySize="1048576" />
</SharePoint>

Configuring Web Part Caching

WebPartCache Storage specifies how a Web Part is cached on the server, if at all. You can enter one of the following values:

Value | Description
None | Prevent caching Web Parts on the server.
CacheObject | Use ASP.NET Web server memory caching. This is the default. In general, this value helps improve performance if your site is installed on a single server.
Database | Cache Web Parts in site server database. In general, this value helps improve performance if your site is installed on a server farm.

The following example sets the Web Part cache storage attribute to its default value:

<SharePoint>
    <WebPartCache Storage="CacheObject" />
</SharePoint>

Note A Web Part must implement caching to take advantage of the server or database cache. Developing Web Parts that use caching is described in the SharePoint Products and Technologies 2003 Software Development Kit .

Setting Web Part Timeout Values

WebPartWorkItem Timeout specifies a timeout value in milliseconds for any asynchronous child processes started by a Web Part. The default value is 7000.

The following example sets the Web Part work item timeout to its default value:

<SharePoint>
    <WebPartWorkItem Timeout value="7000" />
</SharePoint>

Setting the Default Security Policy and Trust Level

You can define and specify a default security policy and trust level for all Web Parts installed on the site server by using two configuration files. There are two default policies:

WSS_Minimal A copy of the ASP.NET web_minimaltrust.config file with WebPartPermission.Connections enabled. This is the default.

WSS_Medium A copy of ASP.NET web_mediumtrust.config file with WebPartPermission.Connections and SharePointPermission.ObjectModel enabled.

The following example defines and sets a minimal trust level

<system.web>
  <securityPolicy>
      <trustLevel name="WSS_Minimal" policyFile="C:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\config\wss_minimaltrust.config" />
   </securityPolicy>
   <trust level="WSS_Minimal" originUrl="" />
</system.web>

The following example defines and sets a medium trust level

<system.web>
  <securityPolicy>
      <trustLevel name="WSS_Medium" policyFile="C:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\config\wss_mediumtrust.config" />
  </securityPolicy>
  <trust level="WSS_Medium" originUrl="" />
</system.web>

For a full discussion of setting trust levels, see the topic "Code Access Security For Administrators" in the SharePoint Products and Technologies 2003 Software Development Kit .

The SafeControls List

To register a Web Part as a safe control for use in Windows SharePoint Services, in the SafeControls block, add a SafeControl element that specifies the Web Part in the top-level web.config file of the virtual server. When you add and delete Web Part assemblies using the Stsadm.exe tool, this is handled by Stsadm.exe.

The following example, from the SharePoint Products and Technologies 2003 Software Development Kit, registers a sample Web Part as a SafeControl:

<SafeControls>
  <SafeControl
   Assembly="SimpleWebPart, Version=1.0.0.0, Culture=neutral, PublicKeyToken=def148956c61a16b"
   Namespace="MyWebParts"
   TypeName="*" >
    .
    .
    .
<\SafeControls>

Related Topics

For an overview of Web Parts, see About Web Parts.

For information on using SharePoint Configuration Analyzer, see Using SharePoint Configuration Analyzer.

For information on managing a site collection Web Part Gallery, see Managing a Site Collection Web Part Gallery.

For information on developing custom Web Parts, see SharePoint Products and Technologies 2003 Software Development Kit .


Using SharePoint Configuration Analyzer

Using SharePoint Configuration Analyzer

SharePoint Configuration Analyzer is a tool that you can download from the Microsoft Download Center to analyze and report on your Microsoft Windows SharePoint Services installation and content. SharePoint Configuration Analyzer reports on a wide range of configuration errors and also copies a set of log files, configuration files, and other data to a results folder for further analysis or archiving.

SharePoint Configuration Analyzer is particularly useful for analyzing and troubleshooting Web Parts on your servers. For example, you can configure SharePoint Configuration Analyzer to list each Web Part installed on a virtual server and to report on all of the pages that contain an instance of each Web Part. This is useful when upgrading a Web Part to a newer version or when deleting a Web Part. Before upgrading or deleting the Web Part, run SharePoint Configuration Analyzer with these options selected. Then, by using the usage data, contact all owners of pages containing the Web Part you are about to upgrade or remove, giving them notice of the impending change.

Note SharePoint Configuration Analyzer is not supported, and is available as is. It does not change the state of your Windows SharePoint Services nor does it repair errors that it reports. SharePoint Configurration Analyzer only copies its analysis results, along with any configuration files, log files, or other data that you requested, to its results folder, as described in this topic and in the SharePoint Configuration Analyzer Help.

What is SharePoint Configuration Analyzer?

SharePoint Configuration Analyzer is a diagnostic tool that verifies settings on your server that are critical to running Microsoft Windows SharePoint Services or Microsoft SharePoint Portal Server and to hosting Web Parts on your server. SharePoint Configuration Analyzer also reports on Web Part usage on your server and retrieves a set of log files, configuration files, and Web Part packages used by Windows SharePoint Services and Internet Information Services (IIS). In a server farm configuration, running SharePoint Configuration Analyzer on each front-end server is a useful way to find and repair inconsistencies in server configurations and to ensure that all Web Part assemblies are deployed on all front-end servers.

When you run SharePoint Configuration Analyzer, you choose from a set of verification and information retrieval options. Verification options analyze aspects of each virtual server's configuration and report on error conditions. Information retrieval options gather information you request without verifying the data.

SharePoint Configuration Analyzer verifies the following and reports any errors it finds:

  • Microsoft Internet Information Services (IIS) settings match Windows SharePoint Services requirements.
  • Web Part and Web Control assemblies are installed in a way that is compatible with IIS.
  • All virtual directories for a virtual server share the same application pool.
  • Web Part and Web Control assemblies listed in the SafeControls list exist.
  • Web Part instances on pages are associated with Web Part assemblies.
  • Policy files listed in Web.config files exist.
  • A copy of Microsoft.sharepoint.dll is not installed in the \bin directory.

In addition to verifying the above information, SharePoint Configuration Analyzer can retrieve the following:

  • List of all application pools for the virtual server.
  • Web.config files found in the following folders:
    • /<wssroot>/
    • /<wssroot>/_vti_bin
    • /<wssroot>/_layouts
    • /<wssroot>/
    • /<wssroot>/wpresources
    • /<wssroot>/_wpresources
  • All security policy files that are referred to from the root Web.config file.
  • All IIS and Windows SharePoint Services log files.
  • The application and server event logs, which are copied to a tab-delimited file.
  • List of all Web Parts and Web Controls listed in the SafeControls list.
  • For each Web Part type found in the database, a list of the pages that contain an instance of that Web Part.
  • List of all Web Part packages installed in the Global Assembly Cache (GAC) and \bin directories.
  • List of all files contained within the main application root.

Note SharePoint Configuration Analyzer also lists general information about the Web server and SQL databases used by Windows SharePoint Services. Some of this information is sensitive. Because of this, you should view the output results of SharePoint Configuration Analyzer by using the administrator's account used to run SharePoint Configuration Analyzer.

Installing SharePoint Configuration Analyzer

You must install SharePoint Configuration Analyzer on the server running Windows SharePoint Services. In a server farm configuration, install SharePoint Configuration Analyzer on every front-end Web server.

To install SharePoint Configuration Analyzer:

  1. Run the installation program from the Microsoft Download Center.
  2. In the Unzip to folder field, enter a folder in which to install SharePoint Configuration Analyzer, such as C:\Program Files\SharePoint Configuration Analyzer, or click Browse and point to a folder.
  3. Click Unzip to complete the installation.

Using SharePoint Configuration Analyzer

Note To use SharePoint Configuration Analyzer, you must be a member of the local Administrator group on the server or servers running Windows SharePoint Services and on the server running Microsoft SQL Server 2000 or Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE). For best results, run SharePoint Configuration Analyzer by using the same account that was used to install Windows SharePoint Services.

Start SharePoint Configuration Analyzer

  1. On your server, use Windows Explorer to locate the SharePoint Configuration Analyzer program, Sca.exe.
  2. From Windows Explorer, double-click Sca.exe.

Specify general parameters

  1. In the Server address field, type the URL of the virtual server or, if your server is configured in scalable hosting mode, type the fully-qualified host name of the server that you want to analyze.

    To analyze only the single site collection at the virtual server's address, clear the Include all site collections check box. Include all site collections is selected by default, specifying that all site collections on the virtual server should be analyzed.

  2. To start the analysis at the top-level Web site of a specific site collection, rather than analyzing the entire virtual server, in the Site collection path field, type the path to a Web site collection.

    If you choose this option, SharePoint Configuration Analyzer will limit its analysis to the database used by the specified site collection.

  3. To package the SharePoint Configuration Analyzer results in a Microsoft cabinet (.cab) file, click Package results into .cab file.

    When you select this option, SharePoint Configuration Analyzer creates a .cab file named "VirtualServerName_PortNumber_AnalyzerPackage_time.cab" and stores it in the SharePoint Configuration Analyzer's results folder. The CAB file includes copies of the log files, configuration files, and other data that you specified.

    Note Along with optionally creating a .cab file, SharePoint Configuration Analyzer always creates a folder, named "VirtualServerName_PortNumber_AnalyzerPackage_time, that contains the set of data it finds.

  4. Click Explore results to view the expanded results folder when SharePoint Configuration Analyzer finishes.

    Note If you don't select Explore results, you can view the expanded results by clicking the message "Last analysis folder: MyServerName_PortNumber_AnalyzerPackage_time" in the status bar at the bottom of the SharePoint Configuration Analyzer window after you run SharePoint Configuration Analyzer.

Specify analysis options

SharePoint Configuration Analyzer has a set of verification options and options that specify which log files and configuration files to include in the results.

  • Choose one or more of the following analysis options:
Option | Description
Verify IIS settings

Verifies that the IP address bindings in Internet Information Services (IIS) match Windows SharePoint Services requirements. SharePoint Configuration Analyzer flags the following IIS configurations because they are not supported by Windows SharePoint Services:

  • Static IP address binding.
  • IIS is configured so that multiple host header names are assigned to a single IP address, and Web Part DLLs are installed outside of the global assembly cache (GAC).

This option also lists all application pools and associated virtual servers.

Retrieve web.config files

Retrieves web.config files for the application root (usually located at \inetpub\wwwroot), _vti_bin, _layouts, _wpresources, and wpresources virtual directories. This option also retrieves any security policy files referenced by the application root web.config file.

Retrieve IIS and SharePoint Services log files

Retrieves all log files generated by IIS and all files with .log and .txt extensions generated by Windows SharePoint Services.

Retrieve server event logs

Retrieves the application and server event logs and stores them in tab-delimited files for easy viewing in a spreadsheet program such as Microsoft Excel.

Note Depending on the size of the server event log files, this operation could take SharePoint Configuration Analyzer a long time to complete.

Verify SafeControl assemblies

Verifies all Web Parts and Web Controls assemblies found in the SafeControls list (taken from the application root's web.config file). Verification includes:

  • Making sure the assemblies exist.
  • Determining the location of each assembly (the GAC or the Local_drive:\inetpub\wwwroot\bin directory).
  • Listing all public Web Part and Web Control types contained in these assemblies.
  • Reporting any conflicts between the assembly location and the Web server configuration (such as installing DLLS in the \bin directory in some IIS configurations).

After the assemblies have been verified, SharePoint Configuration Analyzer performs additional steps to find discrepancies between the use of Web Parts, as reflected in the database, and the Web Part assemblies listed in the web.config file. SharePoint Configuration Analyzer lists all pages with one of these database errors:

  • Web Part instances on pages that are not accounted for in the assemblies listed in the SafeControls list.
  • Uncompressed Web Parts. An uncompressed Web Part is one in which the properties of the Web Part are written directly in a Web page, rather than referenced from a .dwp file. When a page with an uncompressed Web Part is saved, Windows SharePoint Services removes the Web Part properties and other markup from the page and saves that data. Although uncompressed Web Parts are not errors, if a user gets an error when trying to view a Web Part, but the Web Part assembly is properly installed and configured, this could indicate an uncompressed Web Part for which the markup is insufficient to initialize the Web Part.

Note The scope of the database scan is dependent on the value of the Site collection path field.

Create Web Part usage report If you select Verify SafeControl assemblies, you can select Create Web Part usage report to generate, for each Web Part installed on the virtual server, a list of the pages that contain an instance of that Web Part. For example, it is useful to generate this list before upgrading a Web Part to a newer version so that you can contact all users of the Web Part before upgrading it. This option is deselected by default because it may take a long time to complete.

The Web Part usage report is displayed in the Analysis Results pane and is also stored in an XML file named WebPartUsageReport.xml.

Note If you are running SharePoint Configuration Analyzer on a server farm, select this option on only one of the front-end Web servers. This will generate a complete usage report covering all sites on the server farm. Because the Create Web Part usage report option is the most resource-intensive task, generating this report on multiple front-end servers will slow down your server farm environment needlessly.

Save state information Web Parts have a type name, such as Microsoft.SharePoint.Sample.WebPart, along with a globally unique identifier (GUID) value. Some configuration errors, such as a missing assemblies, make it difficult for SharePoint Configuration Analyzer to associate a GUID with its related type name. When you select Save state information, SharePoint Configuration Analyzer creates a reference XML file, named VirtualServerName_PortNumber_VirtualServerStateData.xml. In subsequent sessions, SharePoint Configuration Analyzer uses this file to reconstruct the mappings between GUIDs and type names, and reports the more readable type names in error messages and Web Part usage reports.

For best results, run SharePoint Configuration Analyzer with Save state information selected after installing Windows SharePoint Services to create a "snapshot" of the installed Web Parts, and repeat this each time that you install or update Web Parts packages to keep the state information up to date.

Note When using SharePoint Configuration Analyzer in a server farm environment, you should run SharePoint Configuration Analyzer with Save state information selected on every virtual server.

List Web Part packages | Lists all Web Part packages installed in the GAC or Local_drive:\inetpub\wwwroot\bin directory. To also retrieve the packages, click Retrieve packages, and they will be added to the results folder and CAB file. Note that Retrieve packages is cleared by default because this option can be time-consuming.
List application files | Lists all files contained within the main application root (for example, c:\inetpub\wwwroot).

Start the analysis

  • After specifying general and analysis options, click Go.

Exit SharePoint Configuration Analyzer

  • To exit SharePoint Configuration Analyzer, on the File menu, click Exit.

SharePoint Configuration Analyzer Results

By default, SharePoint Configuration Analyzer packages its results in four ways:

  • In a folder, named VirtualServerName_PortNumber_AnalyzerPackage_time, in the folder in which SharePoint Configuration Analyzer is installed.
  • In the SharePoint Configuration Analyzer's Analysis results pane.
  • In an optional Microsoft cabinet (.cab) file, named VirtualServerName_PortNumber_AnalyzerPackage_time .cab.
  • In the XML file, Analyzer.log, which is stored in the results folder.

For a full description of the results returned by SharePoint Configuration Analyzer, see the SharePoint Configuation Analyzer Help.


Backup and Restore Options for Windows SharePoint Services

Backup and Restore Options for Windows SharePoint Services

There are several methods you can use to back up and restore data for Microsoft Windows SharePoint Services. Each of these methods allows you to back up and restore data, but each method acts at a different level of granularity and may require different permissions. You can back up and restore data for Windows SharePoint Services by using the following methods:

  • Use the Microsoft SQL Server 2000 tools to back up the databases.

    You can use the backup tools included with SQL Server 2000 to get a full-fidelity, complete backup of the databases used by Windows SharePoint Services on your server or server farm. When you use this method, you back up and restore the entire configuration database and each content database on your server or in your server farm. You can then restore any or all of these databases. You must be running SQL Server 2000, not Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE), to be able to use this backup method, and you must be an administrator on the local server computer that is running SQL Server. This option is the most secure of the backup and restore options described in this topic.

    For more information about backing up databases in SQL Server, see "Backing Up and Restoring Databases by Using the SQL Server 2000 Tools" in the Windows SharePoint Services Administrator's Guide and the Help system for SQL Server 2000.

  • Use the Stsadm.exe command-line tool to back up individual site collections.

    You can get a full-fidelity, complete backup or restore of an entire site collection by using the Stsadm.exe command-line tool with the backup and restore operations. This method of backing up and restoring data does not require SQL Server 2000. However, you must still be an administrator on the local server computer that is running Windows SharePoint Services in order to perform this method of backing up and restoring.

    For more information about backing up site collections by using the Stsadm.exe command-line tool, see Backing Up and Restoring Web Sites.

  • Use the Microsoft SharePoint Migration Tool (smigrate.exe) to back up individual sites and subsites.

    You can back up and restore individual sites or subsites by using the SharePoint Migration Tool. This method is not full-fidelity; you may lose some customizations or settings in the process. For example, security settings for the site, such as user membership in site groups, cannot be restored when you use the SharePoint Migration Tool. However, with this backup method, you do not need to be an administrator on the local server computer. Any member of the Administrator site group for a site or subsite can use this method.

    For more information about backing up sites and subsites by using the SharePoint Migration Tool, see Migrating and Upgrading Web Sites.

The following table describes the scope and limitations of each backup and restore method, and the permissions required to perform each.

Method | Scope | Limitations | Required permissions
SQL Server 2000 Backup and Restore | Database | None | Administrator on local server computer
Stsadm.exe Backup and Restore | Site collection | None | Administrator on local server computer
SharePoint Migration Tool Site Migration | Site or subsite | Some customizations or settings may not migrate. Does not migrate security settings. | Member of Administrator site group for the site or subsite

Running Microsoft SQL Server tools frequently (such as once a week) can be costly to an organization. Also, these tools support backup and restoration at the database level only, making it impractical to restore single sites or site collections. The Stsadm.exe command-line tool supports complete backup and restoration at the site-collection level, including security settings. It is ideal for targeted backups and is less costly to run.

A practical and effective backup strategy for your Windows SharePoint Services installation is to use both of these tools. At longer intervals, such as monthly, back up your entire set of databases using the Microsoft SQL Server tools. At shorter intervals, such as weekly, run Stsadm.exe to back up just those site collections that have changed. This will facilitate quick recovery of lost items with a minimum of space usage, while the Microsoft SQL Server tools backups are available for large-scale disaster recovery.


Backing Up and Restoring Databases by Using the SQL Server 2000 Tools

Backing Up and Restoring Databases by Using the SQL Server 2000 Tools

With Microsoft Windows SharePoint Services, you can back up and restore information about your server configuration and about each site you host on your server or server farm. You can back up and restore the configuration database and content databases for your server or server farm. This backup and restore method allows you to recover from a server failure. You must be running Microsoft SQL Server 2000 to perform a database backup and restore.

Note You can also back up and restore individual Web sites hosted on your server or server farm. This backup and restore method is not dependent on the type of database you are using. You can perform this backup and restore even if you are running Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) instead of SQL Server 2000. For more information, see Backing Up and Restoring Web Sites.

In Windows SharePoint Services, all server and site configuration information is stored in the configuration database, and all site content is stored in content databases. If you want to back up all the Windows SharePoint Services information on your server or server farm, you must back up these databases by using the SQL Server 2000 backup and restore tools.

Note You must be running SQL Server 2000 SP3 to back up and restore the databases used by Windows SharePoint Services. If you are running WMSDE, you can use the client tools for SQL Server 2000 to back up and restore WMSDE databases, but there is no provision for backing up and restoring from WMSDE itself. If you want to upgrade from WMSDE to SQL Server so that you can use the backup and restore tools for SQL Server and perform other database server tasks, see Migrating from WMSDE to SQL Server.

Backing Up the Databases

If you installed Windows SharePoint Services with SQL Server on the same computer, the configuration and content databases are stored under \Program Files\Microsoft SQL Server\MSSQL\Data by default. If you are in a server farm or remote SQL Server environment, the databases are stored on another server or multiple servers. There is always one configuration database for the entire server or server farm, and there is at least one content database.

Before you can back up the databases, you must identify which databases you need. By default, the databases are named as follows:

  • The configuration database is named sts_config.mdf by default. Note that this is only the default name. When you created the configuration database, you had the option to specify a different name.
  • The content databases are created with names based on the server name by default. For example, STS_server_name_1.mdf, STS_server_name_12.mdf, and so on. The database names are not sequential. Again, you may have chosen a different naming scheme for the content databases when you created them.

You use the SQL Server 2000 backup and restore tools to back up these databases. Be sure to back up both the configuration database and all of the content databases used by Windows SharePoint Services. To find out how to back up databases in SQL Server, see the SQL Server documentation.

Note When you back up the database using the SQL Server 2000 tools, the backup file includes personalizations made by site users and personal data about site users. This data is also included when you restore from a backup. As part of your own internal privacy policies, you may want to inform users that this data is collected and stored during database backups.

Restoring from a Backup

Creating regular backups allows you to restore your servers and sites in case they happen to fail. To restore a server or server farm from a database backup, you must perform the following steps.

  1. On your server, or on the front-end Web servers in your server farm, in Internet Information Services (IIS), create the virtual servers to host your Web site content.

    For more information about creating a virtual server, see Extending Virtual Servers.

  2. Using the SQL Server restore tools, restore the databases from the backups.

    For more information about restoring databases in SQL Server, see the SQL Server documentation.

  3. In IIS, create the application pools for the content virtual servers.

    Be sure that you use domain accounts for the application pools, and that these accounts are members of the Security Administrators and Database Creators roles in SQL Server. For more information about creating application pools, see the Help system for Internet Information Services.

  4. On your server or front-end Web servers, install Windows SharePoint Services, and connect to the restored configuration database.

    For more information about installation, see the appropriate deployment scenario:

    • Single Server Deployment
    • Remote SQL Server Deployment
    • Server Farm with Multiple Host Names Deployment
    • Intranet and Extranet Deployment
    • Separate Active Directory Organization Unit Deployment

      Note When you install Windows SharePoint Services and connect to an existing configuration database, the included and excluded paths for your server or server farm are automatically recreated. For more information about included and excluded paths, see Managing Paths.

  5. Set the default content database server to the restored database server.

    You can use the Set Default Content Database Server page in SharePoint Central Administration. For more information, see Managing Content Databases.

  6. Extend each virtual server for your server or server farm using the Extend and map to another virtual server option on the Extend Virtual Server page, or by using the extendvsinwebfarm command-line operation.

    This option allows you to connect a new virtual server to a restored content database. Repeat this step for each new virtual server. For more information about mapping one virtual server to another virtual server, see Extending Virtual Servers.

  7. Add any additional content databases that have been restored.

    Use the Manage Content Databases page in SharePoint Central Administration to add content database to a virtual server. Repeat this step for each virtual server. For more information, see Managing Content Databases.

    Note As you reconnect the content databases to your virtual servers, the Web sites for those content databases are restored. Note that only Web sites contained in the list of included paths for the virtual server are restored.

When you have completed these steps, your restoration is complete. All sites included in your backup should be functioning again, complete with the site content, users, and settings as they were when the sites were backed up.


Backing Up and Restoring Web Sites

Backing Up and Restoring Web Sites

With Microsoft Windows SharePoint Services, you can back up and restore individual Web sites hosted on your server or server farm. You can use this backup and restore method to replace a site that has become corrupted, or that contains changes that need to be rolled back. This backup and restore method is not dependent on the type of database you are using. You can perform this backup and restore method even if you are running Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) instead of Microsoft SQL Server 2000.

Caution Previous versions of this guide recommended using regular backup operations to allow recovery of single document or list items. This usage is no longer recommended. Because the backup operation involves reading a large amount of data, running the backup process frequently can interfere with the performance of the system, including blocking end users' access to their sites. If you need a solution for quick recovery of deleted documents or list items, you might want to consider creating a recycle bin by using the Windows SharePoint Services object model. For more information about using the object model to create a recycle bin, see the Add a Recycle Bin to Windows SharePoint Services for Easy Document Recovery article on the MSDN Web site.

If you need to back up a specific site, rather than a whole installation of Windows SharePoint Services, you can do so by using the backup and restore operations with the Stsadm.exe command-line tool. You do not need SQL Server 2000 to perform a site-by-site backup. If you are using WMSDE, this is the only backup and restore option that is available.

When you back up a Web site, you back up the content database for the site, including all pages in the site, files in document libraries or lists, security and permission settings, and feature settings. The backup process creates a single file that contains all of this data. You can then restore your site to either the same location or to a new location. You can back up only top-level Web sites, not individual subsites. The backup file for a top-level Web site includes any subsites of that site.

You must be a member of the server computer's administrators group or a member of the SharePoint administrators group to be able to back up or restore a site.

About Site Backup and Restore

Site backup and restore is intended to help you reconnect sites that have become corrupted or need to be restored to a previous state. This process is not intended for moving a site to a new server. If you want to move a site, use the Microsoft SharePoint Migration Tool (smigrate.exe) instead. For more information, see Migrating and Upgrading Web Sites.

When using site backup and restore, keep the following items in mind:

  • You can automate the backup process by using a batch file, a script, or the Scheduled Tasks item on Microsoft Windows Control Panel.

    You can use the object model to include the backup operation in a scripted procedure. For more information, see the Windows SharePoint Services Software Development Kit.

  • Site backup and restore affects performance.

    The process of backing up and restoring sites takes up both memory and processing power on your server. In addition, if you have many sites, or a large amount of data in your sites, the backup process can take a long time, and might result in access errors for your users. If you choose to schedule automatic backups in a batch file or script, be sure to run the backup process when server usage is minimal or, optimally, when there are no users accessing data on your sites.

  • Site backup and restore are not designed to be used when the server is under active load

    If a site is in use when the backup operation is run, the data in that site might continue to change throughout the operation. The resulting backup file might be inconsistent with the actual state of the site and, if you restore this file, the restored site or database will be inconsistent as well.

  • Sites with duplicate names cannot not be restored.

    This could be a problem in the following situation. If you have two virtual servers, with separate content databases for each virtual server that are only listed by relative paths in the configuration database, the site names may conflict. For example, if the configuration database lists the site names without the http://server_name prefix, you could have several sites that use the same path. For example, http://server_1/sites/site1 and http://server_2/sites/site1 could both be listed in the configuration database as /sites/site1 even though they are on separate virtual servers. In this case, the sites will not be restored correctly, and you will see an error in the restore log file.

  • You must have the appropriate language packs installed to successfully restore a site.

    If a site you are restoring to a new server used a specific language pack, you must add the language pack to the new server before restoring the site or update the new server with the language pack after you restore. If you do not add the language pack, users who browse to the site or any subsites will see a "file not found" error.

Restoring Sites in Active Directory Account Creation Mode

When restoring a site that was running in Active Directory account creation mode, the destination site must also be running in Active Directory account creation mode. Further, you cannot restore a site that was not running in Active Directory account creation mode to a server that is running in Active Directory account creation mode.

Important

  • Do not run the both the original and the restored sites simultaneously. Doing so creates security risks as it allows users from the backup site to have full access to the restored site, and all user management changes to one site will apply to the other site.
  • When deleting either the original or restored site, make sure that you specify the -deleteusers false option on the stsadm.exe command line or users from both sites will be deleted from Active Directory service. For example: stsadm –o deletesites –deleteusers false

Using the Backup Operation

To back up a site, you use the backup operation with the Stsadm.exe command-line tool. The backup operation takes the following parameters.

Parameter | Required? | Description
-filename | yes | Backup filename. For example, backup.dat.
-url | yes | Web site URL. For example, http://server_name/site.
-overwrite | no | Overwrite any existing backup file or Web site. By default, the backup operation does not overwrite files. If you do not specify this parameter and a backup file or Web site exists, the operation will stop.

The filename parameter can take any of the following types of information:

  • A filename, such as backup.dat
  • A path on the local hard disk, such as c:\backups\backup.dat
  • A path on a network share, such as \\share\folder\backup.dat

Note Before you run the backup operation, you may want to list all of your sites and identify which sites to back up. To see a list of sites on your server, you can use the enumsites operation. Listing the sites with enumsites can be useful when you are automating backups. You can include enumsites in your batch file, parse the list of sites, and then walk through the list of sites to create the backups. The enumsites operation uses the following syntax: stsadm.exe -o enumsites -url <url>

To perform a simple backup of a site, you would use syntax similar to the following:

stsadm.exe -o backup -url http://server_name/site -filename backup.dat

To back up a site and overwrite an existing backup file, you would use syntax similar to the following:

stsadm.exe -o backup -url http://server_name/site -filename c:\backups\backup.dat -overwrite

Using the Restore Operation

To restore a site, you use the restore operation with the Stsadm.exe command-line tool. The restore operation takes the same parameters as the backup operation: filename, url, and overwrite.

You have three options for restoring sites from a backup.

  • You can restore a site over an existing site.

    Use this option with caution. When you overwrite an existing site, the existing site is completely overwritten. You cannot merge sites. Any existing site content, and existing site permissions, are destroyed when you overwrite a site.

  • You can restore a site to a new site on the same server.

    This is the recommended option. When you restore a site to a new site on the same server, you can copy the data from the restored site, and paste it back into the original site. Use this method if you are restoring a site to recover data.

    Note In order for the restore operation to work correctly, the included and excluded paths for your virtual server must be configured properly. If you are restoring a site to a new site, be sure to create an included path for the site, if necessary, before restoring the site.

  • You can restore a site to a separate server, with a separate installation of Windows SharePoint Services that uses a copy of the original server's configuration database.

    This is a more complicated scenario, but it gives you the ability to set up two versions of the same site, as in the previous option, but with the ability to use the unused Web site deletion feature to remove the site automatically after a specific time period. For more information about automatically deleting unused Web sites, see Managing Unused Web Sites.

    Note If you are trying to recover a particular list or list item from a site backup, use this method to restore the site, and then copy the list or item from the restored site back to the original site.

To restore a site from a backup file, either to a new site or a separate server, you would use syntax similar to the following:

stsadm.exe -o restore -url http://server_name/site -filename backup.dat

To restore a site from a backup file on a server share, and to overwrite any existing site at the new location, you would use syntax similar to the following:

stsadm.exe -o restore -url http://server_name/site -filename \\share\folder\backup.dat -overwrite

About GUIDs and Restoring Site Collections

If you attempt to restore a backup of a site collection more than once to the same content database, you may get the following error message: "No content databases are available for restoring this site collection. Create a new content database and then try the restore operation again." This is because the globally-unique identifiers (GUID) for lists are preserved in the backup file and reused during restore, but the content database requires list GUIDs to be unique. Therefore, you cannot restore a site collection twice to the same content database, and must instead use a different content database.


Migrating and Upgrading Web Sites

Migrating and Upgrading Web Sites

If you have been using SharePoint Team Services v1.0 from Microsoft, you probably have several Web sites that you need to move to new servers running Microsoft Windows SharePoint Services. You may also have new Web sites based on Windows SharePoint Services that you want to move to another URL or another Internet Service Provider, for example. To accomplish these tasks, you use the Microsoft SharePoint Migration Tool (smigrate.exe).

For larger scale site migration in Windows SharePoint Services, such as moving a site collection to a new server, use the full backup and restore features for Windows SharePoint Services. For more information, see Backing Up and Restoring Web Sites.

When you use the SharePoint Migration Tool, you must actually perform two separate operations: First, you back up the site to a file, and then you restore the site to the new location. During the backup process, you specify the URL for the Web site and the backup file to create. You can also specify the scope of the site migration (whether to migrate just the top-level Web site, or whether to migrate the top-level Web site and any subsites). During the restore process, you specify the new URL and the backup file to restore from.

If you are upgrading from SharePoint Team Services v1.0 to Windows SharePoint Services, you can also specify whether to migrate the security settings for the site. Migrating security settings includes all of the following:

  • The list of user roles and associated rights
  • The list of user accounts and role membership
  • The anonymous access settings
  • The setting for inherited or unique permissions for the site

Before you migrate a site, be sure that all of the settings are the way you want them to be in your destination site. Note that if a user account cannot be verified in the domain, and you are not using Active Directory account creation mode, the account will not be restored.

When restoring a site, it's often helpful to create an account specifically for this purpose. This is beneficial because the SharePoint Migration Tool will substitute the name of the account performing the restore in places where the account of the author or the last person who modified the content is unavailable. For example, if you create an account named "SharePoint Migration" and then use that account to restore a site, users will see "SharePoint Migration" as the author of list items whose author was unavailable.

If the site you are backing up or restoring is large, it can take quite a while to process. For example, a site with about 4.5 gigabytes (GB) of data can take up to 3 hours to back up. The same site can take up to 3 hours to restore, because so many files must be uploaded to the new server. The more files included in a site, the longer the restore process will take. As a general performance guideline, you will have the best backup/restore performance when using separate computers for each task. An example of such a configuration is:

  • One computer running smigrate.exe
  • One or more computers running as front-end Web servers
  • One or more computers running as SQL backend servers

Caution If you are using the SharePoint Migration Tool to migrate and upgrade a site from SharePoint Team Services v1.0 or FrontPage 2002 Server Extensions from Microsoft to Windows SharePoint Services, be aware that several features or types of customizations supported in these environments will not migrate properly or will not work in a migrated site. For a list of items that you must re-create or work around, see "Upgrade Considerations" in the Windows SharePoint Services Administrator's Guide.

You can migrate a site to a new virtual server, to a new top-level Web site on an existing virtual server, or to a subsite under an existing top-level Web site. No matter what level the site is, when you restore the site, you must create a blank site at the destination without applying a site template. For more information about creating a new virtual server, see Extending Virtual Servers. For more information about creating sites, see Creating Sites and Subsites. Follow the steps to create the site, but when prompted to select a site template, close the browser window and do not apply any template (including the Blank Site template) or the restore operation will fail.

Note Some of the steps in this topic require changing settings in Microsoft Internet Information Services (IIS) or Microsoft SQL Server. To complete the steps that use IIS, you must be logged on as a member of the Administrators group on the local computer, or you must be logged on using an account that is both a member of the SharePoint administrators group and that has been granted permissions to administer IIS. To complete the steps that use SQL Server, you must be logged on using an account that is a member of the db_owner role in SQL Server.

Temporary Files Created During Backup and Migration

While creating the backup file, the SharePoint Migration Tool creates temporary files in a folder at the same location where the backup file (*.FWP) are created. You should ensure that there is enough free space at the location where the backup file will be created to hold all of the data and files from the original Web site, plus approximately 25 percent.

While restoring, files are periodically saved in a folder in Temporary Internet Files folder on the computer on which you are running the SharePoint Migration Tool. Make sure the computer you use to run the SharePoint Migration Tool has sufficient disk space to temporarily store approximately 20 percent of the data and files from the original Web site.

Migrating Windows SharePoint Services Sites to Another Server Running Windows SharePoint Services

If you use the SharePoint Migration Tool to migrate a site based on Windows SharePoint Services to another server running Windows SharePoint Services, the following information is not migrated to the new site:

  • Security settings including: rights, site groups and memberships, cross-site groups, anonymous access setting, and whether or not permissions are inherited from the parent site.
  • SharePoint Central Administration settings for the server or virtual server.
  • Personalizations including personal views.
  • Web Part customizations made through Modify My Web Part instead of Modify Shared Web Part.

Migrating Sites to Windows SharePoint Services in Active Directory Account Creation Mode

When you are running Windows SharePoint Services in Active Directory account creation mode, user accounts are automatically created in Microsoft Active Directory directory service when you add users to a site. Likewise, when you migrate a site from SharePoint Team Services v1.0 to a server running Windows SharePoint Services in Active Directory account creation mode, user accounts are automatically created in Active Directory for the users that existed in the site before migration. If you do not want to migrate user information to the new site, use the x parameter with the SharePoint Migration Tool.

The new user accounts are created based on the users' e-mail addresses, so each user must have a unique e-mail address for the account creation to work correctly. If a user does not have an e-mail address in the old site, no account can be created for that user. Also, because only one account is created for each e-mail address, a shared e-mail address results in a merged user account that is given all of the rights that each original user had, and is also listed as the user name for any items added to the site by any of the original users. Be sure that each existing user account has a unique e-mail address before migrating a site, and that you enter the full e-mail address (for example: someone@example.com).

After you migrate a site to a server running Windows SharePoint Services in Active Directory account creation mode, you must reset the passwords for the new user accounts. When user accounts are created during site migration, no automatic e-mail messages are sent with the user name and passwords, so you must send the users their new logon information manually.

Migrating Sites By Using Secure Sockets Layer (SSL) Connections

For the SharePoint Migration Tool to migrate a site by using an SSL connection, the following conditions must be met:

  • The computer on which you are running the SharePoint Migration Tool trusts the certificate authority that issued the SSL certificate.
  • The hostname you provide when running the SharePoint Migration Tool matches the hostname on the SSL certificate.
  • The certificate is valid (for example, it cannot be expired).

If the computer on which you are running the SharePoint Migration Tool does not trust the certificate authority that issued the SSL certificate, you will need to add the certificate authority to your list of trusted certificates by following the steps in the following procedure.

Add certificate authority to list of trusted certificates
  1. Browse to the destination https site. The Security Alert window appears, indicating that the site certificate was issued by a company you do not yet trust.
  2. In the Security Alert window, click View Certificate.
  3. In the Certificate window, click the Certification Path tab.
  4. Click the parent certificate of the selected certificate. The parent certificate will have a red and white "X" through it.
  5. Click View Certificate.
  6. In the second Certificate window, click Install Certificate.
  7. In the Certificate Import Wizard, click Next.
  8. In the Certificate Store window, choose either:
    • Automatically select the certificate store based upon the type of certificate: Choose this option if you want the new certificate to be kept in the default store for that kind of certificate.
    • Place all certificates in the following store: Choose this option if you want to specify the store in which the new certificate will be kept. After choosing this option, click the Browse button and specify the desired store.
  9. Click Next.
  10. Click Finish.
  11. In the Root Certificate Store window, click Yes.

Migrating Sites By Using Proxy Server Connections

Problems can occur if the SharePoint Migration Tool must migrate a site over a proxy server connection. For example, if the proxy server requires different authentication than the destination Web server, the user name and password specified when you ran the SharePoint Migration Tool will be rejected and the migration will fail.

Migrating Sites across Domains

Problems can occur when migrating a site to a destination Web server in another domain. Failures can occur even if you use the -u and -pw parameters to supply the necessary user name and password. To resolve this problem, on the computer on which you are running the SharePoint Migration tool, complete the following steps.

Turn on prompts for user authentication
  1. Click Start.
  2. Click Control Panel.
  3. Click Internet Options.
  4. Click the Security tab.
  5. Click the Internet zone in which the destination site exists.
  6. Click Custom Level.
  7. In the User Authentication Section, under Logon, click Prompt for user name and password.
  8. Click OK.

Before Migrating Sites to Windows SharePoint Services

Before you use the SharePoint Migration Tool to migrate your sites from either SharePoint Team Services v1.0 or Windows SharePoint Services to Windows SharePoint Services, it is recommended that you configure the following settings:

  1. If the original site is running SharePoint Team Services v1.0, you must download and install SharePoint Team Services v1.0 service packs 1 and 2 from the Microsoft Product Update site and then install the SharePoint Team Services Version 1.0 Update for the site to function with the SharePoint Migration Tool.
  2. Set the original site to read-only to ensure consistency. Because backup and restore may take some time, it is best to set the site to read-only so that the original site does not change while you are still restoring.
  3. If the original site is running Windows SharePoint Services, disable blocked file types so that smigrate.exe can include all site files in the backup.
  4. If you are migrating a large Web site and need additional virtual memory, increase the paging file size to at least 1 GB. Increasing the paging file size is recommended especially if you are running the SharePoint Migration Tool directly on a front-end Web server.
  5. Change the following server settings on the destination server (detailed steps appear later in this topic):
    • Increase the Internet Information Services (IIS) timeout settings to 65,000 seconds.
    • If the destination server is using a Microsoft SQL Server 2000 database, disable full-text search before migrating. This step can decrease amount of time required to restore by as much as 40% in some cases.
    • Turn on anonymous user access in IIS (optional — use this setting only if you want to migrate anonymous access settings).
    • If you are using quotas for the destination virtual server, and the site you are migrating is close to the quota limit for the virtual server, double the quota limit.
    • Turn off blocked file extensions on the destination server.
  6. Change the following virtual server settings on the destination virtual server:
    • Change the maximum file size temporarily from 50 MB to 500 MB (or to the maximum upload limit for your hardware configuration).
    • Set the maximum number of allowed alerts to be unlimited.
  7. Create a destination collection, top-level Web site, or site and do not apply a template.

    Note To create a destination site with no template, begin creating the site collection, top-level site, or subsite as usual, but when you get to the page where you are asked to select a template, close the browser window without making a selection. Do not apply any template (including the Blank Site template) or the restore operation will fail.

Important When you have finished migrating your sites to Windows SharePoint Services, change the server settings to the configuration you want to use while users are working with the sites.

Note If you are migrating sites to a server running Windows SharePoint Services in Active Directory account creation mode, you must also be sure that all users of the original Web site have valid, unique e-mail addresses. If you do not want to migrate the users and create new Active Directory accounts for them automatically, be sure to specify the x parameter when you run the SharePoint Migration Tool.

Download and install the update for SharePoint Team Services v1.0 (SharePoint Team Services v1.0 only)

To migrate sites from SharePoint Team Services v1.0 to Windows SharePoint Services, you must verify that the server hosting the original site has been updated to work with the SharePoint Migration Tool. You must download and install SharePoint Team Services v1.0 service packs 1 and 2 from the Microsoft Product Update site and then install the SharePoint Team Services Version 1.0 Update. To install this update, you must be a member of the local administrators group on the server.

Set the original site to read-only

You can set the original site to be read-only by turning off all but browsing and viewing rights on the Set List of Available Rights page for the server that contains the site.

Note This setting applies to all sites and subsites on the server.

If you are migrating a site based on Windows SharePoint Services to a new location, you can set the site to read-only by locking the site. For more information about locking a site, see Configuring Site Quotas and Locks.

  1. On the original server, click Start, point to All Programs, point to Administrative Tools, and then click Microsoft SharePoint Administrator.
  2. On the Server Administration page, click Set list of available rights.
  3. Clear all of the check boxes except for the Browse, View Lists, and View Web Document Discussions check boxes.
  4. Click Submit.
Turn off blocked file extensions in the original site (Windows SharePoint Services only)
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Security Configuration, click Manage blocked file types.
  3. In the list of blocked file types, delete the file types you want to include in the backup.
  4. Click OK.

Caution The list of blocked file extensions affects all sites on the server or in the server farm, not just the site you are migrating. After migrating, you must specify the blocked file settings again to restore this protection for any sites on the server or server farm.

Increase the paging file size

If you are migrating a large site or running the SharePoint Migration Tool directly on a front-end Web server, it is recommended that you increase the paging file size for the server to at least 1 GB.

  1. Click Start, point to All Programs, point to Administrative Tools, and then click Computer Management.
  2. In the console tree, right-click Computer Management (Local), and then select Properties.
  3. On the Advanced tab, under Performance, click Settings.
  4. In the Performance Options dialog box, under Virtual memory, click Change.
  5. In the Drive list, click the drive that contains the paging file you want to change.
  6. Under Paging file size for selected drive, select Custom size, and then type 1024 in the Initial Size (MB) box.
  7. Specify a larger number in the Maximum Size (MB) box, and then click Set.

    This sets the paging file to a minimum of 1 gigabyte (GB).

Changing the Destination Server Settings

Some of the settings must be changed in IIS, and some must be changed in SharePoint Central Administration.

Increase IIS timeout settings
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Double-click the server name that is running Windows SharePoint Services.
  3. Double-click Web Sites.
  4. Right-click the virtual server that you are restoring to, and then click Properties.
  5. On the Web Site tab, in the Connection time out box, change the setting from 120 to 65,000 seconds.
  6. Click OK.

If you want to migrate the anonymous user access settings to the destination server, you must enable anonymous user access in IIS.

Turn on anonymous user access in IIS

This procedure is optional. Turn on anonymous user access only if you want to migrate anonymous access settings.

  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Double-click the server name that is running Windows SharePoint Services.
  3. Double-click Web Sites.
  4. Right-click the virtual server that you are restoring to, and then click Properties.
  5. On the Directory Security tab, under Authentication and access control, click Edit.
  6. Select the Enable anonymous access check box, and then click OK.
  7. Click OK.

After the IIS settings are configured, you can change quota limits by using SharePoint Central Administration.

Double a quota limit
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Component Configuration, click Manage quotas and locks.
  3. On the Manage Quotas and Locks page, click Manage site collection quotas and locks.
  4. Enter the URL of the site collection, and then click View Data.
  5. In the Site Quota Information Section, double the amount of storage allowed for the Limit site storage to a maximum of option.
  6. Click OK.

If you know that the original site contains files that have file extensions on the blocked file extensions list, you must unblock those file extensions before you migrate the site. If you do not remove those file extensions from the blocked list, the files will not be migrated with the rest of the site content.

Disable full-text searching in SQL Server 2000
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, under Component Configuration, click Configure full-text search.
  3. Clear the Enable full-text search and index component check box.
  4. Click OK.
Turn off blocked file extensions on the destination server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Security Configuration, click Manage blocked file types.
  3. In the list of blocked file types, delete the file types you want to allow.
  4. Click OK.

If you want to continue blocking these file types after the site has been migrated, you must add the file extensions back to this list after the migration is completed. Note that this list of blocked file extensions affects all sites on the server or in the server farm, not just the site you are migrating.

Changing the Destination Virtual Server Settings

You change the settings for the destination virtual server by using the Virtual Server General Settings page in SharePoint Central Administration. Specify a larger maximum upload size to allow any existing large files to be restored during migration and allow an unlimited number of alerts to be sure that all of the alerts for your users can be added.

By default, the maximum upload limit is set to 50 MB, which may not be enough to restore your site's content. However, uploading files larger than 50 MB may cause problems, depending on your available system resources. If you greatly increase the maximum file size and then attempt to upload a very large file, the upload may fail or the server may stop responding. The file size at which Windows SharePoint Services may stop responding depends on the hardware you are using and usage patterns. For example, an installation that includes a front-end Web server with 512 MB of RAM and a back-end server with 1 GB of RAM may be able to handle files up to about 128 MB. In general, it is the amount of available memory that determines how large of a file can be uploaded - for a temporary solution, such as when you are running the SharePoint Migration Tool, you can set the maximum upload size to handle files about one quarter of the size of the physical memory for your server.

Note Windows SharePoint Services Service Pack 1 includes a change to provide better support for large file sizes. If you have applied Windows SharePoint Services SP1, you can increase the maximum upload size to any value up to 2 GB (2047 MB). For more information, see Configuring large file support in Installing and Using Service Packs for Windows SharePoint Services.

Change the virtual server settings for maximum uploads and alerts
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, click the name of the virtual server that contains the destination site.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Virtual server general settings.
  5. In the Maximum Upload Size section, in the Maximum upload size box, type the maximum size you want to allow.

    Note By default, the maximum upload size is 50 MB. If you change this setting to a larger size, you may also need to change the IIS Connection Timeout setting. For more information, see Configuring large file support in Installing and Using Service Packs for Windows SharePoint Services.

  6. In the Alerts section, under Maximum number of alerts that a user can create, select Unlimited number.
  7. Click OK.

Create a New Top-level Site without Applying a Template

You can migrate a site to a new virtual server, to a new top-level Web site on an existing virtual server, or to a subsite under an existing top-level Web site. No matter what level the site is, when you restore the site, you must create a blank site at the destination without applying a site template.

You can use the stsadm.exe command line tool to create blank sites and site collections. For example:

 stsadm -o createweb

stsadm -o createsite

Be sure to not use the -sitetemplate parameter.

You can also use the SharePoint Central Administration, Site Administration, and Create pages to create a destination site without applying a template. To do so, begin creating the site collection, top-level site, or subsite as usual, but when you get to the page where you are asked to select a template, close the browser window without making a selection. Do not apply any template (including the Blank Site template) or the restore operation will fail.

Using the SharePoint Migration Tool to Migrate Sites

The SharePoint Migration Tool (smigrate.exe) is available in the Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\Bin folder on your server computer. To use the SharePoint Migration Tool, you must be a site administrator for both the Web site being backed up and the destination Web site.

Note You can also download the SharePoint Migration Tool from the Microsoft Web site.

Smigrate.exe takes the following parameters:

Parameter | Description | Example values
-w | Web site URL. Required. | A valid URL, such as http://myserver/site1 or https://myserver/site1.
-f | The name of the backup file. Required. | A filename, or full path to a filename, with the .fwp extension. For example, backup.fwp, c:\backup.fwp, or \\myserver\folder\backup.fwp. Note The file name extension is optional. If you do not specify the .fwp extension, it will be added automatically.
-r | Restores a site to a new location. | none
-e | Excludes subsites during backup. Optional. | none
-x | Excludes security during restore. Optional. For use when migrating from SharePoint Team Services v1.0 to Windows SharePoint Services only. | none
-y | Overwrites an existing backup file. Optional. | none
-u | The user name for the Web site administrator. This parameter is required if your site supports only Basic authentication. Note that if the current logged on user has sufficient rights to perform the migration, the current user's credentials are used to perform the migration instead of the one specified with the -u parameter. If you want the migration to be performed by a specific account, log on as that account before migrating. Alternatively, you can change your Internet settings so that your computer does not automatically try to authenticate when you connect to Web sites. | A valid user name, in the form DOMAIN\name.
-pw | The password for the Web site administrator. Optional. | A valid password. Use "*" to be prompted to type a password.

Note If Internet Explorer Enhanced Security is enabled on your server, you must specify the u and pw parameters.

To back up a site, you use Smigrate.exe with the following parameters:

smigrate.exe -w Web_site_URL -f backup_filename [-e -y -u user_name -pw password]

For example, to create a backup of http://myserver/site1 to a file called backup.fwp at the root of the c:\ drive, without including any subsites of the Web site, you would type the following:

smigrate.exe -w http://myserver/site1 -f c:\backup.fwp -e

Note If your site has a space in the URL, enclose the URL in quotation marks ("). For example, to back up http://myserver/my site, type "http://myserver/my site".

To restore a site, you use Smigrate.exe with the following parameters:

smigrate.exe -r -w Web_site_URL -f backup_filename [-u user_name -pw password]

For example, to restore the above site to http://yourserver/site2, you would type the following:

smigrate.exe -r -w http://yourserver/site2 -f c:\backup.fwp

If you are logged on with an account that does not have specific permissions to the destination Web site, you can specify a site administrator user name and password that has the appropriate permissions. For example, to restore a site and specify the administrator user name and password, you would use the following syntax:

smigrate.exe -r -w Web_site_URL -f backup_filename -u site_administrator_user_account -pw password

When you migrate a site from SharePoint Team Services v1.0 to Windows SharePoint Services, you can also use the x parameter during restore, which allows you to determine whether or not to preserve the security settings for the Web site (user accounts and site groups). You can run the SharePoint Migration Tool from any computer running Microsoft Windows 2000 Service Pack 3 or later. The tool can be copied to another computer and used even if Windows SharePoint Services is not installed.

Note The upgrade and migration from SharePoint Team Services v1.0 to Windows SharePoint Services is not full fidelity, and some data may be lost because of changes in the functionality between versions. You can view the smigrate.log file to see which items migrated successfully and which did not. The smigrate.log file is stored in the %temp% directory for your user account. If a log file already exists from a previous backup or restore, a log file will be created using the next available name (such as smigrate_1.log, smigrate_2.log, and so on).

To restore a site based on SharePoint Team Services v1.0 to a server running Windows SharePoint Services, and exclude the security information, you use Smigrate.exe with the following parameters:

smigrate.exe -r -w Web_site_URL -f backup_filename -x

Troubleshooting Migration Issues

If your site does not migrate as expected, refer to the following list to understand issues or find solutions:

  • When using the SharePoint Migration Tool to backup my SharePoint Team Services v1.0 site, I get the message: The server administration programs and the server extensions on the Web server are not compatible. The server is too old to use with this administration program. Please consult the section in the Administration Guide on Migrating and Updating Web Sites for more information.

    To migrate sites from SharePoint Team Services v1.0 to Windows SharePoint Services, you must verify that the server hosting the original site has been updated to work with the SharePoint Migration Tool. To download this update, go to the SharePoint Team Services Version 1.0 Update page. To install this update, you must be a member of the local Administrators group on the server.

  • When using the SharePoint Migration Tool to restore a site, I get the following error message: Server error: A site template has already been applied to this site. Once a template has been applied, the site must be deleted and recreated in order to apply a different template.

    To restore to a site, you must first create a blank site without applying a template. To create a destination site with no template, begin creating the site collection, top-level site, or subsite as usual, but when you get to the page where you are asked to select a template, close the browser window without making a selection. Do not apply any template (including the Blank Site template) or the restore operation will fail. After you have created a blank site with no template, you can use the SharePoint Migration Tool to restore to that site.

  • How do I determine if there were errors during migration?

    Check the SharePoint Migration Tool log file for errors. The smigrate.log file is stored in the %temp% directory for your user account. If a log file already exists from a previous backup or restore, new log files will be created using the next available name (such as smigrate_1.log, smigrate_2.log, and so on). Search the log entries for the following error messages: cannot, could not, failure, server error, timed out, unable to, and the server sent a response.

  • Alerts from unavailable users were not restored.

    If a user account no longer exists at restore time, or if the account was a local account, the alerts for that user account cannot be restored.

  • Survey creation times are incorrect.

    Creation times for surveys are not preserved during migration. This applies to all list types, but is most visible for surveys.

  • The site language is incorrect.

    When you restore a site, the language of the restored site must match that of the backed up site. Be sure that the language you need is available on the server you are restoring to.

  • There are too many views.

    If your site was migrated from SharePoint Team Services v1.0 to Windows SharePoint Services, the restored site contains both the views from the original site and the default views for Windows SharePoint Services. The restored SharePoint Team Services v1.0 views are listed after the default Windows SharePoint Services views. You can remove any views that you do not want.

  • I get an error message when I try to back up or restore a site through a proxy server.

    If your firewall or proxy server requires authentication, you may not be able to back up or restore a site.

  • Some of my currency formats changed after migration.

    When migrating a site from SharePoint Team Services v1.0 to Windows SharePoint Services, Windows SharePoint Services converts some obsolete currencies to their modern equivalents. For example, German Deutschmarks are converted to Euros. However, only the format of the currency field is changed. The value for each entry is not altered and must be manually converted by using the desired conversion rate.

  • Some of the entries have the fields Created By or Modified By attributed to the wrong person.

    When you migrate a Web site, the SharePoint Migration Tool attributes any content created by users who are not currently members of the source site to the user who performed the site migration. This problem can happen easily if you migrate to a new site, and then migrate from there to yet another site. The second time you run the SharePoint Migration Tool, it is possible that there will be content from a user from the source site who is not a member of first destination site. After that content is migrated to the second destination site, the content will be attributed to the user who performed the second migration. To resolve this problem, make sure that all team members are listed on the User Information page (Userinfo.aspx) of the source site before migrating. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services.

  • The lookup column I created is blank after I migrated the site.

    If you have a lookup column with the Get information from option set to User Information, the field will show up as blank in the restored site. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services. This problem can happen easily if you migrate to a new site, and then migrate from there to yet another site. The second time you run the SharePoint Migration Tool, it is possible that the lookup field looked up a user from the source site who is not a memeber of the first destination site. When that content is migrated to the second destination site, if the SharePoint Migration Tool cannot find the user name in the second destination site, the lookup column is left blank. To resolve this problem, make sure that all team members are listed on the User Information page (Userinfo.aspx) of the source site before migrating.

  • The properties of library folders have the wrong information in fields such as Created By or Created.

    The SharePoint Migration tools does not preserve library folder information such as Created, Created By, Modified, and Modified By. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services.

  • Some of the properties for files in my library are blank after migration.

    If the files were uploaded to the library using a multiple file upload utility such as the one provided in Office 2003 or using a Windows SharePoint Services-compatible Web page editor such as Office FrontPage 2003, any custom properties that use a default value will be blank after migration.

  • I no longer get alerts for changes in library folders

    The SharePoint Migration tool does not preserve alerts for library folders. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services.

  • The migrated site is larger than the original site

    The size of the restored site will be larger than the original site due to an increase in the size of Web Part Pages. If the original site is near the size quota allowed on the destination server, you may need to increase the quota on the destination server or delete some site content. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services.

  • Properties for my basic page or Web Part Page such as Modified or Modified By have changed after site migration.

    Properties such as Modified or Modified By are not preserved for basic pages or Web Part Pages. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services.

  • The creation date and time for Web discussions have changed after migration.

    The SharePoint Migration Tool does not preserve creation time and date for Web discussions during migration. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services.

  • A user keeps getting alerts for changes to the site, but he or she isn't allowed access to the site.

    The SharePoint Migration Tool migrates alerts to the new site, however, does not migrate site permissions. To resolve this problem, use the SharePoint administration pages to assign the user to a site group on the new site. If you don't want to give the user access to the site, you must manually delete any alerts that he or she created. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services.

  • The version numbers on my documents have changed after migration.

    If you have a library with Document Versions enabled, the versions are numbered sequentially after migration. Deleting a version of a document from the library causes the original version numbers to be non-sequential. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services.

  • The files that I had checked out are checked in after migration.

    File checkout status is not preserved during migration.

  • My user information from the source site didn't get migrated.

    The user information for the user who performs the migration is not copied to the destination site if he or she is already listed on the the User Information page (Userinfo.aspx) of the destination site.

  • The text direction for a list has changed.

    The SharePoint Migration Tool does not preserve the default text direction (right-to-left or left-to-right) during migration. To resolve this problem, you must manually change the text direction for lists after migration. This problem occurs only when migrating Windows SharePoint Services sites to another server running Windows SharePoint Services.

  • After migration, one of the lookup columns for a library has one more entry than there are files.

    After migration, an extra entry exists if a lookup field in a libary references files in the same library.

  • Some folders marked as unbrowsable did not migrate.

    Windows SharePoint Services uses the _private folder to store unbrowsable files and folders. FrontPage 2002 Server Extensions and SharePoint Team Services v1.0 allowed you to mark additional folders as unbrowsable. When you use the SharePoint Migration Tool to migrate a site that has multiple unbrowsable folders, only the _private folder and any files in the _private folder, are restored. If you want to migrate a site that contains additional folders marked as unbrowsable, move the files from those additional folders into the _private folder before migrating.

    Note You can only see the _private folder and its contents when you open the site in a program compatible with Windows SharePoint Services such as Office Word 2003 or Office FrontPage 2003.

In addition, when you migrate a site from SharePoint Team Services v1.0 to Windows SharePoint Services, there are some features or customizations that do not migrate. For a list of these items, see Upgrade Considerations.


Migrating from WMSDE to SQL Server

Migrating from WMSDE to SQL Server

When you install Microsoft Windows SharePoint Services on a single server using the defaults, you have an installation that uses Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) for your databases. This is fine in a small-scale environment, when you are hosting just a few Web sites, but if your server suddenly gets popular and you need to start hosting hundreds of sites, you may run into performance and storage problems. If you find yourself in this situation and need to move to a more scaled out solution, you can switch to using Microsoft SQL Server 2000 Service Pack 3 (SP3) as your database back end. There are two methods you can use to switch your databases to SQL Server 2000:

  • Upgrade the databases to SQL Server on the same computer.

    Use this option if you want to continue running Windows SharePoint Services on a single server.

  • Migrate the content databases to a server farm running SQL Server and Windows SharePoint Services.

    Use this option if you want to move your sites to a server farm, with at least one front-end Web server and at least one back-end database server.

Upgrading the Databases to SQL Server on the Same Computer

If you want to continue using a single server for Windows SharePoint Services, you can simply upgrade your database instance from WMSDE to SQL Server. Because this process requires your sites to be offline while the databases are upgraded, it is recommended that you perform these steps at a time when usage of your sites is generally low, and also that you notify users that their sites will be offline for a time.

Note Before you upgrade your databases, it is a good idea to back them up. If you have the SQL Server client tools installed on your server or on another server, you can use them to back up a WMSDE database. Otherwise, stop WMSDE and make a copy of the database files before installing SQL Server.

Install SQL Server and upgrade your databases
  1. Run the SQL Server 2000 SP2 Setup program, and on the Autorun panel, click SQL Server 2000 Components.
  2. Click Install Database Server, and then on the Welcome panel, click Next.
  3. In the Computer Name box, select Local computer, and then click Next.
  4. In the Installation Selection pane, select Upgrade, remove, or add components to an existing instance of SQL Server, and then click Next.
  5. In the Instance Name pane, clear the Default check box, and then in the Instance name box, select SHAREPOINT, and click Next.
  6. In the Existing Installation pane, verify that Upgrade is selected, and then click Next.
  7. In the Upgrade pane, verify that the Yes, upgrade my programs check box is selected, and then click Next.
  8. In the Licensing Options pane, select your licensing options, and then click Next.
  9. In the Select Components pane, click Server Components, and then select the Full-text Search check box if you want to enable full-text searching.
  10. In the left pane, select the Management Tools check box and in the right pane, select the Enterprise Manager and Query Analyzer check boxes.
  11. Select any other components you want, and then click Next.
  12. In the Start Copying Files pane, click Next, and then click Finish.

After the upgrade to SQL Server 2000 is complete, your SharePoint sites should work as usual.

Migrating the Content Databases to a Server Farm

If you are moving to a larger scale environment, with one or many front-end Web servers and one or many back-end database servers, the process is a more complicated. To switch from WMSDE to SQL Server and move to a server farm, you must perform steps using the Internet Information Services (IIS), Windows SharePoint Services, and SQL Server administration tools. You must also take your sites offline for a while. It is recommended that you perform these steps at a time when usage of your sites is generally low, and also that you notify users that their site will be offline for a time.

The process below assumes that you will continue to use the original Web server computer as either a stand-alone server or part of a server farm, and that you are moving the databases to a new back-end database server running SQL Server.

The steps you take to move from a single-server WMSDE installation to a server farm with SQL Server are:

  1. Install the SQL Server client tools on the original server running WMSDE and SQL Server 2000 Service Pack 3 (SP3). The client tools are used to back up and restore the content and configuration databases. The version of WMSDE that is installed with Windows SharePoint Services does not enable remote connections from SQL Server client tools.
  2. Prepare the destination database server by installing SQL Server 2000 Service Pack 3 (SP3).
  3. In IIS, stop any virtual servers that are hosting SharePoint sites, so that users cannot access the sites.
  4. Disconnect the content databases from the virtual server and remove Windows SharePoint Services from the virtual server.
  5. Decide which domain accounts to use for the SharePoint Central Administration virtual server and the content virtual servers, and then update the SharePoint Central Administration virtual server to use the domain account.

    You can use the same account for both SharePoint Central Administration and the other virtual servers, or for more granular security, you can choose to use different accounts.

  6. Register the instance of WMSDE in SQL Server Enterprise Manager, and then back up the content and configuration databases.
  7. Copy the backup files to the destination server and restore the content and configuration databases.
  8. In SQL Server, change the database ownership and permissions for the configuration and content databases.
  9. Reconnect to the configuration database.
  10. Extend the content virtual server and add the restored content databases to the virtual server.
  11. Update the default content database server for future content database creation.

Installing the SQL Server Client Tools and Backing Up the Content Databases

To create a backup file for a WMSDE database, you must use the SQL Server client tools. You must install the SQL Server client tools to your original server, and then perform the backup. For more information about installing the client tools for SQL Server 2000, see the SQL Server 2000 documentation.

Preparing the Destination Server Farm

You can move your content to an existing or new server farm. Either way, you need to have a back-end database server running SQL Server 2000 SP3 and one or more front-end Web servers running Windows SharePoint Services. For more information about setting up separate servers with SQL Server and Windows SharePoint Services, see Remote SQL Server Deployment or Server Farm with Multiple Host Names Deployment. Your server farm must be up and running before you can upgrade and move the content databases.

Stopping the Virtual Servers Hosting SharePoint Sites

In order to completely back up and restore your SharePoint sites, you must be sure that no users are making changes to the sites. To block users from changing the sites, you can stop the sites in IIS.

Stop a virtual server in IIS
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Click the plus sign (+) next to the server name that contains the virtual server you want to stop.
  3. Click the plus sign (+) next to the Web Sites folder.
  4. Right-click the virtual server you want to stop, and then click Stop.

Disconnecting the Content Databases and Removing Windows SharePoint Services from the Virtual Server

You must disconnect the content databases and remove Windows SharePoint Services from the virtual servers hosting SharePoint sites before you can back up the configuration and content databases.

Remove a content database
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Manage content databases.
  5. On the Manage Content Databases page, under Content Databases, select the database you want to change.
  6. On the Manage Content Database Settings page, in the Remove Content Database section, select the Remove content database check box.
  7. Click OK.

Repeat these steps for any additional content databases. After the content databases have been removed, you can remove Windows SharePoint Services from the virtual servers.

Remove Windows SharePoint Services from a virtual server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, select the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Remove Windows SharePoint Server from Virtual Server.
  5. On the Remove Windows SharePoint Server from Virtual Server page, select Remove without deleting content databases.
  6. Click OK.

Updating the Application Pool Account for SharePoint Central Administration

You must determine which accounts to use for the application pools for the SharePoint Central Administration virtual server and for any virtual servers hosting SharePoint sites. Then, you can update the application pool for the SharePoint Central Administration virtual server to run with the domain account you select. You can use the same account for both SharePoint Central Administration and the other virtual servers, or for more granular security, you can use separate accounts.

Update the application pool account for SharePoint Central Administration
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, under Server Configuration, click Configure virtual server for central administration.
  3. Select Create a new application pool, and then select Configurable.
  4. In the User name box, type the user name to use for the identity.
  5. In the Password box, type the password for that user name.
  6. In the Confirm password box, type the password again.
  7. Click OK.

After you change the application pool for SharePoint Central Administration, you must restart IIS. To restart IIS, on the command line, type iisreset.

Registering the WMSDE Instance in Enterprise Manager and Backing Up the Databases

You must register the WMSDE instance with Enterprise Manager to be able to back up the configuration and content databases. You must have already installed the SQL Server client tools to use Enterprise Manager.

Register the WMSDE database in Enterprise Manager
  1. Click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. Click the plus sign next to Microsoft SQL Servers.
  3. Right-click SQL Server Group, and then click New SQL Server Registration.
  4. In the Register SQL Server Wizard, click Next.
  5. In the Available Servers box, type the original server name and the instance name (for example, server_name\SHAREPOINT), and then click Add.
  6. Click Next.
  7. On the Select an Authentication Mode panel, select one of the following connection methods:
    • The Windows account information I use to log on to my computer (Windows Authentication)
    • The SQL Server login information that was assigned to me by the system administrator (SQL Server Authentication)
  8. Click Next.
  9. On the Select SQL Server Group panel, click Next to add the server to the existing SQL Server Group.
  10. Click Finish.
  11. On the Server registration completed panel, click Close.

After you have registered the WMSDE database with Enterprise Manager, you are ready to back up your configuration and content databases.

Back up the configuration and content databases
  1. Click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. Click the plus sign next to Microsoft SQL Servers.
  3. Click the plus sign next to SQL Server Group.
  4. Click the plus sign next to the WMSDE instance name.
  5. Click the plus sign next to Databases.
  6. Right-click the configuration database name, point to All Tasks, and then click Backup Database.
  7. In the SQL Server Backup dialog box, on the General tab, be sure the correct database is selected in the Database box, and then in the Name box, type the name for the backup.
  8. Under Destination, click Add.
  9. In the Select Backup Destination dialog box, in the File name box, type the path and file name for your backup file, and then click OK.

    For example, c:\database_name.bak.

  10. On the General tab, under Overwrite, select Overwrite existing media.
  11. Click OK to begin the backup.
  12. Repeat these steps to back up the content databases.

Copying the Backup Files and Restoring the Databases

Copy all of the backup files for your configuration and content databases to the following directory on your destination server: \Program Files\Microsoft SQL Server\MSSQL\Backup. After you have copied the files to the destination server, you can restore the databases. After the databases have been restored, they work as fully functional SQL Server databases.

Restore the configuration and content databases
  1. On the new server, click Start, point to All Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. Click the plus sign next to Microsoft SQL Servers.
  3. Click the plus sign next to SQL Server Group.
  4. Click the plus sign next to the WMSDE instance name, if you connected remotely to your original server, or next to (local) (Windows NT), if you performed the backup on another server and have just copied the backup file to the new server.
  5. Right-click Databases, point to All Tasks, and then click Restore Database.
  6. In the Restore database dialog box, on the General tab, in the Restore as database box, type the database name.
  7. In the Restore section, select From device, and then click Select devices.
  8. In the Choose Restore Devices dialog box, click Add.
  9. In the File name box, type the path and file name for your backup file, and then click OK.

    For example, c:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\sts_config.bak.

  10. Click OK to close the Choose Restore Devices dialog box.
  11. On the Options tab, under Move to physical file name, verify that the paths listed for the database and log files are correct.

    For example, the path in the WMSDE backup file might be similar to c:\Program Files\Microsoft SQL Server\MSSQL$SHAREPOINT\Data\database_name, but on the new server, you need to use the path c:\Program Files\Microsoft SQL Server\MSSQL\Data\database_name instead.

  12. Click OK to restore the database.
  13. Repeat these steps to restore the content databases.

Changing the Database Ownership and Permissions for the Databases

You must change the database ownership and permissions for the databases to grant permissions to the application pool accounts you want to use. To change the ownership and permissions, you use SQL Query Analyzer.

Change the database ownership and permissions for the configuration database
  1. On the new server, click Start, point to All Programs, point to Microsoft SQL Server, and then click Query Analyzer.
  2. In the Connect to SQL Server dialog box, in the SQL Server box, type the server name, and then click OK.
  3. On the Query menu, click Change Database.
  4. In the Select Database of server_name box, click the configuration database (sts_config), and then click OK.
  5. In the Query pane, type the following query.
    DECLARE @AdminVSAccount nvarchar(255)
DECLARE @ContentVSAccount nvarchar(255)
SET @ContentVSAccount = N'domain\contentaccount';
SET @AdminVSAccount = N'domain\adminaccount';
EXEC sp_grantlogin @ContentVSAccount;
EXEC sp_changedbowner @AdminVSAccount;
IF NOT EXISTS (SELECT * FROM sysusers WHERE name=@ContentVSAccount)
      EXEC sp_grantdbaccess @ContentVSAccount;
EXEC sp_addrolemember 'db_owner', @ContentVSAccount;
EXEC sp_addsrvrolemember @AdminVSAccount, 'dbcreator'
EXEC sp_addsrvrolemember @AdminVSAccount, 'securityadmin'
EXEC sp_addsrvrolemember @AdminVSAccount, 'processadmin'

    Note In lines 3 and 4, replace domain\contentaccount and domain\adminaccount with the domain account for the content virtual server and the domain account for the SharePoint Central Administration virtual server. If the accounts are the same, SQL Query Analyzer will display an error, but the process will still succeed.

  6. Click the Execute Query button to update the database.
Change the database ownership and permissions for the content databases
  1. On the new server, click Start, point to All Programs, point to Microsoft SQL Server, and then click Query Analyzer.
  2. In the Connect to SQL Server dialog box, in the SQL Server box, type the server name, and then click OK.
  3. On the Query menu, click Change Database.
  4. In the Select Database of server_name box, click the content database you want to update, and then click OK.
  5. In the Query pane, type the following query.
    DECLARE @AdminVSAccount nvarchar(255)
DECLARE @ContentVSAccount nvarchar(255)
SET @ContentVSAccount = N'domain\contentaccount';
SET @AdminVSAccount = N'domain\adminaccount';
EXEC sp_grantlogin @ContentVSAccount;
EXEC sp_grantlogin @AdminVSAccount;
EXEC sp_changedbowner @AdminVSAccount;
IF NOT EXISTS (SELECT * FROM sysusers WHERE name=@ContentVSAccount)
      EXEC sp_grantdbaccess @ContentVSAccount;
EXEC sp_addrolemember 'db_owner', @ContentVSAccount;

    Note In lines 3 and 4, replace domain\contentaccount and domain\adminaccount with the domain account for the content virtual server and the domain account for the SharePoint Central Administration virtual server. If the accounts are the same, SQL Query Analyzer will display an error, but the process will still succeed.

  6. Click the Execute Query button to update the database.

Reconnecting to the Configuration Database

After the permissions have been set, you are ready to reconnect to the configuration database.

Connect to the restored configuration database
  1. On the server running Windows SharePoint Services, click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Server Configuration, click Set configuration database server.
  3. On the Set Configuration Database Server page, in the Database server box, type the name of the new server.
  4. In the SQL Server database name box, type the name of the configuration database (the default is sts_config).
  5. Select the Connect to existing configuration database check box.
  6. Click OK.

Extending the Virtual Servers and Adding the Content Databases

You can extend either the default virtual server (if it was not in use already) or a newly created virtual server. For more information about creating a virtual server, see Extending Virtual Servers.

Important When you extend the virtual server, you must specify the application pool identity to use for the virtual server processes. Be sure to specify an account that is a member of the database owners role in SQL Server for the restored content database, or else add the account to the database owners role before you extend the virtual server. For more information about adding an account to a role in SQL Server, see the SQL Server 2000 documentation.

Extend a virtual server
  1. On the SharePoint Central Administration page, click Extend or upgrade virtual server.
  2. On the Virtual Server List page, click the name of the virtual server to extend.
  3. On the Extend Virtual Server page, in the Provisioning Options section, select Extend and map to another virtual server.
  4. In the Server Mapping section, in the Host name or IIS virtual server name box, click the name of the virtual server that contained the original sites.
  5. In the Application Pool section, select Create a new application pool.

    Note It is recommended that you create a new application pool for each virtual server, so that they run in separate processes. Be sure that the application pool account you specify is a member of the database owners role for the content database you restored.

  6. In the Application pool name box, type the new application pool name.
  7. Under Select a security account for this application pool, select Configurable.
  8. In the User name box, type the account name.
  9. In the Password box, type the password for the account.
  10. In the Confirm password box, type the password again.
  11. Click OK.

Now that the virtual server is extended, you can add any additional restored content databases.

Add the restored content databases
  1. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  2. On the Virtual Server List page, select the virtual server you want to configure.
  3. On the Virtual Server Settings page, under Virtual Server Management, click Manage Content Databases.
  4. On the Manage Content Databases page, click Add a content database.
  5. In the Database Information section, click Specify database server settings.
  6. In the Database name box, type the name of the restored database.
  7. In the Database Capacity Settings section, fill in the capacity settings you want to use.
  8. Click OK.

Repeat these steps to add any additional content databases.

Updating the Default Content Database Server

Now that all of the databases have been moved, you can update the default content database server, so that any new content databases are created on the correct server.

Update the default content database server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Server Configuration, click Set default content database server.
  3. In the Content Database section, enter the new database server name.
  4. Click OK.


Analyzing Web Site Usage

Analyzing Web Site Usage

If you want to know what kind of impact your Web site has, you need to track how many users visit your site, the type and number of hits your site receives, and other site-usage information. Microsoft Windows SharePoint Services includes features that analyze the usage of your site. Summary and detailed usage reports supply information such as:

  • Number of page hits for each individual page
  • Number of unique users
  • Browser and operating system information
  • Referring domains and URLs

Tracking usage information can be useful for identifying which content on your site is being heavily used (and therefore should be kept) and which content is not being heavily used (and may be a candidate for archiving). In addition to site usage statistics, you can also keep track of how much storage space your site is taking up, and the level of activity your site is generating. This information is gathered as part of the quota tracking for sites. For more information about quotas, see "Configuring Site Quotas and Locks" in the Windows SharePoint Services Administrator's Guide.

The usage reports rely on usage log data gathered from the Web sites and stored in the content databases. The log data is a summary record of transactions on your Web site. When you view a usage report in Windows SharePoint Services the data is arranged into a list format. You must be a member of the administrator role (or have the View Usage Data right) for a site in order to view the site usage statistics.

You can view usage data about a site from the Site Administration page.

View site usage data
  1. On the site you want to view data for, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Management and Statistics, click View site usage data.

From the Site Usage Report page, you can see detailed usage reports for sites. If you want to see a summary of usage information for an entire site collection at the same time, you can use the Site Collection Usage Summary page.

View usage summary for a site collection
  1. On the top-level Web site of the site collection, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Site Collection Administration, click View site collection usage summary.

You can also view the details reports about storage by using the Storage Space Allocation link on the Site Collection Usage Summary page.

Related Topics

For more information about changing settings for usage analysis processing, see Configuring Usage Analysis.

For more information about managing quotas, see "Configuring Site Quotas and Locks" in the Windows SharePoint Services Administrator's Guide.


Managing Unused Web Sites

Managing Unused Web Sites

Web sites based on Microsoft Windows SharePoint Services may become inactive for many reasons: perhaps a site was set up for documents relating to a project that is finished, or perhaps a user was trying out Windows SharePoint Services and created a site that he or she no longer needs. Because inactive sites take up space on the servers, it's important to check with site owners to see if their sites are still needed or have become inactive. In Windows SharePoint Services, new administrative options allow you to automatically send notices to site owners requiring them to confirm that their sites are in use. You can also delete unconfirmed sites automatically. These features give you a way to control the number of unused Web sites on your server.

Site use confirmation works like alerts for your users' sites. When sites are created, they are added to the database and are logged as active sites. After a specified time defined by the administrator, the site owners are sent an e-mail notification asking the owners to either reactivate or delete their unused Web sites. The notification e-mail text contains links to confirm that a site is active or to delete a site. After the notification is sent, there are three possible outcomes:

  • If a site is in use, the site owner will click a link to confirm that the site is active and preserve the site. When the owner clicks the confirmation link, the timer is restarted, and the owner will be notified again after the same time period.
  • If a site is not in use, the site owner can delete the site by following instructions in the notification e-mail, or do nothing. The site owner continues to receive periodic e-mail notifications (the period is defined by the administrator) until use is confirmed or the site is deleted.
  • If a site is not in use, and you have turned on the automatic deletion feature, the site owner is queried a specific number of times (a number configured by the administrator), and if use is not confirmed, the site is automatically deleted.

Automatic deletion is an advanced administrative feature that can delete unneeded sites without any administrative intervention and without any backup mechanism. To prevent a site from being deleted without any notification, you must turn on site use confirmation before you can turn on automatic deletion. Also, the site owner must always be sent at least two confirmation notices before a site can be deleted. In addition to these basic safeguards included as defaults, you should also consider the following best practices:

  • Require a secondary contact when sites are created.

    When a user creates a site, the user is listed as the site owner. Depending on your configuration, the user may also be required to specify a secondary contact for the site. Confirmation notifications are automatically sent to the site owner and to the secondary contact, if one exists. For more information, see "Configuring Self-Service Site Creation" in the Windows SharePoint Services Administrator's Guide.

  • Set reasonable intervals between confirmations and before automatic deletion.

    For example, if a site owner is unavailable for four weeks, and sites are deleted after four missed weekly confirmations, the site could be deleted without allowing the owner a chance to confirm. If you are enabling this feature inside a corporation, be sure you consider your organization's policies regarding vacations and leaves of absence when you configure the intervals for confirmation and deletion.

  • Back up Web sites regularly, so you can restore a recent copy if a site is unintentionally deleted.

    For example, if you configure confirmation and automatic deletion to happen on the fifth day of each month, make it a policy to back up your server on the fourth day. You can automate this process by creating a stored process in Microsoft SQL Server to check the sites table and automatically back up any items scheduled for deletion. For more information about SQL Server, see the SQL Server documentation. For more information about the sites table, see the Windows SharePoint Services Software Development Kit.

Configuring Site Use Confirmation and Deletion

There are several settings that you can configure to control how much time elapses between stages for confirmation and automatic deletion. You can configure the following:

  • When to begin sending site use confirmation notices

    The initial notification value controls when the first confirmation notice is sent to a new site, or to a site that has been confirmed as in use. This value does not control the frequency of notifications, only the number of days to wait before the initial notification.

  • How frequently to check for sites needing confirmation and how frequently to send out notifications

    The frequency value affects both how often the server is checked and how often confirmation notices can be sent. If you set the frequency to weekly, the server is checked weekly, and notifications are also sent out weekly, immediately after the server has been checked.

  • What time to perform the check and to send out notifications

    Change this time to suit your environment. For example, if most of your users are online and hitting the server during the day, pick a time during the night when the server is not as busy.

  • How many notifications to send before allowing automatic deletion

    Adjust this number to be sure site owners receive notification before a site is deleted. The number of notifications also depends on the frequency, so if you specify daily checks, with 30 reminders before deletion, the site owner would be notified every day for a month before the site was deleted.

Be sure to configure these times to be useful and reasonable given your organization's context. In a large organization, where users may need data to be stored for some time, you can specify longer intervals (for example, start sending notifications at 180 days, notify every month, and delete after six months without a confirmation). If you are hosting free sites for customers, you may want to shorten these intervals (start sending notifications at 45 days, notify weekly, delete after four weeks). If you are hosting sites for paying customers, you may not want to use this feature, unless you have an automated backup strategy that allows you to restore sites on request.

The following table lists each of these settings as you see them on the Configure Site Collection Use Confirmation and Auto-Deletion page and their default and minimum values.

Setting | Default value | Minimum value
Start sending notifications ___ days after site collection creation, or use is confirmed | 90 days | 30 days
Check for unused site collections, and send notices <Daily Weekly Monthly> and run the check at <time> | Weekly 12:00 AM | Daily
Delete the site collection after sending ___ notices | 4 | Daily minimum: 28 Weekly minimum: 4 Monthly minimum: 2

In a scenario using the default values above, the first notice is sent at 90 days. Another notice is sent every week for five additional weeks. On the sixth week after the initial notification, if the site has not been confirmed, the site is deleted. If at any point the site is confirmed as in use, the count goes back to the start, and the owner will not receive another notice for 90 days.

Note If for any reason the e-mail notification cannot be queued (for example, the SMTP server is down), the count is not incremented. For example, if three notices have been sent, and when it is time for the fourth notice to be sent the next week, the SMTP server is down, the fourth notification is not sent that day, and the count is not incremented. The next week, when the database is checked again, the fourth notice is sent, and the process continues from there.

The confirmation and automatic deletion feature relies on the Microsoft SharePoint Timer service to carry out the timed jobs. The times and intervals you specify here follow the same rules as any other SharePoint Timer service job in Windows SharePoint Services. For more information, see Scheduling Timed Jobs.

Enabling Site Use Confirmation and Automatic Deletion

You manage unused Web sites at the virtual server level by using the Configure Site Collection Use Confirmation and Auto-Deletion page in the HTML Administration pages. You must be an administrator on the server computer or a member of the SharePoint administrators group to access this administration page. By default, both site use confirmation and automatic deletion are turned off.

Open the Configure Site Collection Use Confirmation and Auto-Deletion page
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, click the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Automated Web Site Collection Management, click Configure site collection use confirmation and deletion.

By default, site use confirmation is turned off. If you want to require confirmation of use, you can specify the interval to wait before sending the first notification, and how frequently to continue sending notifications if site use is not confirmed. Notices are sent to the e-mail address specified in the site for the site owner and the secondary owner (if a secondary contact has been identified).

Enable and configure e-mail confirmation notices
  1. On the Configure Site Collection Use Confirmation and Auto-Deletion page, in the Confirmation and Automatic Deletion Settings section, select the Send e-mail notifications to owners of unused site collections check box.
  2. In the Start sending notifications ___ days after site collection creation, or use is confirmed box, type the number of days to wait before sending notifications after the site is created or use is confirmed.

    For example, if you enter 60 days, then when a user creates a site, the first notification will be sent after 60 days. If the user confirms that that the site is in use at that time, another 60 days will go by before they get another notification.

  3. In the Check for unused site collections, and send notices ____ and run the check at ____ boxes, specify daily, weekly, or monthly, and then the time of day to run the check.
  4. Click OK.

You must enable and configure e-mail confirmation notices before you can enable automatic deletion.

Enable and configure automatic deletion
  1. Enable and configure e-mail confirmation notices.
  2. Select the Automatically delete the site collection if use is not confirmed check box.
  3. In the Delete the web after sending ___ notices box, specify how many e-mail notifications to send before deleting the site.
  4. Click OK.

Configuring Site Use Confirmation and Automatic Deletion from the Command Line

You can also configure confirmation and automatic deletion from the command line by using the setproperty operation and the following properties: delete-web-send-email, dead-site-notify-after, dead-site-num-notifications, dead-site-auto-delete, and job-dead-site-delete. For more information, see Command-Line Properties.

Customizing the Notification Text

There are two versions of the confirmation e-mail notification — one is used when only site use confirmation is enabled, the other when automatic deletion is also enabled. The text for the notification e-mail messages is stored in the DEADWEB.XML file in the \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\TEMPLATE\LCID\XML folder for the server, where LCID is the locale ID. You must be an administrator on the server computer to view or change this file. There are different versions of these e-mail messages for each language version. If you host site collections in multiple languages, be sure to customize the specific language versions of the notification e-mail messages as well.


Changing the Application Pool Identity for a Virtual Server

Changing the Application Pool Identity for a Virtual Server

If you need to change the application pool identity for the SharePoint Central Administration virtual server or for a content virtual server, you can do so from within Microsoft Internet Information Services (IIS). When you change the SharePoint Central Administration application pool identity in IIS, you must also change the information for the Microsoft SharePoint Timer service, so you do not lose your connection to the configuration and content databases for Microsoft Windows SharePoint Services.

To change the application pool identity for SharePoint Central Administration and one or more content virtual servers, you must perform the following steps:

  1. Grant the appropriate database permissions to the new identity or identities and change the database owner for the configuration and content databases.
  2. Add the new accounts to the STS_WPG and IIS_WPG groups and verify that the IIS_WPG group has Read and Write permissions to the content area of the virtual server.
  3. Update the application pools in IIS and synchronize the SharePoint Timer Service with the new account information.

Granting Database Permissions and Changing Database Ownership

Before you change the identity, you must ensure that the application pool account you use has the appropriate permissions for your databases in Microsoft SQL Server. To work correctly, the application pool account must be a member of the following roles for your databases in SQL Server: Security Administrators and Database Creators. If you are changing the Administration virtual server and one or more content virtual servers to different accounts, you must perform the following procedure for each account.

Grant Database Creation Rights in SQL Server
  1. On your SQL Server computer, click Start, point to Programs, point to Microsoft SQL Server, and then click Enterprise Manager.
  2. In Enterprise Manager, click the plus sign (+) next to Microsoft SQL Servers, click the plus sign (+) next to SQL Server Group, and then click the plus sign next to your SQL Server.
  3. Click the plus sign (+) next to Security, and then right-click Logins, and click New Login.
  4. In the Name box, type the account in the form DOMAIN\name.
  5. Click the Server Roles tab.
  6. In the Server Role list, select the Security Administrators and Database Creators check boxes, and then click OK.

    Note Do not specify any databases for this login on the Database Access tab.

Change the database ownership and permissions for the configuration database
  1. On the database server, click Start, point to All Programs, point to Microsoft SQL Server, and then click Query Analyzer.
  2. In the Connect to SQL Server dialog box, in the SQL Server box, type the server name, and then click OK.
  3. On the Query menu, click Change Database.
  4. In the Select Database of server_name box, click the configuration database (sts_config), and then click OK.
  5. In the Query pane, type the following query.
    DECLARE @AdminVSAccount nvarchar(255)
DECLARE @ContentVSAccount nvarchar(255)
SET @ContentVSAccount = N'domain\contentaccount';
SET @AdminVSAccount = N'domain\adminaccount';
EXEC sp_grantlogin @ContentVSAccount;
EXEC sp_changedbowner @AdminVSAccount;
IF NOT EXISTS (SELECT * FROM sysusers WHERE name=@ContentVSAccount)
      EXEC sp_grantdbaccess @ContentVSAccount;
EXEC sp_addrolemember 'db_owner', @ContentVSAccount;
EXEC sp_addsrvrolemember @AdminVSAccount, 'dbcreator'
EXEC sp_addsrvrolemember @AdminVSAccount, 'securityadmin'

    Note In lines 3 and 4, replace domain\contentaccount and domain\adminaccount with the domain account for the content virtual server and the domain account for the SharePoint Central Administration virtual server. If the accounts are the same, SQL Query Analyzer will display an error, but the process will still succeed.

  6. Click the Execute Query button to update the database.
Change the database ownership and permissions for the content databases
  1. On the database server, click Start, point to All Programs, point to Microsoft SQL Server, and then click Query Analyzer.
  2. In the Connect to SQL Server dialog box, in the SQL Server box, type the server name, and then click OK.
  3. On the Query menu, click Change Database.
  4. In the Select Database of server_name box, click the content database you want to update, and then click OK.
  5. In the Query pane, type the following query.
    DECLARE @AdminVSAccount nvarchar(255)
DECLARE @ContentVSAccount nvarchar(255)
SET @ContentVSAccount = N'domain\contentaccount';
SET @AdminVSAccount = N'domain\adminaccount';
EXEC sp_grantlogin @ContentVSAccount;
EXEC sp_grantlogin @AdminVSAccount;
EXEC sp_changedbowner @AdminVSAccount;
IF NOT EXISTS (SELECT * FROM sysusers WHERE name=@ContentVSAccount)
      EXEC sp_grantdbaccess @ContentVSAccount;
EXEC sp_addrolemember 'db_owner', @ContentVSAccount;

    Note In lines 3 and 4, replace domain\contentaccount and domain\adminaccount with the domain account for the content virtual server and the domain account for the SharePoint Central Administration virtual server. If the accounts are the same, SQL Query Analyzer will display an error, but the process will still succeed.

  6. Click the Execute Query button to update the database.

Adding Accounts to the STS_WPG and IIS_WPG Groups and Verifying Permissions

You must add the new accounts to the STS_WPG and IIS_WPG groups on all front-end Web servers in your server farm. These groups control access to the IIS metabase, the SharePoint connection string to SQL Server, and other required directories and files. For more information about adding accounts to groups, see the Windows Server 2003 Help system.

The IIS_WPG group must have Read and Write permissions to the content area of the virtual server. For example, if the content virtual server points to c:\inetpub\wwwroot, you must grant the IIS_WPG group Read and Write permissions to this directory. For more information about granting permissions to directories, see the Windows Server 2003 Help system.

Updating the Application Pools and Synchronizing the SharePoint Timer Service

To change the application pool identity for the SharePoint Central Administration virtual server or for a content virtual server, you use Internet Information Services (IIS) Manager. If you have changed the identity for SharePoint Central Administration, you must also synchronize the SharePoint Timer Service to use the new identity.

Update the SharePoint Central Administration application pool in IIS
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Click the plus sign next to your server name.
  3. Click the plus sign next to Web Sites.
  4. Right-click SharePoint Central Administration, and then click Properties.
  5. Click the Home Directory tab.
  6. Make a note of the application pool name in the Application pool box, and then click Cancel.
  7. Click the plus sign next to Application Pools.
  8. Right-click the application pool that needs to be updated, and then click Properties.
  9. In the "Application Pool ID" Properties dialog box, click the Identity tab.
  10. Under Application pool identity, verify that Configurable is selected, and then in the User name box, type the new account to use.
  11. In the Password box, type the password for the new account, and then click OK.

After you have reset the application pool identity, you must restart IIS. To restart IIS, run iisreset on the command line.

Synchronize the SharePoint Timer Service with the new account information
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, under Server Configuration, click Configure virtual server for central administration.
  3. Select Use an existing application pool, and then select the application pool you just updated with the new account for SharePoint Central Administration.
  4. Click OK.

After you have reset the application pool identity, you must restart IIS. To restart IIS, run iisreset on the command line.

Update the content virtual server application pool in IIS
  1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
  2. Click the plus sign next to your server name.
  3. Click the plus sign next to Web Sites.
  4. Right-click the virtual server you need to update, and then click Properties.
  5. Click the Home Directory tab.
  6. Make a note of the application pool name in the Application pool box, and then click Cancel.
  7. Click the plus sign next to Application Pools.
  8. Right-click the application pool that needs to be updated, and then click Properties.
  9. In the "Application Pool ID" Properties dialog box, click the Identity tab.
  10. Under Application pool identity, verify that Configurable is selected, and then in the User name box, type the new account to use.
  11. In the Password box, type the password for the new account, and then click OK.

After you have reset the application pool identity, you must restart IIS. To restart IIS, run iisreset on the command line.


Monitoring Events for Windows SharePoint Services

Monitoring Events for Windows SharePoint Services

Part of managing servers is monitoring the applications and services running on your servers so that you can take action either when an error occurs or before a limit is reached. Use the events, alerts, and System Monitor counters in this topic to monitor service status and troubleshoot issues for your front-end Web servers running Microsoft Windows SharePoint Services. When you monitor events for Windows SharePoint Services and related services, you can make sure that your users' SharePoint sites are available when they need them.

The following types of events are covered in this topic:

  • Web Site and SQL Server Events
  • Services Events
  • Active Directory Events
  • Virus Scanner Events
  • HTML Transformation Events
  • Baseline Server Events

Note The Microsoft Windows SharePoint Services Monitoring Design and Implementation whitepaper, available on the Microsoft Web site, contains more information about these events and errors and how one team, the Internet Platform and Operations group at Microsoft, used these errors and events to monitor Windows SharePoint Services during the beta release.

Web Site and SQL Server Events

The Windows NT Event log entries from Windows SharePoint Services all have the same Event ID (1000). For these events, the description field contains unique elements - usually the pound sign (#) followed by a number. These unique elements are called out in the following tables.

When the content and configuration databases cannot be reached, the Windows SharePoint Services service on the front-end Web server will be interrupted.

Event | Cannot connect to database
Event Type | Error
Event Source | Windows SharePoint Services 2.0
Event Category | None
Event ID | 1000
Description contains | substring '#50070'
Response | Check the database connection information and make sure that the database server is running.

The following two events are alerts, sent through e-mail messages to system administrators.

Event | Database capacity reached
Event Type | Error
Event Source | Windows SharePoint Services 2.0
Event Category | None
Event ID | 1000
Description contains | substring '#50068'
Response | Change the content database Web site capacity settings or add more content databases.
Event | Database capacity warning reached
Event Type | Warning
Event Source | Windows SharePoint Services 2.0
Event Category | None
Event ID | 1000
Description contains | substring '#50069'
Response | Either change the content database Web site capacity settings or add more content databases.

Services Events

When the following errors occur with Web parts, the SharePoint Timer Services, STSWel, or W3WP, they should be investigated and troubleshooted. When these events occur, Windows SharePoint Services services are still available but certain components on one server may not be functioning normally.

Error | Web Part rendering failure
Provider Name | Application
Provider Type | Windows NT Event Log
Event Type | Error
Source Name | Windows SharePoint Services 2.0
Description contains | Substring 'VerifySafeControls failed for guid’
Error | Web Part unsafe control detected
Provider Name | Application
Provider Type | Windows NT Event Log
Event Number | 1000
Event Type | Error
Source Name | Windows SharePoint Services 2.0
Description contains | Substring 'Unsafecontrol exception (GetTypeFromGuid)'
Error | OWSTimer and STSWel error
Provider Name | Application
Provider Type | Windows NT Event Log
Event Number | 1000
Event Type | Error
Source Name | Windows SharePoint Services 2.0
Description contains | Substring ‘owstimer.exe’
Error | W3WP error
Provider Name | Application
Provider Type | Windows NT Event Log
Event Number | 1000
Event Type | Error
Source Name | Windows SharePoint Services 2.0
Description contains | Substring ‘w3wp.exe’

Active Directory Events

The following three events are related to Active Directory account creation, deletion, and updating. Immediate action should be taken when an error is received.

Event | Cannot add user to Active Directory
Event Type | Information
Event Source | Windows SharePoint Services 2.0
Event Category | None
Event ID | 1000
Description | #1966150: Adding user <username> to OU <active directory OU> in domain <domain name> FAILED with HRESULT <error code from AD handler>
Event | Cannot delete user from Active Directory
Event Type | Information
Event Source | Windows SharePoint Services 2.0
Event Category | None
Event ID | 1000
Description | #1966151: Deleting user %user% from OU %OU% in domain %DOMAIN% FAILED with HRESULT %HR%
Event | Cannot update user in Active Directory
Event Type | Information
Event Source | Windows SharePoint Services 2.0
Event Category | None
Event ID | 1000
Description | #1966152: Updating user %user% from OU %OU% in domain %DOMAIN% FAILED with HRESULT %HR%

Virus Scanner Events

If a virus scanner is installed to the front-end Web servers, the following events may be logged in certain scenarios.

Event | Virus checking, loading virus scanner
Event Type | Information
Event Source | Windows SharePoint Services 2.0
Event Category | None
Event ID | 1000
Description | #96000f: Loading antivirus scanner...
Event | Virus checking, cannot load virus scanner
Event Type | Information
Event Source | Windows SharePoint Services 2.0
Event Category | None
Event ID | 1000
Description | #960010: Finished loading antivirus scanner. No scanner installed.

HTML Transformation Events

HTML transformation server is an optional component for a server farm running Windows SharePoint Services. An HTML transformation server runs an HTML viewer service such as Microsoft Office 2003 HTML Viewer. If an HTML transformation server is configured, the events in this category should be configured and monitored.

Event | HTML launcher started
Provider Name | Application
Provider Type | Windows NT Event Log
Source Name | Microsoft.Office.HtmlTrans.Launcher
Description contains | substring 'start'
Event | HTML load balancer stopped
Provider Name | Application
Provider Type | Windows NT Event Log
Event Number | 0
Source Name | Microsoft.Office.HtmlTrans.LoadBalancer
Description contains | Substring 'stop'
Event | HTML launcher1 stopped
Provider Name | Application
Provider Type | Windows NT Event Log
Event Number | 0
Source Name | Microsoft.Office.HtmlTrans.Launcher
Description contains | Substring 'stop'
Event | HTML load balancer 1 started
Provider Name | Application
Provider Type | Windows NT Event Log
Event Number | 0
Source Name | Microsoft.Office.HtmlTrans.LoadBalancer
Description contains | Substring 'start'
Event | HTML transformation server CPU usage
Provider Name | Processor - % Processor Time-_Total-3.0-minutes
Provider Type | Windows NT Performance Counter

Baseline Server Events

To make sure your servers are available to your users, you must monitor baseline server events, such as events for NetLogon, Internet Information Server (IIS), Microsoft SQL Server, and so on. The following events and System Monitor counters help you track the status of your servers.

Server Type | Event or Perfmon Counter
Front-end Web server | IIS stop and start times
Front-end Web server | NetLogon Service stop and start times
Front-end Web server | WSS Service stop and start times
Front-end Web server | Web Service: Connection Attempts/second > 500/second
Active Directory server | Events from the standard Microsoft Operations Manager (MOM) pack for Active Directory
Back-end database server | Events from the standard Microsoft Operations Manager (MOM) pack for SQL Server
All servers | Server login successes and failures
All servers | Memory: % Committed Bytes in Use > 80%
All servers | Memory: Available Mbytes < 50MB
All servers | Processor: % Processor Time: _Total (CPU Utilization) > 80%
All servers | Current Connections - Error 2000
All servers | Disk usage <10%
All servers | System: Processor Queue Length > 10
All servers | Memory Pages/second >220

You can also create a script to ping each front-end Web server to make sure that each port is responding, including the SharePoint Central Administration port. You can use the MOM scripts to create a URL monitoring rule and script to do this automatically. Note that the monitoring accounts must be able to access each port to be able to ping them.

If you want to understand the system load and service usage status for each server, you can also monitor the following System Monitor counters.

Server Type | Perfmon Counter
Front-end Web server | Process (w3wp)\% Processor Time Process (w3wp)\Private Bytes
Front-end Web server | Process (w3wp)\Working Set Process (w3wp)\Handle Count
Front-end Web server | .NET CLR Memory\# Bytes in All Heaps
Front-end Web server | .NET CLR Memory\Large Object Heap Size
Front-end Web server | .NET CLR Memory\% Time in GC
Front-end Web server | ASP.NET\Worker Process Restarts
Back-end database server | Process(sqlservr)\% Processor Time
Back-end database server | Process(sqlservr)\Working Set
Back-end database server | SQLServer:General Statistics\User Connections
Back-end database server | SQLServer:Locks\Number of Deadlocks/sec
Back-end database server | SQLServer:Locks\Lock Waits/sec
Back-end database server | SQLServer:Locks\Lock Wait Time (ms)
Back-end database server | SQLServer:SQL Statistics\Batch Requests/sec


Customizing a Web Site Based on Windows SharePoint Services

Customizing a Web Site Based on Windows SharePoint Services

Web sites based on Microsoft Windows SharePoint Services are designed to be flexible. You can tailor a site to fit your users' needs by adding or removing pages, changing the appearance of pages, changing the site navigation, and making other customizations. To customize Web sites based on Windows SharePoint Services, you must have the following rights, all of which are included in the Web Designer and Administrator site groups by default:

  • Manage Lists
  • Add and Customize Pages
  • Apply Themes and Borders
  • Apply Style Sheets

Other users of your site cannot gain access to the pages required to perform these tasks unless you specifically assign them to a site group that contains these permissions. For more information about controlling permissions and assigning rights and site groups, see "Managing Site Groups and Permissions" in the Windows SharePoint Services Administrator's Guide.

Customizing Web Sites in the Browser

Basic customization can be done from within the browser, using links from the Home, Create, and Site Settings pages of the Web site. From the browser you can perform basic customizations such as the following:

  • Add a list.
  • Change the layout of the home page.
  • Change the picture on the home page.
  • Add a Web Part to a Web Part Page.
  • Change a site's display name (not the URL).
  • Apply a theme.

The Windows SharePoint Services Help files contain more information about customizing Web sites from within the browser.

Customizing Web Sites by Using Web Page Editing Tools

Additional customization can be done by using a Windows SharePoint Services–compatible Web page editor, such as Microsoft Office FrontPage 2003. With a Web page editor you can perform customizations such as the following:

  • Add borders to pages.
  • Insert graphics.
  • Add components to the home page.
  • Change the navigation of a site.

For example, if you have created a custom theme for Windows SharePoint Services sites in Office FrontPage 2003, and added the theme name to the list of themes in Office FrontPage 2003, you can edit the list of available themes in Windows SharePoint Services to include your new theme. An XML template called spthemes.xml contains the theme name, style sheet location, thumbnail, preview, and description of each theme that is available through the browser. This XML file is used to render the theme selection page. You can modify this XML file (by opening it in any editor, such as Notepad) to include a custom theme on the Apply Theme to Web page. You must be a member of the local administrators group for the server to edit this file. For more information about creating a theme and adding it to the list of themes in Office FrontPage 2003, see the Office FrontPage 2003 Help system.

Add a custom theme to the list of available themes
  1. On the top link bar, click Site Settings.
  2. In the Customization section, click Apply theme to site.
  3. In the Address bar on the browser, replace the file name themeweb.aspx with spthemes.xml.

  4. For example, if the Address bar showed http://server_name/_layouts/1033/themeweb.aspx, you would change the path to http://server_name/_layouts/1033/spthemes.xml.

  5. Edit the XML file and add a new section for your custom theme, similar to the following:

    - <Templates>

    <TemplateID>newtemplateid</TemplateID>

    <DisplayName>NewTemplateDisplayName</DisplayName>

    <Description>Description</Description>

    <Thumbnail>../images/image.png</Thumbnail>

    <Preview>../images/image.gif</Preview>

    </Templates>

For more information about customizing Web site elements in a Windows SharePoint Services–compatible Web page editor, see the Help system for the Web page editor.

Customizing Web Sites by Using Administrative Controls

If you are an Administrator, you can customize how Web sites work by performing tasks such as the following:

  • Change settings, such as regional settings.
  • Add, remove, or modify site groups.
  • Add or remove users, or change their site group membership.

You control these features by using the Site Administration pages. Only an administrator of the site can perform these types of customizations, or users who are members of a site group that contains administrative rights, such as the Manage Site Groups right.

Customizing Web Sites Programmatically

You can perform advanced Web development customizations by using the programming model behind Windows SharePoint Services. You can use the programming model to make Web site customizations such as:

  • Add, edit, delete, and retrieve data from SharePoint lists.
  • Create new lists and set list metadata (such as the fields in a list).
  • Work with documents in document libraries.
  • Perform administrative tasks such as creating Web sites, adding users, creating roles, and so on.

For more information about advanced customizations, see the Windows SharePoint Services Software Development Kit.


Customizing Help

Customizing Help

Web sites based on Microsoft Windows SharePoint Services are fully customizable — you can add any type of Web page to the site, and all kinds of interactive content to the pages. To complement this flexibility in the site, the Help system for Windows SharePoint Services was designed to be customizable. So, when you customize the pages available on a Web site, you can also customize the Help available for those pages by adding topics that contain information specific to your organization.

For example, you might want to customize Help when:

  • You change the behavior of a default Web site page and want to explain how users can interact with the modified page.
  • You add a new page to the site with a form that users must fill out and you want to provide assistance for particular fields in the form.
  • You want to explain your organization's Web site policies, processes, or structure to new users of the site.

You must have administrator rights to the server computer to add topics to the Windows SharePoint Services Help system.

Performing Basic Customization of Help

Basic customization of Help consists of adding new Help topics. You can use any level 4 HTML-compatible Web page editor, such as Microsoft Office FrontPage 2003, to create topics. When you add a topic, be sure to edit the table of contents topic to include the new file, and also create a hyperlink in the index topic to link to important terms in the new topic.

Help for Windows SharePoint Services is stored as HTML and image files in the file system of the server computer. These files are stored per server, so when you add a Help topic, it is available for all users of that server. The following table lists and describes the contents of the folders used to store Help content on a server.

Folder | Contains
\_vti_bin\help\lcid\sts | All Help topic files. LCID stands for the locale ID. For example, U.S. English Help topics are stored in \_vti_bin\help\1033\.
\_vti_bin\help\lcid\sts\html\ | Localized HTML, cascading style sheets, and JavaScript files used in the Help topics.
\_vti_bin\help\lcid\sts\images\ | Localized images used in the Help topics.
About the Windows SharePoint Services Help Folder and Security

Because the Windows SharePoint Services Help topics take advantage of JScript coding to control some Help features, the \_vti_bin\help\lcid\sts\ folder that contains the Windows SharePoint Services Help files grants Read and Read and Execute permissions to the Everyone group. Be sure to tightly control access to this folder, and any of the other Windows SharePoint Services installation folders. Because of the Read and Execute permission, a user with Write permissions to this folder could potentially add malicious scripting to files in the folder, which would then be allowed to run.

Customizing Special Help Files

The Help system for Windows SharePoint Services consists of Help topic files plus special files such as the table of contents, index, glossary, and other files. When you add custom content to the Help system, consider updating these special files as well to contain references to your new content.

Finding Specific Help Files

You can easily find topics in the Help system by browsing through the table of contents. After you identify the topic you want, you can turn on the Address bar for the Help window (in Microsoft Internet Explorer, on the View menu, click Toolbars, and then click Address Bar), and then make a note of the file name. Alternatively, you can use Microsoft Windows search feature to search through the _vti_bin\lcid\sts\html folder to find a particular sentence or phrase in Help.

Performing Advanced Customization of Help

You can also perform more advanced customization of the Help system. For example, each default page has one or more unique Help topics associated with it. These associations are maintained in an XML file called sts.xml. By editing this file, you can make your custom Help topics appear in the list of context-sensitive topics for a particular page in your Web site. For more information about advanced customization of Help, see the Windows SharePoint Services Software Development Kit.

Preserving Customized Help When Installing Service Packs

Windows SharePoint Services service packs often contain updated Help files. If you customize a default Help topic, and then apply a service pack, your customized version of the Help file can be overwritten. Because service packs update default Help topics, it is not recommended that you customize the default Help topics, aside from the table of contents and index files. New topics that you add to the Help system are not overwritten by service packs, unless you use the same file names as existing or new topics.

If you are customizing the Help system extensively, be sure to back up your customized topics before applying a service pack, so that you can restore your customizations after the service pack has been installed.


Configuring Discussion Boards

Configuring Discussion Boards

Discussion boards provide forums for site participants to converse about topics. Most Microsoft Windows SharePoint Services site templates include the ability to create discussion boards, and many sites and workspace sites have a built-in discussion board called General Discussion. As a server administrator, you can set the number of characters of text displayed in an expanded discussion item, control how long the "!New" tag is displayed for a discussion entry, and change the display order of discussion items.

Display More than 400 Characters of Discussion Text

Threaded view limits the number of characters of text displayed in an expanded discussion item to 400. To configure Windows SharePoint Services to exceed this limit in all discussion boards on the server, you must edit the file onet.xml and then reprovision the site. (Reprovisioning a site means reapplying Windows SharePoint Services to a virtual server.)

Note To complete this task you must be a member of the local Administrator group on the server computer.

Warning Making changes to an originally installed onet.xml file on a server running Windows SharePoint Services is not supported and can break existing sites. Changes to onet.xml will be overwritten if you reinstall or upgrade Windows SharePoint Services.

Edit the onet.xml file

  1. Using Notepad or another XML editor, open the file onet.xml, which is in the folder C:\Program Files\Common Files\Microsoft Shared\Web server Extensions\60\Template\1033\STS\XML by default.
  2. Edit each instance of the following string, replacing “400” with the number of characters to display:

    Limit Len=400

    Note Windows SharePoint Services will exceed the limit you specify to avoid displaying an incomplete word.

  3. Save the file onet.xml.

Reprovision the site

  1. On the server, click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. Click the Web site you are reprovisioning.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Remove Windows SharePoint Services from Virtual Server.
  5. On the Remove Windows SharePoint Services from Virtual Server page, select Remove without deleting content databases, and click OK.
  6. From the Central Administration home page, click Extend or upgrade virtual server.
  7. Click the Web site to provision.
  8. Click Extend and map to existing virtual server.
  9. In the Application Pool section, click Use an Existing App Pool click the application pool associated with the virtual server (STSAPPOOL1 in the default Windows SharePoint Services installation), and click OK.

Change the Expiration Date of the "!NEW" Tag

Because discussion boards can be heavily used, new items, and their accompanying "!New" tags, can proliferate. Site designers may find this annoying, and they may want to shorten the number of days that these tags are displayed. The following steps configure Windows SharePoint Services to stop showing "!New" tags in less than the default two days. This will change the expiration time for all "!New" tags in lists on the server. Setting the time to zero will disable the "!New" tag completely. This setting will affect all lists and libraries on the server, not just the discussion boards.

This procedure uses the SharePoint administration utility stsadm.exe, which is available, by default, in the Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\Bin folder on your server computer.

Note To use the stsadm.exe utility, you must be a member of the local Administrators group on the server or a member of the SharePoint administrators group.

  • Run stsadm.exe by using the following syntax, where Number_Of_Days is the number of days that Windows SharePoint Services should display the "!New" tag:

    stsadm -o setproperty -pn days-to-show-new-icon -pv Number_Of_Days -url http://Server_Address

The following example sets the expiration time to one day:

stsadm -o setproperty -pn days-to-show-new-icon -pv 1 -url http://MyServer

Change the Discussion Board Display Order

Discussion board entries are displayed either from oldest entry to newest or from newest to oldest. You can change the order in which items are displayed by editing the Schema.xml file for the discussion board. To edit the file Schema.xml, you must be a member of the local Administrators group on the server.

  1. Using Notepad or another XML editor, open the file Schema.xml (in the folder C:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\Template\1033\STS\Lists\Discuss by default).
  2. Locate the following code in Schema.xml:

  <OrderBy>
  <FieldRef Name="ThreadID" Ascending="FALSE" />
  <FieldRef Name="Ordering" />
  </OrderBy>

    Alternately, the Ascending attribute could be set to the value "True":

  <OrderBy>
  <FieldRef Name="ThreadID" Ascending="TRUE" />
  <FieldRef Name="Ordering" />
  </OrderBy>

  3. To display threaded discussion lists on the virtual server in oldest to newest order, make sure that the Ascending attribute is set to the value "TRUE" To display newest items first, set the Ascending attribute to "FALSE".
  4. Save and close the file Schema.xml.
  5. After you modify the file Schema.xml, you must restart Internet Information Services (IIS) to have the changes take effect. To restart IIS, type iisreset on the command line.


Extending Windows SharePoint Services

Extending Windows SharePoint Services

Microsoft Windows SharePoint Services is a technology that was designed to be extended and used with other products. Several products from Microsoft and other software vendors use Windows SharePoint Services as an extensible platform. These products build additional features that work with Windows SharePoint Services or customize existing features to meet the users' needs. This extension and customization can be as simple as editing an XML template file or providing special Web Parts that can be used on Web Part Pages, or as complex as creating entire products that build on the Windows SharePoint Services functionality. Other products may also provide administrative or user tools that interact with Windows SharePoint Services, or may link their document editing applications into Windows SharePoint Services to allow users to edit documents directly from the site.

If you have installed Windows SharePoint Services as part of another product, be sure to read the administrative documentation for that product to find out what additional features you have that are not covered in the Windows SharePoint Services Administrator's Guide.

If you are interested in building features for Windows SharePoint Services to work with your product, you can find information about building Web Parts, connecting to Windows SharePoint Services, and customizing Windows SharePoint Services features and templates files in the Windows SharePoint Services Software Development Kit.

Related Topics

For more information about creating or customizing templates, see "Working with Templates" in the Windows SharePoint Services Administrator's Guide.

For more information about distributing Web Parts, see Managing Web Parts on Virtual Servers.


Binding to a Document Library Event Handler

Binding to a Document Library Event Handler

Microsoft Windows SharePoint Services includes changes that allow you to bind an event handler to a document library. With this feature, you can use document library events to start other processes, such as workflow processes. You can develop managed code that takes advantage of document library events and create an application based on Windows SharePoint Services to perform whatever actions you need. When you combine document libraries, your own event-handling managed code, and possibly XML forms, you can create complex workflow processes that are easy for users to work with.

For example, in the healthcare industry, when a new patient is admitted to a hospital, there is a lot of paperwork that needs to be generated, and it needs to be done in a specific order. You can write an application that interacts with XML forms in a document library to do such things as:

  • Track when a new admissions form is added to the document library.
  • Extract the insurance information and forward it to the billing application.
  • Notify the staff in the appropriate section of the hospital to pull the patient's chart.

Tracking Events in Document Libraries

The following events can be tracked for document libraries.

Event | Description
Insert | A new document is added to the document library.
Update | An existing document is edited.
Delete | An existing document is deleted.
Move | A document is moved or renamed.
Copy | A document or folder is copied.
Check In | A document is checked in.
Check Out | A document is checked out.
Cancel Check-Out | Changes made to a checked out document are undone.

For more information about writing managed code to interact with document library events, see the Microsoft Windows SharePoint Services Software Development Kit.

Enabling Document Library Events

If you want to allow developers in your organization to use the document library events to write code, you must enable this feature at the virtual server level.

Enable document library events for a virtual server
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. Under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, click the name of the virtual server you want to configure.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Virtual server general settings.
  5. On the Virtual Server General Settings page, in the Event Handlers section, next to Event handlers are, select On.
  6. Click OK.

After the feature is enabled, you can write code to handle the events, and then specify the code to use for a particular document library in the document library settings.

Enable document library events for a specific document library
  1. On the appropriate Web site, navigate to the document library you want to monitor.
  2. Under Actions, click Modify columns and settings.
  3. Under General Settings, click Change advanced settings.
  4. In the Event Handler section, in the Assembly name box, type the strong name of the assembly containing the event handler class.
  5. In the Class Name box, type the full class name for the event handler.

    Note The Class Name value is case sensitive.

  6. In the Properties box, list any appropriate properties for the event handler.
  7. Click OK.

Note Be aware that event settings are preserved when a document library is saved as a list template. For more information about templates, see "Working with Templates" in the Windows SharePoint Services Administrator's Guide.


Working with Templates

Working with Templates

There are methods for providing prepackaged site and list content in Microsoft Windows SharePoint Services:

  • You can build a new site definition. Site definitions include the set of basic pages and schema from which all SharePoint sites and lists are derived. Site definitions are stored on the file system of each front-end Web server as Web pages and XML files.
  • You can save an existing site or list as a custom template. Custom templates are a way of packaging up a set of changes to an existing site definition and making those available for new sites and lists. Every custom template is based on a site definition. Custom templates are stored in the database and made available through the central or site collection template galleries.

Each method can package up either an entire site or just one list. The site creation template picker page shows both site definitions and sites saved as custom site templates. The Create page shows lists defined in the site definition, and lists saved as custom list templates.

Working with Site Definitions

When you install Windows SharePoint Services on a Web server computer, the default set of site definitions is also installed. Every site definition is stored in a folder on the file system of each front-end Web server and includes at minimum an Onet.xml file. Administrators of the server computer can create custom versions of the default set of site definitions. To create a custom version of a site definition, it is recommended that you create a new site definition, rather than editing the existing site definition files. If you edit the default site definition files, and then upgrade to a later version of Windows SharePoint Services, you will lose your customizations, and any sites based on the site definitions can potentially be broken. For more information about creating custom site definitions, see the Windows SharePoint Services Software Development Kit.

You can also mark a site definition as hidden, so it does not appear in the list of site types that users can create. For example, if you have a customized version of the Team Site template that you want users to base their sites on, rather than the default version, you can hide the default version of the Team Site template.

To mark a site definition as hidden, you modify the hidden parameter in the Webtemp.xml file. The Webtemp.xml file lists all of the site definitions available for the server, and is stored on the server computer at \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\Template\LCID\XML, where LCID is a locale ID, such as 1033 for U.S. English. You can open the Webtemp.xml file in any XML editor, such as Notepad. To hide a particular template, locate the section for that template in the Webtemp.xml file, and then set the hidden parameter to true. Set hidden to false to unhide the template.

For more information about working with site definitions, see the Windows SharePoint Services Software Development Kit.

Working with Custom Templates

You can create custom site or list templates for your users. To create a custom template, you save an existing site or list as a site or list template. You can add custom site templates to the central template gallery or the site collection template galleries, and you can add custom list templates to the site collection template gallery. When you save a site or list as a site or list template, it retains an ID that indicates which site definition the template is based on.

Caution Template files include personal information such as server URLs and user account names. Only share template files with trusted users and groups.

About Site Templates

Users can customize a site and save the customized site as a site template, so that other users in the site collection can create similar sites later. Site templates created by another user or software vendor can also be imported to the site collection template gallery.

To create a site template based on a Web site, you must a member of the Administrators site group for the current Web site. To add or import a site template to the site collection gallery, you must have the Add Items right for the site template gallery, which is included by default in the Web Designer and Administrator site groups for the top-level Web site in a site collection.

A site template is a file that includes all of the design information about the site, such as:

  • The lists within a site.
  • Any Web Part Pages within a site.
  • Any custom pages within a site.
  • The theme or borders applied to a site.
  • Any customizations to the Quick Launch bar.
  • Site content (list and document library contents — optional).

Site templates do not include the following items:

  • Security settings, such as a list of users or groups with permissions to the site from which the template was created.
  • Personalizations to Web Part Pages.
  • Web discussions from the original site.
  • Alerts from the original site.
  • Web Part assemblies that were added to the original site.

Site templates are stored as files with the .stp extension.

Using Site Templates

Users can create subsites based on templates available on the server or on the site collection. When a user creates a top-level Web site, he or she can base the site on a site template from either of the following sources:

  • The site definitions available on the server
  • Custom site templates in the central template gallery

When a user creates a new subsite, he or she can choose from the combined list of templates from the following sources:

  • The site definitions available on the server
  • Custom site templates in the central template gallery
  • Custom site templates in the site collection template gallery

When the user creates a subsite, he or she chooses a template from templates available on the Template Selection page. This page shows all templates available on the server and site collection, filtered by the language that was selected on the Create Site page. The new subsite is based on the template, but can be customized and changed, just like any other site.

About List Templates

When a user creates a new list, he or she selects a list template to use in creating the list. Windows SharePoint Services includes many list templates by default, and users can customize an existing list and save the customized list as a new list template. List templates created by other users or software vendors can also be imported to the site collection template gallery.

You must have the Manage Lists right to create a list template. The Manage Lists right is included in the Web Designer and Administrator site groups by default. To add or import a list template to the site collection gallery, you must have the Add Item right for the list template gallery, which is included by default in the Web Designer and Administrator site groups for the top-level Web site in a site collection.

A list template is a file that includes all of the design information about the list, such as:

  • The columns and fields in the list.
  • Any views created for the list.
  • List content (optional).

List templates do not include:

  • Security settings, such as a list of users or groups with permissions to the list from which the template was created.
  • Lookup field links. Although lists can contain lookup fields that reference data in another list, that other list (and its data) is not included when you save a list template.

List templates are stored as files with the .stp extension.

Using List Templates

Users can create lists based on templates available on the server or on the site collection. To create a list based on a template, the user can go to the Create page in a site, and then click the list name to create. Custom list templates are listed on the Create page alongside the default set of list templates from the site definitions.

Note When a user creates a list, he or she can select a list template from the set of list templates on the server and the site collection. This set is filtered based on the site language and the site definition ID that your site is based on. For example, a site based on the Meeting Workspace template has a different site definition ID from a site based on the Team Site template. If you create a Meeting Announcements custom list template from the Announcements list in a site based on a Meeting Workspace template, that template is not available from within a site based on the Team Site template.

Creating Templates

Members of the Administrator site group for a site can create a template based on that site.

Create a site template
  1. On the site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Management and Statistics, click Save site as template.
  4. In the File name box, type the filename to use for the site template file.
  5. In the Template title box, type the title you want to use for the template in the site template gallery.
  6. In the Template description box, type a description for the site template.
  7. If you want to include the existing site content, select the Include content check box.
  8. Click OK.

You must be a member of the Web Designer or Administrator site group to be able to create a list template.

Create a list template
  1. Navigate to the list you want to save as a template.
  2. Under Actions, click Modify settings and columns.
  3. On the Customize <List Name> page, under General Settings, click Save list as template.
  4. In the File name box, type the filename to use for the template file.
  5. In the Template title box, type the title you want to use for the template in the list template gallery.
  6. In the Template description box, type a description for the template.
  7. If you want to include the existing content, select the Include content check box.
  8. Click OK.

Managing the Site Template Gallery

Site templates are added or removed from the site template gallery at the site collection level. You must go to the Site Administration page for the top-level Web site in a site collection to manage the site template gallery.

When a user creates a site template, it is automatically added to the site template gallery for the site collection. If you want to import a site template from an .stp file, you can do so from the Manage Site Template Gallery page.

Add a template to the site template gallery
  1. On the top-level Web site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Site Collection Galleries, click Manage site template gallery.
  4. On the Site Template Gallery page, click Upload Template.
  5. In the Name box, type the path to the template, or click Browse.

    You can upload multiple templates by clicking Upload Multiple Files.

  6. Click Save and Close.
Delete a template in the site template gallery
  1. On the top-level Web site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Site Collection Galleries, click Manage site template gallery.
  4. On the Site Template Gallery page, click the Edit icon next to the template name.
  5. On the Site Template Gallery: <Name> page, click Delete.

Managing the List Template Gallery

List templates are managed at the site collection level. You must be an administrator of the top-level Web site in a site collection to manage the list template gallery.

When a user creates a list template, it is automatically added to the list template gallery for the site collection. If you want to import a list template from an .stp file, you can do so from the Manage List Template Gallery page.

Add a template to the list template gallery
  1. On the top-level Web site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Site Collection Galleries, click Manage list template gallery.
  4. On the List Template Gallery page, click Upload Template.
  5. In the Name box, type the path to the template, or click Browse.

    You can upload multiple templates by clicking Upload Multiple Files.

  6. Click Save and Close.
Delete a template in the list template gallery
  1. On the top-level Web site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Site Collection Galleries, click Manage list template gallery.
  4. On the List Template Gallery page, click the Edit icon next to the template name.
  5. On the List Template Gallery: <Name> page, click Delete.

Managing the Central Template Gallery

There is a centralized store of site templates called the central template gallery. This gallery is managed for your entire server or server farm, and can only be managed by using the command-line tool, Stsadm.exe. You must be a member of the local administrators group for the server computer to manage the central template gallery.

You use the following operations to manage the central template gallery.

Operation | Description
addtemplate | Adds a template to the central template gallery.
deletetemplate | Removes a template from the central template gallery.
enumtemplates | Lists the templates currently in the central template gallery.

The addtemplate operation takes the required filename and title parameters and the optional description parameter. To add a template, you would use the following syntax:

stsadm.exe -o addtemplate -filename <filename> -title <template title> -description <description of the template>

The deletetemplate operation takes the required title parameter and the optional lcid parameter. To delete a template from the central template gallery, you would use the following syntax:

stsadm.exe -o deletetemplate -title <template title> -lcid <language>

Note After you add or delete a template from the central template gallery, you need to restart the Web service in Internet Information Services (IIS). You can restart all of IIS at once by running iisreset on the command line, or just restart the specific Web sites in Internet Information Services (IIS) Manager. If you are in a server farm environment, you must restart the Web services for each front-end Web server in your server farm.

The enumtemplates operation takes the optional lcid parameter. To list all templates in the central template gallery, you would use the following syntax:

stsadm.exe -o enumtemplates

To list only templates for a specific language, you would use the following syntax:

stsadm.exe -o enumtemplates -lcid <language>

For more information about command-line parameters, see Command-Line Parameters. For a list of valid locale IDs (LCIDs), see Regional and Language Settings.

Using Site Templates from the Central Template Gallery

Users can create sites based on templates available in the central template gallery by using the same method as is used for any other site template. When the user creates a site, he or she chooses a template from templates available on the Template Selection page.

Administrators can also create sites based on the site templates available in the server template gallery. To create a site based on a template in the central template gallery, the administrator must use the createsite or createweb operation on the command line, and specify the template name as _GLOBAL_#number, where number refers to the template ID. For example, if you have a site template in the central template gallery with the ID 2, you could use the following syntax to create a site based on that template:

stsadm.exe -o createsite -url <url> -ownerlogin <DOMAIN\username>
-owneremail <someone@example.com> -sitetemplate _GLOBAL_#2

Note To find the template ID for a global template, you can use the enumtemplates operation.

Sharing Templates

You can share list and site templates with users outside of your site collection by giving them a copy of the .stp template file. You can give them a copy of the template file, just like any other file, by sending it in an e-mail message, posting it to a network share or Web site, or making a copy on a disk.

If the users are members of the Administrator or Web Designer site groups for their sites, they have the Add Item right for the site and list template galleries, and can add the site or list template to their site or list template gallery, and start using it.

To create a copy of a template, you must perform the following steps:

  1. Create the template.
  2. Navigate to the template gallery (whether site or list), right-click the file, and then click Save As to save the file to a network share or your local computer.


Using the SDK to Perform Advanced Customization

Using the SDK to Perform Advanced Customization

The Microsoft Windows SharePoint Services Software Development Kit is a great resource for learning to customize Web sites programmatically. Using the information and examples in the Software Development Kit (SDK), you can:

  • Customize sites, including layouts, navigation bars, themes, and lists.

    Most site-level customization, such as page layouts, themes, and custom lists, can also be performed by using a Web page editor compatible with Windows SharePoint Services, such as Microsoft Office FrontPage 2003. However, if you want to perform identical customizations across sites, it is much easier and quicker to do so programmatically.

  • Create custom templates.

    Although you can create list and site templates from within the Web browser, you can create more complex templates (for example, templates that link to databases) or edit the front-end templates by using information from the SDK.

  • Create custom Web Parts.

    Although you can easily customize instances of Web Parts from within the Web browser, to create a new Web Part assembly (.dll) to support a custom class of Web Parts, you need the information in the SDK.

  • Connect an application to Microsoft Windows SharePoint Services.

    For example, if you want to use Windows SharePoint Services as a front-end to another application (such as a workflow application), you can learn how to connect by reading the SDK.

This is just a short list of some of the tasks you can perform by using information from the SDK. The SDK also contains information about other customization tasks and programmatically administering sites and servers. For more information about any of these tasks, see the Windows SharePoint Services Software Development Kit.


Using the Object Model to Manage Windows SharePoint Services

Using the Object Model to Manage Windows SharePoint Services

You can use the object model for Microsoft Windows SharePoint Services to manage your servers, sites, users, and other resources. To access the administrative object model for Windows SharePoint Services, you must be an administrator of the local server computer or a member of the SharePoint administrators group.

If you are using a Web application (such as a billing application) to access the object model and perform administrative functions, you must be sure that the Web application is running in the same security context as Windows SharePoint Services. In other words, the Internet Information Services (IIS) application pool for the Web application must allow access to the SharePoint administrators group, or you must include the application pool account in the SharePoint administrators group, or the application pool must be the same application pool as is used for SharePoint Central Administration.

If you are relying on the SharePoint administrators group for the security context, keep in mind that there are some actions that that group cannot perform. The following actions must be performed by a member of the local administrators group for the server computer:

  • Extending virtual servers or removing Windows SharePoint Services from a virtual server
  • Changing the configuration database settings
  • Changing the SharePoint administrators group
  • Managing paths

If you want to perform these tasks from a custom application that calls the administrative object model directly, the application must be running as a member of the local administrator group.

Administrative Object Model Scenarios

There are many times when it would be useful to use the object model to perform administrative tasks for Windows SharePoint Services, rather than using the command line tool or HTML Administration pages. For example, you would use the object model when:

  • You are using Windows SharePoint Services in Active Directory account creation mode.

    Active Directory account creation mode allows you to automatically create accounts for users in the Active Directory directory service, rather than using pre-existing domain accounts. When you are in this mode, there are certain administrative tasks that are unavailable in the HTML Administration pages. For example, you cannot create a top-level Web site, you cannot enable Self-Service Site Creation, and you cannot add a user to a site from the Central Administration pages. To perform these actions in Active Directory account creation mode, you must use the object model or the command line. For more information about Active Directory account creation mode, see Managing Users and Cross-Site Groups.

  • You have a custom administrative application that you use to manage servers in your server farm, rather than using SharePoint Central Administration.

    If your environment is very complex, and your organization uses a special administrative application to manage servers, you can use the object model to call the Windows SharePoint Services administrative functions, rather than using the HTML Administration pages or the command line.

  • You have a Web application that needs to call into Windows SharePoint Services to perform a specific set of administrative tasks.

    For example, if you have an application that coordinates online meetings, and you want to create Meeting Workspaces in Windows SharePoint Services automatically, you can use the object model to do so.

  • You want to generate administrative reports to track sites, usage, or other data.

    You can use the object model to enumerate the sites owned by particular users, find out how many users or how many files are being added to sites, or determine trends and perform capacity planning to decide when it is time to add another server to your server farm.

  • You want to make site creation conditional based on billing information or generate custom pages based on billing information.

    For example, you can use a billing application to verify billing information before a user can create a site. Or, you can use contact or billing information to generate a custom page that shows which sites belong to which site owners.

  • You want to make site access conditional based on billing or employment status.

    You can use the quota mechanisms to automatically lock a site if a customer or group is not current in its billing, and only allow access when the billing charges are rationalized. Or if a user is no longer part of your organization, you can lock all sites owned by that user until you determine what to do with the sites. For more information about quotas and locking sites, see Configuring Site Quotas and Locks.

For more information about the administrative object model and using it to perform administrative tasks, see the Windows SharePoint Services Software Development Kit.


Troubleshooting Installation Issues

Troubleshooting Installation Issues

More troubleshooing information is available on the Web.

Cannot Connect to the Configuration Database Message

  • I get a "cannot connect to the configuration database" message when I try to set the configuration database for Microsoft Windows SharePoint Services.

    If the password associated with the account used to connect to Microsoft SQL Server has expired or changed, you will see a "cannot connect to the configuration database" message until you reset the password in SQL Server. For more information about changing passwords in SQL Server, see Help in SQL Server Enterprise Manager.

    Note You may also see a "service unavailable" message if the password for an Internet Information Services (IIS) application pool identity has changed or expired. For more information about changing passwords for application pool identities, see "Service Unavailable Message" in Troubleshooting Other Issues.

    This message may also appear if Internet Information Services (IIS) is running in IIS 5.0 compatibility mode. Windows SharePoint Services requires IIS 6.0 to be running in IIS 6.0 worker process isolation mode. To change to IIS 6.0 worker process isolation mode, in Internet Information Services (IIS) Manager, right-click Web Sites and then click Properties. On the Service tab, clear the Run WWW service in IIS 5.0 isolation mode check box.

Extending a Virtual Server

  • I installed Windows SharePoint Services, but I can't extend a virtual server.

    Is your file system formatted with FAT instead of NTFS? If you installed Windows SharePoint Services to a disk drive formatted with the FAT file system, your default virtual server might not be extended. On the Microsoft Windows platform, the security features of Windows SharePoint Services require the NTFS file system. For more information, see Hardware and Software Requirements.

    Does the virtual server exist in Internet Information Services? Before you can extend a new virtual server with Windows SharePoint Services, you must create the virtual server by using the Internet Information Services (IIS) Manager. For more information, see Extending Virtual Servers.

  • When I extended a virtual server, I created a new application pool, but entered an account that is used for an existing application pool. I got a message that I need to restart IIS, or I cannot access my virtual server.

    If you attempt to reuse an existing IIS application pool account (that is not currently used for a virtual server running Windows SharePoint Services), you must restart IIS before you can access the virtual server.

    Caution Reusing an account from a non-Windows SharePoint Services application pool is not secure, and is not recommended. You can reuse an application pool account that is already being used for Windows SharePoint Services or that was previously used for Windows SharePoint Services.

    To restart IIS, on the command line, type iisreset.

  • When I try to extend a virtual server, I get an error message that FrontPage Server Extensions or SharePoint Team Services v1.0 from Microsoft is installed on the default virtual server.

    You must remove FrontPage Server Extensions or SharePoint Team Services v1.0 before you can extend the default virtual server. You can extend a different virtual server if you want to continue running FrontPage Server Extensions or SharePoint Team Services v1.0. For more information about upgrading to Windows SharePoint Services, see Upgrade Considerations. For information about migrating site content from FrontPage Server Extensions or SharePoint Team Services v1.0 to Windows SharePoint Services, see Migrating and Upgrading Web Sites.

    Remove FrontPage 2002 Server Extensions from a virtual server
    1. Click Start, point to All Programs, point to Administrative Tools, and then click Microsoft SharePoint Administrator.
    2. In the list of virtual servers, next to the virtual server name, click Administration.
    3. On the Virtual Server Administration page, click Uninstall FrontPage 2002 Server Extensions.
    4. On the Uninstall FrontPage 2002 Server Extensions page, next to Full Uninstall, click Yes.
    5. Click Uninstall.

    After you remove FrontPage 2002 Server Extensions, you must restart IIS by running iisreset on the command line before you can try extending the virtual server again.

    Note If you have already uninstalled FrontPage Server Extensions or SharePoint Team Services v1.0 from the default virtual server, but you still see this message, you may need to delete the _vti_pvt\service.cnf file manually. This file is in the content folder for the virtual server (usually c:\inetpub\wwwroot). _vti_pvt is a hidden folder, so you must unhide it before you can locate and delete the service.cnf file.

  • When I try to extend a virtual server, I get a message that the request timed out.

    If the request to extend a virtual server times out, you can try the following workarounds:

    1. Check to see whether full-text searching is enabled for your server or server farm. If it is enabled, turn it off, and then extend the virtual server. After the virtual server is extended, you can enable full-text searching again. For more information about configuring full-text searching, see Managing and Customizing Search.
    2. Change the timeout length for the process. To change the timeout length, you must edit the web.config file for the administration virtual server. This file is in the Windows SharePoint Services installation folder, at \Program Files\Common Files\Microsoft Shared\Web Server Extensions\60\template\admin\LCID, where LCID is the locale ID, such as 1033 for U.S. English. Add the following to the web.config file in the <system.web> section: <httpRuntime executionTimeout="999999"/>. After you edit the web.config file, you must reset IIS by running iisreset on the command line.

  • I extended a new virtual server, and the usage analysis processing is not working for the new virtual server.

    If usage analysis processing was configured before you extended the virtual server, it must be enabled manually for the new virtual server. For more information, see Usage Analysis in Troubleshooting Other Issues.

Installing on Windows Server 2003, Web Edition

  • I am installing on Microsoft Windows Server 2003, Web Edition, and the installation ends without installing Windows SharePoint Services or extending a virtual server.

    You must use the remotesql=yes property to install Windows SharePoint Services on Windows Server 2003, Web Edition. For more information about installing Windows SharePoint Services to work with Microsoft SQL Server 2000, see Remote SQL Server Deployment.

Page Cannot Be Found Message

  • After I have installed Windows SharePoint Services, I get a "page cannot be found" message when the SharePoint Central Administration page tries to open.

    Windows SharePoint Services requires ASP.NET to run. If you already had an instance of ASP.NET running when you installed Windows SharePoint Services, it is possible that you now have two ASP.NET installations on the same server. In this case, the new installation of ASP.NET may be prohibited in IIS. You must enable the new instance of ASP.NET before the SharePoint Central Administration pages can run. To enable the new instance of ASP.NET, in Internet Information Services (IIS) Manager, click Web Service Extensions. In the list of Web Service Extensions, select the new instance of ASP.NET, and then click Allow.

Reusing Application Pools

  • I have an existing application pool that I want to use for a virtual server that I am extending with Windows SharePoint Services.

    If you reuse an existing application pool when you extend a virtual server, the application pool account will not be automatically added to the local IIS_WPG and STS_WPG groups (the application pool groups for Internet Information Services (IIS) and Windows SharePoint Services), and any new sites that you create will not be accessible.

    If the application pool was created when you extended a different virtual server with Windows SharePoint Services, the application pool may already be part of these groups. If, however, the application pool was used for another purpose, and you want to use it with Windows SharePoint Services, you must manually add the application pool account to these groups. For more information about adding an account to a local group, see Help in Windows Server 2003.

Running Windows SharePoint Services on a Domain Controller

  • I installed Windows SharePoint Services to a computer, and then made the computer a domain controller. Now when I go to SharePoint Central Administration or to a page in my SharePoint site, I see a "file not found" error, or an "access denied" error.

    In order for the permissions for Windows SharePoint Services to be configured correctly, Internet Information Services (IIS) and Windows SharePoint Services must be installed to the domain controller after it is promoted to domain controller. If you have already installed IIS and Windows SharePoint Services to a computer, and you now need to make that computer a domain controller, you must uninstall IIS and Windows SharePoint Services, promote the computer to domain controller, and then reinstall IIS and Windows SharePoint Services. For more information about running IIS on a domain controller, see the IIS documentation.

Site Migration Error When Migrating a Site from SharePoint Team Services v1.0

  • I am migrating a site from SharePoint Team Services v1.0 and I get the following message: 1376258 The server administration programs and the server extensions on the Web server are not compatible. The server is too old to use with this administration program.

    Before you can use the Microsoft SharePoint Migration Tool (smigrate.exe) to migrate sites from SharePoint Team Services v1.0 to Windows SharePoint Services, you must verify that you are running the update to SharePoint Team Services v1.0 that updates it to function better with the SharePoint Migration Tool. To download this update, go to Microsoft Office XP Web Services Update.

Typical Installation Ends Without Creating a Site

  • I am installing Windows SharePoint Services on a single server, using the Typical Installation option. When Setup ends, I get an error that the server instance specified was not found.

    If the Default Web Site in IIS is set to a port other than port 80, the Typical Installation for Windows SharePoint Services may end without creating a site. Use the SharePoint Central Administration pages to extend the Default Web Site virtual server and create a Web site manually. For more information, see Extending Virtual Servers.


Troubleshooting Other Issues

Troubleshooting Other Issues

More troubleshooting information is available on the Web.

Cannot Connect to the Configuration Database Message

I get a "cannot connect to the configuration database" message when I try to set the configuration database for Microsoft Windows SharePoint Services.

If you are using SQL Server authentication, and the password associated with the SQL Server system account used to connect to the Microsoft SQL Server databases has expired or changed, you will see a "cannot connect to the configuration database" message until you reset the password in SQL Server. For more information about changing passwords in SQL Server, see Help in SQL Server Enterprise Manager.

You may also see this message if the application pool for the administration virtual server does not have the appropriate rights to the databases in SQL Server. The administration virtual server's application pool account must be a member of the Security Administrators and Database Creators roles for SQL Server, and that account should also be the database owner of the configuration database. The application pool accounts for additional virtual servers must also be database owners for the configuration database, in order to create and manage the content databases for that virtual server.

Verify also that the account for the administration virtual server's application pool is in the both IIS_WPG and STS_WPG local groups. If the account for the application pool is not in these local groups, add the account to these local groups.

Note You may also see a "service unavailable" message if the password for an Internet Information Services (IIS) application pool identity has changed or expired. For more information about changing passwords for application pool identities, see Service Unavailable Message in this topic.

Database Already Exists Message

When I try to manage a content database on the Manage Content Databases page in SharePoint Central Administration, I get one of the following error messages:

  • Database database_name already exists. (Error code: 1801)
  • The current user or the application pool identity of the virtual server is not the owner of the database database_name on server servername\sharepoint.

This issue may occur when the database owner of the database that you are connecting to is different from the application pool identity that Windows SharePoint Services is running under. To resolve this issue, you must change the database ownership and the permissions for the content database to match the identities of the virtual server accounts for content and configuration. The steps for changing the database ownership differ depending on whether you are running SQL Server or Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE).

This issue is also covered by article 828815 in the Microsoft Knowledge Base.

Changing the Database Ownership and Permissions for SQL Server

If you are running Microsoft SQL Server, you can change the ownership and permissions by using SQL Query Analyzer.

Change the database ownership and permissions in SQL Query Analyzer
  1. On the new server, click Start, point to All Programs, point to Microsoft SQL Server, and then click Query Analyzer.
  2. In the Connect to SQL Server dialog box, in the SQL Server box, type the server name, and then click OK.
  3. On the Query menu, click Change Database.
  4. In the Select Database of server_name box, click the configuration database (sts_config), and then click OK.
  5. In the Query pane, type the following query.

    Note In lines 3 and 4, replace domain\contentaccount and domain\adminaccount with the domain account for the content virtual server and the domain account for the SharePoint Central Administration virtual server. If the accounts are the same, SQL Query Analyzer will display an error, but the process will still succeed.

    DECLARE @AdminVSAccount nvarchar(255)
DECLARE @ContentVSAccount nvarchar(255)
SET @ContentVSAccount = N'domain\contentaccount';
SET @AdminVSAccount = N'domain\adminaccount';
EXEC sp_grantlogin @ContentVSAccount;
EXEC sp_grantlogin @AdminVSAccount;
EXEC sp_changedbowner @AdminVSAccount;
IF NOT EXISTS (SELECT * FROM sysusers WHERE name=@ContentVSAccount)
EXEC sp_grantdbaccess @ContentVSAccount;
EXEC sp_addrolemember 'db_owner', @ContentVSAccount;
  6. Click the Execute Query button to update the database.

Changing the Database Ownership and Permissions for WMSDE

If you are running WMSDE, you must perform the following steps: Add the Network Service account to the SYSADMIN role for WMSDE, then use the Manage Content Database page to add the database back to the virtual server, and then remove Network Service from the SYSADMIN role.

Set Network Service as SYSADMIN for WMSDE
  1. Click Start, point to All Programs, point to Accessories, and then click Command Prompt.
  2. At the command prompt, type the following command (where servername is the name of your server) and then press ENTER.

    osql -S servername\sharepoint -E

  3. Type the following command and then press ENTER.

    sp_addsrvrolemember 'nt authority\network service', 'sysadmin'

  4. Type go, and then press ENTER.

After the Network Service account has been added to the SYSADMIN role, you can add the content database to the virtual server.

Add the content database
  1. Click Start, point to All Programs, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, under Virtual Server Configuration, click Configure virtual server settings.
  3. On the Virtual Server List page, click the virtual server you want to add the content database to.
  4. On the Virtual Server Settings page, under Virtual Server Management, click Manage content databases.
  5. On the Manage Content Databases page, under Content Databases, click Add a content database.
  6. In the Database Information section, click Specify database server settings.
  7. In the Database server box, type the name of the database server.
  8. In the Database name box, type the name of the database.
  9. In the Database Capacity Settings section, type a number in the Number of sites before a warning event is generated box.
  10. Type a number in the Maximum number of sites that can be created in this database box.
  11. Click OK.

After the content database has been restored, you can reset the SYSADMIN role to not include the Network Service account.

Restore the SYSADMIN role
  1. At the OSQL command prompt, type the following command and then press ENTER.

    sp_dropsrvrolemember 'nt authority\network service', 'sysadmin'

  2. Type go, and then press ENTER.

General Site Use Issues

  • Site users report that they can't get to a list, document library, discussion board, or survey, yet I can see it listed on the Document Libraries, Discussion Boards, or Lists page.

    The default view may have been deleted. Do one of the following:

    • Set an existing view as the default view.
    • Create a new view to use as the default view.

    Note To specify a default view or create a new view you must be a member of the Web Designer site group or a site group that has the Manage Lists right.

  • I can no longer modify a view by using my Web browser.

    If a view is modified extensively by using a Windows SharePoint Services-compatible Web page editor, such as Microsoft Office FrontPage 2003, it can no longer be modified in the Web browser.

    Note To modify a view you must be a member of the Web Designer site group or a site group that has the Manage Lists right.

  • I can't get custom Active Server Pages to work correctly on my site.

    By default, the ISAPI filter for Windows SharePoint Services blocks the use of any ASP pages that are not part of the Windows SharePoint Services installation. If you want to use custom ASP pages with your SharePoint sites, you must put the ASP pages in a separate virtual directory and create an excluded path for the directory in Windows SharePoint Services. This allows Internet Information Services (IIS), rather than Windows SharePoint Services, to control the directory and allows the ASP pages to run. Also, IIS does not allow ASP pages to be displayed by default. You may also need to allow Active Server Pages in IIS before your custom Active Server Pages work correctly. For more information, see the IIS Help system. Active Server Pages issues are also covered by article 828810 in the Microsoft Knowledge Base.

    Note To perform these steps, you must be a member of the local Administrators group on the server running Windows SharePoint Services.

Full-Text Search Issues

  • Full-text searching does not include any file types other than .doc, .xls, .ppt, .txt, and .htm in the search results.

    If you are using the full-text searching for Microsoft SQL Server 2000, the following filters are installed by default: .doc, .xls, .ppt, .txt, and .htm. You can install custom filters to allow you to search other file types. For more information about enabling full-text searching, see Managing and Customizing Search. For more information about adding filters to SQL Server full-text searching, see the SQL Server 2000 documentation.

  • I can't enable search for a server.

    Is your server running Windows SharePoint Services-compatible search server software, such as Microsoft SQL Server 2000 or later? By default, Windows SharePoint Services installs the Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) database. However, to enable the search functionality, the server's back-end database must be running Microsoft SQL Server 2000 or another Windows SharePoint Services-compatible search server.

    Is your server part of a server farm? If each server in the server farm is not running Windows SharePoint Services-compatible search server software, such as Microsoft SQL Server 2000 or later, the search controls may not appear. To resolve this problem, make sure that all servers in the server farm are running Windows SharePoint Services-compatible search server software.

  • Enabling full-text searching has failed.

    If you are enabling full-text searching with Microsoft SQL Server in a server farm environment, the process can time out or fail if one of the servers is offline or has a hard disk drive failure. If enabling full-text searching is taking more than a minute or two, you can restart the SQL Server services and run a stored procedure to enable searching.

    Restart the SQL Server processes
    1. On your computer running SQL Server, open a command prompt and run the following commands:

      net stop mssearch

      net stop mssqlserver

      net start mssqlserver

      net start mssearch

    2. Open SQL Server Query Analyzer and connect to the database for Windows SharePoint Services.
    3. Run the following stored procedures:

      exec proc_DisableFullTextSearch

      exec proc_EnableFullTextSearch

Restoring a List, List Item, or Document

  • A user deleted an item, document, or list, and now needs to recover it.

    If you have a recent backup of either the content database or the site, you can restore the backup to a new, temporary server or site, and then copy the deleted item, document, or list to the original site. After you have recovered the list, item, or document, you can delete the restored version of the database or site. For more information, see Backing Up and Restoring Databases and Backing Up and Restoring Web Sites.

    Note To copy an entire list or document library, save the list or document library (including the content) as a list template, and then import the list template and create a list or document library based on that template. When you include the content in the template, your new instance of the list includes all of the items or documents from the old list. List templates do not include per-list permission settings or created by or modified by data from the original list. For information about creating a list template, see Working with Templates.

Service Unavailable Message

  • I get a "service unavailable" message when I try to view my site or the administration pages for my site or server.

    If the password for the application pool for a virtual server has expired or changed, you will see a "service unavailable" message until you reset Internet Information Services (IIS) and SQL Server to accept the new password.

    Note You may also see a "cannot connect to configuration database" error message if you are using SQL Server authentication and the password associated with the system account for SQL Server has expired or changed. If you see this message, you must reset the password in SQL Server. For more information about changing passwords in SQL Server, see Help in SQL Server Enterprise Manager.

    Reset an application pool password in IIS
    1. Click Start, point to All Programs, point to Administrative Tools, and then click Internet Information Services (IIS) Manager.
    2. Click the plus sign next to your server name.
    3. Click the plus sign next to Application Pools.
    4. Right-click the application pool that needs to be updated, and then click Properties.
    5. In the "Application Pool ID" Properties dialog box, click the Identity tab.
    6. Under Application pool identity, in the Password box, type the new password, and then click OK.
    7. In the Confirm Password dialog box, type the password again, and then click OK.

    After you change the password in IIS, you must restart IIS to connect with the new password. To restart IIS, type iisreset on the command line.

Security Issues

  • I want to prevent users from seeing links to areas in this site, such as Site Administration.

    Rather than hiding links and controls from users, Windows SharePoint Services checks users' rights when they click links or try to perform actions on the site. If a user is not a member of a site group or cross-site group with the proper rights, he or she cannot enter site administration or change the settings for a site, list, or library. There are no administrative controls to hide links from unauthorized users.

  • I've deleted users from my site, but I'm still being notified that my quota is full and I can't add any more users.

    To have any effect on your user quota, users must be removed at the site collection level. You can do this by using SharePoint Central Administration or the Manage Site Collection Users page in Site Administration. Removing users from individual sites will not allow you to add more users. To remove site collection users by using the Site Administration pages, do the following:

    1. On the top link bar, click Site Settings.
    2. In the Administration section, click Go to Site Administration.
    3. In the Site Collection Administration section, click View site collection user information.
    4. Select the check box next to the users that you want to delete, and then click Remove Selected Users.

    Note You must be a site collection administrator to remove users from a site collection.

  • I removed a user from a site but he or she is still receiving alerts from it.

    When you remove a user from a Web site, site group, or cross-site group after he or she has created alerts, you must manually delete any alerts that he or she has set up. This is also true for any lists or libraries where you change security settings to limit access. If a user has set up alerts for the list or library, he or she will continue to receive them after you change the security settings. For information on deleting alerts for users, see Managing Alerts.

Usage Analysis Issues

  • I see a "no data" message or a message that usage reports are not available when I try to view the Site Usage Report page

    Usage analysis must be turned on, and users must have visited a page in your site before any data can appear on the Site Usage Report page. If you are seeing the error "No usage data is available for this web" on this page, verify that usage analysis has been turned on for the server.

    If the site is new (created today), or has not been used before today, no data will appear until the usage log processing has been done (usually within 24 hours).

    If there has been no activity on the site for the past 31 days, the Site Usage Report page will say that usage reports are not available.

    For more information about enabling usage analysis, see Configuring Usage Analysis.

  • I extended a new virtual server, and the usage analysis processing is not working for the new virtual server.

    If usage analysis processing was configured before you extended the virtual server, it must be enabled manually for the new virtual server. To enable usage analysis for the new virtual server, you can use either of the following methods:

    1. Use the command-line tool Stsadm.exe with the setproperty operation to set the schedule for usage analysis on the new virtual server. To set the schedule, run the following operation:
      stsadm.exe -o setproperty -pn job-usage-analysis
-pv "daily between HH:MM:SS and HH:MM:SS" -url <URL to virtual server>
    2. Use the Configure Usage Analysis page to reconfigure usage analysis for all virtual servers.

    Note Usage analysis information is not available until the usage analysis processing has been run at least once.

  • The number of users that I'm seeing is higher than I expected.

    If you have removed users from a subsite, but not from the site collection, the users will still appear in the usage data. If you are trying to remove users so that you are under your quota, you must remove users at the site collection level, not at the subsite level.

    Also, server administrators are included as users in the usage analysis results, even though they are not members of a site. If they perform actions within a site or run a monitoring utility on a site collection, those activities are included in the usage analysis results. However, server administrators are not counted towards user quotas.

For more information about enabling usage analysis, see Configuring Usage Analysis.

SSL Termination Is Not Supported

My alert message URLs are wrong and I get an "Access denied" message when I try to upload a document to a document library.

Secure Sockets Layer (SSL) termination is a configuration where an HTTPS request from the client is first processed by either a proxy server or a firewall, and then the request is forwarded to a Web server by using HTTP. SSL termination is not supported for Windows SharePoint Services. If SSL termination is configured, alert messages may contain the wrong URL (HTTP rather than HTTPS), and your users may not be able to upload documents to document libraries (they receive an Access Denied message after attempting to authenticate).

This issue is also covered by article 831106 in the Microsoft Knowledge Base.

Web Part Errors on the Home Page

I get one of the following errors when I view the home page of my site:

  • Web Part Error: Cannot deserialize (convert an XML stream back into an object) the Web Part on the server.
  • Web Part Error: One of the properties of the Web Part has an incorrect format. Windows SharePoint Services cannot deserialize the Web Part. Check the format of the properties and try again.

These errors can be caused when permissions that Windows SharePoint Services configured on the Windows Temp directory were unintentionally reset (perhaps during an upgrade to the operating system). To resolve this issue, make sure that the following permissions are configured correctly.

Windows directory | Required permissions
%WinDir%\Temp | Administrators - Full control SYSTEM - Full control STS_WPG - Read, Write Network Service (for a domain controller only) - Read, Write
%WinDir%\System32\Logfiles | STS Administrators - Full Control SYSTEM - Full control STS_WPG - Read, Write Network Service (for a domain controller only) - Read, Write

Note If your usage analysis log files are stored in a different location, you must also be sure that the permissions for those log files match the permissions for the Logfiles directory above.

For more information about the permissions needed for Windows SharePoint Services to perform as expected, see Files and Permissions. This issue is also covered by article 826786 in the Microsoft Knowledge Base.

Assigned IP Addresses Are Not Supported

When I try to modify my site or add or export Web parts I get one of the following error messages:

  • Cannot retrieve properties at this time.
  • The server could not complete your request. Contact your Internet service provider or Web server administrator to make sure that the server has the FrontPage Server Extensions or SharePoint Services installed.

This problem may occur when one or both of the following conditions are true:

  • You have configured the virtual server in IIS to have an assigned IP address, and then extended the virtual server with Windows SharePoint Services.
  • You have configured the virtual server in IIS to use host headers, and then extended the virtual server with Windows SharePoint Services, and then you installed a Web Part assembly to the Bin folder instead of to the global assembly cache.

In each of these configurations, Windows SharePoint Services cannot obtain sufficient information from the virtual server to load the Web Part or Web Parts on the site. To address these issues, use one of the following methods, as appropriate to your situation:

  1. Assigned IP addresses are not supported. If you have assigned an IP address in IIS, you must change the IP address to use All Unassigned before you can use Windows SharePoint Services. For more information about changing the IP address in IIS, see the IIS Help system.
  2. If you host a virtual server that has a host header name and you installed a Web Part assemblies to the Bin folder, you must move the assembly to the global assembly cache. For more information, see the Windows SharePoint Services Software Development Kit.
  3. Consider using scalable hosting mode for Windows SharePoint Services. For more information, see Server Farm with Multiple Host Names Deployment.

This issue is also covered by article 830342 in the Microsoft Knowledge Base.

Configuring Kerberos Authentication

When a virtual server is extended with Windows SharePoint Services, the virtual server is configured to use Integrated Windows authentication. By configuring Integrated Windows authentication on the virtual server, the virtual server can run as a domain account, and you do not have to configure a service principal name (SPN) in Active Directory directory services. If your environment requires Kerberos authentication, you must first enable Kerberos in IIS, and then configure a service principal name (SPN) in Active Directory directory services for the domain account that the virtual server is running as. You do not have to configure the service principal name if the application pool identity for the virtual server is configured to use a built-in security principal (such as Network Service or Local System).

Enabling Kerberos in IIS

There are two methods you can use to enable Kerberos in IIS. You can choose between these two methods, depending on your needs:

  • Manually edit the IIS metabase.

    If you are enabling Kerberos for only one virtual server, you can directly edit the IIS metabase.

  • Use IIS administration scripts to edit the IIS metabase.

    If you need to enable Kerberos authentication for several virtual server, consider using a script that you can run for each virtual server.

Method 1: Manually edit the IIS metabase to enable Kerberos authentication
  1. On the server running IIS, open Notepad, and then open the Metabase.xml file that is located in the following folder on the hard disk, where %systemroot% is the path and folder name where Microsoft Windows is installed:

    %systemroot%\System32\Inetsrv

  2. In the <IIsWebServer> section, locate the following line:

    NTAuthenticationProviders="NTLM"

  3. Modify the line so that it reads exactly as follows:

    NTAuthenticationProviders="Netgotiate,NTLM"

  4. Save the file, and then quit Notepad.
  5. Open a command prompt, and then restart IIS by typing iisreset.
Method 2: Use an IIS administration script to edit the IIS metabase and enable Kerberos authentication
  1. On the server running IIS, open a command prompt.
  2. Change to the Inetpub\Adminscripts folder, and then type the following line, where Drive is the hard disk drive where Windows is installed, and then press ENTER:

    cd Drive:\inetpub\adminscripts

  3. Type the following line, where xx is the virtual server ID number, and then press ENTER.

    cscript adsutil.vsb get w3svc/xx/NTAuthenticationProviders

    Note The virtual server ID of the default Web site in IIS is 1.

    The following string is returned:

    ntauthenticationproviders: (STRING) "NTLM"

  4. To enable Kerberos on the virtual server, type the following line, where xx is the virtual server ID number, and then press ENTER.

    cscript adsutil.vsb get w3svc/xx/NTAuthenticationProviders "Negotiate,NTLM"

  5. Type iisreset and then press ENTER to restart IIS.

Configuring Server and Account Delegation and Configuring a Service Principal Name for the Domain Account

After you have enabled Kerberos in IIS, you must configure a service principal name for the domain account that the virtual server is running under.

Note You do not need to perform these steps if the virtual server application pool identity is using one of the built-in security principals (such as Network Service or Local System). The built-in accounts are automatically configured to work with Kerberos authentication.

If you use a remote computer running SQL Server 2000 for your configuration and content databases, and you want to use the built-in Network Service account as a domain account, you must add the domain\computername$ entry to SQL Server and grant it Database Creators and Security Administrators permissions. This allows Windows SharePoint Services to connect to the remote computer running SQL Server and create and manage the configuration and content databases. For more information about granting permissions in SQL Server, see Remote SQL Server Deployment.

If the server running IIS is a member of the domain, but is not a domain controller, the server must be trusted for delegation before Kerberos authentication can work correctly.

Configure the server running IIS to be trusted for delegation
  1. On the domain controller, start Active Directory Users and Computers.
  2. In the left pane, click Computers.
  3. In the right pane, right-click the name of the server running IIS, and then click Properties.
  4. Click the General tab, and then select the Trust computer for delegation check box.
  5. Click OK.

If the application pool identity is configured to use a domain user account, the user account must be trusted for delegation. before you can use Kerberos authentication.

Configure the domain account to be trusted for delegation
  1. In Active Directory Users and Computers, in the left pane, click Users.
  2. In the right pane, right-click the name of the user account, and then click Properties.
  3. Click the Account tab, and then under Account Options, select the Account is trusted for delegation check box.
  4. Click OK.

If the application pool identity is a domain user account, you must configure a service profile name (SPN) for that account.

Configure a service profile name for the domain account
  1. Download and install the Setspn.exe command line utility from the Microsoft Web site.
  2. Open a command prompt, and then run the following command:

    Setspn -A HTTP/ServerNameDomain\username

    Where ServerName is the fully-qualified domain name of the server, domain is the name of the domain, and username is the name of the user account.


Command-Line Operations

Command-Line Operations

This topic lists and explains the operations you can perform with Stsadm.exe. For detailed information about the required and optional parameters, including short forms of the parameters, see Command-Line Parameters. For more information about using the command-line tool, see "Introducing the Administration Tools for Windows SharePoint Services" in the Windows SharePoint Services Administrator's Guide.

Note To use stsadm.exe, you must be a member of the local Administrators group for the server computer.

You can also get a list of the command-line operations by typing stsadm.exe -help on the command line. Syntax help for specific operations is available by typing stsadm.exe -help <operation name>.

Operations in This Topic
  • addpath
  • addtemplate
  • adduser
  • addwppack
  • backup
  • binddrservice
  • createadminvs
  • createsite
  • createsiteinnewdb
  • createweb
  • deleteadminvs
  • deleteconfigdb
  • deletepath
  • deletesite
  • deletetemplate
  • deleteuser
  • deleteweb
  • deletewppack
  • disablessc
  • disablestsisapis
  • email
  • enablessc
  • enablestsisapis
  • enumroles
  • enumsites
  • enumsubwebs
  • enumtemplates
  • enumusers
  • enumwppacks
  • extendvs
  • extendvsinwebfarm
  • getadminport
  • getproperty
  • removedrservice
  • renameweb
  • restore
  • setadminport
  • setconfigdb
  • setproperty
  • siteowner
  • unextendvs
  • uninstall
  • upgrade
  • userrole

addpath

Adds a defined path (inclusion or exclusion) to a virtual server. For more information, see Managing Paths.

Required parameters | Optional parameters
-url -type | <none>

Sample syntax:

 stsadm.exe -o addpath -url <url>
  -type <exclusion/explicitinclusion/wildcardinclusion>

addtemplate

Adds a site template to the template gallery.

Note If you want the changes to the template list to take effect immediately, run the iisreset command after you run the addtemplate operation.

Required parameters | Optional parameters
-filename -title | -description

Sample syntax:

 stsadm.exe -o addtemplate -filename <template filename>
  -title <template title> [-description <template description>]

adduser

Adds a user account to the specified site and assigns it to the specified site group. Use the siteadmin parameter to register the user as the site administrator.

Required parameters | Optional parameters
-url -userlogin -useremail -role -username | -siteadmin

Sample syntax:

 stsadm -o adduser -url <url> -userlogin <DOMAIN\username>
  -useremail <someone@example.com> -role <site group name>
  -username <user's display name> [-siteadmin]

addwppack

Adds a Web Part package to your server Web Part gallery. Use the globalinstall parameter to install the Web Parts in the global assembly cache (GAC) rather than in the Bin directories of each virtual server. Assemblies installed in the GAC are available to all applications on the server. The url parameter optionally specifies the URL of the virtual server on which to install the Web Parts. To install the Web Parts on every virtual server on a server, omit theurl parameter. Use the force parameter to overwrite an existing Web Part package with a new version, or to repair a Web Part package by reinstalling it. Use the lcid parameter to specify a language for the Web Part package.

Use filename to specify the path to the cabinet file containing the Web Parts and associated resources. If the Web Part package has already been installed on another server in a server farm configuration, you can install the Web Part package from the configuration database by using the name parameter.

Required parameters | Optional parameters
either -filename or -name | -url -globalinstall -force -lcid

Sample syntax:

 stsadm.exe -o addwppack -filename <Web Part Package filename>
  [-url <url> -globalinstall -force -lcid <language>]

backup

Creates a backup of the site at the specified URL. Use the overwrite parameter to replace an existing backup file.

Required parameters | Optional parameters
-url -filename | -overwrite

Sample syntax:

 stsadm.exe -o backup -url <url> -filename <filename> [-overwrite]

binddrservice

Registers a data retrieval service for the list of data retrieval services that pertain to a specific setting on the Data Retrieval Services Settings page. Specify the service name and then the setting. Settings include enabled, responsesize, timeout, and update.

Required parameters | Optional parameters
-servicename -setting | <none>

Sample syntax:

 stsadm.exe -o binddrservice -servicename <service name> -setting <enabled/responsesize/timeout/update>

createadminvs

Creates the administration virtual server for Microsoft Windows SharePoint Services. Use the admapid... parameters to create a new application pool for IIS, or to specify the application pool to use for the administration virtual server.

Note This operation is intended for use by other products, and not by administrators of Windows SharePoint Services.

Required parameters | Optional parameters
<none> | -admapcreatenew -admapidname -admapidtype -admapidlogin -admapidpwd

Sample syntax:

 stsadm.exe -o createadminvs [-admapcreatenew]
  [-admapidname <app pool id>]
  [-admapiptype <configurableid/NetworkService/LocalService/LocalSystem>]
  [-admapidlogin <app pool user account>] [-admapidpwd <app pool password>]

createsite

Creates a site at the specified URL with the specified user as owner and administrator. If you do not specify the template to use, the owner can choose the template when he or she first browses to the site.

Required parameters | Optional parameters
-url -ownerlogin -owneremail | -ownername -lcid -sitetemplate -title -description -quota

Sample syntax:

 stsadm.exe -o createsite -url <url>
  -ownerlogin <DOMAIN\username> -owneremail <someone@example.com>
  [-ownername <display name>] [-lcid <language>]
  [-sitetemplate <site template>] [-title <title>]
  [-description <description>] [-quota <quota template>]

Note You must specify the -lcid option when using a non-English template.

createsiteinnewdb

Creates a site at the specified URL and creates a new content database with the username and password you specify. If you do not specify the template to use, the owner can choose the template when he or she first browses to the site.

Required parameters | Optional parameters
-url -ownerlogin -owneremail | -ownername -databaseuser -databasepassword -databaseserver -databasename -lcid -sitetemplate -title -description -secondarylogin -secondaryemail -secondaryname

Sample syntax:

 stsadm.exe -o createsiteinnewdb -url <url>
  -ownerlogin <DOMAIN\username> -owneremail <someone@example.com>
  [-ownername <owner's name>]
  [-databaseuser <databaseusername>] [-databasepassword <databasepassword>
  [-databaseserver <databaseserver>] [-databasename <databasename>]
  [-lcid <language>] [-sitetemplate <site template>]
  [-title <title>] [-description <description>]
  [-secondarylogin <DOMAIN\username>] [-secondaryemail <someone@example.com>]
  [-secondaryname <secondary owner's name>]

Note You must specify the -lcid option when using a non-English template.

createweb

Creates a subsite at the specified URL. If you do not specify the template to use, the owner can choose the template when he or she first browses to the site. Use the unique parameter to specify unique permissions for the subsite.

Required parameters | Optional parameters
-url | -lcid -sitetemplate -title -description -unique

Sample syntax:

 stsadm.exe -o createweb -url <url> [-lcid <language>]
  [-sitetemplate <site template>] [-title <title>]
  [-description <description>] -unique]

Note You must specify the -lcid option when using a non-English template.

deleteadminvs

Deletes the administration virtual server for Windows SharePoint Services.

Caution This operation is intended for use by other products, and not by administrators of Windows SharePoint Services. If you delete the administrative virtual server for Windows SharePoint Services, you can no longer manage Windows SharePoint Services. This operation cannot be undone.

Required parameters | Optional parameters
<none> | <none>

Sample syntax:

 stsadm.exe -o deleteadminvs

deleteconfigdb

Deletes the configuration database for Windows SharePoint Services.

Required parameters | Optional parameters
<none> | <none>

Sample syntax:

 stsadm -o deleteconfigdb

deletepath

Removes an included or excluded path from the list of paths managed by Windows SharePoint Services.

Required parameters | Optional parameters
-url | <none>

Sample syntax:

 stsadm -o deletepath -url <url>

deletesite

Deletes the specified site. To delete users from Active Directory directory services, specify true for the deleteadaccounts parameter.

Required parameters | Optional parameters
-url | <none>
-deleteadaccounts |

Sample syntax:

 stsadm.exe -o deletesite -url <url> -deleteadaccounts <true/false>

deletetemplate

Deletes the specified site template.

Required parameters | Optional parameters
-title | -lcid

Sample syntax:

stsadm.exe -o deletetemplate -title <template title> [-lcid <language>]

deleteuser

Deletes the specified user.

Required parameters | Optional parameters
-url -userlogin | <none>

Sample syntax:

 stsadm -o deleteuser -url <url> -userlogin <DOMAIN\username>

deleteweb

Deletes the specified subsite.

Required parameters | Optional parameters
-url | <none>

Sample syntax:

 stsadm.exe -o deleteweb -url <url>

deletewppack

Removes the Web Parts in a Web Part package from a virtual server. When you delete the last instance of a Web Parts package on a server or server farm, Stsadm.exe also deletes the Web Part package from the configuration database.

The parameter name specifies the name of the Web Part package. The parameter url optionally specifies the URL of the virtual server on which to delete the Web Parts. If url is omitted, Stsadm.exe deletes the Web Parts from the Bin folder of every virtual server on the server or from the global assembly cache.

Use the lcid parameter to remove a particular language version of a Web Part package.

Required parameters | Optional parameters
-name | -url -lcid

Sample syntax:

 stsadm -o deletewppack -name <name of Web Part package> [-url <url> -lcid <language>]

disablessc

Disables Self-Service Site Creation for the specified virtual server.

Required parameters | Optional parameters
-url | <none>

Sample syntax:

 stsadm -o disablessc -url <url>

disablestsisapis

Disables the Windows SharePoint Services ISAPI extensions. This operation is used by the Setup program for Windows SharePoint Services.

Required parameters | Optional parameters
<none> | <none>

Sample syntax:

 stsadm -o disablestsisapis

email

Sets the e-mail configuration settings for your server, or for a specific virtual server (when you use the url parameter).

Required parameters | Optional parameters
-outsmtpserver -fromaddress -replytoaddress -codepage | -url

Sample syntax:

stsadm.exe -o email -outsmtpserver <SMTP server>
  -fromaddress <someone@example.com> -replytoaddress <someone@example.com>
  -codepage <codepage> [-url <url>]

enablessc

Enables Self-Service Site Creation for the specified virtual server.

Required parameters | Optional parameters
-url | -requiresecondarycontact

Sample syntax:

 stsadm -o enablessc -url <url> [-requiresecondarycontact]

enablestsisapis

Enables the Windows SharePoint Services ISAPI extensions. This operation is used by the Setup program for Windows SharePoint Services.

Required parameters | Optional parameters
<none> | <none>

Sample syntax:

 stsadm -o enablestsisapis

enumroles

Lists the site groups that are available for use in a particular site or subsite.

Required parameters | Optional parameters
-url | <none>

Sample syntax:

 stsadm -o enumroles -url <URL>

enumsites

Lists all of the sites that have been created under a particular virtual server. The url parameter must be the URL of a virtual server.

Required parameters | Optional parameters
-url | <none>

Sample syntax:

 stsadm -o enumsites -url <URL>

enumsubwebs

Lists the subsites that have been created under a particular site.

Required parameters | Optional parameters
-url | <none>

Sample syntax:

 stsadm -o enumsubwebs -url <URL>

enumtemplates

Lists the site templates that are available.

Required parameters | Optional parameters
<none> | -lcid

Sample syntax:

stsadm.exe -o enumtemplates [-lcid <language>]

enumusers

Lists the users of a particular site or subsite.

Required parameters | Optional parameters
-url | <none>

Sample syntax:

stsadm.exe -o enumusers -url <url>

enumwppacks

Lists the Web Part Packages currently in your server Web Part gallery.

Required parameters | Optional parameters
<none> | -name -url

Sample syntax:

 stsadm -o enumwppacks [-name <name of Web Part Package>]
   [-url <URL>]

extendvs

Extends a virtual server with Windows SharePoint Services and creates a new content database.

Note Extending a virtual server creates a site but does not require the createsite parameter. Use the donotcreatesite parameter if you do not want to create a site when you extend the virtual server.

Required parameters | Optional parameters
-url -ownerlogin -owneremail | -ownername -databaseuser (du) -databaseserver (ds) -databasename (dn) -databasepassword (dp) -lcid -sitetemplate -donotcreatesite -apcreatenew -apidname -apidtype -apidlogin -apidpwd

Sample syntax:

 stsadm -o extendvs -url <url> -ownerlogin <DOMAIN\username>
  -owneremail <someone@example.com> [-ownername <display name>]
  [-du <database user>] [-ds <database server>] [-dn <database name>]
  [-dp <database user password>][-lcid <lcid>] [-sitetemplate <site template>]
  [-donotcreatesite] [-apcreatenew] [-apidname <app pool name>]
  [-apidtype <configurableid/NetworkService/LocalService/LocalSystem>]
  [-apidlogin <DOMAIN\username>]
  [-apidpwd <app pool password>]

extendvsinwebfarm

Extend a virtual server with Windows SharePoint Services for use in a server farm. This operation does not create a new content database, but allows you to connect to an existing virtual server (vsname) and use the same content database.

Required parameters | Optional parameters
-url -vsname | -apcreatenew -apidname -apidtype -apidlogin -apidpwd

Sample syntax:

 stsadm -o extendvsinwebfarm -url <url> -vsname <virtual server name>
  [-apcreatenew] [-apidname <app pool name>]
  [-apidtype <configurableid/NetworkService/LocalService/LocalSystem>]
  [-apidlogin <DOMAIN\username>]
  [-apidpwd <app pool password>]

getadminport

Returns the administration port for Windows SharePoint Services.

Required parameters | Optional parameters
<none> | <none>

Sample syntax:

 stsadm -o getadminport

getproperty

Returns the property value for the specified property name. For a list of valid properties, see Command-Line Properties.

Required parameters | Optional parameters
-propertyname (pn) | -url

Sample syntax:

 stsadm -o getproperty -pn <property name> [-url <url>]

removedrservice

Removes a data retrieval service from the list of data retrieval services that pertain to a specific setting on the Data Retrieval Services Settings pages. Specify the service name, and then the setting. Settings include enabled, responsesize, timeout, and update.

Required parameters | Optional parameters
-servicename -setting | <none>

Sample syntax:

 stsadm.exe -o removedrservice -servicename <service name> -setting <enabled/responsesize/timeout/update>

renameweb

Renames the specified subsite.

Required parameters | Optional parameters
-url -newname |

Sample syntax:

 stsadm.exe -o renameweb -url <url> -newname <new subsite name>

restore

Restores a Web site from a backup file. Use the overwrite parameter to replace any existing Web site at the new location.

Required parameters | Optional parameters
-url -filename | -overwrite

Sample syntax:

 stsadm.exe -o restore -url <url> -filename <filename> [-overwrite]

setadminport

Sets the port number for the administration virtual server for Windows SharePoint Services. Use the ssl parameter to specify a Secure Sockets Layer (SSL) connection to the port. Use the admap... parameters to specify the IIS application pool to use or to create a new IIS application pool for the administration virtual server.

Required parameters | Optional parameters
-port | -ssl -admapcreatenew -admapidname -admapidtype -admapidlogin -admapidpwd

Sample syntax:

 stsadm.exe -o setadminport -port <port> [-ssl]
  [-admapcreatenew] [-admapidname <app pool id>]
  [-admapiptype <configurableid/NetworkService/LocalService /LocalSystem>]
  [-admapidlogin <app pool user account>] [-admapidpwd <app pool password>]

setconfigdb

Creates the configuration database or specifies the connection to an existing configuration database. Setting the configuration database is required before a virtual server can be extended.

Required parameters | Optional parameters
-databaseserver (ds) | -connect -databaseuser (du) -databasepassword (dp) -databasename (dn) -hh -adcreation -addomain -adou

Sample syntax:

 stsadm.exe -o setconfigdb [-connect] -ds <database server>
  [-du <database user>] [-dp <database user password>] [-dn <database name>]
  [-hh] [-adcreation] [-addomain <AD domain> [-adou <AD OU>]

setproperty

Sets the specified property with the specified value. Use the url property to specify a virtual server or site collection to apply the property to, or omit the url parameter to apply the property at the server or server farm level. For a list of valid properties, see Command-Line Properties.

Required parameters | Optional parameters
-propertyname (pn) -propertyvalue (pv) | -url

Sample syntax:

 stsadm.exe -o setproperty -pn <property name>
  -pv <property value> [-url <url>]

siteowner

Sets the owner or secondary owner of a site collection. Either the ownerlogin or secondownerlogin parameter must be used.

Required parameters | Optional parameters
-url either -ownerlogin or -secondownerlogin |

Sample syntax:

 stsadm.exe -o siteowner -url <url>   [-ownerlogin <DOMAIN\username> | -secondownerlogin <DOMAIN\username>]

unextendvs

Removes Windows SharePoint Services from a particular virtual server. Use the deletecontent parameter to delete the content databases for the virtual server.

Required parameters | Optional parameters
-url | -deletecontent

Sample syntax:

 stsadm.exe -o unextendvs -url <url> [-deletecontent]

uninstall

Uninstalls Windows SharePoint Services from the default virtual server at port 80. Any other virtual servers that were extended with Windows SharePoint Services will not be unextended. Uninstall removes the Windows SharePoint Services ISAPI extensions and any virtual directories or other files from the virtual server. It does not delete the content databases unless you include the deletecontent parameter. This operation is used by the Setup program for Windows SharePoint Services.

Required parameters | Optional parameters
<none> | -deletecontent

Sample syntax:

 stsadm.exe -o uninstall [-deletecontent]

upgrade

Upgrades the server or the specified virtual server with Windows SharePoint Services. This operation is used by the Setup program for Windows SharePoint Services.

Required parameters | Optional parameters
<none> | -url

Sample syntax:

 stsadm.exe -o upgrade [-url <url>]

userrole

Specifies the site group membership for a user. Use the add and delete parameters to specify whether to add the user to a site group or remove the user from a site group.

Required parameters | Optional parameters
-url -userlogin -role | -add -delete

Sample syntax:

 stsadm.exe -o userrole -url <url> -userlogin <DOMAIN\username>
  -role <site group name> [-add] [-delete]


Command-Line Parameters

Command-Line Parameters

The following table lists and explains the parameters you can use with operations for Stsadm.exe. For detailed information about the operations, including sample syntax, see Command-Line Operations. For more information about using the command-line tool, see "Introducing the Administration Tools for Windows SharePoint Services" in the Windows SharePoint Services Administrator's Guide.

Parameter | Short form | Definition | Sample values
adcreation |  | Specifies that new user accounts are created in Microsoft Active Directory directory service. |
add |  | Specifies that the user is added to a site group when the userrole operation is run. |
addomain |  | The Active Directory domain. |
admapcreatenew |  | Specifies that a new application pool is created in Internet Information Services (IIS). |
admapidlogin |  | The user name to use for running processes in the administrative application pool. | This value must be a Microsoft Windows user name, and must be qualified with a domain name, for example DOMAIN\name.
admapidname |  | The administrative application pool ID. |
admapidpwd |  | The password that corresponds to the admapidlogin. |
admapidtype |  | The identity type to use for the administrative application pool. | (configurableid/ NetworkService/LocalService/LocalSystem)
adou |  | The Active Directory organizational unit (OU). |
apcreatenew | -apnew | Specifies that a new application pool is created in Internet Information Services (IIS). |
apidlogin | -apl | The user name to use for running processes in the application pool. | This value must be a Windows user name, and must be qualified with a domain name, for example DOMAIN\name.
apidname |  | The application pool ID. |
apidpwd |  | The password that corresponds to the apidlogin. |
apidtype |  | The identity type to use for the application pool. | (configurableid/ NetworkService/LocalService/LocalSystem)
codepage |  | The language codepage to use for e-mail messages. | This value must be a valid codepage, such as 65001.
connect |  | Connects to an existing database, rather than creating a new one. |
databasename | -dn | The name of the Microsoft SQL Server database or Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE) database used for Windows SharePoint Services data. | The default database name is automatically generated based on the machine name, virtual server, and subsite. For example, SharePoint_collab_stsid.
databasepassword | -dp | The password that corresponds to the administrator user name for the SQL Server database or WMSDE database. |
databaseserver | -ds | The server on which the Windows SharePoint Services collaboration database exists. | The default is the local machine name. For example, SQL_01.
databaseuser | -du | The administrator user name for the SQL Server database or WMSDE database. |
delete |  | Specifies that the user is deleted from a site group when the userrole operation is run. |
deleteadaccounts |  | Specifies that users are deleted from Active Directory directory service when the deletesite operation is run. |
deletecontent |  | Specifies that the content databases are deleted when a virtual server is unextended or Windows SharePoint Services is uninstalled. |
description | -desc | The site or template description. | Any text string.
donotcreatesite |  | Specifies that no site is created when a virtual server is extended. |
force |  | Specifies that an existing Web Part package is overwritten when the addwppack operation is run. |
filename | -f | A valid file name for a file, template, or Web Part package. | A full path and file name, such as C:\Myfiles\Filename.htm.
fromaddress |  | The e-mail address to use as a From address on server messages, such as alert notifications. | This value must be a valid e-mail address, in the form someone@example.com.
globalinstall |  | Specifies that, when the addwppack operation is run, the Web Part package is installed in the global assembly cache (GAC) rather than in the Bin directories of each virtual server. Assemblies installed in the GAC are available to all applications on the server.. |
hh |  | Specifies that the server is in a server farm hosting configuration. No database is created and the virtual server is extended by connecting to existing content database. You must specify an existing SQL connection string to the configuration database when you use this parameter. |
lcid |  | The locale ID for sites created on this virtual server. Default is the install language for Windows SharePoint Services. | A locale ID, for example 1033.
name | -n | The name of a Web Part package. |
newname | -new | The new name to use when renaming a subsite. |
operation | -o | The operation to perform. | For a list of available operations, see Command-Line Operations.
outsmtpserver |  | The SMTP server to use for outgoing messages. |
overwrite |  | Specifies that any existing backup files or existing Web sites will be overwritten during backup or restore. |
owneremail |  | The site owner's e-mail address. | This value must be a valid e-mail address, in the form someone@example.com.
ownerlogin |  | The site owner's user account. | This value must be a Windows user name, and must be qualified with a domain name, for example DOMAIN\name.
ownername |  | The site owner's display name. |
port |  | The port to use for SharePoint Central Administration. | An integer, such as 80.
propertyname | -pn | A valid property name. | For names, see Command-Line Properties.
propertyvalue | -pv | A valid property value. | For more information, see Command-Line Properties.
quota | -qt | The quota template to apply to sites created on the virtual server. | A quota template name. For example, personalquotas.
replytoaddress |  | The e-mail address that users can reply to when they receive server messages. | This value must be a valid e-mail address, in the form someone@example.com.
requiresecondarycontact |  | Specifies that users must supply a secondary contact when they create a new site. |
role |  | A valid site group name. | For example, reader.
secondaryemail | -se | The secondary site owner's e-mail address. | This value must be a valid e-mail address, in the form someone@example.com.
secondarylogin | -sl | The secondary site owner's user account. | This value must be a Windows user name, and must be qualified with a domain name, for example DOMAIN\name.
secondaryname | -sn | The secondary site owner's display name. |
servicename | -svc | The name of a data retrieval service. | For example, Service1.
setting |  | A setting for data retrieval services. | Any of the following values: enabled, responsesize, timeout, update.
siteadmin |  | Specifies that the user is an administrator of the site. |
sitetemplate | -st | The template to apply to the new site. | The value must be in the form name#configuration. If you do not specify the configuration, configuration 0 is the default (for example, STS#0). The list of available templates can be customized to include templates you create. Values available in a default installation include: STS#0 (Team Site) STS#1 (Blank Site) STS#2 (Document Workspace) MPS#0 (Basic Meeting Workspace) MPS#1 (Blank Meeting Workspace) MPS#2 (Decision Meeting Workspace) MPS#3 (Social Meeting Workspace) MPS#4 (Multipage Meeting Workspace) Note If you added a template to the central template gallery, you must specify the template name as _GLOBAL_#number, where number refers to the template ID.
ssl |  | Specifies that Secure Sockets Layer (SSL) encryption is used for the administration port. |
title | -t | The template or site title | Any text string.
type |  | Type of path to add or remove. | (exclusion/explicitinclusion/wildcardinclusion)
unique |  | Specifies that the subsite uses unique permissions. |
url |  | The URL to the virtual server, site, or subsite. | For example, http://myserver/site1.
useremail |  | An e-mail address. | This value must be a valid e-mail address, in the form someone@example.com.
userlogin |  | A user account. | This value must be a Windows user name, and must be qualified with a domain name, for example DOMAIN\name.
username | -u | A user name. | Always use the short form for this parameter (u). This value must be either a Windows user account name or a Windows group account name, and can be qualified with a domain name, for example DOMAIN\name.
vsname |  | The virtual server name. |


Command-Line Properties

Command-Line Properties

This topic lists and explains the properties that can be set on the command line by using the Stsadm.exe tool with the getproperty and setproperty operations. To see the current value of a property, you use the getproperty operation. To set the value for a property, you use the setproperty operation. The following examples show the syntax to use when getting or setting a property:

stsadm.exe -o getproperty -pn <property name> [-url <url>]
stsadm.exe -o setproperty -pn <property name> -pv <property value> [-url <url>]

Some properties are available for the entire server, and are called server properties. Some are only available for an individual virtual server. When you get or set a server property, you can omit the url parameter. You must include the url parameter to get or set virtual server properties. For more information about setting properties, see "Introducing the Administration Tools for Windows SharePoint Services" in the Windows SharePoint Services Administrator's Guide.

Server Properties for Windows SharePoint Services

  • Antivirus properties
  • Content database properties
  • Data retrieval services properties
  • General server properties
  • HTML Viewer properties
  • Security properties
  • Site confirmation and automatic deletion properties
  • Usage analysis properties

Virtual Server Properties for Windows SharePoint Services

  • Alert properties
  • Data retrieval services properties
  • General virtual server properties
  • Security properties
  • Site confirmation and automatic deletion properties
  • Web Part configuration properties

Alert Properties

Use these properties to configure alerts for your server. The alerts-enabled, alerts-limited, and alerts-maximum properties can be set at either the server (and server farm) or virtual server level. Use the -url parameter to configure these properties for a specific virtual server or omit it to configure these properties for an entire server. The job-daily-alerts, job-immediate-alerts, and job-weekly-alerts properties properties can be set only at the virtual server level. You must specify the -url parameter when you configure these properties. For more information about alerts, see Managing Alerts.

Property name | Description | Values
alerts-enabled | Specifies whether alerts are enabled for this virtual server | "true" or "false"
alerts-limited | Specifies whether users are limited as to the number of alerts they can create | "true" or "false"
alerts-maximum | If alerts-limited is configured, specifies the maximum number of alerts that users can create | A numerical value
job-daily-alerts | Specifies the time to send out daily alerts | A phrase that includes the frequency interval and time range to send out notifications. For example "daily between 22:00:00 and 06:00:00".
job-immediate-alerts | Specifies how long to wait before sending out daily alerts | A phrase that includes the frequency interval and time range to send out notifications. For example "every 5 minutes between 0 and 59".
job-weekly-alerts | Specifies the day and time to send out weekly alerts | A phrase that includes the frequency interval and time range to send out notifications. For example "weekly between Fri 22:00:00 and Mon 06:00:00".

Antivirus Properties

Use these properties to configure antivirus protection for your server. These properties can be set only at the server (and server farm) level. You do not need to specify the -url parameter when you configure these properties. For more information about using antivirus scanning, see Configuring Antivirus Protection.

Property name | Description | Values
avallowdownload | Specifies whether users can download infected files to their client computers | "yes" or "no"
avcleaningenabled | Specifies whether antivirus cleaning is enabled | "yes" or "no"
avdownloadscanenabled | Specifies whether the download scans are enabled | "yes" or "no"
avnumberofthreads | Specifies the number of threads to take up with antivirus processes | A numerical value, the number of threads to use
avtimeout | Specifies the timeout time for scanning | A numerical value, in seconds
avuploadscanenabled | Specifies whether the upload scans are enabled | "yes" or "no"

Content Database Properties

Use these properties to set the server name, user name, and password to use for the default content database for your server. These properties can be set only at the server (and server farm) level. You do not need to specify the -url parameter when you configure these properties. For more information about the default content database, see Managing Content Databases.

Property name | Description | Values
defaultcontentdb-password | Specifies the password for the defaultcontentdb-user | A password
defaultcontentdb-server | Specifies the server that contains the default content database | A server name
defaultcontentdb-user | Specifies the username for the default content database | A user account in the format DOMAIN\username

Data Retrieval Services Properties

Use these properties to configure data retrieval services for your virtual server, server, or server farm. These properties can be set at either the server or virtual server level. Use the -url parameter to configure these properties for a specific virtual server or omit it to configure these properties for an entire server. For more information about data retrieval services, see Configuring Data Retrieval Services.

Property name | Description | Values
data-retrieval-services-enabled | Specifies whether data retrieval services are enabled | "true" or "false"
data-retrieval-services-enabled-list | The list of services to which the data-retrieval-services-enabled setting applies | A list of services, such as "OLEDB;SOAP Passthrough"
data-retrieval-services-inherit | Specifies whether to inherit the server farm settings for a virtual server | "true" or "false"
data-retrieval-services-response-size | Specifies the maximum size for data returned from the back-end source | An integer value in kilobytes (KB) between 1 and 100,000
data-retrieval-services-response-size-list | The list of services to which the data-retrieval-services-response-size setting applies | A list of services, such as "OLEDB"
data-retrieval-services-timeout | Specifies the time an adapter will wait for a response from the back-end data source | An integer value in seconds between 1 and 100,000
data-retrieval-services-timeout-list | The list of services to which the data-retrieval-services-timeout setting applies | A list of services, such as "OLEDB"
data-retrieval-services-update | Specifies whether adapters can execute requests that contain updatable queries | "true" or "false"
data-retrieval-services-update-list | The list of services to which the data-retrieval-services-update setting applies | A list of services, such as "OLEDB"
data-retrieval-services-oledb-providers | Specifies the list of supported OLEDB providers | The list of OLEDB providers, separated by semi-colons For example: "DB2OLEDB;IBMDADB2;MSDAORA;OraOLEDB.Oracle;SQLOLEDB"

General Virtual Server Properties

Use the following properties to specify general settings for a virtual server. These properties can be set only at the virtual server level. You must specify the -url parameter when you configure these properties. For more information about specifying virtual server general settings, see Configuring Virtual Servers. For more information about large-file-chunk-size, see Configuring large file support in Installing and Using Service Packs for Windows SharePoint Services.

Property name | Description | Values
days-to-show-new-icon | Specifies how long (in days) to display the New icon for items added to a Web site | A numerical value (number of days)
defaultquotatemplate | Specifies the default quota template for Web sites | A quota template name
defaulttimezone | Specifies the default time zone for Web sites | A time zone (numerical). For a list of valid time zones, see Regional and Language Settings.
large-file-chunk-size | Specifies the chunk size to use for large files | A numerical value, in megabytes (MB). The default value is 5 MB.
max-file-post-size | Specifies the maximum size for files posted to Web sites | A numerical value, in megabytes (MB). The default value is 50 MB.

General Server Properties

Use these properties to specify settings for your server. These properties can be set only at the server (and server farm) level. You do not need to specify the -url parameter when you configure these properties. For more information about changing IIS application pool identities, see .Changing the Application Pool Identity for a Virtual Server. For more information about user account modes, see Installation Considerations for Windows SharePoint Services. For more information about full-text search, see Managing and Customizing Search.

Property name | Description | Values
adminportidentity | Contains the IIS Application Pool identity that is being used for the SharePoint Central Administration port. You can only use the "getproperty" operation with this property - it cannot be set through the command line. To set this property, you must change the IIS Application Pool identity in IIS. | The IIS Application Pool identity that the Central Administration port is running under
fulltextsearchenabled | Specifies whether full text searching and indexing is enabled | "1" (yes) or "0" (no)

HTML Viewer Properties

Use these properties to specify HTML Viewer options for your server or server farm. These properties can be set only at the server (and server farm) level. You do not need to specify the -url parameter when you configure these properties. For more information about HTML viewing, see Managing HTML Viewers.

Property name | Description | Values
htmltranslbpath | Specifies the path (URL) to the HTML Viewer server | A URL
htmltransmaxcachesize | Specifies the maximum cache size for the HTML Viewer | A numerical value, in MB
htmltransmaxsize | Specifies the maximum file size that can be viewed | A numerical value, in MB
htmltranson | Specifies whether HTML viewing is enabled | "true" or "false"
htmltranstimeout | Specifies the timeout time for HTML viewing | A numerical value, in seconds

Security Properties

Use these properties to set security policies for Self-Service Site Creation, user names and passwords, and security validation, and to get the virtualserverpermsmask property.

Some of these properties can be set only at the virtual server level. You must specify the -url parameter when you configure these properties. For more information about Self-Service Site Creation, see Configuring Self-Service Site Creation.

Property name Description Values
createadaccounts Contains a value specifying which user account mode has been configured. "Yes" indicates that you are in Active Directory account creation mode, "no" indicates that you are in domain account mode.

You can only use the "getproperty" operation with this property - it cannot be set through the command line. This property is set when you install Windows SharePoint Services and choose a user account mode.

This property is only available at the server level and does not take the -url parameter.

"yes" or "no"
ssc Specifies whether to allow Self-Service Site Creation.

This property can only be set at the virtual server level and requires the -url parameter.

"yes" or "no"
ssc-contact Specifies whether or not to require a secondary contact for sites created by using Self-Service Site Creation.

This property can only be set at the virtual server level and requires the -url parameter.

"yes" or "no"
adaccountdomain Specifies the Active Directory domain name to use for user accounts in Active Directory account creation mode.

This property can only be set at the server level and does not take the -url parameter.

A domain name
adaccountou Specifies the organizational unit to use for user accounts in Active Directory account creation mode.

This property can only be set at the server level and does not take the -url parameter.

An organizational unit name
send-ad-email Specifies whether or not to send usernames and passwords through e-mail.

This property can only be set at the virtual server level and requires the -url parameter.

"true" or "false"
securityvalidation-enabled Specifies whether security credentials must be validated again before an operation that has timed out can be run again.

This property can only be set at the virtual server level and requires the -url parameter.

"true" or "false"
securityvalidation-expire Specifies whether Web Page Security Validation is set to never expire.

This property can only be set at the virtual server level and requires the -url parameter.

"true" or "false"
securityvalidation-timeout Specifies how long (in minutes) to wait before requiring security validation for a timed-out operation.

This property can only be set at the virtual server level and requires the -url parameter.

A number (minutes to wait)
virtualserverpermsmask Contains a value that indicates what changes have been made to the list of user rights available for use on a virtual server with the virtualserverpermsmask property.

You can only use the "getproperty" operation with this property - it cannot be set through the command line. This property is set when you make changes to the Manage User Rights for Virtual Server page in SharePoint Central Administration.

This property is only available at the virtual server level and requires the -url parameter.

For more information about configuring the list of user rights available for use on a virtual server, see Controlling User Rights and Assigning Tasks.

A hashed number

Site Confirmation and Automatic Deletion Properties

These properties can be set either at the server (and server farm) level or at the virtual server level. Use the -url parameter to configure these properties for a specific virtual server or omit it to configure these properties for an entire server. For more information about site confirmation and automatic deletion, see Managing Unused Web Sites.

Property name | Description | Values
delete-web-send-email | Specifies whether to send e-mail notifications about unused Web sites | "yes" or "no"
dead-site-notify-after | Specifies how long to wait before sending the first e-mail notification | A numerical value (the number of days to wait before sending notifications)
dead-site-num-notifications | Specifies how many e-mail notifications to send | A numerical value (the number of notifications to send)
dead-site-auto-delete | Specifies whether to automatically delete unused Web sites | "yes" or "no"
job-dead-site-delete | Specifies when to delete unused Web sites automatically | A phrase that includes the frequency interval and time range to delete unused Web sites automatically. For example "weekly at Sat 0:00:00".

Usage Analysis Properties

This property can be set either at the server (and server farm) level or at the virtual server level. Use the -url parameter to configure these properties for a specific virtual server or omit it to configure these properties for an entire server. For more information about usage analysis, see Configuring Usage Analysis.

Property name | Description | Values
job-usage-analysis | Specifies the frequency (daily, weekly, monthly) and time of day to perform the usage analysis processes. | A phrase that includes the frequency interval and time range to perform usage analysis log processing. For example "daily between 16:55:00 and 17:00:00".

If you want the job to start at a specific time, set the beginning and end times to the same time, for example: "daily between 16:55:21 and 16:55:21".

Note This property can be set only to "daily", not to "weekly" or "immediate".

If you want to view the current setting for the job-usage-analysis property, you must include the URL parameter. For example, to see the current usage analysis setting for the default Web site, use the following syntax:

stsadm.exe -o getproperty -pn job-usage-analysis -url http://localhost

Web Part Configuration Properties

Use these properties to configure Web Part settings. These properties can be set only at the virtual server level. You must specify the -url parameter when you configure these properties. For more information about configuring Web Part settings, see About Web Parts and Managing Web Parts on Virtual Servers.

Property name | Description | Values
spallowglobalcatalog | Specifies whether users can use the online Web Part gallery | "1" or "0"
spallowsp2p | Specifies whether users can connect Web Parts (pass data or values from a source Web Part to a target Web Part) | "1" or "0"


Command-Line Options for Setupsts.exe

Command-Line Options for Setupsts.exe

When you install Microsoft Windows SharePoint Services, you can use command-line properties and setup options to control how it is installed. For example, to install Windows SharePoint Services to work with a remote installation of Microsoft SQL Server, you run Setupsts.exe with the remotesql=yes option to avoid installing Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE). Then, after the installation, you can specify the SQL Server connection information and extend your servers.

The following table lists and explains the properties you can use with the command-line Setup program (Setupsts.exe) for Windows SharePoint Services.

Property | Description
remotesql=yes/no | An optional property that specifies whether or not WMSDE is installed with Windows SharePoint Services. The default value is no. Set this property to yes if you are going to use an existing or remote installation of Microsoft SQL Server with Windows SharePoint Services. For more information, see Remote SQL Server Deployment.
fulluninstall=yes/no | Specifies whether or not to remove Windows SharePoint Services from extended virtual servers when performing an uninstall. The default value is yes. It is recommended that you use the Add or remove programs control panel to uninstall Windows SharePoint Services. For more information, see Uninstalling Windows SharePoint Services.
provision=yes/no | Specifies whether or not to provision the administrative virtual server, extend the default virtual server, and create a top-level Web site during installation. The default value is yes. Set this property to no if you want to provision virtual servers later using the Stsadm.exe command-line tool. Note The remotesql=yes property also installs Windows SharePoint Services without provisioning the default virtual server, but it does provision the administration virtual server.

Not all of the standard setup options for Microsoft Windows Installer programs are supported by Windows SharePoint Services. For example, you cannot create an administrative installation point for Windows SharePoint Services (performed for other programs by including the /a option). The following table lists and describes the setup options supported by Windows SharePoint Services.

Option | Description
datadir="<path>\\" | Specifies where to install WSMDE. Set this property to a path on your local server, for example: datadir="d:\program files\wmsdedata\\". For more information, see Single Server Deployment.
l <path to log file> | Log setup messages to the specified file.
q or qn | Run Setupsts in quiet mode (unattended setup with no user intervention). For more information, see Performing a Quiet Installation.
qb | Run Setupsts in basic mode (limited user intervention). Includes a progress bar.
qf | Run Setupsts in full mode (user must fill in options during setup). This is the default option.
qr | Run Setupsts in reduced mode. Displays reduced UI during installation.
qn+ | Run Setupsts in quiet mode (unattended setup with no user intervention). Displays a Setup complete dialog box at the end of the installation.
qb+ | Run Setupsts in basic mode (limited user intervention). Includes a progress bar and a Setup complete dialog box at the end of the installation. If you cancel the installation, the dialog box is not displayed.
qb- | Run Setupsts in basic mode (limited user intervention). Does not display a Setup complete dialog box.
x | Uninstall Windows SharePoint Services.


User Rights and Site Groups

User Rights and Site Groups

This topic explains the rights and site groups you can assign to users by using operations in Stsadm.exe and by using HTML Administration pages. Each user right or site group is listed by the name that appears in HTML Administration pages. The name used to identify a site group for the Stsadm.exe command-line tool is listed in a table. For each site group, the default rights included in that site group are listed. For each right, any rights dependent on the right are listed, as well as any default site groups that include the right.

For more information about user rights and site groups, see "Managing Site Groups and Permissions" and "Managing Users and Cross-Site Groups" in the Windows SharePoint Services Administrator's Guide. For more information about using the command-line tool, see "Introducing the Administration Tools for Windows SharePoint Services" in the Windows SharePoint Services Administrator's Guide.

Default Site Groups in Windows SharePoint Services

  • Guest
  • Reader
  • Contributor
  • Web Designer
  • Administrator

User Rights Available for Windows SharePoint Services

  • Add and Customize Pages
  • Add Items
  • Add/Remove Private Web Parts
  • Apply Style Sheets
  • Apply Themes and Borders
  • Browse Directories
  • Cancel Check-out
  • Create Cross-Site Groups
  • Create Subsites
  • Delete Items
  • Edit Items
  • Manage Lists
  • Manage List Permissions
  • Manage Personal Views
  • Manage Site Groups
  • Manage Web Site
  • Update Personal Web Parts
  • Use Self-Service Site Creation
  • View Items
  • View Pages
  • View Usage Data

Default Site Groups

Microsoft Windows SharePoint Services includes five site groups by default. You can customize the rights available in these site groups (except for the Guest and Administrator site groups) or add new site groups to combine different sets of rights.

Guest

The Guest site group is designed to be combined with per-list permissions on particular lists to give guest users access to a specific list, without giving them access to the entire site. The Guest site group cannot be customized or deleted.

Command-line name | Rights included by default
guest | None

Reader

The Reader site group allows a user to view items in lists and document libraries, view pages in the site, and create a site using Self-Service Site Creation.

Command-line name | Rights included by default
reader | Use Self-Service Site Creation View Pages View Items

Contributor

The Contributor site group allows a user to interact with Web Parts and lists and document libraries. They can also create and manage personal views and cross-site groups, and personalize Web Part Pages.

Command-line name | Rights included by default
contributor | All rights included in the Reader site group, plus: Add Items Add/Remove Private Web Parts Browse Directories Create Cross-Site Groups Delete Items Edit Items Manage Personal Views Update Personal Web Parts

Web Designer

The Web Designer site group allows a user to customize the Web site using the HTML tools or a Web page editor compatible with Windows SharePoint Services, such as Microsoft Office FrontPage 2003. For example, Web Designers can create lists from within the site or add new pages to the site by using a Web page editor.

Command-line name | Rights included by default
web designer | All rights included in the Contributor site group, plus: Add and Customize Pages Apply Themes and Borders Apply Style Sheets Cancel Check-out Manage Lists

Administrator

The Administrator site group allows a user to have complete control over a Web site. Members of the Administrator site group can configure settings, manage users and site groups, and view usage analysis data.

Command-line name | Rights included by default
administrator | All rights included in the Web Designer site group, plus: Create Subsites Manage List Permissions Manage Site Groups View Usage Data

User Rights

Windows SharePoint Services includes 21 rights, which are used in the five default user site groups. You can change which rights are included in a particular site group (except for the Guest and Administrator site groups) or create a new site group to contain a specific list of rights.

Add and Customize Pages

Grants permission to create ASP.NET, ASP, and HTML pages for a Web site.

Site groups included in by default | Dependent rights
Web Designer, Administrator | Browse Directories, View Pages

Add Items

Grants permission to add items to lists or add documents to document libraries.

Site groups included in by default | Dependent rights
Contributor, Web Designer, Administrator | View Items, View Pages

Add/Remove Private Web Parts

Grants permission to add and remove Web Parts in order to personalize Web Part Pages.

Site groups included in by default | Dependent rights
Contributor, Web Designer, Administrator | Update Personal Web Parts, View Items, View Pages

Apply Style Sheets

Grants permission to apply a style sheet to the entire Web site.

Site groups included in by default | Dependent rights
Web Designer, Administrator | View Pages

Apply Themes and Borders

Grants permission to apply a theme or border to an entire Web site.

Site groups included in by default | Dependent rights
Web Designer, Administrator | View Pages

Browse Directories

Grants permission to browse the directory structure of a Web site.

Site groups included in by default | Dependent rights
Contributor, Web Designer, Administrator | View Pages

Cancel Check-out

Grants permission to cancel the check-out action performed by another user.

Site groups included in by default | Dependent rights
Web Designer, Administrator | View Pages

Create Cross-Site Groups

Grants permission to create or delete cross-site groups, or to change membership of a cross-site group.

Site groups included in by default | Dependent rights
Contributor, Web Designer, Administrator | View Pages

Create Subsites

Grants permission to create a new subsite or workspace site, such as a Document Workspace site or Meeting Workspace site.

Site groups included in by default | Dependent rights
Reader, Contributor, Web Designer, Administrator | View Pages

Delete Items

Grants permission to delete list items and documents from the Web site.

Site groups included in by default | Dependent rights
Contributor, Web Designer, Administrator | View Items, View Pages

Edit Items

Grants permission to edit existing list items and documents in the Web site.

Site groups included in by default | Dependent rights
Contributor, Web Designer, Administrator | View Items, View Pages

Manage Lists

Grants permission to create, edit, or delete lists and change their settings.

Site groups included in by default | Dependent rights
Web Designer, Administrator | View Items, View Pages, Manage Personal Views

Manage List Permissions

Grants permission to change permissions for a list or document library.

Site groups included in by default | Dependent rights
Administrator | Manage Lists, View Items, View Pages, Manage Personal Views

Manage Personal Views

Grants permission to create, edit, or delete personal views on lists.

Site groups included in by default | Dependent rights
Contributor, Web Designer, Administrator | View Items, View Pages

Manage Site Groups

Grants permission to create, delete, and edit site groups, both by changing the rights assigned to the site group and by changing which users are members of the site group.

Site groups included in by default | Dependent rights
Administrator | View Pages

Manage Web Site

Grants permission to perform administration tasks for a particular site or subsite.

Site groups included in by default | Dependent rights
Administrator | View Pages

Update Personal Web Parts

Grants permission to update Web Parts to display personalized information.

Site groups included in by default | Dependent rights
Contributor, Web Designer, Administrator | View Items, View Pages

Use Self-Service Site Creation

Grants permission to use the Self-Service Site Creation tool to create a top-level Web site.

Site groups included in by default | Dependent rights
Reader, Contributor, Web Designer, Administrator | View Pages

View Items

Grants permission to view items in lists, documents in document libraries, and Web discussion comments.

Site groups included in by default | Dependent rights
Reader, Contributor, Web Designer, Administrator | View Pages

View Pages

Grants permission to browse pages in the Web site.

Site groups included in by default | Dependent rights
Reader, Contributor, Web Designer, Administrator | None

View Usage Data

Grants permission to view reports on Web site usage.

Site groups included in by default | Dependent rights
Administrator | View Pages


Files and Permissions

Files and Permissions

This appendix lists the detailed, minimum file permission settings that must be in place for Microsoft Windows SharePoint Services to perform as designed.

Windows SharePoint Services Installation Directory

The Windows SharePoint Services installation directory is C:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\60 by default.

Installation directory | User | Permissions
\ADMISAPI | Users Administrators SYSTEM | Read & Execute Full Control Full Control
\BIN | Users Administrators SYSTEM | Read & Execute Full Control Full Control
\CONFIG | Users Administrators SYSTEM | Read & Execute Full Control Full Control
\ISAPI | Users Administrators SYSTEM | Read & Execute Full Control Full Control
\TEMPLATE | Users Administrators SYSTEM | Read & Execute Full Control Full Control

Web Site Content Area

This listing is for a Web site content area of \inetpub\wwwroot.

Web site content area | User | Permissions
\inetpub Note All directories enclosing the content root will grant LIST permissions to these accounts. |  |
\inetpub\wwwroot\_vti_pvt | Users Administrators SYSTEM IIS_WPG Internet Guest Account (IUSR_*) | Read & Execute, Read Full Control Full Control Read & Execute, Read Special Permissions
web.config | Users Administrators SYSTEM IIS_WPG Internet Guest Account (IUSR_*) | Read & Execute, Read Full Control Full Control Read & Execute, Read, Special Permissions Special Permissions
wpresources\web.config | Users Administrators SYSTEM IIS_WPG IUSR_* Internet Guest Account (IUSR_*) | Read & Execute, Read Full Control Full Control Read & Execute, Read, Special Permissions Special Permissions

Windows Directory

Windows SharePoint Services also changes permissions for two folders in the Microsoft Windows directory (%WinDir%).

Windows directory | User | Permissions
%temp% | Administrators SYSTEM STS_WPG Network Service (for a domain controller only) | Full Control Full Control Read, Write Read, Write
%WinDir%\logfiles\STS | Administrators SYSTEM STS_WPG Network Service (for a domain controller only) | Full Control Full Control Read, Write Read, Write


Special Directories and Storage Locations

Special Directories and Storage Locations

This appendix lists folders and files used by Microsoft Windows SharePoint Services.

Installation Directory Files

The following files are added to the installation directory (c:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\60) when you install Windows SharePoint Services.

Folder | Description | Files and purpose
\ADMISAPI | The physical directory addressed by the SharePoint Central Administration virtual directory. | admin.asmx — ISAPI filter for administration
\BIN | Contains the core binary files for Windows SharePoint Services. | *.DLL — Core binary files OWSTIMER.EXE — Microsoft SharePoint Timer service SMIGRATE.EXE — Microsoft SharePoint Migration Tool STSADM.EXE — Stsadm utility STSCFG.EXE — Configuration utility used by Setup
\BIN\LCID\ | Contains the core binary files used by specific languages. | FPEXT.MSG — Error messages and text strings ONETINTL.DLL — Core international binary file
\CONFIG | Contains configuration files and default values for the server. | *.xml — XML files used to map default values appwpresweb.config — Configuration file adminweb.config — Configuration file for the administrative virtual server gacwpresweb.config — Configuration file layoutsweb.config — Configuration file for the _layouts directory web.config — Configuration file for virtual servers wss_mediumtrust.config — Configuration file wss_minimaltrust.config — Configuration file
\ISAPI | The physical directory addressed by the /_vti/_bin virtual directory. | *.asmx — SOAP protocol receptors *.aspx — Form pages Global.asax — ASP.NET namespace definition *.xml — XML file for managed code *.DLL — Core binary files for managed code web.config — Configuration file
\ISAPI\BIN | Contains binary files for the /_vti/_bin virtual directory. | STSSOAP.DLL — Binary file used for SOAP code
\ISAPI\HELP\LCID\STS\HTML | Contains Help files and support files used in the Help system. | *.css *.htm *.js layout.swf
\ISAPI\HELP\LCID\STS\IMAGES | Contains images used in the Help system. | *.gif
\ISAPI_VTI_ADM | Contains Microsoft Office FrontPage 2003 legacy binary files. | ADMIN.DLL — Binary file used for administration from Office FrontPage 2003
\ISAPI\_VTI_AUT | Contains Office FrontPage 2003 legacy binary files. | AUTHOR.DLL — Binary file used for authoring from Office FrontPage 2003
\TEMPLATE | Contains all site templates and core Web site files. |
\TEMPLATE\LCID\MPS | Contains files that are copied to the root of the Web site upon instantiation with a Meeting Workspace template (for example, default.aspx). | *.aspx — Form pages
\TEMPLATE\LCID\MPS\DOCTEMP\SMARTPGS\ | Contains files used for Web Part Pages in Meeting Workspaces. | spstd1.aspx — Form page
\TEMPLATE\LCID\MPS\LISTS | Contains the actual lists used in the Meeting Workspace templates, along with schema definition and default views. |
\TEMPLATE\LCID\MPS\LISTS\AGENDA | Contains files used for the Agenda list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\MPS\LISTS\DECISION | Contains files used for the Decisions list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\MPS\LISTS\DOCLIB | Contains files used for document libraries in the Meeting Workspace templates. | *.aspx — Form pages *.HTM — Dialog boxes SCHEMA.XML — Schema file
\TEMPLATE\LCID\MPS\LISTS\MEETINGS | Contains files used for the Meeting Workspace templates. | MoveToDt.ASPX — Form page SCHEMA.XML — Schema file
\TEMPLATE\LCID\MPS\LISTS\OBJECTIV | Contains files used for the Objectives list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\MPS\LISTS\PEOPLE | Contains files used for the Attendees list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\MPS\LISTS\TEXTBOX | Contains files used for the Text Box list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\MPS\LISTS\THGBRING | Contains files used for the Things to Bring list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\MPS\LISTS\WKSPGLIB | Contains files used for lists in the Meeting Workspace templates. | SCHEMA.XML — Schema file
\TEMPLATE\LCID\MPS\XML | Contains the available lists in the Meeting Workspace templates, base types for fields (onet.xml), and the standard view template for new views. | *.XML — XML files for site schema and views
\TEMPLATE\LCID\STS | Contains files that are copied to the root of the Web site upon instantiation with the Team Site template (for example, default.aspx). | default.aspx — Default home page for sites based on Team Site templates
\TEMPLATE\LCID\STS\DOCTEMP\BLANKPGS | Contains the default document templates. | bpstd.aspx _blankpage.htm
\TEMPLATE\LCID\STS\DOCTEMP\FP | Contains document templates for Office FrontPage 2003. | FPTMPL.HTM — Default document templates for FrontPage documents
\TEMPLATE\LCID\STS\DOCTEMP\PPT | Contains document templates for Microsoft Office PowerPoint 2003. | FILELIST.XML MASTER03.CSS MASTER03.HTM MASTER03.XML PPTMPL.HTM PPTMPL.POT PRES.XML PREVIEW.WMF SLIDE001.HTM
\TEMPLATE\LCID\STS\DOCTEMP\SMARTPGS | Contains document templates for Web Part Pages. | *.aspx _smartpage.htm _webpartpage.htm
\TEMPLATE\LCID\STS\DOCTEMP\WORD | Contains document templates for Microsoft Office Word 2003. | WDTMPL.DOC WDTMPL.HTM
\TEMPLATE\LCID\STS\DOCTEMP\XL | Contains document templates for Microsoft Office Excel 2003. | FILELIST.XML SHEET001.HTM SHEET002.HTM SHEET003.HTM STYLE.CSS TABSTRIP.HTM XLTMPL.HTM XLTMPL.XLS
\TEMPLATE\LCID\STS\DOCTEMP\XMLFORMS\BLANK | Contains document templates for Microsoft Office InfoPath 2003. | TEMPLATE.XML — Default document templates for XML documents
\TEMPLATE\LCID\STS\DWS | Contains files that are copied to the root of the Web site upon instantiation with a Document Workspace template. | default.aspx — Default home page for Document Workspaces
\TEMPLATE\LCID\STS\LISTS | Contains the actual lists along with schema definition and default views. |
\TEMPLATE\LCID\STS\LISTS\ANNOUNCE | Contains files used for the Announcements list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\CONTACTS | Contains files used for the Contacts list. | *.aspx — Form pages SCHEMA.XML — Schema file VCARD.VCF — Contacts form
\TEMPLATE\LCID\STS\LISTS\CUSTLIST | Contains files used for custom lists. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\DATASRCS | Contains files used for data sources for lists. | SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\DISCUSS | Contains files used for the Discussion Board list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\DOCLIB | Contains files used for document libraries. | *.aspx — Form pages *.HTM — Dialog boxes SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\EVENTS | Contains files used for the Events list. | *.aspx — Form pages EVENT.ICS — Event form SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\FAVORITE | Contains files used for the Favorites list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\GRIDLIST | Contains files used for the Datasheet view of lists. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\IMGLIB | Contains files used for picture libraries. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\ISSUE | Contains files used for the Issues list. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\LISTTEMP | Contains files used for the list template gallery. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\TASKS | Contains files used for the Tasks list. | *.aspx — Form pages SCHEMA.XML — Schema file TASK.ICS — Task form
\TEMPLATE\LCID\STS\LISTS\VOTING | Contains files used for surveys. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\WEBTEMP | Contains files used for the site template gallery. | *.aspx — Form pages *.HTM — Dialog boxes SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\WPLIB | Contains files used for the Web Part gallery. | *.aspx — Form pages SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\LISTS\WPLIB\DWP | Contains Web Part files. | *.dwp — Default Web Parts in the site collection Web Part gallery
\TEMPLATE\LCID\STS\LISTS\XMLFORM | Contains files used for form libraries. | *.aspx — Form pages *.HTM — Dialog boxes SCHEMA.XML — Schema file
\TEMPLATE\LCID\STS\XML | Contains the available lists in the site template, base types for fields (onet.xml), and the standard view template for new views. | *.XML — XML files for site schema and views
\TEMPLATE\LCID\XML | Contains the XML files with base list and field types defined for all site templates. | *.XML — XML templates used in all site templates for a particular language
\TEMPLATE\ADMIN\LCID | Contains files used for the site administration pages. | *.aspx, *.css, *.js — Administration pages, styles, and JavaScript files
\TEMPLATE\ADMIN\LCID\aspnet_client\system_web\Version | Contains ASP.NET files. | SmartNav.htm SmartNav.js WebUIValidation.js ASP.NET files
\TEMPLATE\ADMIN\LCID\BIN | Contains binary files used for the site administration pages. | *.DLL - Core binaries
\TEMPLATE\ADMIN\LCID\XML | Contains XML files used for the site administration pages. | adminleftnavbar.sts.xml — XML file for the left link bar (Action menu and Views list) setuperror.htm — Setup messages
\TEMPLATE\IMAGES | Contains images shared by all pages on the server, addressed by the virtual directory /_layouts/images. | *.gif, *.jpg, *.png
\TEMPLATE\LAYOUTS | Addressed by the virtual directory /_layouts, this directory contains language subdirectories that contain the forms for creating lists, site administration pages, and so on. These directories are shared by all sites. | Global.asax — ASP.NET namespace definition *.aspx — Form pages web.config — Configuration file
\TEMPLATE\LAYOUTS\LCID | Contains forms for creating lists, site administration pages, and so on, for a specific language. | *.aspx — Form pages *.css — Style sheets *.htm — Dialog boxes *.htc — Menu control *.js — JavaScript files *.xml — XML templates *.xsd — XML definitions
\TEMPLATE\LAYOUTS\LCID\IMAGES | Contains images used in the default site pages for a specific language. | *.gif, *.jpg
\TEMPLATE\LAYOUTS\LCID\MPS | Contains form pages and scripting files for Meeting Workspaces. Note This folder is added only if you have used a Meeting Workspace template. | *.aspx — Form pages MEETINGS.JS — JavaScript file
\TEMPLATE\LAYOUTS\LCID\STYLES | Contains style sheets shared by all site templates for a particular language. Addressable by the virtual directory /_layouts/styles. | *.CSS — Style sheets
\TEMPLATE\LAYOUTS\BIN | Contains core binary files. | Microsoft.SharePoint.ApplicationPages.dll — Core binary
\TEMPLATE\SQL | Contains stored procedures for Microsoft SQL Server. | *.SQL — Stored procedures for SQL Server
\TEMPLATE\THEMES | Contains the list of themes. | THEMES.INF — Themes list
\TEMPLATE\THEMES\Theme | Contains files used by a specific theme. | *.gif — Images *.css — Style sheets theme.INF — Theme definition file theme.utf8 — Theme file for UTF8 encoding
\TEMPLATE\XML | Contains XML files used by all site templates in all languages. | *.XML — Templates used across all languages and site types
\TEMPLATE\XML\HELP | Contains XML files used by the Help system. | STS.XML — Context-sensitive Help mapping file

Web Part Resource Files

In addition to the installation directory, there is a Web Part resources directory that contains files used to support custom Web Parts in Windows SharePoint Services. The c:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\wpresources directory contains a web.config file that is used to help control security for ASP.NET files used in Web Parts. For more information about custom Web Parts, see the Windows SharePoint Services Software Development Kit.

Web Site Content Files

The following files are added to each top-level Web site or subsite when a SharePoint site is created.

Folder | Description | Files and purpose
\inetpub\folder | Configuration file | web.config
\inetpub\folder\_vti_pvt | SpeedDial shortcuts | service services
\inetpub\folder\wpresources\ | Configuration file for Web Parts | web.config

All other Web site files are stored in the content and configuration database.


Regional and Language Settings

Regional and Language Settings

This topic lists the regional and language settings you can specify from the command line by using operations in Stsadm.exe and by using HTML Administration pages. For more information about specifying regional and language settings, see Language Considerations. For more information about the syntax for command-line operations, see Command-Line Operations.

The following types of regional and language settings are used in Microsoft Windows SharePoint Services:

  • Language IDs
  • Locale IDs
  • Time zones
  • Currency IDs

Language IDs

The Language ID determines the language used for text on pages in the Web site (such as the text on the Site Settings page). The languages available for site creation depend on the language template packs you have installed to your server or server farm. Web sites based on Windows SharePoint Services can be created in the following languages.

ID | Language | ID | Language
1025 | Arabic | 1041 | Japanese
1028 | Chinese - Traditional | 1042 | Korean
1029 | Czech | 1043 | Dutch
1030 | Danish | 1044 | Norwegian
1031 | German | 1045 | Polish
1032 | Greek | 1046 | Portuguese - Brazilian
1033 | English | 1049 | Russian
1034 | Spanish | 1053 | Swedish
1035 | Finnish | 1054 | Thai
1036 | French | 1055 | Turkish
1037 | Hebrew | 2052 | Chinese - Simplified
1038 | Hungarian | 2070 | Portuguese
1040 | Italian | 3076 | Chinese - Hong Kong SAR

Windows SharePoint Services also supports input and display of text in the following languages, but not site creation.

ID | Language | ID | Language
1026 | Bulgarian | 1048 | Romanian
1050 | Croatian | 2074 | Serbian
1061 | Estonian | 1051 | Slovak
1081 | Hindi with Indic PT | 1060 | Slovenian
1062 | Latvian | 1058 | Ukrainian
1063 | Lithuanian |  |

Locale IDs

The Locale ID controls the numbering, sorting, calendar, and time formatting for the Web site. You can change the locale for a Web site by using the Regional Settings page. Web sites based on Windows SharePoint Services can be set to the following Locale IDs.

ID | Locale | ID | Locale
1078 | Afrikaans | 1037 | Hebrew
1052 | Albanian | 1081 | Hindi
5121 | Arabic (Algeria) | 1038 | Hungarian
15361 | Arabic (Bahrain) | 1039 | Icelandic
3073 | Arabic (Egypt) | 1057 | Indonesian
2049 | Arabic (Iraq) | 1040 | Italian (Italy)
11265 | Arabic (Jordan) | 2064 | Italian (Switzerland)
13313 | Arabic (Kuwait) | 1041 | Japanese
12289 | Arabic (Lebanon) | 1099 | Kannada
4097 | Arabic (Libya) | 1087 | Kazakh
6145 | Arabic (Morocco) | 1111 | Konkani
8193 | Arabic (Oman) | 1042 | Korean
16385 | Arabic (Qatar) | 1088 | Kyrgyz (Cyrillic)
1025 | Arabic (Saudi Arabia) | 1062 | Latvian
10241 | Arabic (Syria) | 1063 | Lithuanian
7169 | Arabic (Tunisia) | 1071 | Macedonian (FYROM)
14337 | Arabic (U.A.E.) | 2110 | Malay (Brunei Darussalam)
9217 | Arabic (Yemen) | 1086 | Malay (Malaysia)
1067 | Armenian | 1102 | Marathi
2092 | Azeri (Cyrillic) | 1104 | Mongolian (Cyrillic)
1068 | Azeri (Latin) | 1044 | Norwegian (Bokmal)
1069 | Basque | 2068 | Norwegian (Nynorsk)
1059 | Belarusian | 1045 | Polish
1026 | Bulgarian | 1046 | Portuguese (Brazil)
1027 | Catalan | 2070 | Portuguese (Portugal)
3076 | Chinese (Hong Kong SAR) | 1094 | Punjabi
5124 | Chinese (Macau SAR) | 1048 | Romanian
2052 | Chinese (PRC) | 1049 | Russian
4100 | Chinese (Singapore) | 1103 | Sanskrit
1028 | Chinese (Taiwan) | 3098 | Serbian (Cyrillic)
1050 | Croatian | 2074 | Serbian (Latin)
1029 | Czech | 1051 | Slovak
1030 | Danish | 1060 | Slovenian
1125 | Divehi | 11274 | Spanish (Argentina)
2067 | Dutch (Belgium) | 16394 | Spanish (Bolivia)
1043 | Dutch (Netherlands) | 13322 | Spanish (Chile)
3081 | English (Australia) | 9226 | Spanish (Colombia)
10249 | English (Belize) | 5130 | Spanish (Costa Rica)
4105 | English (Canada) | 7178 | Spanish (Dominican Republic)
9225 | English (Caribbean) | 12298 | Spanish (Ecuador)
6153 | English (Ireland) | 17418 | Spanish (El Salvador)
8201 | English (Jamaica) | 4106 | Spanish (Guatemala)
5129 | English (New Zealand) | 18442 | Spanish (Honduras)
13321 | English (Philippines) | 2058 | Spanish (Mexico)
7177 | English (South Africa) | 19466 | Spanish (Nicaragua)
11273 | English (Trinidad) | 6154 | Spanish (Panama)
2057 | English (United Kingdom) | 15370 | Spanish (Paraguay)
1033 | English (United States) | 10250 | Spanish (Peru)
12297 | English (Zimbabwe) | 20490 | Spanish (Puerto Rico)
1061 | Estonian | 3082 | Spanish (Spain)
1080 | Faeroese | 1034 | Spanish (Traditional Sort) - Spain
1065 | Farsi | 14346 | Spanish (Uruguay)
1035 | Finnish | 8202 | Spanish (Venezuela)
2060 | French (Belgium) | 1089 | Swahili
3084 | French (Canada) | 1053 | Swedish
1036 | French (France) | 2077 | Swedish (Finland)
5132 | French (Luxembourg) | 1114 | Syriac
6156 | French (Monaco) | 1097 | Tamil
4108 | French (Switzerland) | 1092 | Tatar
1110 | Galician | 1098 | Telugu
1079 | Georgian | 1054 | Thai
3079 | German (Austria) | 1055 | Turkish
1031 | German (Germany) | 1058 | Ukrainian
5127 | German (Liechtenstein) | 1056 | Urdu
4103 | German (Luxembourg) | 2115 | Uzbek (Cyrillic)
2055 | German (Switzerland) | 1091 | Uzbek (Latin)
1032 | Greek | 1066 | Vietnamese
1095 | Gujarati |  |

Time Zones

Web sites based on Windows SharePoint Services can be set to any of the time zones recognized by Microsoft Windows Server 2003.

Code | Time zone | Code | Time zone
39 | (GMT-12:00) Eniwetok, Kwajalein | 59 | (GMT+02:00) Helsinki, Riga, Tallinn
16 | (GMT-11:00) Midway Island, Samoa | 27 | (GMT+02:00) Jerusalem 26 (GMT+03:00) Baghdad
15 | (GMT-10:00) Hawaii | 74 | (GMT+03:00) Kuwait, Riyadh
14 | (GMT-09:00) Alaska | 51 | (GMT+03:00) Moscow, St. Petersburg, Volgograd
13 | (GMT-08:00) Pacific Time (US and Canada); Tijuana | 56 | (GMT+03:00) Nairobi
38 | (GMT-07:00) Arizona | 25 | (GMT+03:30) Tehran
12 | (GMT-07:00) Mountain Time (US and Canada) | 24 | (GMT+04:00) Abu Dhabi, Muscat
55 | (GMT-06:00) Central America | 54 | (GMT+04:00) Baku, Tbilisi, Yerevan 48 (GMT+04:30) Kabul
11 | (GMT-06:00) Central Time (US and Canada) | 58 | (GMT+05:00) Ekaterinburg
37 | (GMT-06:00) Mexico City | 47 | (GMT+05:00) Islamabad, Karachi, Tashkent
36 | (GMT-06:00) Saskatchewan | 23 | (GMT+05:30) Calcutta, Chennai, Mumbai, New Delhi
35 | (GMT-05:00) Bogota, Lima, Quito | 62 | (GMT+05:45) Kathmandu 46 (GMT+06:00) Almaty, Novosibirsk
10 | (GMT-05:00) Eastern Time (US and Canada) | 71 | (GMT+06:00) Astana, Dhaka
34 | (GMT-05:00) Indiana (East) | 66 | (GMT+06:00) Sri Jayawardenepura
9 | (GMT-04:00) Atlantic Time (Canada) | 61 | (GMT+06:30) Yangon (Rangoon)
33 | (GMT-04:00) Caracas, La Paz | 22 | (GMT+07:00) Bangkok, Hanoi, Jakarta
65 | (GMT-04:00) Santiago | 64 | (GMT+07:00) Krasnoyarsk
28 | (GMT-03:30) Newfoundland 8 (GMT-03:00) Brasilia | 45 | (GMT+08:00) Beijing, Chongqing, Hong Kong SAR, Urumqi
32 | (GMT-03:00) Buenos Aires, Georgetown | 63 | (GMT+08:00) Irkutsk, Ulaan Bataar
60 | (GMT-03:00) Greenland | 21 | (GMT+08:00) Kuala Lumpur, Singapore
30 | (GMT-02:00) Mid-Atlantic | 73 | (GMT+08:00) Perth 75 (GMT+08:00) Taipei
29 | (GMT-01:00) Azores | 20 | (GMT+09:00) Osaka, Sapporo, Tokyo 72 (GMT+09:00) Seoul
53 | (GMT-01:00) Cape Verde Is. | 70 | (GMT+09:00) Yakutsk 19 (GMT+09:30) Adelaide
31 | (GMT) Casablanca, Monrovia | 44 | (GMT+09:30) Darwin
2 | (GMT) Greenwich Mean Time : Dublin, Edinburgh, Lisbon, London | 18 | (GMT+10:00) Brisbane
4 | (GMT+01:00) Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna | 76 | (GMT+10:00) Canberra, Melbourne, Sydney
6 | (GMT+01:00) Belgrade, Bratislava, Budapest, Ljubljana, Prague | 43 | (GMT+10:00) Guam, Port Moresby
3 | (GMT+01:00) Brussels, Copenhagen, Madrid, Paris | 42 | (GMT+10:00) Hobart
57 | (GMT+01:00) Sarajevo, Skopje, Sofija, Vilnius, Warsaw, Zagreb | 68 | (GMT+10:00) Vladivostok
69 | (GMT+01:00) West Central Africa | 41 | (GMT+11:00) Magadan, Solomon Is., New Caledonia
7 | (GMT+02:00) Athens, Istanbul, Minsk | 17 | (GMT+12:00) Auckland, Wellington
5 | (GMT+02:00) Bucharest | 40 | (GMT+12:00) Fiji Islands, Kamchatka, Marshall Is.
49 | (GMT+02:00) Cairo | 67 | (GMT+13:00) Nuku'alofa
50 | (GMT+02:00) Harare, Pretoria |  |

Currency IDs

Web sites based on Windows SharePoint Services can be set to use the following currencies.

ID | Currency | ID | Currency
5121 | 1,254 .ج.د (Arabic-Algeria) | 4106 | Q1,254 (Guatemala)
15361 | 1,254 .ب.د (Arabic-Bahrain) | 18442 | L. 1254 (Honduras)
3073 | 1,254 .م.ج (Arabic-Egypt) | 3076 | HK$1,254 (Hong Kong SAR)
2049 | 1,254 .ع.د (Arabic-Iraq) | 1038 | 1 254 Ft (Hungary)
11265 | 1,254 .ا.د (Arabic-Jordan) | 1081 | रु 1,254 (India)
13313 | 1,254 .ك.د (Arabic-Kuwait) | 6153 | IR£1,254 (Ireland)
12289 | 1,254 .ل.ل (Arabic-Lebanon) | 1037 | ₪1,254 (Israel)
4097 | 1,254 .ل.د (Arabic-Libya) | 1041 | ¥1,254 (Japan)
6145 | 1,254 .م.د (Arabic-Morocco) | 1042 | ₩1,254 (Korea)
8193 | 1,254 .ع.ر (Arabic-Oman) | 2058 | $1,254 (Mexico)
16385 | 1,254 .ق.ر (Arabic-Qatar) | 5129 | $1,254 (New Zealand)
1025 | 1,254 .س.ر (Arabic-Saudi Arabia) | 19466 | C$ 1254 (Nicaragua)
10241 | 1,254 .س.ل (Arabic-Syria) | 1044 | kr 1 254 (Norway)
7169 | 1,254 .ت.د (Arabic-Tunisia) | 1056 | Rs 1,254 (Pakistan)
14337 | 1,254 .إ.د (Arabic-U.A.E) | 6154 | B/. 1,254 (Panama)
9217 | 1,254 .ي.ر (Arabic-Yemen) | 15370 | Gs 1.254 (Paraguay)
11274 | $ 1.254 (Argentina) | 2052 | ￥1,254 (People's Republic of China)
3081 | $1,254 (Australia) | 10250 | S/. 1,254 (Peru)
3079 | öS 1.254 (Austria) | 1045 | 1 254 zł (Poland)
16394 | $b 1.254 (Bolivia) | 1049 | 1 254р. (Russia)
1046 | R$ 1.254 (Brazil) | 4100 | $1,254 (Singapore)
3084 | 1 254 $ (Canada) | 1051 | 1 254 Sk (Slovakia)
4105 | $1,254 (Canada) | 1060 | 1.254 SIT (Slovenia)
13322 | $ 1.254 (Chile) | 7177 | R 1,254 (South Africa)
9226 | $ 1.254 (Colombia) | 1053 | 1.254 kr (Sweden)
5130 | C1.254 (Costa Rica) | 2055 | SFr. 1'254 (Switzerland)
1029 | 1 254 Kč (Czech Republic) | 1028 | NT$1,254 (Taiwan)
1030 | kr 1.254 (Denmark) | 1054 | ฿1,254 (Thai)
7178 | RD$1,254 (Dominican Republic) | 1055 | 1.254 TL (Turkey)
17418 | C1254 (El Salvador) | 2057 | £1,254 (United Kingdom)
-2 | 1,254 € (European Union) | 1033 | $1,254 (United States)
-1 | € 1,254 (European Union) | 14346 | $U 1.254 (Uruguay)
1065 | 1,254 ريال (Farsi) | 8202 | Bs 1.254 (Venezuela)
1032 | 1.254 Δρχ (Greece) | 1066 | 1,254 ₫ (Vietnamese)


Glossary

Glossary
A | B | C | D | E | F | H | I | J | L | M | N | P
Q | R | S | T | U | V | W
A
Back to top
access control list (ACL)
Contains a list of users or groups and their security permissions. Identifies who can update, modify, or delete an object on a computer or resource on the network.
Active Server Pages (ASP pages)
A technology that allows Web developers to combine scripts and HTML code to create dynamic Web content and Web-based applications.
administration port
The Internet Information Services (IIS) virtual server and port used for SharePoint Central Administration.
alert
A feature that notifies a user by e-mail when there is a change to an item, document, list, or document library on the Web site.
Anonymous authentication
An authentication method that provides access to users who do not have user accounts on the server computer.
Anonymous user access
The ability to gain access to a Web server on which one does not have an account. Usually, anonymous users have more restricted access rights than users with accounts.
application pool
In Internet Information Services (IIS), a group of one or more URLs served by a worker process.
B
Back to top
Basic authentication
An authentication protocol supported by most Web servers and browsers. Transmits the user name and password in clear text.
C
Back to top
cache
A special memory subsystem in which frequently used data values are duplicated for quick access.
Certificate authentication
An authentication method that provides security for TCP/IP connections. Also known as Secure Sockets Layer (SSL).
character set
A group of alphabetic, numeric, and other characters that have some relationship in common. For example, the standard ASCII character set includes letters, numbers, symbols, and control codes that make up the ASCII coding scheme. See also code page.
check in
To release the lock for editing and enable other users to view the updated file or check out the file.
check out
To lock a file while editing it to prevent others from overwriting or editing it inadvertently. Only the user who checks out a document can edit the document.
clear text
Unencrypted, non-machine dependent, ASCII text in readable form.
code page
An ordered set of characters in which a numeric index (code point) is associated with each character of a particular writing system. There are separate code pages for different writing systems, such as Western European and Cyrillic.
code point
A numeric value in Unicode encoding or in a code page; corresponds to a character. In the Western European code page, 132 is the code point for the character ä; however, in another code page, the code point 132 might correspond to a different character.
Common Gateway Interface (CGI)
A standard method of extending Web server functionality by executing programs or scripts on a Web server in response to Web browser requests, such as in form processing. Use of CGI can make a Web page more dynamic.
configuration database
The Microsoft SQL Server or MSDE database that contains the configuration information that applies across all servers in a deployment of Windows SharePoint Services, such as virtual server information.
configuration property
A property that allows an administrator to control Windows SharePoint Services settings.
connection type
The type of Web Part connection. For example, the Provide Row To connection type passes a row of data from one Web Part to another Web Part, and the Get Filter From connection type gets a value from one Web Part and filters the data in another Web Part based on that value.
content database
The Microsoft SQL Server or WMSDE database that contains the content for one or more SharePoint sites.
cross-site group
A custom security group that applies to more than one Web site. A cross-site group can be assigned to a site group as if it was a single user.
D
Back to top
Digest Access authentication
An authentication method that transmits user names and passwords in a secure format.
discussion server
A computer that stores discussion text and information about the location of the file being discussed.
discussion thread
In a discussion board or Web discussions, a series of messages or comments in which replies to a message or comment are nested directly under it, instead of the messages or comments being arranged in chronological or alphabetical order.
document library
A folder where a collection of files is stored and the files often use the same template. Each file in a library is associated with user-defined information that is displayed in the content listing for that library.
Document Workspace site
A Web site based on the Document Workspace template that workspace members use for discussing, editing, and working together on a document.
E
Back to top
encryption
A method used to scramble the content of a file or data packet to make the data unreadable without the decryption key.
encryption key
A block of data that is used to encrypt or decrypt information.
encryption, 128-bit
A high level of encryption that uses a 128-bit key to scramble the contents of a file or data packet to make the data unreadable without the decryption key.
encryption, 40-bit
Low level of encryption that uses a 40-bit key to scramble the contents of a file or data packet to make the data unreadable without the decryption key.
extend
To apply Windows SharePoint Services to a virtual server.
extranet
An external Web site for an organization; usually secured so that only authorized users can gain access to it.
F
Back to top
file allocation table (FAT)
A common format for file cataloging used by MS-DOS and Microsoft Windows operating systems to manage files on a hard disk; a physical method of storing and accessing files from a hard disk. The FAT contains a list of all files on the physical or logical drive.
File Transfer Protocol (FTP)
A protocol used to gain remote access to a Web server.
firewall
A security system that uses a proxy server outside of an organization's network to protect the network against external threats, such as malicious users or corrupt files.
FrontPage Server Extensions
A set of programs and scripts that support authoring in Microsoft Office FrontPage and extend the functionality of a Web server.
H
Back to top
home page
The main page of a Web site. A home page usually has hyperlinks to other pages, both inside and outside the site.
hyperlink
A colored and underlined block of text or a graphic that a user clicks to go to a file, a location in a file, an HTML page on the World Wide Web, or an HTML page on an intranet. Hyperlinks can also go to newsgroups and to Gopher, Telnet, and FTP sites.
I
Back to top
Integrated Windows authentication
An authentication method that encrypts user names and passwords in a multiple-transaction interaction between client and server. Also known as Windows NT Challenge/Response authentication.
Internet
The worldwide collection of networks and gateways that use the TCP/IP suite of protocols to communicate with one another. If you have access to the Internet, you can retrieve information from millions of sources, including schools, governments, businesses, and individuals.
Internet Information Services (IIS)
Software services from Microsoft that support Web site creation, configuration, and management, along with other Internet functions. Internet Information Services include Network News Transfer Protocol (NNTP), File Transfer Protocol (FTP), and Simple Mail Transfer Protocol (SMTP).
Internet Server Application Programming Interface (ISAPI)
A Web server application-development interface, developed by Process Software and Microsoft, that can be used in place of CGI.
intranet
A private network for an organization based on Internet protocols such as TCP/IP.
J
Back to top
JScript
An object-based scripting language distantly and loosely related to Java. JScript code is inserted directly into an HTML page.
L
Back to top
list
A Web site component that stores and displays information that users can add to by using their browsers. Requires a Web server that is running Windows SharePoint Services.
local administrators group
The group of users who have permission to perform administration tasks on the local server computer. The permissions for this group are set by using the administration tools for the operating system.
locale ID (LCID)
A 32-bit value defined by Microsoft Windows that identifies a particular language. The LCID consists of a language ID, a sort ID, and reserved bits. For example, the LCID for U.S. English is 1033, and the LCID for Japanese is 1041.
M
Back to top
Meeting Workspace site
A Web site based on a Meeting Workspace site template that is used for planning, posting, and working together on meeting materials, and following up after a meeting or series of meetings.
Microsoft SQL Server 2000 Desktop Engine (MSDE 2000)
A data store based on Microsoft SQL Server technology, but designed and optimized for use on smaller computer systems, such as a single-user computer or a small workgroup server. Previously known as Microsoft Data Engine.
Microsoft SQL Server 2000 Desktop Engine (Windows) (WMSDE 2000)
A version of MSDE 2000 designed specifically for Windows SharePoint Services.
multihosting
The ability of a Web server to support more than one Internet address and more than one home page. Also called multihoming.
N
Back to top
network domain name
A group of users in a network who share a common set of shared resources, such as server disk drives and printers. A large network may have several domains based upon the needs of each set of users.
NTFS file system
An advanced file system designed for use specifically with Microsoft Windows NT and later operating systems. NTFS allows for stronger security and more flexible file management methods than FAT. See also file allocation table (FAT).
P
Back to top
personal view
A view of a list, SharePoint document library, or Web Part Page that is available only to a particular user. The personal view of a Web Part Page uses a combination of shared property values and personalized property values. Changes made to a personal view apply only to the list, library, or page in that view and are therefore visible to that user only.
personalized Web Part
A shared Web Part that has been modified by a user in personal view. The changes made to a Web Part personalized in this way are visible only to the user who made those changes.
private Web Part
A Web Part added to a Web Part Page by a user who is working on the page in personal view. Private Web Parts are available only to the user who added or imported the Web Part.
Q
Back to top
quiet installation
An installation run by using the /q command-line option that runs without generating any user prompts. Also known as unattended installation.
quota
A value that limits the amount of storage or number of users for a Web site.
quota template
A predefined set of quotas to apply to a site or to all sites on a virtual server.
R
Back to top
remote host
A Web server on a separate server computer. A remote host is connected to other servers by a network connection.
rights
File-level and folder-level permissions that allow access to a Web site.
role
See site group.
S
Back to top
scripting language
A programming language designed specifically for Web site programming. Examples include JScript and Microsoft Visual Basic Scripting Edition (VBScript).
Secure Sockets Layer (SSL)
A proposed open standard that was developed by Netscape Communications for establishing a secure communications channel to prevent the interception of critical information, such as credit card numbers.
server farm
A centralized grouping of network servers maintained by an enterprise or, often, an Internet service provider (ISP). A server farm provides a network with load balancing, scalability, and fault tolerance. Individual servers may be connected in such a way that they appear to represent a single resource.
Setupsts.exe
The setup program for Windows SharePoint Services.
shared view
A view of a list, document library, or Web Part Page that every user with the appropriate rights for a site can see. The shared view of a Web Part Page uses shared property values. Changes made to a shared view apply to the list, library, or page as it appears to all users.
shared Web Part
A Web Part added to a Web Part Page by a user who is working on the page in shared view. Shared Web Parts are available to all users of a Web Part Page who have the appropriate permissions.
site
A group of related Web pages that is hosted by an HTTP server on the World Wide Web or an intranet. The pages in a Web site generally cover one or more topics and are interconnected through hyperlinks. Most Web sites have a home page as their starting point.
site collection
A set of Web sites on a virtual server that have the same owner and share administration settings. Each site collection contains a top-level Web site and can contain one or more subsites. There can be multiple site collections on each virtual server.
site group
A custom security group that applies to a specific Web site. Users are assigned to site groups to grant them rights on a SharePoint site.
SMTP mail server
An e-mail server that uses the Simple Mail Transfer Protocol (SMTP). SMTP is a member of the TCP/IP suite of protocols that governs the exchange of electronic mail between message transfer agents.
SQL Server computer
A computer running Microsoft SQL Server with a configured database.
static Web Part
A Web Part added to a Web page (.aspx) and that is not in a Web Part zone.
subsite
A complete Web site stored in a named subdirectory of the top-level Web site. Each subsite can have administration, authoring, and browsing permissions that are independent from the top-level Web site and other subsites.
survey
A Web site component that presents users with a set of questions specified by the creator of the survey and collects user responses. Results are tallied in a graphical summary. A survey requires a Web server that is running Windows SharePoint Services.
T
Back to top
tool pane
A task pane on a Web Part Page used to browse, search for, and import Web Parts from Web Part galleries, and to modify custom and common Web Part properties.
tool part
A control in the tool pane that allows users to set properties, execute commands, invoke wizards, and manipulate Web Parts on a Web Part Page.
top-level Web site
The default, top-level site provided by a Web server or virtual server. To gain access to the top-level Web site, you supply the URL of the server without specifying a page name or subsite.
U
Back to top
Uniform Resource Locator (URL)
An address that specifies a protocol (such as HTTP or FTP) and a location of an object, document, World Wide Web page, or other destination on the Internet or an intranet. Example: http://www.microsoft.com/.
usage analysis
Data collected to evaluate how a Web site is being used, such as visitor user names, number of visits to each page, and the types of Web browsers used.
user locale
A setting that determines formats and sort orders for date, time, currency, and so on. Also known as regional settings.
V
Back to top
vCard
The Internet standard for creating and sharing virtual business cards.
versioning
The process of creating a backup copy of a document or picture whenever a revision is saved to the library.
virtual server
A virtual computer that resides on an HTTP server but appears to the user as a separate HTTP server. Several virtual servers can reside on one computer, each capable of running its own programs and each with individualized access to input and peripheral devices. Each virtual server can have its own domain name and IP address.
Visual Basic Scripting Edition (VBScript)
A subset of the Visual Basic for Applications programming language optimized for Web-related programming. As with Microsoft JScript, code for VBScript is embedded in HTML documents.
W
Back to top
Web address
The path to an object, document, file, page, or other destination. An address can be a URL (Web address) or a UNC path (network address), and can include a specific location within a file, such as a Word bookmark or an Excel cell range. Also known as address.
Web discussion
Comments that users attach to Web pages and documents. Known as Web discussions to differentiate from discussion boards. Requires a Web server that is running SharePoint Team Services or Windows SharePoint Services.
Web farm
See server farm.
Web Part
A modular unit of information that consists of a title bar, a frame, and content. Web Parts are the basic building blocks of a Web Part Page. A Web Part is the combination of a Web Part Description file (.dwp) and a Web Part assembly file (.dll). All Web Parts are based on Web Custom Controls.
Web Part description file (.dwp)
An XML file that defines default property settings for installing a Web Part, including references to any other files required to run and display the part.
Web Part Page
A special type of Web page that contains one or more Web Parts. A Web Part Page consolidates data, such as lists and charts, and Web content, such as text and images, into a dynamic information portal built around a common task or special interest.
Web server
A computer that hosts Web pages and responds to requests from browsers. Also known as an HTTP server, a Web server stores files whose URLs begin with http://.
workspace site
A subsite based on the Document Workspace or Meeting Workspace site templates.


Index

Index
A | B | C | D | E | F | G | H | I | J | K | L | M
N | O | P | Q | R | S | T | U | V | W | X | Y | Z
A
Back to top
access

    access control list defined Glossary

    anonymous See anonymous user access

    blocking Configuring Site Quotas and Locks

    managing See user accounts; user authentication

account modes

    about account modes Managing Users and Cross-Site Groups

    Active Directory account creation mode Separate Active Directory Organization Unit Deployment

    domain account mode Installation Considerations for Windows SharePoint Services

accounts

    about account modes Managing Users and Cross-Site Groups

    Active Directory accounts Separate Active Directory Organization Unit Deployment

    domain accounts Installation Considerations for Windows SharePoint Services

Active Directory account creation mode

    migrating sites to Windows SharePoint Services 2.0 Migrating and Upgrading Sites

Active Directory accounts

    Managing Users and Cross-Site Groups

    Separate Active Directory Organization Unit Deployment

Active Server pages (ASP pages)

    about ASP pages Windows SharePoint Services Architecture

    defined Glossary

adding documents to document libraries via e-mail attachments Configuring E-Mail-Enabled Document Libraries
adding Help topics Customizing Help
additional Web Parts, deploying Managing Web Parts on Virtual Servers
administration

    administration pages for site or server, problems viewing Troubleshooting Other Issues

    administrative object model scenarios Using the Object Model to Manage Windows SharePoint Services

    administrative tasks, assigning Controlling User Rights and Assigning Tasks

    Administrator site group

      Managing Site Groups and Permissions

      User Rights and Site Groups

      Windows SharePoint Services Security Model

    SharePoint administrators group Managing the SharePoint Administrators Group

    Web sites, customizing using administrative controls Customizing a Web Site Based on Windows SharePoint Services

administration port

    configuring Introducing the Administration Tools for Windows SharePoint Services

    controlling access to Windows SharePoint Services Security Model

    defined Glossary

Administration Tools for Windows SharePoint Services 2.0

    about Administration Tools Introducing the Administration Tools for Windows SharePoint Services

    command-line administration See command-line administration

    HTML Administration pages See HTML Administration pages

administration virtual server

    application pool identity, changing Changing the Application Pool Identity for the Administration Virtual Server

Administrator's Guide for Microsoft Windows SharePoint Services

    copyright information Administrator's Guide for Microsoft Windows SharePoint Services Copyright Information

    table of contents Welcome

Advanced Author role (SharePoint Team Services v1.0)

    Windows SharePoint Services 2.0 equivalent Upgrade Considerations

advanced customization of Web sites Using the SDK to Perform Advanced Customization
Afrikaans, regional and language settings Regional and Language Settings
Albania, regional and language settings Regional and Language Settings
alerts

    alert properties, command-line configuration Command-Line Properties

    defined Glossary

    impact on server performance Performance Implications of Windows SharePoint Services Features

    managing Managing Alerts

    notification of exceeded quota limit for storage Configuring Site Quotas and Locks

    scheduling sending of notifications Scheduling Timed Jobs

    sending via SMTP server Configuring E-Mail Settings

Algeria, regional and language settings Regional and Language Settings
analyzing Web site usage

    configuring analysis Configuring Usage Analysis

    impact on server performance Performance Implications of Windows SharePoint Services Features

    scheduling processing of analysis log files Scheduling Timed Jobs

    viewing usage summary data Analyzing Web Site Usage

anonymous authentication defined Glossary
anonymous insertions to document libraries from e-mail attachments Configuring E-Mail-Enabled Document Libraries
anonymous user access

    configuring Configuring Authentication

    defined Glossary

    rights and permissions

      Controlling User Rights and Assigning Tasks

      Managing Site Groups and Permissions

    security considerations Windows SharePoint Services Security Model

anti-virus protection

    downloaded or uploaded files Configuring Antivirus Protection

    e-mail attachments, document libraries and Configuring E-Mail-Enabled Document Libraries

    impact of filters on server performance Performance Implications of Windows SharePoint Services

    properties, command-line configuration Command-Line Properties

    security settings for Internet Explorer Enhanced Security and Windows SharePoint Services

    suspect file extensions and Configuring Blocked File Extensions

application pools

    changing identity Changing the Application Pool Identity for the Administration Virtual Server

    configuring Installation Considerations for Windows SharePoint Services

    defined Glossary

    problems reusing Troubleshooting Installation Issues

applications

    application pools See application pools

    connecting to Windows SharePoint Services 2.0 Using the SDK to Perform Advanced Customization

Arabic regional and language settings Regional and Language Settings
architecture for Windows SharePoint Services 2.0

    Creating Sites and Subsites

    Windows SharePoint Services Architecture

Argentina, regional and language settings Regional and Language Settings
Armenia, regional and language settings Regional and Language Settings
ASP pages

    ASP.NET (ASPX) pages Windows SharePoint Services Architecture

    defined Glossary

attachments to e-mails, anonymous insertion to document libraries

    Configuring E-Mail-Enabled Document Libraries

    Scheduling Timed Jobs

Australia, regional and language settings Regional and Language Settings
Austria, regional and language settings Regional and Language Settings
authentication

    about authentication methods in Windows SharePoint Services 2.0 Windows SharePoint Services Security Model

    Basic authentication See Basic authentication

    certificate authentication See certificate authentication

    choosing an authentication type for SQL Server Installation Considerations for Windows SharePoint Services

    configuring Configuring Authentication

    Digest Access authentication, defined Glossary

    integrated Windows authentication See integrated Windows authentication

    Kerberos authentication, data retrieval services and Configuring Data Retrieval Services

Author role (SharePoint Team Services v1.0), Windows SharePoint Services 2.0 equivalent Upgrade Considerations
automatic deletion of unused Web sites

    detecting and deleting unused Web sites Managing Unused Web Sites

    properties, command-line configuration Command-Line Properties

    scheduling detection and deletion Scheduling Timed Jobs

    unused sites, impact on server performance Performance Implications of Windows SharePoint Services Features

automating site backup and restore operations Backing Up and Restoring Web Sites
Azeri, regional and language settings Regional and Language Settings
B
Back to top
background processes, scheduling Scheduling Timed Jobs
backing up and restoring databases

    Backing Up and Restoring Databases by Using the SQL Server 2000 Tools

    Backup and Restore Options for Windows SharePoint Services

backing up and restoring Web sites

    about Web site backup and restore Introducing Windows SharePoint Services

    methods Backup and Restore Options for Windows SharePoint Services

    procedures Backing Up and Restoring Web Sites

    upgrade considerations Upgrade Considerations

Bahrain, regional and language settings Regional and Language Settings
balancing network load Managing a Server Farm Running Windows SharePoint Services
Basic authentication

    configuring Configuring Authentication

    defined Glossary

    security considerations Windows SharePoint Services Security Model

Basque, regional and language settings Regional and Language Settings
Belarus, regional and language settings Regional and Language Settings
Belgium, regional and language settings Regional and Language Settings
Belize, regional and language settings Regional and Language Settings
blocked file extensions Configuring Blocked File Extensions
blocking malicious users

    overloading server storage capacity with anonymous document insertions Configuring E-Mail-Enabled Document Libraries

    unauthorized access to administrative port Windows SharePoint Services Security Model

    virus attacks See anti-virus protection

blocking users from sites

    controlling traffic load with quotas Configuring Site Quotas and Locks

Bolivia, regional and language settings Regional and Language Settings
Boolean searches Managing and Customizing Search
borders, adding to Web pages Customizing a Web Site Based on Windows SharePoint Services
Brazil, regional and language settings Regional and Language Settings
browsers

    browser information, tracking in Web site usage analysis Analyzing Web Site Usage

    Browser role (SharePoint Team Services v1.0), Windows SharePoint Services 2.0 equivalent Upgrade Considerations

    customizing Web sites in Customizing a Web Site Based on Windows SharePoint Services

Brunei, regional and language settings Regional and Language Settings
buffers, allowing number of sites to grow beyond warning level Managing Content Databases
Bulgaria, regional and language settings Regional and Language Settings
C
Back to top
CAB file

    adding Web Parts to Server Gallery from Managing a Site Collection Web Part Gallery

cache defined Glossary
Canada, regional and language settings Regional and Language Settings
canceling a document checkout and returning to previous version Managing Versions and Checking Documents In and Out
Cannot Connect to Configuration Database message

    Troubleshooting Installation Issues

    Troubleshooting Other Issues

capacity planning Capacity Planning for Windows SharePoint Services
Caribbean, regional and language settings Regional and Language Settings
Catalan, regional and language settings Regional and Language Settings
Central Administration pages

    configuring server settings on Specifying Central Administration Settings

    e-mail settings Configuring E-Mail Settings

    enabling SSL for Configuring Authentication

    replicating configuration settings to other servers Managing a Server Farm Running Windows SharePoint Services

Central Template Gallery Working with Templates
certificate authentication

    configuring Configuring Authentication

    defined Glossary

    security implications Windows SharePoint Services Security Model

CGI defined Glossary
changes to documents, reversing Managing Versions and Checking Documents In and Out
changing authentication methods Configuring Authentication
character sets

    defined Glossary

    e-mail and Configuring E-Mail Settings

checking documents in and out

    about document checkout and version management Managing Versions and Checking Documents In and Out

    check in, check out defined Glossary

Chile, regional and language settings Regional and Language Settings
China

    Chinese language resource packages, full-text search and Managing and Customizing Search

    Regional and language settings Regional and Language Settings

clear text

    defined Glossary

    use by Basic authentication in transmitting user names and passwords Windows SharePoint Services Security Model

client applications, data retrieval services and Configuring Data Retrieval Services
client requirements for Windows SharePoint Services 2.0 Hardware and Software Requirements
code page defined Glossary
code point defined Glossary
Colombia, regional and language settings Regional and Language Settings
command-line administration

    about command-line administration Introducing the Administration Tools for Windows SharePoint Services

    about command-line operations used with Stsadm.exe (list and descriptions) Command-Line Operation

    about command-line options for Stsadm.exe (list and descriptions) Command-Line Options for Setupsts.exe

    about command-line parameters (list and descriptions) Command-Line Parameters

    about command-line properties (list and descriptions) Command-Line Properties

    alerts, configuring Managing Alerts

    anti-virus protection, configuring Configuring Antivirus Protection

    background processes, scheduling Scheduling Timed Jobs

    Central Template Gallery, managing Working with Templates

    configuration database, managing Managing the Configuration Database

    configuration database, replicating settings to other servers Managing a Server Farm Running Windows SharePoint Services

    data retrieval services, configuring Configuring Data Retrieval Services

    database management, configuring Managing the Configuration Database

    e-mail settings, configuring Configuring E-Mail Settings

    locale ID, specifying Configuring Regional Settings

    paths, managing Managing Paths

    self-service site creation, configuring Configuring Self-Service Site Creation

    site groups, viewing Managing Site Groups and Permissions

    sites and subsites, creating Creating Sites and Subsites

    sites and subsites, managing Managing Sites and Subsites

    Sites, subsites and site collections, backing up and restoring Backup and Restore Options for Windows SharePoint Services

    unattended installation of Windows SharePoint Services 2.0 Performing a Quiet Installation

    unused Web sites, confirmation and automatic deletion Managing Unused Web Sites

    users, managing Managing Users and Cross-Site Groups

    virtual servers, creating and extending Extending Virtual Servers

    virtual servers, removing Uninstalling Windows SharePoint Services

    Web Parts, adding Managing Web Parts on Virtual Servers

    Web sites and subsites, creating Creating Sites and Subsites

    Web sites, backing up and restoring Backing Up and Restoring Web Sites

    Web sites, migrating and upgrading Migrating and Upgrading Web Sites

Common Gateway Interface (CGI) defined Glossary
communication between client and server

    Office FrontPage 2003 and Windows SharePoint Services Architecture

communications privacy

    certificates authentication and Windows SharePoint Services Security Model

components, adding to home page Customizing a Web Site Based on Windows SharePoint Services
configuration (architecture) choices for Windows SharePoint Services 2.0 Windows SharePoint Services Architecture
configuration database

    backing up and restoring

      Backing Up and Restoring Databases by Using the SQL Server 2000 Tools

      Backup and Restore Options for Windows SharePoint Services

    blocked file extensions, list storage in Configuring Blocked File Extensions

    connecting to, problems with Troubleshooting Installation Issues

    defined Glossary

    managing Managing the Configuration Database

    removing or uninstalling Windows SharePoint Services 2.0, effect on Uninstalling Windows SharePoint Services

    replicating configuration settings Managing a Server Farm Running Windows SharePoint Services

    virtual servers and Extending Virtual Servers

configuration properties

    defined Glossary

    setting Introducing the Administration Tools for Windows SharePoint Services

configuring server settings from the SharePoint Central Administration page Specifying Central Administration Settings
configuring virtual servers Configuring Virtual Servers
Contacts Web Part About Web Parts
content database

    backing up and restoring

      Backing Up and Restoring Databases by Using the SQL Server 2000 Tools

      Backup and Restore Options for Windows SharePoint Services

    defined Glossary

    managing Managing Content Databases

    migrating to a server farm Migrating from WMSDE to SQL Server

    properties, command-line configuration Command-Line Properties

    removing or uninstalling Windows SharePoint Services 2.0, effect on Uninstalling Windows SharePoint Services

    virtual servers and Extending Virtual Servers

    Web discussions, maintaining threaded discussions in Managing Web Discussions

Content Editor Web Part About Web Parts
Contributor role (SharePoint Team Services v1.0)

    Windows SharePoint Services 2.0 equivalent Upgrade Considerations

Contributor site group

    Managing Site Groups and Permissions

    User Rights and Site Groups

converting file formats to HTML on the fly Managing HTML Viewers
copyright information for Administrator's Guide for Microsoft Windows SharePoint Services Administrator's Guide for Microsoft Windows SharePoint Services Copyright Information
Costa Rica, regional and language settings Regional and Language Settings
Croatia, regional and language settings Regional and Language Settings
cross-site groups

    about managing access rights for Windows SharePoint Services Security Model

    managing Managing Users and Cross-Site Groups

currency ID Regional and Language Settings
custom roles and rights for site groups

    transfer following upgrade to Windows SharePoint Services 2.0 Upgrade Considerations

customizing Help system Customizing a Web Site Based on Windows SharePoint Services
customizing templates Working with Templates
customizing Web sites

    Customizing a Web Site Based on Windows SharePoint Services

    Using the SDK to Perform Advanced Customization

Czech Republic, regional and language settings Regional and Language Settings
D
Back to top
data retrieval services

    Command-Line Properties

    Configuring Data Retrieval Services

databases

    backing up and restoring

      Backing Up and Restoring Databases by Using the SQL Server 2000 Tools

      Backup and Restore Options for Windows SharePoint Services

    configuration database See configuration database

    content database See content database

    database requirements for Windows SharePoint Services 2.0

      Hardware and Software Requirements

      Installation Considerations for Windows SharePoint Services

    removing or uninstalling Windows SharePoint Services 2.0, effect on Uninstalling Windows SharePoint Services

    virtual servers and Extending Virtual Servers

data-bound Web parts, data retrieval services and Configuring Data Retrieval Services
data-bound Web Parts, data retrieval services and Configuring Data Retrieval Services
dates, regional settings for Configuring Regional Settings
default Help topics, customizing Customizing a Web Site Based on Windows SharePoint Services
default site definitions Working with Templates
default site groups User Rights and Site Groups
defining site groups Managing Site Groups and Permissions
definitions Glossary
delegating administrative tasks Controlling User Rights and Assigning Tasks
delegating user management Windows SharePoint Services Security Model
deleting unused Web sites

    scheduling checking and automatic deletion of Scheduling Timed Jobs

    server performance impact of unused Web sites Performance Implications of Windows SharePoint Services Features

    site use confirmation and automatic deletion Managing Unused Web Sites

Denmark, regional and language settings Regional and Language Settings
deploying additional Web Parts Managing Web Parts on Virtual Servers
deploying Windows SharePoint Services 2.0

    Intranet and Extranet Deployment

    Remote SQL Server Deployment

    Separate Active Directory Organization Unit Deployment

    Server Farm with Multiple Host Names Deployment

    Single Server Deployment

dictionary Glossary
Digest Access authentication, defined Glossary
directories

    included and excluded paths Managing Paths

    special directories and storage locations (list and descriptions) Special Directories and Storage Locations

disaster recovery

    restoring backed-up databases Backing Up and Restoring Databases by Using the SQL Server 2000 Tools

discussions

    discussion threads, discussion server defined Glossary

    discussion threads, managing Managing Web discussions

display name of Web site, changing Customizing a Web Site Based on Windows SharePoint Services
Divehi, regional and language settings Regional and Language Settings
document libraries

    defined Glossary

    document versioning Managing Versions and Checking Documents In and Out

    enabling documents to be added automatically as e-mail attachments

      Configuring E-Mail-Enabled Document Libraries

      Scheduling Timed Jobs

    event handling Binding to a Document Library Event Handler

    personal view defined Glossary

Document Workspace site defined Glossary
domain accounts

    Installation Considerations for Windows SharePoint Services

    Managing Users and Cross-Site Groups

domain controller computers

    Active Directory account creation mode and Separate Active Directory Organization Unit Deployment

    problems running Windows SharePoint Services 2.0 Troubleshooting Installation Issues

domain-named sites

    namespace configurations for Windows SharePoint Services Architecture

    network domain name defined Glossary

Dominican Republic, regional and language settings Regional and Language Settings
downloading files

    blocked file extensions Configuring Blocked File Extensions

    viruses, protection against Configuring Antivirus Protection

duplicate site names, effect on restoring Web sites Backing Up and Restoring Web Sites
Dutch regional and language settings Regional and Language Settings
E
Back to top
Ecuador, regional and language settings Regional and Language Settings
Egypt, regional and language settings Regional and Language Settings
El Salvador, regional and language settings Regional and Language Settings
e-mail

    alerts, configuring e-mail settings for Managing Alerts

    attachments, adding to a document library

      Configuring E-Mail-Enabled Document Libraries

      Scheduling Timed Jobs

    attachments, blocked file extensions Configuring Blocked File Extensions

    configuring settings for Configuring E-Mail Settings

    instant messaging, matching e-mail addresses Configuring Online Presence Settings

encryption

    defined Glossary

    user name and password encryption, Integrated Windows authentication and Windows SharePoint Services Security Model

English

    English language resource package, full-text search and Managing and Customizing Search

    regional and language settings Regional and Language Settings

error conditions, troubleshooting See troubleshooting
Estonia, regional and language settings Regional and Language Settings
European Union, regional settings Regional and Language Settings
event handlers Binding to a Document Library Event Handler
Exchange Instant Messaging service accounts, online presence detection and Configuring Online Presence Settings
excluded paths Managing Paths
explicit inclusion path type Managing Paths
extending virtual servers

    applying Windows SharePoint Services to virtual servers Extending Virtual Servers

    extend defined Glossary

    troubleshooting Troubleshooting Installation Issues

extending Windows SharePoint Services features Extending Windows SharePoint Services
extranet/intranet deployment of Windows SharePoint Services 2.0

    about intranet and extranet deployment Intranet and Extranet Deployment

    intranet, extranet defined Glossary

F
Back to top
Faeroese regional and language settings Regional and Language Settings
Farsi regional and language settings Regional and Language Settings
file allocation table (FAT) defined Glossary
File Transfer Protocol (FTP) defined Glossary
files

    containing viruses, protection against Configuring Antivirus Protection

    file extensions, blocked Configuring Blocked File Extensions

    file permissions (list and descriptions) Files and Permissions

Finland, regional and language settings Regional and Language Settings
firewalls

    about firewall protection

      Windows SharePoint Services Architecture

      Windows SharePoint Services Security Model

    defined Glossary

    e-mail security and Configuring E-Mail-Enabled Document Libraries

    Web Part gallery, allowing access to from behind firewall Managing Web Parts on Virtual Servers

flagging site owners Windows SharePoint Services Security Model
folders

    See also directories

    converting entire contents to HTML Managing HTML Viewers

Form Web Part About Web Parts
France

    French language resource package, full-text search and Managing and Customizing Search

    regional and language settings Regional and Language Settings

FREETEXT Managing and Customizing Search
front-end Web servers Managing a Server Farm Running Windows SharePoint Services
FrontPage 2002 Server See Microsoft FrontPage 2002 Server
full-text searching of Web sites

    full-text search index defined Glossary

    resolving problems with Troubleshooting Other Issues

    Search, managing and customizing Managing and Customizing Search

G
Back to top
Galicia, regional and language settings Regional and Language Settings
general settings for virtual servers, specifying Configuring Virtual Servers
Georgia, regional and language settings Regional and Language Settings
Germany

    German language resource package, full-text search and Managing and Customizing Search

    regional and language settings Regional and Language Settings

glossary of terms Glossary
graphics, adding to Web pages Customizing a Web Site Based on Windows SharePoint Services
Greece, regional and language settings Regional and Language Settings
groups

    administrators groups

      Managing Site Groups and Permissions

      Managing the SharePoint Administrators Group

      Windows SharePoint Services Security Model

    cross-site groups

      Managing Users and Cross-Site Groups

      Windows SharePoint Services Security Model

    site groups See site groups

Guatemala, regional and language settings Regional and Language Settings
Guest site group

    Managing Site Groups and Permissions

    User Rights and Site Groups

Gujarati, regional and language settings Regional and Language Settings
H
Back to top
12-hour, 24-hour time formats Configuring Regional Settings
hardware load balancing Managing a Server Farm Running Windows SharePoint Services
hardware requirements for Windows SharePoint Services 2.0 Hardware and Software Requirements

    stand-alone server deployment Single Server Deployment

Help, customizing for Web sites Customizing Help
hidden site definitions Working with Templates
hierarchy of sites for Windows SharePoint Services 2.0

    Creating Sites and Subsites

    Windows SharePoint Services Architecture

hits, tracking in Web site usage analysis Analyzing Web site usage
home page

    defined Glossary

    layout, changing Customizing a Web Site Based on Windows SharePoint Services

Honduras, regional and language settings Regional and Language Settings
Hong Kong, regional and language settings Regional and Language Settings
host names, multiple, server deployment for Server Farm with Multiple Host Names Deployment
hosting

    hosting choices for Windows SharePoint Services 2.0 See deploying Windows SharePoint Services 2.0

    hosting more than 1,000 Web sites, server deployment for Remote SQL Server Deployment

    non-scalable hosting mode See stand-alone servers

    remote host defined Glossary

    scalable hosting mode See server farms

HTML Administration pages

    about HTML Administration pages Introducing the Administration Tools for Windows SharePoint Services

    anti-virus protection, enabling Configuring Antivirus Protection

    Central Administration pages See Central Administration pages

    configuration database, managing Managing the Configuration Database

    content database, managing Managing Content Databases

    e-mail settings, configuring from Configuring E-Mail Settings

    managed paths and

      Configuring Self-Service Site Creation

      Managing Paths

    regional settings, changing Configuring Regional Settings

    SharePoint administrators group Managing the SharePoint Administrators Group

    sites and subsites, managing Managing Sites and Subsites

    users and site groups, managing

      Managing Site Groups and Permissions

      Managing Users and Cross-Site Groups

    virtual servers, extending Extending Virtual Servers

HTML viewing servers

    impact on server performance Performance Implications of Windows SharePoint Services Features

    managing Managing HTML Viewers

    properties, command-line configuration Command-Line Properties

HTTP administration port Introducing the Administration Tools for Windows SharePoint Services
HTTP PUT, POST requests Windows SharePoint Services Architecture
Hungary, regional and language settings Regional and Language Settings
hyperlink defined Glossary
I
Back to top
Iceland, regional and language settings Regional and Language Settings
IIS See Internet Information Services (IIS)
Image Web Part About Web Parts
included paths Managing Paths
incoming URLs, mapping to physical paths Windows SharePoint Services Architecture
India, regional and language settings Regional and Language Settings
Indonesia, regional and language settings Regional and Language Settings
installing a Web Part Package Managing Web Parts on Virtual Servers
installing language template packs Language Considerations
installing Windows SharePoint Services 2.0

    command-line installation and configuration

      Command-Line Operation

      Command-Line Options for Setupsts.exe

      Command-Line Parameters

      Command-Line Properties

    installing as part of another product Extending Windows SharePoint Services

    pre-installation choices Installation Considerations for Windows SharePoint Services

    server farms

      Intranet and Extranet Deployment

      Server Farm with Multiple Host Names Deployment

    stand-alone servers Single Server Deployment

    troubleshooting Troubleshooting Installation Issues

    unattended installation Performing a Quiet Installation

    uninstalling Uninstalling Windows SharePoint Services

    using SQL Server on a separate server Remote SQL Server Deployment

instant messaging Configuring Online Presence Settings
integrated Windows authentication

    configuring Configuring Authentication

    defined Glossary

    security features Windows SharePoint Services Security Model

intent, searching by Managing and Customizing Search
Internet defined Glossary
Internet Explorer Enhanced Security

    about Internet Explorer Enhanced Security Internet Explorer Enhanced Security and Windows SharePoint Services

    e-mail-enabled document libraries and Configuring E-Mail-Enabled Document Libraries

Internet Information Services (IIS)

    anonymous access, configuring Configuring Authentication

    application pools Installation Considerations for Windows SharePoint Services

    authentication methods Windows SharePoint Services Security Model

    creating virtual servers in Extending Virtual Servers

    default Web Site, setting to port other than 80 Troubleshooting Installation Issues

    defined Glossary

    enabling SSL in Windows SharePoint Services Security Model

    IIS metabase, reduced dependency on Windows SharePoint Services Architecture

    SMTP service for Configuring E-Mail Settings

Internet Service Provider (ISP)

    managing resources Configuring Site Quotas and Locks

intranet

    defined Glossary

    intranet/extranet deployment of Windows SharePoint Services 2.0 Intranet and Extranet Deployment

    managing resources through site quotas and locks Configuring Site Quotas and Locks

Iraq, regional and language settings Regional and Language Settings
Ireland, regional and language settings Regional and Language Settings
ISAPI filter

    ISAPI defined Glossary

    Windows SharePoint Services and Windows SharePoint Services Architecture

Israel, regional and language settings Regional and Language Settings
Italy

    Italian language resource package, full-text search and Managing and Customizing Search

    resource and language settings Regional and Language Settings

J
Back to top
Jamaica, regional and language settings Regional and Language Settings
Japan

    Japanese language resource package, full-text search and Managing and Customizing Search

    regional and language settings Regional and Language Settings

JavaScript defined Glossary
Jordan, regional and language settings Regional and Language Settings
junk e-mail messages Configuring E-Mail-Enabled Document Libraries
Kannada regional and language settings Regional and Language Settings
K
Back to top
Kazakhstan, regional and language settings Regional and Language Settings
Kerberos authentication, data retrieval services and Configuring Data Retrieval Services
Konkani regional and language settings Regional and Language Settings
Korea

    regional and language settings Regional and Language Settings

Kuwait, regional and language settings Regional and Language Settings
Kyrgyz regional and language settings Regional and Language Settings
L
Back to top
language ID

    Language Considerations

    Regional and Language Settings

language template packs

    installing Language Considerations

languages

    about methods for controlling language settings on Web sites Language Considerations

    backing up and restoring Web sites, matching language packs Backing Up and Restoring Web Sites

    full-text searching of Web sites, SQL Server 2000 language resources packages for Managing and Customizing Search

    regional settings and Configuring Regional Settings

Latvia, regional and language settings Regional and Language Settings
layouts of Web sites, advanced customization Using the SDK to Perform Advanced Customization
Lebanon, regional and language settings Regional and Language Settings
Libya, regional and language settings Regional and Language Settings
Liechtenstein, regional and language settings Regional and Language Settings
List Template Gallery Working with Templates
lists

    adding Customizing a Web Site Based on Windows SharePoint Services

    customization, advanced Using the SDK to Perform Advanced Customization

    list defined Glossary

    list of servers in a server farm, managing Managing a Server Farm Running Windows SharePoint Services

    list or list item, problems restoring Troubleshooting Other Issues

    list templates Working with Templates

    SharePoint lists, data retrieval services and Configuring Data Retrieval Services

    viewing permissions for (per-list permissions) Managing Site Groups and Permissions

Lithuania, regional and language settings Regional and Language Settings
load balancing Managing a Server Farm Running Windows SharePoint Services
local administrators group

    about managing security for Web site content Windows SharePoint Services Security Model

    defined Glossary

locale ID

    locale ID, user locale defined Glossary

    regional and language settings

      Configuring Regional Settings

      Language Considerations

      Regional and Language Settings

localhost host name

    browsing to SharePoint sites as Internet Explorer Enhanced Security and Windows SharePoint Services

locking sites Configuring Site Quotas and Locks
log files, usage tracking

    Analyzing Web Site Usage

    Configuring Usage Analysis

    Performance Implications of Windows SharePoint Services Features

logical architecture for Windows SharePoint Services 2.0

    Creating Sites and Subsites

    Windows SharePoint Services Architecture

Luxembourg, regional and language settings Regional and Language Settings
M
Back to top
Macau, regional and language settings Regional and Language Settings
Macedonia, regional and language settings Regional and Language Settings
Macintosh clients

    requirements for running Windows SharePoint Services 2.0 Hardware and Software Requirements

Malaysia, regional and language settings Regional and Language Settings
malicious users

    overloading server storage capacity with anonymous document insertions Configuring E-Mail-Enabled Document Libraries

    preventing access to administrative port Windows SharePoint Services Security Model

    virus attacks See anti-virus protection

managed code, writing to interact with document library events Binding to a Document Library Event Handler
managed paths

    about managed paths Managing Paths

    self-service site creation and Configuring Self-Service Site Creation

mapping rights between SharePoint Team Services v1.0 and Windows SharePoint Services 2.0 Upgrade Considerations
mapping URLs

    incoming URLs, mapping to physical paths Windows SharePoint Services Architecture

Marathi regional and language settings Regional and Language Settings
maximum file size posted to server Command-Line Properties
maximum site count on virtual server Managing Content Databases
Meeting Workspace site defined Glossary
message text for alerts, customizing Managing Alerts
Mexico, regional and language settings Regional and Language Settings
Microsoft Exchange 2000

    public folders, linking to document libraries Configuring E-Mail-Enabled Document Libraries

Microsoft FrontPage 2002 Server

    FrontPage 2002 Server Extensions, port assignments Installation Considerations for Windows SharePoint Services

    FrontPage Server Extensions defined Glossary

    upgrading FrontPage 2002 Server Extensions to Windows SharePoint Services 2.0 Upgrade Considerations

Microsoft FrontPage 2003

    editing Web sites in Customizing a Web Site Based on Windows SharePoint Services

Microsoft SharePoint Team Services v1.0

    upgrading to Microsoft SharePoint Services 2.0 Upgrade Considerations

Microsoft SharePoint Timer Service Configuring E-Mail-Enabled Document Libraries
Microsoft SQL Server

    authentication type, choosing Installation Considerations for Windows SharePoint Services

    connection security Windows SharePoint Services Security Model

    databases supported by Windows SharePoint Services 2.0

      Hardware and Software Requirements

      Installation Considerations for Windows SharePoint Services

    full-text searching of Web sites, enabling Managing and Customizing Search

    MSDE, migrating from

      Migrating from WMSDE to SQL Server

      Upgrade Considerations

    quiet installation of Windows SharePoint Services 2.0 with Performing a Quiet Installation

    remote SQL Server deployment Remote SQL Server Deployment

    SQL Server computer defined Glossary

    standalone-server installation of Windows SharePoint Services 2.0 to use SQL Server Single Server Deployment

Microsoft SQL Server Desktop Engine (MSDE)

    defined Glossary

    installation considerations Installation Considerations for Windows SharePoint Services

    installation with Windows SharePoint Services 2.0 on stand-alone server Single Server Deployment

    migrating to SQL server

      Migrating from WMSDE to SQL Server

      Upgrade Considerations

    quiet installation of Windows SharePoint Services 2.0 with Performing a Quiet Installation

Microsoft Windows Server 2003

    installing prior to upgrade from SharePoint Team Services v1.0 to Windows SharePoint Services 2.0

      Troubleshooting Installation Issues

      Upgrade Considerations

    Network Load Balancing Managing a Server Farm Running Windows SharePoint Services

Microsoft Windows SharePoint Services 2.0

    Active Directory account creation mode Separate Active Directory Organization Unit Deployment

    administration tools Introducing the Administration Tools for Windows SharePoint Services

    Administrator's Guide, copyright information Administrator's Guide for Microsoft Windows SharePoint Services Copyright Information

    architecture Windows SharePoint Services Architecture

    backup and restore options Backup and Restore Options for Windows SharePoint Services

    data retrieval services Configuring Data Retrieval Services

    databases types, compatible Installation Considerations for Windows SharePoint Services

    deployment types See deploying Windows SharePoint Services 2.0

    extension and customization features Extending Windows SharePoint Services

    hardware and software requirements Hardware and Software Requirements

    Help system Customizing Help

    HTML viewing servers and Managing HTML Viewers

    installing See installing Windows SharePoint Services 2.0

    language template packs Language Considerations

    new features Introducing Windows SharePoint Services

    object model Using the Object Model to Manage Windows SharePoint Services

    paths, managed Managing Paths

    performance Performance Implications of Windows SharePoint Services

    regional settings

      Configuring Regional Settings

      Language Considerations

    resource management options Configuring Site Quotas and Locks

    scale limits Capacity Planning for Windows SharePoint Services

    security elements

      Internet Explorer Enhanced Security and Windows SharePoint Services

      Windows SharePoint Services Security Model

    Software Development Kit Using the SDK to Perform Advanced Customization

    templates See templates

    throughput limits Capacity Planning for Windows SharePoint Services

    uninstalling Uninstalling Windows SharePoint Services

    upgrading from SharePoint Team Services v1.0 Upgrade Considerations

    virtual servers See virtual servers

migrating from WMSDE to SQL Server

    Migrating from WMSDE to SQL Server

    Upgrade Considerations

migrating Web sites

    Migrating and Upgrading Web Sites

    Troubleshooting Installation Issues

    Upgrade Considerations

Monaco, regional and language settings Regional and Language Settings
Mongolian regional and language settings Regional and Language Settings
Morocco, regional and language settings Regional and Language Settings
MSDE See Microsoft SQL Server Desktop Engine (MSDE)
multihosting defined Glossary
multiple host names Server Farm with Multiple Host Names Deployment
multiple versions of documents Managing Versions and Checking Documents In and Out
N
Back to top
.NET Passport accounts, online presence detection and Configuring Online Presence Settings
name (display name) of Web site, changing Customizing a Web Site Based on Windows SharePoint Services
namespace configurations for URLs Windows SharePoint Services Architecture
navigation bars on Web sites, advanced customization Using the SDK to Perform Advanced Customization
Netherlands, regional and language settings Regional and Language Settings
network domain name defined Glossary
network load balancing Managing a Server Farm Running Windows SharePoint Services
neutral language resource package, full-text search and Managing and Customizing Search
new features in Windows SharePoint Services 2.0 Introducing Windows SharePoint Services
New Zealand, regional and language settings Regional and Language Settings
Nicaragua, regional and language settings Regional and Language Settings
non-scalable hosting mode See stand-alone servers
Norway, regional and language settings Regional and Language Settings
NTFS file system defined Glossary
numbers, configuring display to locales Configuring Regional Settings
O
Back to top
object model Using the Object Model to Manage Windows SharePoint Services
Office FrontPage 2003 client

    communication with Windows SharePoint Services 2.0 Windows SharePoint Services Architecture

OLEDB, data retrieval services and Configuring Data Retrieval Services
Oman, regional and language settings Regional and Language Settings
Online gallery Managing Web Parts on Virtual Servers
online presence, detecting Configuring Online Presence Settings
on-the-fly file format conversion to HTML Managing HTML Viewers
operating system information, tracking in Web site usage analysis Analyzing Web Site Usage
P
Back to top
Page Cannot Be Found message Troubleshooting Installation Issues
page hits, usage data collection Analyzing Web Site Usage
Panama, regional and language settings Regional and Language Settings
Paraguay, regional and language settings Regional and Language Settings
passwords

    See also user authentication

    encryption using Integrated Windows authentication Windows SharePoint Services Security Model

paths

    managed paths Managing Paths

    self-service site creation and managed paths Configuring Self-Service Site Creation

performance

    about performance implications of Windows SharePoint features Performance Implications of Windows SharePoint Services Features

    performance limits for Windows SharePoint Services Capacity Planning for Windows SharePoint Services

    site backup and restore operations, effect on server performance Backing Up and Restoring Web Sites

    traffic load and, controlling with quotas Configuring Site Quotas and Locks

    Web Parts, managing performance options for Managing Web Parts on Virtual Servers

    Web server performance, managing paths and Managing Paths

per-list permissions Managing Site Groups and Permissions
permissions

    See also site groups

    application pool account permissions Changing the Application Pool Identity for the Administration Virtual Server

    files and permissions (list and descriptions) Files and Permissions

    managing Managing Site Groups and Permissions

    user rights, managing

      Controlling User Rights and Assigning Tasks

      User Rights and Site Groups

    user rights, mapping from SharePoint Team Services v1.0 to Windows SharePoint Services 2.0 Upgrade Considerations

personal view defined Glossary
Peru, regional and language settings Regional and Language Settings
Philippines, regional and language settings Regional and Language Settings
Poland, regional and language settings Regional and Language Settings
Portugal, regional and language settings Regional and Language Settings
prepackaged site and list content See templates
preventing malicious user access

    access to administrative port Windows SharePoint Services Security Model

    overloading server storage capacity with anonymous document insertions Configuring E-Mail-Enabled Document Libraries

    virus attacks See anti-virus protection

privacy

    certificates authentication and Windows SharePoint Services Security Model

problem solving See troubleshooting
programmatic customization of Web sites Customizing a Web Site Based on Windows SharePoint Services
public folder

    linking with a document library

      Configuring E-Mail-Enabled Document Libraries

      Scheduling Timed Jobs

Puerto Rico, regional and language settings Regional and Language Settings
Punjabi regional and language settings Regional and Language Settings
Q
Back to top
Qatar, regional and language settings Regional and Language Settings
querying data sources using data retrieval services Configuring Data Retrieval Services
quiet installation of Windows SharePoint Services 2.0

    performing Performing a Quiet Installation

    quiet installation defined Glossary

quotas

    quota templates

      Command-Line Properties

      Configuring Site Quotas and Locks

    quota, quota template defined Glossary

R
Back to top
read/write transaction mix Capacity Planning for Windows SharePoint Services
Reader site group

    Managing Site Groups and Permissions

    User Rights and Site Groups

read-only transaction mix Capacity Planning for Windows SharePoint Services
recursive paths Managing Paths
referring domains, tracking in Web site usage analysis Analyzing Web Site Usage
regional settings for Web sites

    about regional settings Language Considerations

    configuring Configuring Regional Settings

remote administration

    See also HTML Administration pages

    Introducing the Administration Tools for Windows SharePoint Services

remote host defined Glossary
remote procedure call mechanism Windows SharePoint Services Architecture
remote SQL Server deployment of Windows SharePoint Services 2.0

    Configuring Data Retrieval Services

    Remote SQL Server Deployment

removing Microsoft Windows SharePoint Services 2.0 from a server Uninstalling Windows SharePoint Services
resource management

    See also performance

    limiting users and storage with quotas and locks Configuring Site Quotas and Locks

restoring databases from a backup Backing Up and Restoring Databases by Using the SQL Server 2000 Tools
restoring Web sites

    Backing Up and Restoring Web Sites

    Backup and Restore Options for Windows SharePoint Services

restricting user access to sites

    See also blocking malicious users

    Configuring Site Quotas and Locks

retrieving files

    blocked file extensions Configuring Blocked File Extensions

    multiple versions of documents, managing Managing Versions and Checking Documents In and Out

    viruses, protection against Configuring Antivirus Protection

reversing changes to documents Managing Versions and Checking Documents In and Out
roles and rights of site groups

    changes following upgrade to Windows SharePoint Services 2.0 Upgrade Considerations

    managing Controlling User Rights and Site Groups

    permissions See permissions

    role, right defined Glossary

Romania, regional and language settings Regional and Language Settings
Russia, regional and language settings Regional and Language Settings
S
Back to top
safe mode

    running ASP.NET (ASPX) pages in Windows SharePoint Services Architecture

Sanskrit regional and language settings Regional and Language Settings
Saudi Arabia, regional and language settings Regional and Language Settings
scalable hosting mode See server farms
scaling

    about scalable architecture Windows SharePoint Services Architecture

    non-scalable hosting mode See stand-alone servers

    scalable hosting mode See server farms

    scale limits of server configurations Capacity Planning for Windows SharePoint Services

scheduling background processes Scheduling Timed Jobs
scripting language defined Glossary
SDK (Software Development Kit) Using the SDK to Perform Advanced Customization
search function

    See also full-text searching of Web sites

    about search in Windows SharePoint Services 2.0 Managing and Customizing Search

searching by intent Managing and Customizing Search
secondary contact name, self-service site creation Configuring Self-Service Site Creation
Secure Sockets Layer (SSL) security

    about SSL security Windows SharePoint Services Security Model

    defined Glossary

    enabling SSL Configuring Authentication

security

    about Windows SharePoint Services security Windows SharePoint Services Security Model

    access and permissions, controlling See permissions; site groups; user accounts; user authentication

    anti-virus protection See anti-virus protection

    blocked file extensions Configuring Blocked File Extensions

    blocking access Configuring Site Quotas and Locks

    e-mail

      Configuring Blocked File Extensions

      Configuring E-Mail-Enabled Document Libraries

    firewalls Windows SharePoint Services Architecture

    Internet Explorer Enhanced Security Internet Explorer Enhanced Security and Windows SharePoint Services

    new features in Windows SharePoint Services 2.0 Introducing Windows SharePoint Services

    NTFS file system defined Glossary

    self-service site creation and Configuring Self-Service Site Creation

    SSL See Secure Sockets Layer (SSL) security

    Web Parts and Web Part Pages Managing Web Parts on Virtual Servers

self-service site creation Configuring Self-Service Site Creation
Serbia, regional and language settings Regional and Language Settings
Server Applications Program Interface (ISAPI) filter Windows SharePoint Services Architecture
server farms

    about server farm configuration of Windows SharePoint Services 2.0 Windows SharePoint Services Architecture

    configuring servers on Specifying Central Administration Settings

    defined Glossary

    enabling SSL for the SharePoint central administration pages Configuring Authentication

    intranet/extranet deployment Intranet and Extranet Deployment

    managing Managing a Server Farm Running Windows SharePoint Services

    migrating content databases to Migrating from WMSDE to SQL Server

    multiple host names deployment Server Farm with Multiple Host Names Deployment

    user account creation, scalable hosting mode Separate Active Directory Organization Unit Deployment

servers

    See also Web servers

    about server configurations Capacity Planning for Windows SharePoint Services

    configuring on SharePoint Central Administration page Specifying Central Administration Settings

    discussion server Managing Web Discussions

    performance issues Performance Implications of Windows SharePoint Services Features

    properties, command-line configuration Command-Line Properties

    removing vs. uninstalling Windows SharePoint Services 2.0 from the server computer Uninstalling Windows SharePoint Services

    server configuration variable in throughput testing Capacity Planning for Windows SharePoint Services

    server failures, recovering from Backing Up and Restoring Databases by Using the SQL Server 2000 Tools

    server farms See server farms

    single-server deployments See stand-alone servers

    upgrading from SharePoint Team Services v1.0 to Windows SharePoint Services 2.0 Upgrade Considerations

    virtual See virtual servers

Service Unavailable message Troubleshooting Other Issues
setup See installing Windows SharePoint Services 2.0
shared view defined Glossary
SharePoint administrators group

    about managing security for Web site content Windows SharePoint Services Security Model

    managing Managing the SharePoint Administrators Group

SharePoint Central Administration page

    configuring server settings on Specifying Central Administration Settings

    e-mail settings Configuring E-Mail Settings

    enabling SSL for Configuring Authentication

    managing users from Configuring E-Mail Settings

SharePoint lists, data retrieval services and Configuring Data Retrieval Services
SharePoint Services 2.0 See Microsoft Windows SharePoint Services 2.0
SharePoint Team Services v1.0 See Microsoft SharePoint Team Services v1.0
sharing templates Working with Templates
Singapore, regional and language settings Regional and Language Settings
Site Administration page

    about the Site Administration page Introducing the Administration Tools for Windows SharePoint Services

    problems viewing Troubleshooting Other Issues

site backup and restore

    Backing Up and Restoring Web Sites

    Backup and Restore Options for Windows SharePoint Services

site collections

    See also site groups

    about site collections Creating Sites and Subsites

    backing up and restoring Backup and Restore Options for Windows SharePoint Services

    defined Glossary

    managing users from top-level Web site in Managing Users and Cross-Site Groups

site content

    dividing into subsites Creating Sites and Subsites

    managing See content database

site groups

    about controlling rights for users and user groups Windows SharePoint Services Security Model

    administrative tasks, assigning to Controlling User Rights and Assigning Tasks

    cross-site groups Managing Users and Cross-Site Groups

    defined Glossary

    permissions Managing Site Groups and Permissions

    roles and rights definitions, changes following upgrade to Windows SharePoint Services v2.0 Upgrade Considerations

    self-service subsite creation Configuring Self-Service Site Creation

    user rights and User Rights and Site Groups

site owners, flagging Windows SharePoint Services Security Model
site quotas Configuring Site Quotas and Locks
Site Settings page Introducing the Administration Tools for Windows SharePoint Services
Site Template Gallery Working with Templates
sites

    See also Web sites

    access to, blocking users from Configuring Site Quotas and Locks

    adding users and cross-site groups to Managing Users and Cross-Site Groups

    backing up and restoring using Smigrate.exe tool Upgrade Considerations

    defined Glossary

    Document Workspace site defined Glossary

    languages in which displayed Language Considerations

    migrating from SharePoint Team Services v1.0 to Windows SharePoint Services 2.0

      Migrating and Upgrading Web Sites

      Troubleshooting Installation Issues

      Upgrade Considerations

    namespace configurations for Windows SharePoint Services Architecture

    regional settings

      Configuring Regional Settings

      Language Considerations

    searching Managing and Customizing Search

    site definitions, saving as templates Working with Templates

    site groups See site groups

    site templates Working with Templates

    sites and subsites, creating

      Configuring Self-Service Site Creation

      Creating Sites and Subsites

      Managing Site Groups and Permissions

    sites and subsites, managing Managing Sites and Subsites

    tracking items within, alerts and Managing Alerts

    unused sites, detecting and deleting

      Command-Line Properties

      Managing Unused Web Sites

    usage analysis

      Analyzing Web site usage

      Configuring Usage Analysis

      Performance Implications of Windows SharePoint Services Features

      Scheduling Timed Jobs

      Troubleshooting Other Issues

Slovak regional and language settings Regional and Language Settings
Slovenia, regional and language settings Regional and Language Settings
SMTP server

    defined Glossary

    e-mail message transmission via Configuring E-Mail Settings

Software Development Kit (SDK) Using the SDK to Perform Advanced Customization
software requirements for Windows SharePoint Services 2.0 Hardware and Software Requirements
solving problems See troubleshooting
sort order, configuring regional settings for Configuring Regional Settings
South Africa, regional and language settings Regional and Language Settings
Spain

    regional and language settings Regional and Language Settings

    Spanish language resource package, full-text search and Managing and Customizing Search

special directories and storage locations (list and descriptions) Special Directories and Storage Locations
spoofed e-mail addresses Configuring E-Mail-Enabled Document Libraries
SQL Server See Microsoft SQL Server
SSL See Secure Sockets Layer (SSL) security
stand-alone servers

    See also servers

    about stand-alone server configuration of Windows SharePoint Services 2.0 Windows SharePoint Services Architecture

    configuring from SharePoint Central Administration page Specifying Central Administration Settings

    installing Windows SharePoint Services 2.0 on Single Server Deployment

    user account creation, non-scalable hosting mode Separate Active Directory Organization Unit Deployment

stemming search terms Managing and Customizing Search
subfolder-named sites

    namespace configurations for Windows SharePoint Services Architecture

subsites

    configuring Configuring Self-Service Site Creation

    creating Creating Sites and Subsites

    defined Glossary

    managing Managing Sites and Subsites

    permissions Managing Site Groups and Permissions

survey defined Glossary
Swahili, regional and language settings Regional and Language Settings
Sweden

    regional and language settings Regional and Language Settings

    Swedish language resource package, full-text search and Managing and Customizing Search

switching between permissions models Managing Site Groups and Permissions
Switzerland, regional and language settings Regional and Language Settings
Syria, regional and language settings Regional and Language Settings
Syriac, regional and language settings Regional and Language Settings
T
Back to top
table of contents Welcome
Taiwan, regional and language settings Regional and Language Settings
Tamil, regional and language settings Regional and Language Settings
tasks, administrative, assigning Controlling User Rights and Assigning Tasks
Tatar, regional and language settings Regional and Language Settings
TCP/IP connection

    message integrity for, SSL security and Windows SharePoint Services Security Model

Team Site Web Part gallery Managing a Site Collection Web Part Gallery
Telnet defined Glossary
Telugu, regional and language settings Regional and Language Settings
templates

    advanced customizaton using the SDK Using the SDK to Perform Advanced Customization

    creating and customizing Working with Templates

    language template packs Language Considerations

    quota templates See quotas

    XML templates See XML templates

terms defined Glossary
Thailand

    regional and language settings Regional and Language Settings

    Thai language resource package, full-text search and Managing and Customizing Search

themes

    advanced customization Using the SDK to Perform Advanced Customization

    applying to a Web site Customizing a Web Site Based on Windows SharePoint Services

throughput limits of server configurations Capacity Planning for Windows SharePoint Services
time zones, configuring regional settings for

    Command-Line Properties

    Configuring Regional Settings

    Regional and Language Settings

timed jobs, scheduling Scheduling Timed Jobs
top-level Web site defined Glossary
tracking Web site usage

    Analyzing Web Site Usage

    Configuring Usage Analysis

    Managing Unused Web Sites

    Performance Implications of Windows SharePoint Services Features

transaction mix Capacity Planning for Windows SharePoint Services
Trinidad, regional and language settings Regional and Language Settings
troubleshooting

    installation issues Troubleshooting Installation Issues

    other issues Troubleshooting Other Issues

    site migration issues Migrating and Upgrading Web Sites

trusted e-mail addresses Configuring E-Mail-Enabled Document Libraries
trusted users, assigning administrative tasks to Controlling User Rights and Assigning Tasks
Tunisia, regional and language settings Regional and Language Settings
Turkey, regional and language settings Regional and Language Settings
U
Back to top
Ukraine, regional and language settings Regional and Language Settings
unattended installation of Windows SharePoint Services 2.0 Performing a Quiet Installation
Uniform Resource Locators See URLs
uninstalling Internet Explorer Enhanced Security Configuration Internet Explorer Enhanced Security and Windows SharePoint Services
uninstalling language template packs Language Considerations
uninstalling Windows SharePoint Services 2.0 Uninstalling Windows SharePoint Services
United Arab Emirates, regional and language settings Regional and Language Settings
United Kingdom

    neutral language resource package, full-text search and Managing and Customizing Search

    regional and language settings Regional and Language Settings

United States, regional and language settings Regional and Language Settings
UNIX clients

    requirements for installation of Windows SharePoint Services 2.0 Hardware and Software Requirements

unlocking sites Configuring Site Quotas and Locks
unsuccessful site creation Troubleshooting Installation Issues
unused Web sites

    impact on server performance Performance Implications of Windows SharePoint Services Features

    scheduling detection and automatic deletion Scheduling Timed Jobs

    site use confirmation and automatic deletion Managing Unused Web Sites

unwanted e-mail messages Configuring E-Mail-Enabled Document Libraries
upgrading to Windows Server 2003 Upgrade Considerations
upgrading to Windows SharePoint Services 2.0 Upgrade Considerations

      See also installing Windows SharePoint Services 2.0

upgrading Web sites

    Migrating and Upgrading Web Sites

    Upgrade Considerations

uploading files

    blocked file extensions Configuring Blocked File Extensions

    viruses, protection against Configuring Antivirus Protection

Urdu, regional and language settings Regional and Language Settings

    about URL namespace configurations Windows SharePoint Services Architecture

    defined Glossary

    groups of, in IIS See application pools

    paths and Managing Paths

    tracking in Web site usage analysis Analyzing Web Site Usage

Uruguay, regional and language settings Regional and Language Settings
usage analysis

    configuring

      Command-Line Properties

      Configuring Usage Analysis

    defined Glossary

    impact on server performance Performance Implications of Windows SharePoint Services Features

    scheduling log file processing Scheduling Timed Jobs

    troubleshooting Troubleshooting Other Issues

user accounts

    about account modes Managing Users and Cross-Site Groups

    Active Directory accounts Separate Active Directory Organization Unit Deployment

    domain accounts Installation Considerations for Windows SharePoint Services

user authentication

    about authentication methods in Windows SharePoint Services 2.0 Windows SharePoint Services Security Model

    choosing an authentication type for SQL Server Installation Considerations for Windows SharePoint Services

    configuring Configuring Authentication

    Kerberos authentication, data retrieval services and Configuring Data Retrieval Services

users

    accounts See user accounts

    adding to sites and assigning to site groups Managing Users and Cross-Site Groups

    authentication See user authentication

    blocking access to sites Configuring Site Quotas and Locks

    malicious users, protecting against See malicious users

    unique users, tracking information about Analyzing Web Site Usage

    user groups See site groups

    user locale defined Glossary

    user names, encryption using Integrated Windows authentication Windows SharePoint Services Security Model

    user rights

      See also permissions

      Controlling User Rights and Assigning Tasks

      User Rights and Site Groups

Uzbekistan, regional and language settings Regional and Language Settings
V
Back to top
VBScript defined Glossary
vCard defined Glossary
Venezuela, regional and language settings Regional and Language Settings
versioning documents

    about document versioning Managing Versions and Checking Documents In and Out

    versioning defined Glossary

Vietnam, regional and language settings Regional and Language Settings
viewers, HTML

    impact on server performance Performance Implications of Windows SharePoint Services Features

    managing Managing HTML Viewers

viewing permissions for a list Managing Site Groups and Permissions
Virtual Basic Scripting Edition (VBScript) defined Glossary
Virtual Server gallery Managing Web Parts on Virtual Servers
virtual servers

    about virtual servers Windows SharePoint Services Architecture

    alerts, configuring for Managing Alerts

    anonymous access, configuring in IIS Configuring Authentication

    application pool identity, changing Changing the Application Pool Identity for the Administration Virtual Server

    application pools, problems reusing Troubleshooting Installation Issues

    configuring Configuring Virtual Servers

    content database management Managing Content Databases

    data retrieval services and Configuring Data Retrieval Services

    defined Glossary

    document library events, enabling Binding to a Document Library Event Handler

    e-mail Configuring E-Mail Settings

    extend defined Glossary

    extending Extending Virtual Servers

    extending, solving problems with Troubleshooting Installation Issues

    IIS application pools for Installation Considerations for Windows SharePoint Services

    online presence detection and instant messaging Configuring Online Presence Settings

    properties, command-line configuration Command-Line Properties

    removing Windows SharePoint Services 2.0 from Uninstalling Windows SharePoint Services

    site use confirmation and automatic deletion Managing Unused Web Sites

virus protection

    configuring Configuring Antivirus Protection

    e-mail attachments, document libraries and Configuring E-Mail-Enabled Document Libraries

    impact of filters on server performance Performance Implications of Windows SharePoint Services

    security settings for Internet Explorer Enhanced Security and Windows SharePoint Services

    suspect file extensions and Configuring Blocked File Extensions

W
Back to top
warning when virtual server site count exceeds maximum Managing Content Databases
Web address defined Glossary
Web Designer site groups

    Managing Site Groups and Permissions

    User Rights and Site Groups

Web discussions

    defined Glossary

    managing Managing Web discussions

Web farms See server farms
Web page based HTML Administration pages Introducing the Administration Tools for Windows SharePoint Services
Web Part Page gallery About Web Parts
Web Parts

    adding to a Web Part page Customizing a Web Site Based on Windows SharePoint Services

    custom Web Parts, creating using the SDK Using the SDK to Perform Advanced Customization

    custom Web Parts, deploying Managing Web Parts on Virtual Servers

    data-bound Web Parts, data retrieval services and Configuring Data Retrieval Services

    defined Glossary

    managing Managing Web Parts on Virtual Servers

    Web Part resource directory Special Directories and Storage Locations

Web servers

    defined Glossary

    front-end Web servers Managing a Server Farm Running Windows SharePoint Services

    hardware requirements for Windows SharePoint Services 2.0 Hardware and Software Requirements

    performance, enhancing by managing paths Managing Paths

    Web Parts, performance and security options Managing Web Parts on Virtual Servers

Web sites

    See also virtual servers

    backing up and restoring

      Backing Up and Restoring Web Sites

      Backup and Restore Options for Windows SharePoint Services

    content files, storage directories Special Directories and Storage Locations

    customizing

      Customizing a Web Site Based on Windows SharePoint Services

      Using the SDK to Perform Advanced Customization

    Help, customizing Customizing Help

    home page defined Glossary

    Meeting Workspace site defined Glossary

    migrating and upgrading Migrating and Upgrading Web Sites

    top-level Web site defined Glossary

    tracking items within, alerts and Managing Alerts

    unused Web sites

      Managing Unused Web Sites

      Scheduling Timed Jobs

    Web Part galleries About Web Parts

    Web Parts See Web Parts

what's new in Windows SharePoint Services 2.0 Introducing Windows SharePoint Services
wildcard inclusion path type Managing Paths
Windows NT Challenge Response

    Configuring Authentication

    Windows SharePoint Services Security Model

Windows NT Integrated authentication Windows SharePoint Services Security Model
Windows Server 2003 See Microsoft Windows Server 2003
Windows SharePoint Services 2.0. See Microsoft Windows SharePoint Services 2.0
workarounds for Internet Explorer Enhanced Security Configuration Internet Explorer Enhanced Security and Windows SharePoint Services
workspace defined Glossary
WYSIWYG formatting of file content Managing HTML Viewers
X
Back to top
.XML forms

    document library event handling and Binding to a Document Library Event Handler

.XML templates

    alerts, customizing message text for Managing Alerts

    Web sites, customizing Customizing a Web Site Based on Windows SharePoint Services

.XML Web services

    data retrieval service Configuring Data Retrieval Services

XML forms

    document library event handling and Binding to a Document Library Event Handler

XML templates

    alerts, customizing message text for Managing Alerts

    Web sites, customizing Customizing a Web Site Based on Windows SharePoint Services

XML Web services

    data retrieval service Configuring Data Retrieval Services

Y
Back to top
Yemen, regional and language settings Regional and Language Settings
Z
Back to top
Zimbabwe, regional and language settings Regional and Language Settings


Managing Web Part Availability

Managing Web Part Availability

Microsoft Windows SharePoint Services allows users to add Web Parts to Web Part Pages in a SharePoint site. A Web Part is a modular unit of information that has a single purpose. For example, the list of default Web Parts available with Windows SharePoint Services includes:

  • Content Editor Web Part — Displays unstructured Web content, such as text or images.
  • Image Web Part — Displays a picture.
  • Form Web Part — Allows you to add an HTML form.
  • Contacts — Allows you to display the Contacts list on a Web Part Page.
Users can add Web Parts to Web Part Pages and can personalize or share existing Web Parts with other users. Web Parts can also be connected to each other. For example, if you connect an Image Web Part to a data list, you can make the image change depending on which item in the data list is selected. You can even create custom Web Parts by using the Web Part Framework. For more information about creating a Web Part, see the Windows SharePoint Services Software Development Kit.

Users can include Web Parts from any of the following sources by default:

  • The Web Part Page Gallery — A collection of Web Parts that are available to a specific Web Part Page but not actually on the page. Each Web Part Page has its own Web Part Page gallery.
  • The Team Site Web Part Gallery — The most central Web Part gallery for your work group. This Web Part gallery is typically managed by your server administrator, who decides which Web Parts are available and safe for your team site. By default, the gallery name is the name of your site. There is only one Team Site gallery for each site collection.
  • The Virtual Server Gallery — If your enterprise is large, has many team sites, and has decided to install the same set of Web Parts on many team sites, these Web Parts may be stored in a Virtual Server Gallery. Web Parts in the Virtual Server Gallery can be added from a Web Part assembly. For more information about Web Part assemblies, see "Managing Web Parts on Virtual Servers" in the Windows SharePoint Services Administrators Guide.
  • The Online Gallery — An additional set of Web Parts available from Microsoft. In this gallery, you can locate several MSNBC Web Parts that display news, stock, and weather information.

When a user adds a Web Part to a Web Part Page, they can browse any of these sources to find a Web Part.

Managing Security and Performance Options for Web Parts and Web Part Pages

You can control whether users can connect Web Parts to each other within a site, and whether to allow access to the online Web Part gallery. The online Web Part gallery contains many Web Parts that users can download and install to use on their sites. Both of these actions have potential impact on your server and site security and performance. For example, if you allow Web Part connections, and a user connects a complex Web Part to a large data set, the Web Part Page that contains those Web Parts could take a long time to load when a user browses to it. Also, if a user connects to a Web Part that contains a scripting error or malicious code, it could open up a security hole in the user's site, or, potentially, on your server.

You can change these configuration options at the virtual server level. By default, both security options are enabled at the server level. You only need to change these options if you do not want to allow either Web Part connections or access to the online Web Part gallery. If you have multiple servers in a server farm environment, and you want to change these settings for all virtual servers, you must configure these options for each virtual server on each server in that server farm. You must be an administrator of the local server computer, or a member of the SharePoint Administrators group to configure security and performance options for Web Parts and Web Part Pages.

Configure options for Web Parts and Web Part Pages

  1. On your server computer, click Start, point to Administrative Tools, and then click SharePoint Central Administration.
  2. On the SharePoint Central Administration page, click Configure virtual server settings.
  3. On the Virtual Server List page, click the virtual server you want to configure.
  4. On the Virtual Server Settings page, click Manage security settings for Web Part Pages.
  5. Select the options you want to enable or disable, and then click OK.

    You can also return to using the default server settings of enabling users to both connect Web Parts and use the Online Web Part gallery, by clicking Restore Defaults.

If your server is behind a proxy server or firewall, you must also edit the web.config file for each virtual server for which you want to enable the online Web Part library. In a server farm environment, you must edit this file for each virtual server in every front-end Web server in the server farm.

Allow access to the online Web Part gallery from behind a proxy server or firewall
  1. On your Web front-end server computer, open Notepad, navigate to the folder containing the virtual server for which you want to enable the online Web Part gallery, and then open the web.config file under the following directory:

    \Inetpub\wwwroot

  2. In the web.config file, add the following lines.

    <system.net>
      <defaultProxy>
      <proxy proxyaddress="http://Proxy_Server:port" bypassonlocal = "true"/>
      </defaultProxy>
    </system.net>
    Where Proxy_Server:port is the proxy server or firewall used for your environment.

  3. Save and close the web.config file.
  4. Repeat steps 1 through 3 for each virtual server for which you want to enable access to the online Web Part gallery.

Managing the Web Part Gallery for a Site

Administrators of a top-level Web site can determine which Web Parts are available to the users of sites in their site collection. They can use the Web Part Gallery page to add or remove Web Parts from the list of Web Parts available for use, or to upload new Web Parts. Note that users may also have access to Web Parts in the online Web Part gallery, or in the Server gallery. The Web Part gallery for a site controls only a subset of all Web Parts available to users.

Make a Web Part available in the Web Part gallery

  1. On a top-level Web site, click Site Settings.
  2. Under Administration, click Go to Site Administration.
  3. Under Site Collection Galleries, click Manage Web Part gallery.
  4. On the Web Part Gallery page, click New Web Part.
  5. Select the check box next to the Web Parts you want to include in the gallery, and then click Populate Gallery.

    Note The list of Web Parts that can be added to the Web Part gallery is derived from the list of safe Web Parts in the web.config file. There may be Web Parts in the web.config file that have never been in the gallery, or that were deleted from the gallery. When you click Populate Gallery, the Web Parts you select are added to the gallery and are made available to all users.

If you have installed a Web Part Package, and need to add the Web Parts to the gallery, you can use the Upload Web Part button to add the new Web Parts to the gallery.

Web Parts can be organized into groups for easy filtering in the gallery. You can specify which group a Web Part belongs to when you add a Web Part to the Web Part gallery. Groups are optional — you can add a Web Part without specifying a group.

Add a Web Part to the Web Part gallery

  1. On the Web Part Gallery page, click Upload Web Part.
  2. In the Name box, type the name of the Web Part (including the full path to the .dwp file), or click Browse.
  3. In the Group box, select a group, or under Specify your own value:, type a group name for the Web Part.
  4. Click Save and Close.

You can add several Web Parts to your gallery at once by using the Upload Multiple Files option on the Upload Web Part page.

Note You must be using a Windows SharePoint Services-compatible client application to use the Upload Multiple Files option.

Add multiple Web Parts to the Web Part gallery

  1. On the Web Part Gallery page, click Upload Web Part.
  2. Under Name, click Upload Multiple Files.
  3. Select the check boxes next to the Web Parts you want to upload, and then click Save and Close.

You can remove a Web Part from the gallery if you want to make it unavailable to users. If a user has already used a Web Part in the site, and you delete the Web Part from the site gallery, the Web Part will remain on the Web Part Page, and will still work. However, if an administrator on the server computer removes the Web Part assembly that contains the Web Part from the server, or marks the assembly as unsafe in the Web.config file for the server, the Web Part will no longer run, and the user will see an error message.

Remove a Web Part from the Web Part gallery

  1. On the Web Part Gallery page, next to the Web Part you want to remove, click the Edit icon.
  2. On the Web Part Gallery: <Web Part Name> page, click Delete.
  3. Click OK to delete the Web Part.

Related Topics

Server administrators can install new Web Parts as part of a Web Part Package. For more information, see "Managing Web Parts on Virtual Servers" in the Windows SharePoint Services Administrators Guide.


Deploying Additional Web Parts

Deploying Additional Web Parts

Microsoft Windows SharePoint Services comes with several Web Parts that your users can use right away, and many more are available in the online Web Part gallery. In addition, you can create your own Web Parts or install Web Part Packages that include Web Parts from Microsoft or other software vendors.

Caution Web Parts contain code. Before adding a Web Part to the Web Part Gallery, make sure it is from a trusted source.

Creating Custom Web Parts

You can create custom Web Parts by using the Web Part Framework, and add them to the Web Part gallery for a site collection. If you want to deploy your custom Web Parts to multiple servers, or share them with other organizations, you can create a Web Part Package. For more information about creating a Web Part or a Web Part Package, see the Windows SharePoint Services Software Development Kit.

Installing a Web Part Package

A custom Web Part Package can be packaged and distributed as a cabinet (CAB) file. If you have a Web Part Package in CAB format, you can use the command line to install it to your server, or to all Web servers in your server farm. Web Part Packages from Microsoft (such as add-in packs for Windows SharePoint Services) are packaged into a Microsoft Windows Installer (MSI) file. You simply install the MSI file to your Web server, and the Web Parts are added to the server gallery.

When you install a Web Part Package, it is added to the virtual server gallery, and can be used for any site on that virtual server. You can use the command-line to distribute the Web Part Package to any other virtual server, or to any Web server in a server farm.

Adding Web Parts from a CAB File to the Server Gallery

You use the command-line tool Stsadm.exe to add the Web Parts in a Web Part Package (in CAB file format) to the list of Web Parts available for a server. The following operations are available for Web Part Packages in Stsadm.exe:

  • addwppack — Adds a Web Part Package to the Web Part gallery for your server or server farm.
  • deletewppack — Removes a Web Part Package from the Web Part gallery for your server.
  • enumwppacks — Lists the Web Part Packages currently in the Web Part gallery for your server.

These operations take the optional -url, -filename, -name, -farm, and -force parameters. For example, to list the Web Part Packages that are currently available for your server, you would use the following syntax:

stsadm.exe -o enumwppacks

To add a new Web Part Package to your virtual server, you would use the following syntax:

stsadm.exe -o addwppack -filename <path to file> -url <URL>

You can add a Web Part Package to all virtual servers on a server by using the -globalinstall parameter. To do so, you would use the following syntax:

stsadm.exe -o addwppack -filename <Web Part Package filename> -globalinstall

If you have already installed a Web Part Package to a server, and you want to distribute it to other servers in a server farm, you can use the following syntax:

stsadm.exe -o addwppack -name <name of Web Part Package>

You can use the -force parameter to overwrite an existing Web Part Package with a new version, or to repair a Web Part Package by reinstalling it.

To delete a Web Part Package, you would use the following syntax:

stsadm -o deletewppack -name <name of Web Part Package> [-url <url>]

For more information about using these commands, see Command-Line Operations.